/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.common.web.HiddenResultsMessage'); //$NON-NLS-1$

dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.common.web', 'HiddenResultsMessageMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('dijit._Templated'); //$NON-NLS-1$

(function(){

	/**
	 * Footer to show below results if they can be hidden with filter text.
	 * Can show the count of hidden results with a link to show them all.
	 */
	dojo.declare(
		'com.ibm.relm.common.web.HiddenResultsMessage', //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.common.web', 'templates/HiddenResultsMessage.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,
			messages: dojo.i18n.getLocalization('com.ibm.relm.common.web', 'HiddenResultsMessageMessages'), //$NON-NLS-1$ //$NON-NLS-2$

			postCreate: function() {
				this.inherited(arguments);

			},

			setHiddenCount: function(hiddenCount) {
				if (hiddenCount === 0) {
					this.hide();
				}
				else {
					this.domNode.style.display = ''; //$NON-NLS-1$

					this._messageNode.innerHTML = hiddenCount === 1 ?
						this.messages.hiding1Result :
						dojo.replace(this.messages.hidingXResults, [hiddenCount]);
				}
			},

			hide: function() {
				this.domNode.style.display = 'none'; //$NON-NLS-1$
			},

			_showAll: function(e) {
				dojo.stopEvent(e);

				this.hide();
				this.shouldShowAll();
			},

			/**
			 * Callback when the Show All link is clicked. 
			 * Owning widget should show all the results in response to
			 * this. Will hide this message.
			 */
			shouldShowAll: function() {
				
			}
		}
	);

})();