/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.common.web.HoverToolbar'); //$NON-NLS-1$

dojo.require('jazz.ui.Toolbar'); //$NON-NLS-1$

(function(){

	/**
	 * Extension to jazz.ui.Toolbar that adds support for hiding buttons
	 * until hovered over or focused on. Focus support is automatic. To enable
	 * hover support, add the class 'relm-HoverToolbar-onHover' to a parent element
	 * that should reval the toolbar on hover.
	 */
	dojo.declare(
		'com.ibm.relm.common.web.HoverToolbar', //$NON-NLS-1$
		[ jazz.ui.Toolbar ],
		{
			postCreate: function() {
				this.inherited(arguments);

				dojo.addClass(this.domNode, 'relm-HoverToolbar'); //$NON-NLS-1$

				if (this.absoluteRight) {
					dojo.addClass(this.domNode, 'relm-HoverToolbar-absoluteRight'); //$NON-NLS-1$					
				}

				var self = this;
				this.connect(this, 'onFocus', function() { //$NON-NLS-1$
					dojo.addClass(self.domNode, 'relm-HoverToolbar-onFocus'); //$NON-NLS-1$
				});

				this.connect(this, 'onBlur', function() { //$NON-NLS-1$
					dojo.removeClass(self.domNode, 'relm-HoverToolbar-onFocus'); //$NON-NLS-1$
				});
			}
		}
	);

})();