(function () {
	dojo.provide("relm.iahost.WelcomePageContent"); //$NON-NLS-1$

	dojo.require("dm.app.analysis.ui.internal.util.AnalysisIcons"); //$NON-NLS-1$
	dojo.require("dm.app.analysis.ui.internal.application.AnalysisActions"); //$NON-NLS-1$
	dojo.require("dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil"); //$NON-NLS-1$
	dojo.require("dm.app.analysis.ui.AnalysisWelcomeUtil"); //$NON-NLS-1$

	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.requireLocalization("relm.iahost", "AnalysisWelcomeMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	var messages  = dojo.i18n.getLocalization("relm.iahost", "AnalysisWelcomeMessages"); //$NON-NLS-1$ //$NON-NLS-2$

	var AnalysisIcons   = dm.app.analysis.ui.internal.util.AnalysisIcons;
	var AnalysisActions = dm.app.analysis.ui.internal.application.AnalysisActions;
	var AnalysisUtil = dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil;
	var AnalysisWelcomeUtil = dm.app.analysis.ui.AnalysisWelcomeUtil;

	dojo.declare("relm.iahost.WelcomePageContent", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$

		"class": "relmAnalysisWelcome", //$NON-NLS-1$ //$NON-NLS-2$

		messages: messages,
		
		widgetsInTemplate: true,
		templatePath: dojo.moduleUrl("relm.iahost","templates/WelcomePageContent.html"), //$NON-NLS-1$ //$NON-NLS-2$
		
		// init properties
		editor: null,
		
		constructor: function(args) {
			this.messages = messages;
		},
		
		postCreate: function() {
			this.inherited(arguments);
			
			this.editor = AnalysisWelcomeUtil.editor;
			
			if (!this.editor){
				console.error("Welcome page content could not access the Editor."); //$NON-NLS-1$
				return;
			}

			// In conformance to other Relm Welcome Pages:
			dojo.style(this.editor.headerContainerNode, "marginTop", "0.5em"); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.style(this.editor.headerContainerNode, "paddingTop", "5px"); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.style(this.editor.headerContainerNode, "paddingBottom", "12px"); //$NON-NLS-1$ //$NON-NLS-2$
			
			// Set the hrefs on the title and image anchors for each welcome action.
			var action = AnalysisUtil.getAllAnalysisUri(this.hostPageId);
			this.viewIADiagsImageAnchor.href = action;
			this.viewIADiagsTitleAnchor.href = action;
			
			action = AnalysisUtil.getAllConfigAnalysisUri(this.hostPageId);
			this.viewIAConfigsImageAnchor.href = action;
			this.viewIAConfigsTitleAnchor.href = action;

			action = AnalysisUtil.getAllProfileAnalysisUri(this.hostPageId);
			this.viewIAProfilesImageAnchor.href = action;
			this.viewIAProfilesTitleAnchor.href = action;


			action = AnalysisUtil.getNewAnalysisUri(this.hostPageId);
			this.createIADiagImageAnchor.href = action;
			this.createIADiagTitleAnchor.href = action;

			action = AnalysisUtil.getNewAnalysisConfigUri(this.hostPageId);
			this.createIAConfigImageAnchor.href = action;
			this.createIAConfigTitleAnchor.href = action;

			action = AnalysisUtil.getNewAnalysisProfileUri(this.hostPageId);
			this.createIAProfileImageAnchor.href = action;
			this.createIAProfileTitleAnchor.href = action;

			
			this.editor.containerNode.appendChild(this.domNode);
			this.startup();
		},
		
		startup: function() {
			this.inherited(arguments);
		},
		
		/** Handle the resizing of the browser window. The left content widget of the welcome page
		*  contains the content for all of the analysis sections. These will be larger than the
		*  welcome page so the left content widget is set for auto-scrolling. However, when the
		*  window is resized, the height of that left content widget must be modified so that the
		*  vertical scrollbar will be shown.
		*/
		resize: function(size) {
			this.inherited(arguments);
			if (!size) {
				return;
			}
			if (size.h) {
				this._leftContent.style.height = size.h + "px"; //$NON-NLS-1$
			}
		}
	});


}());