/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function () {
	dojo.provide('relm.iahost.WelcomePageProvider'); //$NON-NLS-1$
	
	// summary
	//	Replace the DM Welcome page content with RELM welcome page content
	//
	dojo.require('relm.iahost.WelcomePageContent'); //$NON-NLS-1$
	dojo.require('dm.app.analysis.ui.internal.pages.AnalysisWelcome'); //$NON-NLS-1$
	
	var welcomePrototype = dm.app.analysis.ui.internal.pages.AnalysisWelcome.prototype;
	
	welcomePrototype.createContentWidget = function () {
		return new relm.iahost.WelcomePageContent({editor: null});
	};

	// summary
	//  Modify the Reports Welcome page content to remove their links and menu items 
	//  to non-existant and unsupported topics
	//
	dojo.require('com.ibm.team.reports.web.ui.internal.ReportsComponentMenu'); //$NON-NLS-1$
	dojo.require('com.ibm.team.reports.web.ui.internal.ReportsView'); //$NON-NLS-1$
	
	// override the foundation reports menu to not render the unsupported optional items for
	// Cognos and Jazz Reporting Service entries
	var reportsMenuPrototype = com.ibm.team.reports.web.ui.internal.ReportsComponentMenu.prototype;
	reportsMenuPrototype._addOptionalTasks = function() {
		dojo.hitch(this, reportsMenuPrototype._removePlaceholder)();
		return;
	}
	
	// override the welcome page content rendering to hide the Cognos and Jazz Reporting Service entries
	var reportsWelcomePrototype = com.ibm.team.reports.web.ui.internal.ReportsView.prototype;
	var _oldSetMainContent = reportsWelcomePrototype._setMainContent;
	reportsWelcomePrototype._setMainContent = function (domNode) {
		dojo.hitch(this, _oldSetMainContent)(domNode);
		
		// task3 is the Jazz Reporting Service section in the Welcome page
		var jrsSect = dojo.query('.task3', domNode); //$NON-NLS-1$
		if (jrsSect.length > 0) {
			dojo.style(jrsSect[0], 'display', 'none');  //$NON-NLS-1$ //$NON-NLS-2$
		}
		// task4 is the Cognos reporting section in the Welcome page
		var cogSect = dojo.query('.task4', domNode); //$NON-NLS-1$
		if (cogSect.length > 0) {
			dojo.style(cogSect[0], 'display', 'none'); //$NON-NLS-1$ //$NON-NLS-2$
		}
		
		var learnLink = dojo.query('a[data-dojo-attach-point="_learnLink"]', domNode)[0]; //$NON-NLS-1$
		if (learnLink && learnLink.href && learnLink.href.indexOf("relmhelp") != -1) //$NON-NLS-1$
			learnLink.href = "http://www.ibm.com/support/knowledgecenter/SSYMRC_5.0.1/com.ibm.rational.reporting.overview.doc/topics/c_ovr_overview.html"; //$NON-NLS-1$

		var dashboardLink = dojo.query('a.img-db-mini', domNode)[0]; //$NON-NLS-1$
		if (dashboardLink && dashboardLink.href && dashboardLink.href.indexOf("relmhelp") != -1) //$NON-NLS-1$
			dashboardLink.href = "http://www.ibm.com/support/knowledgecenter/SSYMRC_5.0.1/com.ibm.jazz.dashboard.doc/topics/c_about_dash_mini.html"; //$NON-NLS-1$
	};


}());