/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.ple.web.admin.DoorsIntegrationSettings"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.ple.web.admin', 'RtcIntegrationSettingsMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("relm.app.Permissions"); //$NON-NLS-1$

(function(){

	var isJazzAdmin = relm.app.Permissions.isJazzAdmin();

	dojo.declare(
		"com.ibm.relm.ple.web.admin.DoorsIntegrationSettings", //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','admin/templates/DoorsIntegrationSettings.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: true,

			messages: dojo.i18n.getLocalization('com.ibm.relm.ple.web.admin', 'RtcIntegrationSettingsMessages'), //$NON-NLS-1$ //$NON-NLS-2$

			postCreate: function() {
				this.inherited(arguments);

				if (!isJazzAdmin) {
					this.enabledCheckbox.disabled = true;
				}
			},

			onChange: function() {
				this._saveButton.disabled = false;
			},

			onSave: function(e) {
				this._saveButton.disabled = true;
				this._errorBox.hideMessage();


				var self = this;
				jazz.client.xhrPost({
					url: net.jazz.ajax._contextRoot + '/ple/doors_settings', //$NON-NLS-1$
					handleAs: 'json', //$NON-NLS-1$
					content: {
						enabled: this.enabledCheckbox.checked
					},
				
					load: function () {
						self._successBox.showMessage({
							type: jazz.ui.MessageBox.STATUS_TYPES.OK,
							summary: self.messages.saveSucceeded
						});
						self._successBox.hideLater();
					},
				
					error: function(error, ioArgs) {
						self._saveButton.disabled = false;
						self._errorBox.showXhrError(ioArgs.xhr);
					}
				});
			},

			refresh: function() {
				this._errorBox.hideMessage();
				this._saveButton.disabled = true;

				var self = this;
				jazz.client.xhrGet({
					url: net.jazz.ajax._contextRoot + '/ple/doors_settings', //$NON-NLS-1$
					handleAs: 'json', //$NON-NLS-1$
			
					handle: function() {
						self._saveButton.disabled = true;
					},

					load: function(settings) {
						self.enabledCheckbox.checked = settings.enabled;
					},

					error: function(error, ioArgs) {
						self._errorBox.showXhrError(ioArgs.xhr);
					}
				});
			}
		});
})();