/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	connectionFailed: "Cannot connect to the Rational Team Concert server.", //$NON-NLS-1$
	teamConcertIntegration: "Rational Team Concert", //$NON-NLS-1$
	rationalTeamConcert: "Rational Team Concert Servers", //$NON-NLS-1$
	serverUrlLabel: "Server URL:", //$NON-NLS-1$
	enabled: "Enabled", //$NON-NLS-1$
	exampleUrl: "Example: https://rtc-hostname:9443/ccm", //$NON-NLS-1$
	saveSucceeded: "Saved", //$NON-NLS-1$
	save: "Save", //$NON-NLS-1$
	addUrl: "Add", //$NON-NLS-1$

	doorsSettingsPage: "Rational DOORS", //$NON-NLS-1$
	doorsBaselineSection: "Baselined Modules", //$NON-NLS-1$
	enabledDoorsBaselines: 'Create links to baselines of requirements modules', //$NON-NLS-1$
	doorsHelpText:
		"<p>In Rational Engineering Lifecycle Manager products, you can create artifact links to a specific baseline of a Rational DOORS module. After a specific baseline module is chosen, whenever the artifact link is clicked, that specific baseline of the module always opens.<\/p>" + //$NON-NLS-1$
		"<p>To get started, configure Rational Engineering Lifecycle Manager to communicate with all DOORS servers currently connected to the index. Any DOORS servers that you add must have a friend relationship with Rational Engineering Lifecycle Manager. (Set the relationship on Application > Communication > Friends (Outbound).)<\/p>", //$NON-NLS-1$

	// Label for checkbox that is also used to describe the following state group text field.
	rqmBaselinedTestPlansEnabled: "Treat test plans as baselines if in state group:", //$NON-NLS-1$
	rqmSettingsPage: "Rational Quality Manager", //$NON-NLS-1$
	rqmBaselineTestPlansSection: "Baselined Test Plans", //$NON-NLS-1$
	rqmBaselineStateGroupIdentiferLabel: "State group identifer:", //$NON-NLS-1$
	rqmStateGroupExample: "Example: \"published\"", //$NON-NLS-1$
	rqmDefaultStateGroup: "published", //$NON-NLS-1$
	rqmHelpText:
		"<p>Rational Quality Manager provides a facility to create lightweight baselines for test plans. Test plans that are transitioned into a designated state group are automatically treated as baselines. RELM can filter baseline test plans separately from other test plans in some search results.<\/p>" + //$NON-NLS-1$
		"<p>By default, the \"Published\" state group is used for this purpose. If you have customized your workflow to use another state group, enter the <i>identifier<\/i> of that state group here. The identifier of a state group is normally the same as its name, but in all lowercase and without spaces or punctuation.<\/p>" + //$NON-NLS-1$
		"<p> To set up: " + //$NON-NLS-1$
			"<ol>" + //$NON-NLS-1$
				"<li>Each integrated Quality Manager server must be configured as a friend server. <\/li>" + //$NON-NLS-1$
				"<li>The consumer key on the Quality Manager server must be configured with a functional user with full read privileges. Either:" + //$NON-NLS-1$
					"<ol type='a'>" + //$NON-NLS-1$
						"<li>Configure <tt>etl_user<\/tt> as the functional user (the user typically used for data warehousing).<\/li>"+ //$NON-NLS-1$
						"<div style='padding: 5px 0px 5px 0px'>or<\/div>" + //$NON-NLS-1$
						"<li>Create a user with an appropriate Quality Manager license " + //$NON-NLS-1$
						" with full read privileges and either 1) add the user to all appropriate project areas, or 2) give the user the <tt>JazzAdmins<\/tt> or <tt>JazzDWAdmins<\/tt> repository privileges to be able to access all project areas.<\/li>" + //$NON-NLS-1$
					"<\/ol>" + //$NON-NLS-1$
				"<\/li>" + //$NON-NLS-1$
			"<\/ol>" + //$NON-NLS-1$
		"<\/p>", //$NON-NLS-1$

	helpText:
		"<p>Use Rational Engineering Lifecycle Manager product hierarchies to control the components in a Rational Team Concert stream.<\/p>" + //$NON-NLS-1$
		"<p>Use the integration to:<\/p>" + //$NON-NLS-1$
		"<ul>" + //$NON-NLS-1$
		"	<li>organize components into a structured hierarchy.<\/li>" + //$NON-NLS-1$
		"	<li>link streams and components to requirements, test plans, and other indexed artifacts.<\/li>" + //$NON-NLS-1$
		"	<li>easily move components between streams.<\/li>" + //$NON-NLS-1$
		"<\/ul>" + //$NON-NLS-1$
		"<p>To get started, add a server URL to connect to a Rational Team Concert repository where your streams and components reside. Any Rational Team Concert servers that you add must have a friend relationship with Rational Engineering Lifecycle Manager. (Set the relationship on Application > Communication > Friends (Outbound).) " + //$NON-NLS-1$
		"<a href=\'http://www.ibm.com/support/knowledgecenter/SS2L6K_5.0.1/com.ibm.rational.relm.doc/topics/c_intro_2integrations.html\'>Learn More...<\/a><\/p>" //$NON-NLS-1$


});