/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.conf.componentInfo"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$

com.ibm.relm.explorer.web.conf.componentInfo = {
  label: 'name', //$NON-NLS-1$
  items: [
  	{
		id: "container", //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer', //$NON-NLS-1$
		attributes: [
		   	{name: 'id'}, //$NON-NLS-1$
  			{name: 'left', value: 10}, //$NON-NLS-1$
			{name: 'top', value: 10}, //$NON-NLS-1$
 			{name: 'width', value: 10}, //$NON-NLS-1$
			{name: 'height', value: 10}, //$NON-NLS-1$
			{name: 'baseQueryId'}, //$NON-NLS-1$
			{name: 'queryParams'}, //$NON-NLS-1$
			{name: 'uiParams'}, //$NON-NLS-1$
			{name: 'parameters'}, //$NON-NLS-1$
			{name: 'nodeType'}, //$NON-NLS-1$
			{name: 'halign'}, //$NON-NLS-1$
			{name: 'valign'}, //$NON-NLS-1$
			{name: 'margin', value: 0}, //$NON-NLS-1$
			{name: 'hspacing'}, //$NON-NLS-1$
			{name: 'vspacing'}, //$NON-NLS-1$
			{name: 'layout'}, //$NON-NLS-1$
			{name: 'columns'}, //$NON-NLS-1$
			{name: 'showGrid', value: false}, //$NON-NLS-1$
			{name: 'reduceRatio'}, //$NON-NLS-1$
			{name: 'treestyle'}, //$NON-NLS-1$
			{name: 'treedir'}, //$NON-NLS-1$
			{name: 'expandDepth'}, //$NON-NLS-1$
			{name: 'childLinkId'}, //$NON-NLS-1$
			{name: 'layerVariable'}, //$NON-NLS-1$
			{name: 'layerOrder'}, //$NON-NLS-1$
			{name: 'stroke'}, //$NON-NLS-1$
			{name: 'fill'}, //$NON-NLS-1$
			{name: 'r'}, //$NON-NLS-1$
			{name: 'pack', value: true}, //$NON-NLS-1$
			{name: 'elementId'}, //$NON-NLS-1$
			{name: 'upstream'} //$NON-NLS-1$
 		]
	},
  	{
		id: "text", //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.internal.view.nodes.Text', //$NON-NLS-1$
		attributes: [
 			{name: 'left', value: 0}, //$NON-NLS-1$
			{name: 'top', value: 0}, //$NON-NLS-1$
 			{name: 'font', value: { family: 'arial', weight:'bold', size: '14pt' }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		    {name: 'fill', value: '#222222', type: "fill"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		    {name: 'stroke', type: "stroke"}, //$NON-NLS-1$ //$NON-NLS-2$
		    {name: 'decoration'}, //$NON-NLS-1$
 			{name: 'text'}, //$NON-NLS-1$
		    {name: 'href'}, //$NON-NLS-1$
		    {name: 'action'} //$NON-NLS-1$
 		]
	},
	{
		id: 'image', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.internal.view.nodes.Image', //$NON-NLS-1$
		attributes: [
			{name: 'left', value: 0}, //$NON-NLS-1$
			{name: 'top', value: 0}, //$NON-NLS-1$
			{name: 'width', value: 20}, //$NON-NLS-1$
			{name: 'height', value: 20}, //$NON-NLS-1$
			{name: 'src'}, //$NON-NLS-1$
		    {name: 'href'}, //$NON-NLS-1$
		    {name: 'action'} //$NON-NLS-1$
		]
	},
	{
		id: 'baseResourceNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "130"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "35"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "${icon}",	x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "iconShape"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 20, y: 15, fill: "#222222", font: { family: "arial", weight: "bold", size: "9pt" }, dojoAttachPoint: "titleShape"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$
				{type: "text", text: "${summary}", x: 5, y: 29, fill: "#222222", font: { family: "arial", size: "9pt" }, dojoAttachPoint: "summaryShape"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "", y: 2, width: 16, height: 16, dojoAttachPoint: "statusIcon"}//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				]
			}
		]
	},
	{
		id: 'simpleResourceNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "22"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image", src: "${icon}", x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "iconShape"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${summary}", x: 20, y: 15, fill: "#222222", font: { family: "arial", size: "9pt" }, dojoAttachPoint: "summaryShape"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "", y: 2, width: 16, height: 16, dojoAttachPoint: "statusIcon"}//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				]
			}
			]
	},
	{
		id: 'requirementNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "22"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "oslc_rm:Requirement"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
   				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
   				{type: "image", src: "${icon}", x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
   				{type: "text", text: "${summary}", x: 20, y: 15, fill: "#222222", font: { family: "arial", size: "9pt" }, dojoAttachPoint: "summaryShape"} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				]
			}
		]
	},
	{
		id: 'taskNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "35"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "oslc_cm:ChangeRequest"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "${icon}",	x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 20, y: 15, fill: "#222222", font: { family: "arial", weight: "bold", size: "9pt" }, dojoAttachPoint: "titleShape"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$
				{type: "text", text: "${summary}", x: 20, y: 29, fill: "#222222", font: { family: "arial", size: "9pt" }, dojoAttachPoint: "summaryShape"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "", y: 2, width: 16, height: 16, dojoAttachPoint: "statusIcon"}//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				]
			}
		]
	},
	{
		id: 'processNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "35"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "oslc_cm:ChangeRequest"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "${icon}",	x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 20, y: 15, fill: "#222222", font: { family: "arial", size: "9pt", weight: "bold" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ 
				{type: "text", text: "${summary}", x: 20, y: 29, fill: "#222222", font: { family: "arial", size: "9pt" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{type: "image",	src: "", y: 2, width: 16, height: 16, dojoAttachPoint: "statusIcon"}//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				]
			}
		]
	},
	{
		id: 'defectNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "35"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "oslc_cm:ChangeRequest"},//$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "${icon}",	x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 20, y: 15, fill: "#222222", font: { family: "arial", weight: "bold", size: "9pt" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "text", text: "${summary}", x: 20, y: 29, fill: "#222222", font: { family: "arial", size: "9pt" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{type: "image",	src: "", y: 2, width: 16, height: 16, dojoAttachPoint: "statusIcon"}//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				]
			}
		]
	},
	{
		id: 'testPlanNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${description}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "35"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "oslc_qm:TestPlan"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "${icon}",	x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 20, y: 15, fill: "#222222", font: { family: "arial", weight: "bold", size: "9pt" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "text", text: "${summary}", x: 20, y: 29, fill: "#222222", font: { family: "arial", size: "9pt" }} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				]
			}
		]
	},
	{
		id: 'testCaseNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "22"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "oslc_qm:TestCase"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "${icon}",	x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 20, y: 15, fill: "#222222", font: { family: "arial", size: "9pt" }} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				]
			}
		]
	},
	{
		id: 'testExecutionRecordNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "22"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "oslc_qm:TestExecutionRecord"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image", src: "${icon}", x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 20, y: 15, fill: "#222222", font: { family: "arial", size: "9pt" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{type: "image",	src: "", y: 2, width: 16, height: 16, dojoAttachPoint: "statusIcon"}//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				]
			}
			]
	},
	{
		id: 'testScriptNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "22"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "oslc_qm:TestScript"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image", src: "${icon}", x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 20, y: 15, fill: "#222222", font: { family: "arial", size: "9pt" }} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				]
			}
			]
	},
	{
		id: 'testResultNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "140"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "22"},  //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"},	 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"},		 //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'status', value: "${status}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "oslc_qm:TestResult"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image", src: "${icon}", x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 20, y: 15, fill: "#222222", font: { family: "arial", size: "9pt" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{type: "image",	src: "", y: 2, width: 16, height: 16, dojoAttachPoint: "statusIcon"}//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				]
			}
			]
	},
	{
		id: 'productNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "160"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "45"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "5"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "pd:ItemVersion"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "${icon}",	x: 7, y: 7, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 25, y: 20, fill: "#222222", font: { family: "arial", weight: "bold", size: "14px" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "text", text: "${summary}", x: 25, y: 37, fill: "#222222", font: { family: "arial", size: "14px" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				]
			}
		]
	},
	{
		id: 'configurationNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
  			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
		 	{name: 'title', value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "160"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "45"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "5"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "pd:ConfigurationVersion"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "image",	src: "${icon}",	x: 7, y: 7, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "text", text: "${title}", x: 25, y: 20, fill: "#222222", font: { family: "arial", weight: "bold", size: "14px" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "text", text: "${summary}", x: 25, y: 37, fill: "#222222", font: { family: "arial", size: "14px" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				]
			}
		]
	},
	{
		id: 'personNode', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode', //$NON-NLS-1$
		attributes: [
			{name: 'uri', value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'title', value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'summary', value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'image', value: "${image}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'width', value: "160"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'height', value: "45"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'overflow', value: "clip"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'fill', value: "white", type: "fill"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'stroke', value: "#C5C5C5", type: "stroke"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'r', value: "2"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'artifactType', value: "foaf:Person"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
				{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "rect", x: 7, y: 7, width: 16, height: 16, stroke: "gray", fill: "lightgray"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "circle", cx: 15, cy: 12, stroke: "gray", r: 3, fill: "gray"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				{type: "path", path: "m 11 22 l 0 -4 a 4 2 0 1 1 8 0 l 0 4 z", stroke: "gray", fill: "gray"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
				{type: "image", src: "${image}", x: 7, y: 7, width: 16, height: 16}, //$NON-NLS-1$ //$NON-NLS-2$
				{type: "text", text: "${title}", x: 26, y: 20, fill: "#222222", font: { family: "arial", weight: "bold", size: "9pt" }}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
				{type: "text", text: "${summary}", x: 26, y: 37, fill: "#222222", font: { family: "arial", size: "9pt" }} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				]
			}
		]
	},
	{
		id: "diagramNode", //$NON-NLS-1$
		className: "com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode", //$NON-NLS-1$
		attributes: [
			{name: "uri", value: "${resource}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "title", value: "${shortTitle}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "summary", value: "${title}"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "width", value: "140"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "height", value: "160"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "overflow", value: "clip"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "fill", value: "white", type: "fill"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: "stroke", value: "#C5C5C5", type: "stroke"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: "r", value: "2"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "artifactType", value: "dm_diagram:Diagram"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: "targetShapes", value: [ //$NON-NLS-1$
					{type: "rect", width: "${width}", height: "${height}", stroke: "${stroke}", r: "${r}", fill: "${fill}"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					{type: "image", src: "${icon}", x: 2, y: 2, width: 16, height: 16, dojoAttachPoint: "typeIcon"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
					{type: "text", text: "${summary}", x: 20, y: 15, fill: "#222222", font: {family: "arial", weight: "bold", size: "9pt"}}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					{type: "image", src: "${uri}", x: 2, y: 20, width: 136, height: 136} //$NON-NLS-1$ //$NON-NLS-2$
				]
			}
		]
	},
	{
		id: 'baseConnection', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.internal.view.connections.BaseConnection', //$NON-NLS-1$
		attributes: [
			{name: 'stroke', value: {width: 1, color: "#999999"}, type: "stroke"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'startDir'}, //$NON-NLS-1$
			{name: 'endDir'}, //$NON-NLS-1$
			{name: 'r', value: 5}, //$NON-NLS-1$
			{name: 'sourceDecorationProps', type: "decoration"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'targetDecorationProps', value: {"preset":"filled_arrow_s"}, type: "decoration"} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		]
	},
	{
		id: 'roundConnection', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.internal.view.connections.RoundConnection', //$NON-NLS-1$
		attributes: [
 			{name: 'stroke', value: {width: 1, color: "#999999"}, type: "stroke"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'curveType', value: 'CubicBezier'}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'startDir'}, //$NON-NLS-1$
			{name: 'endDir'}, //$NON-NLS-1$
			{name: 'sourceDecorationProps', type: "decoration"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'targetDecorationProps', value: {"preset":"filled_arrow_s"}, type: "decoration"} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		]
	},
	{
		id: 'lineConnection', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.ui.internal.view.connections.LineConnection', //$NON-NLS-1$
		attributes: [
 			{name: 'stroke', value: {width: 1, color: "#999999"}, type: "stroke"},		 //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'startDir'}, //$NON-NLS-1$
			{name: 'endDir'}, //$NON-NLS-1$
			{name: 'sourceDecorationProps', type: "decoration"}, //$NON-NLS-1$ //$NON-NLS-2$
			{name: 'targetDecorationProps', value: {"preset":"filled_arrow_s"}, type: "decoration"} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		]
	},
	{
		id: 'GridHeader', //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.base.internal.gdc.Text', //$NON-NLS-1$
		attributes: [
			{name: 'fillColor', value: "#CDE1EB", type: "fill"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'fill', value: "blue", type: "fill"}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			{name: 'font', value: '{ family: "arial", weight:"bold", size: "12pt" }'} //$NON-NLS-1$ //$NON-NLS-2$
		]
	},
	{
		id: "GridLine", //$NON-NLS-1$
		className: 'com.ibm.relm.explorer.web.base.internal.gdc.Polyline', //$NON-NLS-1$
		attributes: [
 			{name: 'stroke', value: '{color: "#BAD1DF", style: "LongDash"}', type: "stroke"} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 		]
	}
]};

jazz.client.xhrGet({
	url: com.ibm.relm.explorer.web.ui.uiComponentServiceUri, 
	load: function(data){
		if(dojo.isArray(data)){
			var items = com.ibm.relm.explorer.web.conf.componentInfo.items;
			// override existing items
			for(var i=data.length-1; i>=0; i--){
				var component = data[i];
				for(var j=items.length-1; j>=0; j--){
					var item = items[j];
					if(component.id == item.id){
						dojo.mixin(item, component);
						data.splice(i, 1);
						break;
					}
				}
			}
			// add new items
			if(data.length > 0){
				com.ibm.relm.explorer.web.conf.componentInfo.items = data.concat(items);
			}
		}
	},
	error: function(error){
		console.error(error);
	},
	handleAs: "json", //$NON-NLS-1$
	sync: true
});

