/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.relm.ple.web.configgroupings.ConfigGroupingsEditorInput"); //$NON-NLS-1$

dojo.require("com.ibm.relm.common.web.ui.editor.EditorInput"); //$NON-NLS-1$
dojo.require("dojox.encoding.digests.MD5"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

var runningCount = 1;

dojo.declare("com.ibm.relm.ple.web.configgroupings.ConfigGroupingsEditorInput", com.ibm.relm.common.web.ui.editor.EditorInput, { //$NON-NLS-1$
	
	projectId: null,
	queryUri: null,
	_name: null,
	_id: null,
	_description: null,
	
	constructor: function(params) {
		this.addState('action', "ple.edit_config_grouping"); //$NON-NLS-1$ //$NON-NLS-2$
		this.addState('mode', "edit"); //$NON-NLS-1$ //$NON-NLS-2$
		this.addState('uri', params.uri); //$NON-NLS-1$
		this.addState('name', params.name); //$NON-NLS-1$
		
		// integrated the remaining parameters into the EditorInput.
		dojo.mixin(this, params);
		this._name = this.name;
		this._id = this.id;
		this._description = this.description;
		this.resourceInfo = {uri: this.uri};
		
	},
	
	isLoaded: function() {
		return true;
	},
	
	_loadTargetResource: function (infos)
	{
		this.targetElement = infos[0];
	},
	
	configGroupingLoaded: function(config) {
		this._name = this._params.name = config.name;
		this._description = this._params.description = config.description;
		this.resourceInfo = {uri: config.uri};
		this._params.uri = config.uri;
	},
	
	configGroupingUpdated: function(config) {
		this.configGroupingLoaded(config);
	},
	
	getId: function() {
		if (this._id === null ) {
			if(dojo.isString(this.uri) && this.uri.length > 0) {
				this._id = this.uri;
			} else if (this.getState('id')) { //$NON-NLS-1$
				this._id = this.getState('id'); //$NON-NLS-1$
			}
		}
		return this._id;
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("com.ibm.relm.ple.web", "ui/images/productGrouping.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	getName: function() { 
		
		return this._name;
	},
	
	setName: function (name) {
		this._name = name;
	},
	
	getTooltip: function() {
		return this._description || ''; //$NON-NLS-1$
	},
	
	getBasePresentationUri: function() {
		return ""; //$NON-NLS-1$
	}
	
});

}());
