/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("relm.app.core.internal.WebUiInitializers"); //$NON-NLS-1$

//
// Clients must simply require this class in their application.
//

dojo.require("jazz.core.RegistryFactory"); //$NON-NLS-1$
dojo.require("jazz.core.loader"); //$NON-NLS-1$

var EXT_PT = "com.ibm.relm.web.app.webUiInitializers"; //$NON-NLS-1$
var E_INITIALIZER = "initializer"; //$NON-NLS-1$
var A_JS_MODULE = "jsModule"; //$NON-NLS-1$

var queue = [];
	
//
// Reads the server extension. All unbound initializers are executed
// immediately while all bound initializers are cached.
//

dojo.forEach(jazz.core.RegistryFactory.getRegistry().getExtensionPoint(EXT_PT).getExtensions(), function(extension) {
	dojo.forEach(extension.getConfigurationElements(), function(config) {
		if (E_INITIALIZER == config.getName()) {
			var className = config.getAttribute(A_JS_MODULE);
			
			// Removed a lot of code here from 4.0.3. Using delayed, bound
			// initializers relies on knowledge of how Jazz and Dojo load
			// modules. This is different in dojo 1.8 and Jazz Foundation
			// 4.0.4 and the methods used here don't work (e.g.,
			// dojo.setObject is not necessarily called to create
			// namespaced modules). This means that is broken in RELM
			// 4.0.4. I (@jgillibr) see no need to fix this though.
			// There's no obvious performance benefit to delaying this.
			// For now, just queue up everything to load now. It will
			// happen asynchronously anyway.
			queue.push(className);
		}
	});
});

// Changed to async loading in RELM 4.0.4 to support foundation 
// changes. Since nothing appeared to wait for this anyway (called from addOnLoad)
// then it's probably a safe change.
console.debug('Async load of web UI initializers: ', queue); //$NON-NLS-1$
jazz.core.loader.batch_load_async(queue, function() {
	// no op callback
});

queue.length = 0;

})();