/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
 
// ilog dojo.diagrammer is trying to dynamically load these modules, which
// doesn't work with dojo 1.8 + JFS 4.0.4. Just require them here to ensure they are preloaded.
dojo.require('dijit._base'); //$NON-NLS-1$
dojo.require('dijit.dijit'); //$NON-NLS-1$
dojo.require('dijit.form.Textarea'); //$NON-NLS-1$
dojo.require('dijit.Tooltip'); //$NON-NLS-1$
dojo.require('dojo.number'); //$NON-NLS-1$
dojo.require('dojo.parser'); //$NON-NLS-1$
dojo.require('dojo._base.array'); //$NON-NLS-1$
dojo.require('dojo._base.connect'); //$NON-NLS-1$
dojo.require('dojo._base.declare'); //$NON-NLS-1$
dojo.require('dojo._base.json'); //$NON-NLS-1$
dojo.require('dojo._base.lang'); //$NON-NLS-1$
dojo.require('dojo.data.api.Identity'); //$NON-NLS-1$
dojo.require('dojo.data.api.Notification'); //$NON-NLS-1$
dojo.require('dojo.data.api.Read'); //$NON-NLS-1$
dojo.require('dojo.data.api.Write'); //$NON-NLS-1$
dojo.require('dojo.fx'); //$NON-NLS-1$
dojo.require('dojox.collections.ArrayList'); //$NON-NLS-1$
dojo.require('dojox.collections._base'); //$NON-NLS-1$
dojo.require('dojox.collections.Dictionary'); //$NON-NLS-1$
dojo.require('dojox.collections.Set'); //$NON-NLS-1$
dojo.require('dojox.collections.Stack'); //$NON-NLS-1$
dojo.require('dojox.dtl._base'); //$NON-NLS-1$
dojo.require('dojox.dtl.Context'); //$NON-NLS-1$
dojo.require('dojox.gfx'); //$NON-NLS-1$
dojo.require('dojox.gfx.fx'); //$NON-NLS-1$
dojo.require('dojox.gfx.svg'); //$NON-NLS-1$
dojo.require('dojox.gfx.matrix'); //$NON-NLS-1$
dojo.require('dojox.gfx.move'); //$NON-NLS-1$
dojo.require('dojox.gfx.shape'); //$NON-NLS-1$
dojo.require('dojox.gfx.utils'); //$NON-NLS-1$
dojo.require('dojox.lang.functional.array'); //$NON-NLS-1$
dojo.require('dojox.lang.functional.fold'); //$NON-NLS-1$
dojo.require('dojox.dtl.tag.logic'); //$NON-NLS-1$
dojo.require('dijit._Container'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.MenuButton'); //$NON-NLS-1$

dojo.require('jazz.core.loader'); //$NON-NLS-1$

(function() {
dojo.provide("relm.app.core.internal.Workarounds"); //$NON-NLS-1$

//Hack for Jazz Foundation 4.0.4. If you are not logged in, the order things
//are loaded after the log in causes jazz.core.loader code to take a path
//that hits an uninitialized _loaded variable. Setting this to an empty array
//(if not set already) work around that problem. This may be caused by the
//very early use of jazz.core.loader from WebUiInitializers, which was added
//in 4.0.4. Mostly seen with ?debug=true on
if (!jazz.core.loader._loaded) {
	jazz.core.loader._loaded = [];
}

// Views relies on this property in GfXWidgets to know if the shape is a container
// or not. This was removed in dojo 1.8 though, so put it back. Should probably
// check for the presence of an .addChild method instead.
dijit._Container.prototype.isContainer = true;

/**
 * HACK: This is a copy of this method with one change: if oldParent is
 * `null`, then it will now use document.body instead. Otherwise, it throws an
 * error. This was needed after changing to dojo 1.8 and foundation 4.0.4.
 * When a text node is created, its width is being measured while it's being
 * created and before it's in the dom. This means there is not
 * rawNode.parentNode. I (Jay) have no idea why this happens or what changed
 * in this release to surface this problem.
 *
 * Note that the reason getTextWidth is called *seems* to be because of a hack
 * that dojo.diagrammer is doing which swaps some gfx methods and results in
 * this method getting called early. Not sure of the details, but if you set a
 * breakpoint here, you can see dojo.diagrammer in the stack, even if you're
 * on the Views page.
 */
dojox.gfx.svg.Text.prototype.getTextWidth = function() {
	var rawNode = this.rawNode;
	var oldParent = rawNode.parentNode || document.body;
	var measurementNode = rawNode.cloneNode(true);
	measurementNode.style.visibility = 'hidden'; //$NON-NLS-1$

	// Some default value.
	var widthPx;
	var text = measurementNode.firstChild.nodeValue;
	oldParent.appendChild(measurementNode);

	if (text) {
		try {
			if (measurementNode.getBBox) {
				widthPx = parseInt(measurementNode.getBBox().width, 10);
			}
		}
		catch (e) {
			// Ignore. Not sure why getBBox fails sometimes, though I don't see any impact
			// in the diagrams.
			// This comment was here before, though I couldn't see how the code worked, and it always
			// was wrong when I ran it before.
			// Yang: work around svgweb bug 417 -- http://code.google.com/p/svgweb/issues/detail?id=417
		}
	}

	oldParent.removeChild(measurementNode);
	if (!widthPx) widthPx = 68;
	return widthPx;
};


/* set default to blue instead of orange
   NGB: removed this override since it doesn't actually do anything (the default hoverStyle is ORANGE_BORDER)
dojo.require("jazz.ui.SimpleToolbar");
dojo.extend(jazz.ui.SimpleToolbar, {
	hoverStyle: jazz.ui.SimpleToolbar.HoverStyles.ORANGE_BORDER
});
*/

//NGB: the next lines are a complete hack.  It looks like code in BackendScr is retrieving the JTS scr document and parsing it to
//get information for the setup of ModelingApplication.  In addition, it looks like there are a bunch of dependencies in
//our code on net.jazz.ajax._dataServerRoot which is not set in our new deployment environment.  I have introduced a new
//global rnet.jazz.ajax._sharedJtsServerUrl and replaced occurrences of net.jazz.ajax._dataServerRoot in our code but we need to
//investigate why we are trying to refer to things directly on the JTS in this way.

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient"); //$NON-NLS-1$


net.jazz.ajax._sharedJtsServerUrl = net.jazz.ajax.dataServerRoot(); // fallback

var obj = {
	
	passed: function(response) {
		if(response){
			net.jazz.ajax._sharedJtsServerUrl = response;
		}
	},
	failed: function(response) {
	}
};
try {
	var srq = new com.ibm.team.repository.web.transport.ServiceRequest("com.ibm.team.repository.service.IServerDescriptionRestService","getConfiguredJazzTeamServerURI"); //$NON-NLS-1$ //$NON-NLS-2$
	var srh= new com.ibm.team.repository.web.transport.ServiceResponseHandler(obj, "passed", "failed");		 //$NON-NLS-1$ //$NON-NLS-2$
	com.ibm.team.repository.web.transport.TeamServerClient.invokeService(srq,srh,{sync: true});
} catch (e) {
}

dojo.require("dojox.lang.aspect"); //$NON-NLS-1$
dojo.require("relm.app.core.util"); //$NON-NLS-1$
dojo.require("rmps.core.RootServices"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$


/**
 * If no presentation URI is provided and the resource URI refers
 * to the front server, then set a local presentation URI.
 */
/*
 *  Commented out because this doesn't work for RELM, but only for DM
 *  
dojox.lang.aspect.advise(jazz.ui.ResourceLink, "buildRendering", {
	before: function() {
		var self = dojox.lang.aspect.getContext().instance;
		if (!self.presentationUri) {
			var modelsUri = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "models");
			if (self.uri) {
				var uri = self.uri;
			} else if (!self.uri && self.srcNodeRef && self.srcNodeRef.tagName === "A") {
				var uri = self.srcNodeRef.href;
			} else {
				return;
			}

			if (uri.indexOf(modelsUri) === 0) {
				self.presentationUri = relm.app.core.util.getViewResourceUri(uri);
			}
		}
	}
});
*/

dojox.lang.aspect.advise(jazz.ui.ResourceLink, "buildRendering", { //$NON-NLS-1$
	after: function() {
		var self = dojox.lang.aspect.getContext().instance;
		if(self.domNode){
			var currentUri= self.uri;
			
			/*If a link does not reside in the same application context, then, we have to make sure that it will open a new tab */
			if(currentUri.indexOf(net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL) !== 0){
				self.domNode.target = "_blank";					 //$NON-NLS-1$
			}
		}
	}
});

// commented out for RELM 
//dojo.extend(jazz.ui.ResourceLink, {
//	_styleLink: function() {
//		/*@see: https://jazz.net/jazz/web/projects/Jazz%20Foundation#action=com.ibm.team.workitem.viewWorkItem&id=153398 */
//		this.inherited("_styleLink",arguments)
//		if (dojo.isIE) {
//		 	this.domNode.style.position = "relative";
//		 }
//	}
//});


// This method doesn't exist in dojo 1.8, but ilog dojo diagrammer uses it.
// Stub out something similar here. In practice, I think they only use this to check for BiDi
// support, which RELM doesn't really support anyway.
// Note that this is async, which may not be compatible with how requireIf was being used,
// but jazz.core.loader.load_sync is not really supported anymore.
if (!dojo.requireIf) {
	dojo.requireIf = function relmRequireIf(condition, module) {
		if (condition) {
			jazz.core.loader.load_async(module, function() {
				console.debug('Conditionally include module:' + module); //$NON-NLS-1$
			});
		}
	};
}


// dojo.coords is deprecated and buggy. dojo.position works, but requires
// a second call to dojo.marginBox if you really need it. Most code doesn't.
dojo.coords = dojo.position;

// This foundation method doesn't properly check the imgClass property (an option instead of imgSrc),
// which causes it to show too much margin around the caret. This is a copy
// of that method from 5.0 with checks for imgClass as well.
jazz.ui.toolbar.MenuButton.prototype._updateClass = function(){
	var bool = (!this.pressed && !this.label && !(this.imgSrc || this.imgClass)) || (this.pressed && !this.labelPressed && !(this.imgSrc || this.imgSrcPressed || this.imgClass || this.imgClassPressed));
	dojo.toggleClass(this.domNode, "caret-only", bool); //$NON-NLS-1$
};

})();
