/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("relm.app.core.util"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$

relm.app.core.util = {

	_basicPrefix: "#action=relm.app.", //$NON-NLS-1$
	
	getWelcomeUri: function() {
		return this._basicPrefix + "welcome"; //$NON-NLS-1$
	},

	getViewResourceUri: function(resourceUri)  {
		var obj = {"resourceUri": resourceUri}; //$NON-NLS-1$
		return this._basicPrefix + "viewResource&" + dojo.objectToQuery(obj); //$NON-NLS-1$
	},

	getSearchUri: function(queryString)  {
		var obj = {query: queryString};
		return this._basicPrefix + "search&" + dojo.objectToQuery(obj); //$NON-NLS-1$
	},

	getBaselineStatusUri: function() {
		return this._basicPrefix + "baselineStatus"; //$NON-NLS-1$
	},

	getRequestBaselineUri: function() {
		return this._basicPrefix + "requestBaseline"; //$NON-NLS-1$
	},
	
	getProxyRequestUri: function(uri){
		var obj = {
			"uri": uri //$NON-NLS-1$
		};
		return rmps.core.RootServices.getUri(rmps.core.Namespaces.FP, "processProxy")+ "?"+ dojo.objectToQuery(obj); //$NON-NLS-1$ //$NON-NLS-2$
	}
	
};

})();


