/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.dnd.DropBar'); //$NON-NLS-1$

dojo.require('dijit._Templated'); //$NON-NLS-1$

(function(){
	/**
	 * This is just a visual indicator where something can be dropped "between" something.
	 * It is used in the product tree to show a drop above or below it and looks like
	 * >-----------------<
	 *
	 * This is always absolutely positioned and implicitly connected to the document body.
	 * The initial x, y, and w must be passed to the constructor. Height is always the same: it's just
	 * a line.
	 */
	dojo.declare(
		'com.ibm.relm.ple.web.dnd.DropBar', //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','dnd/templates/DropBar.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,

			x: 10,
			y: 10,
			w: 100,

			postCreate: function() {
				// Shift up a bit so that the middle of the line is at the "y"
				// point as opposed to the top the of side bar arrows.
				var top = this.y - 4;

				dojo.style(this.domNode, {
					top: top + 'px', //$NON-NLS-1$
					left: this.x + 'px', //$NON-NLS-1$
					width: this.w + 'px' //$NON-NLS-1$
				});

				this.placeAt(document.body);
			}
		}
	);

})();