/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.relm.explorer.web.explorer.ExplorerInput"); //$NON-NLS-1$

dojo.require("com.ibm.relm.common.web.ui.editor.EditorInput"); //$NON-NLS-1$
dojo.require("dojox.encoding.digests.MD5"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

var runningCount = 1;

dojo.declare("com.ibm.relm.explorer.web.explorer.ExplorerInput", com.ibm.relm.common.web.ui.editor.EditorInput, { //$NON-NLS-1$
	
	projectId: null,
	queryUri: null,
	_name: null,
	_id: null,
	
	constructor: function(params) {
		this.addState('action', "com.ibm.relm.explorer.web.showExplorer"); //$NON-NLS-1$ //$NON-NLS-2$
		this.addState('queryUri', params.queryUri); //$NON-NLS-1$
		
		// integrated the remaining parameters into the EditorInput.
		dojo.mixin(this, params);
		if(this.id)	this._id = this.id;
		this._name = this.queryName;
		this._description = this.queryDescription;
		this.resourceInfo = {uri: this.queryUri};
		
	},
	
	isLoaded: function() {
		return true;
	},
	
	queryUpdated: function(query) {
		this._name = query.name;
		this._description = query.description;
	},
	
	queryUriUpdated: function(uri) {
		this.addState('queryUri', uri); //$NON-NLS-1$
		this.resourceInfo.uri = uri;
		this._id = uri.split("/").pop(); //$NON-NLS-1$
	},
	
	_loadTargetResource: function (infos)
	{
		this.targetElement = infos[0];
	},
	
	
	getId: function() {
		if (this._id === null ) {
			if(dojo.isString(this.resourceInfo.uri) && this.resourceInfo.uri.length > 0) {
				this._id = this.resourceInfo.uri;
			} else if (this.getState('id')) { //$NON-NLS-1$
				this._id = this.getState('id'); //$NON-NLS-1$
			}
		}
		return this._id;
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/query.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	getName: function() { 
		
		return this._name;
	},
	
	setName: function (name) {
		this._name = name;
	},
	
	getTooltip: function() {
		return this._description || ''; //$NON-NLS-1$
	},
	
	getBasePresentationUri: function() {
		return ""; //$NON-NLS-1$
	}
	
});

}());
