/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/


(function()  {
dojo.provide("com.ibm.relm.explorer.web.explorer.matrix.CreateMatrixWizard"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("jazz.ui.Wizard"); //$NON-NLS-1$
dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.explorer.matrix.SetAxisesStep"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.matrix.SelectRelationStep"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "CreateMatrixWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$

//var wizardStepHeader = jazz.ui.wizard.WizardStepHeader;
//var wizardStep = jazz.ui.wizard.WizardStep;

dojo.declare("com.ibm.relm.explorer.web.explorer.matrix.CreateMatrixWizard",  //$NON-NLS-1$
		[jazz.ui.Wizard, dijit._Widget, dijit._Templated] ,{
	
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web",  "explorer/matrix/templates/CreateMatrixWizard.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,
	
	queries: null,
		
	step1: null,
	step2: null,

	postMixInProperties: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "CreateMatrixWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.inherited(arguments);
	},
	
	postCreate: function() {

		// Step 1
		this.step1 = new com.ibm.relm.explorer.web.explorer.matrix.SetAxisesStep({
			wizard: this,
			queries: this.queries,
			stepTitle: this.messages.setAxisesStep
		});
		this.addStep(this.step1);
		// Step 2
		this.step2 = new com.ibm.relm.explorer.web.explorer.matrix.SelectRelationStep({
			wizard: this,
			stepTitle: this.messages.selectRelationStep
		});
		this.addStep(this.step2);
		
		this.selectStep(1);

	},
	
	destroy: function(){
		this.step1.destroy();
		this.step2.destroy();
		this.inherited(arguments);
	},
	
	getMatrixInfo: function(){
		return {
			rowVar: this.step1.getRowVar(),
			rowQueryURI: this.step1.getRowQueryURI(),
			rowValues: this.step1.getRowValues(),
			columnVar: this.step1.getColumnVar(),
			columnQueryURI: this.step1.getColumnQueryURI(),
			columnValues: this.step1.getColumnValues(),
			relations: this.step2.getRelations()
		};
	}
	
});

}) ();