/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

(function()  {
dojo.provide("com.ibm.relm.explorer.web.explorer.matrix.EditRelationshipDialog"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.Textarea"); //$NON-NLS-1$

dojo.require('jazz.app.ua.TextHoverHelp'); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$
dojo.require("dijit.form.CheckBox"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog");//$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.EditorUtils");  //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "CreateMatrixWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.relm.explorer.web.explorer.matrix.EditRelationshipDialog",  //$NON-NLS-1$
		[dijit._Widget, dijit._Templated],
{
	widgetsInTemplate: true, 
	templateString: 
		"<div class='com-ibm-relm-explorer-web-matrix-dialog'>" +//$NON-NLS-1$
		"<table width='100%' cellspacing='7'>" +//$NON-NLS-1$
		"	<tr><td>${messages.relationName}</td><td><input type='text' dojoAttachPoint='relationNameField' style='width:100%'></input></tr>" +//$NON-NLS-1$
		"	<tr><td valign='top'>${messages.propertyPath}</td><td><textarea rows='3' dojoType='dijit.form.Textarea' dojoAttachPoint='propertyPathField' style='width: 100%;'></textarea>" +//$NON-NLS-1$
		"	<a dojoAttachEvent='onclick:edit' style='cursor:pointer'>${messages.appendPredefinedLinkTypes}</a></tr>" +//$NON-NLS-1$
		"</table>" +//$NON-NLS-1$
		"</div>",//$NON-NLS-1$
		
	postMixInProperties: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "CreateMatrixWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	postCreate: function(){
		this.inherited(arguments);
		if(this.relationName){
			this.relationNameField.value = this.relationName;
		}
		if(this.propertyPath){
			this.propertyPathField.set("value", this.propertyPath);//$NON-NLS-1$		
		}
	},
	
	getValues: function(){
		return {
			relationName : this.relationNameField.value,
			propertyPath: this.propertyPathField.get('value')//$NON-NLS-1$
		};
	},
	
	edit: function(){
		this._openAddPropertyPathDialog();
	},

	_fillPredefinedRelationshipTypes: function(){
		// fill relation selection box
		this.relationSelect.options.length = 0;
		var self = this;
		jazz.client.xhrGet({
			url: com.ibm.relm.explorer.web.ui.matrixServiceUri,
			preventCache: true,
			handleAs: "json", //$NON-NLS-1$
			load: function(result){
				dojo.forEach(result, function(rel, i){
					self.relationSelect.options[i] = new Option(rel.name, rel.propertyPath);
				}, self);
			}
		});

		this.connect(this.relationSelect, "onchange", function(){//$NON-NLS-1$
		});				
	},
	
	_openAddPropertyPathDialog: function(){
		var contentWidget = new com.ibm.relm.explorer.web.explorer.matrix._AddPredefinedLinkTypesDialogContent();
		var self = this;
		new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
			dialogContent: contentWidget,
			primaryTitle: this.messages.appendPredefinedLinkTypesTitle,
			onOpen: function(){
				dijit.focus(contentWidget.relationSelect);
			},
			onOK: function(values){
				var select = contentWidget.relationSelect;
				var v = "";//$NON-NLS-1$
				for (var i = 0; i < select.options.length; i++) {
					var option = select.options[i];
				    if (option.selected) {
			    		v = v ? v + "/" + option.value : option.value;//$NON-NLS-1$
			        }
				}
				if(v){
					var current = self.propertyPathField.get("value") || ""; //$NON-NLS-1$//$NON-NLS-2$
					self.propertyPathField.set("value", current.length > 0 ? current + "/" + v : v);//$NON-NLS-1$//$NON-NLS-2$
				}
			}
		});
	}	
});

dojo.declare("com.ibm.relm.explorer.web.explorer.matrix._AddPredefinedLinkTypesDialogContent",  //$NON-NLS-1$
		[dijit._Widget, dijit._Templated],
{
	templateString: 
		"<div><select dojoAttachPoint='relationSelect' style='width: 100%;' size='10' multiple></select>",//$NON-NLS-1$
		
	postCreate: function(){
		this.inherited(arguments);
		this.queryMessages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._fillLinkTypes();
	},
		
	_fillLinkTypes: function(){
		// fill relation selection box
		this.relationSelect.options.length = 0;
		this.relationSelect.disabled = true;
		this.relationSelect.options[0] = new Option(this.queryMessages.loading, "");//$NON-NLS-1$
		com.ibm.relm.explorer.web.ui.internal.editor.EditorUtils.getConnectionTypeItems(dojo.hitch(this, function(linkTypes){
			this.relationSelect.options.length = 0;
			dojo.forEach(linkTypes, function(rel, i){
				this.relationSelect.options[i] = new Option(rel.name, rel.value);
			}, this);
			this.relationSelect.disabled = false;
		}));
		this.connect(this.relationSelect, "onchange", function(){//$NON-NLS-1$
		});
	}
		
});


}) ();