/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.explorer.page.MoveQuery"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.explorer.page.ExplorerClient"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.common.AbstractMoveCopyDialog"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "ExplorerMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() { // module container

var ExplorerClient = com.ibm.relm.explorer.web.explorer.page.ExplorerClient;

/**
 * Widget to move a report or folder
 */
var MoveQuery = dojo.declare("com.ibm.relm.explorer.web.explorer.page.MoveQuery", com.ibm.relm.explorer.web.ui.internal.common.AbstractMoveCopyDialog,  { //$NON-NLS-1$
	postMixInProperties: function(){
		this.inherited(arguments);

		var messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		var errorMessages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "ExplorerMessages"); //$NON-NLS-1$ //$NON-NLS-2$

		this.label_serviceError = errorMessages.invokeServiceError;
		this.label_myResources = messages.myQueries;
		this.label_sharedResources = messages.sharedQueries;
		this.label_permissionError = messages.noPermissionToCreateView;
		
		this.serviceClient = ExplorerClient;
		this.argsNameForServiceCall = "queryURIs";//$NON-NLS-1$
	}
});

MoveQuery.CSH_NEW_QUERY_EDITOR = "com.ibm.jazz.reports.web.cshelp.new_query_editor"; //$NON-NLS-1$

})();