/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012,2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.explorer.page.QueryList"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.common.ListPage"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.explorer.page.ExplorerClient"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.MoveQuery"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.MetaNav"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.matrix.CreateMatrixWizard"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.util');//$NON-NLS-1$
dojo.require("com.ibm.relm.le.leeditor.page.LifecycleElementListTable"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryListMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
var JazzUIWorkbench = net.jazz.ajax.ui.PlatformUI.getWorkbench();
var ROWTYPE_FOLDER = "folder"; //$NON-NLS-1$
var AE_LIST_MODE_EXEC = "execute"; //$NON-NLS-1$
var ServiceResponseHandler = com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler;
var QUERY_SERVICE_URL = com.ibm.relm.explorer.web.ui.queryServiceUri;

dojo.declare("com.ibm.relm.explorer.web.explorer.page.QueryList", //$NON-NLS-1$
		com.ibm.relm.explorer.web.ui.internal.common.ListPage,
{
	_collapseIcon : dojo.moduleUrl("com.ibm.relm.explorer.web", "explorer/images/collapse.gif"), //$NON-NLS-1$ //$NON-NLS-2$
	_expandIcon : dojo.moduleUrl("com.ibm.relm.explorer.web", "explorer/images/expand.gif"), //$NON-NLS-1$ //$NON-NLS-2$
	_resourceIcon : dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/query.gif"), //$NON-NLS-1$ //$NON-NLS-2$

	_serviceURL : QUERY_SERVICE_URL,
	_serviceClient : com.ibm.relm.explorer.web.explorer.page.ExplorerClient,
	_moveCopyDialog : com.ibm.relm.explorer.web.explorer.page.MoveQuery,

	actionPrefix : "#action=com.ibm.relm.explorer.web.showQueryList", //$NON-NLS-1$
	selectAction: "#action=com.ibm.relm.explorer.web.showExplorer&queryUri=", //$NON-NLS-1$
	editFolderAction:"#action=com.ibm.relm.explorer.web.editQueryFolder", //$NON-NLS-1$
	createQueryAction: "#action=com.ibm.relm.explorer.web.showExplorer&mode=create", //$NON-NLS-1$

	ROWTYPE_RESOURCE : "query", //$NON-NLS-1$
	_folderType: "query", //$NON-NLS-1$

	aeResourcesTab: null, //Tag for artifact element
	_label_AEResources: "",//$NON-NLS-1$
	_widgets: [],

	postMixInProperties: function() {
		this.inherited(arguments);
		var messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryListMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._label_MyResources = messages.PrivateQueries;
		this._label_SharedResources = messages.SharedQueries;
		this._label_AEResources = messages.AEQueries;
		this._label_createResource = messages.createQuery;
		this._label_deleteResource = messages.deleteQueryMsg;
		this._label_deleteResources = messages.deleteQueriesMsg;
		this._label_moveResource = messages.moveQuery;
		this._label_moveResources = messages.moveQueries;

		this._messages = messages;
		this.isAE = (this.scope == "ae") ? true : false; //$NON-NLS-1$
	},
	postCreate: function(){
		this.inherited(arguments);
		this.aeResourcesTab = new dijit.form.ToggleButton({label: this._label_AEResources});
		this.connect(this.aeResourcesTab, "onClick", "onClickAEResources"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.place(this.aeResourcesTab.domNode, this.titleArea);

		this._aeTable = new com.ibm.relm.le.leeditor.page.LifecycleElementListTable({
			mode: AE_LIST_MODE_EXEC,
			_filterArea: this._filterArea,
			showMessage: dojo.hitch(this, this.showMessage),
			hideMessage: dojo.hitch(this, this.hideMessage),
			_updateActions: dojo.hitch(this, this._updateActions)
		});
		this._resultsArea.appendChild(this._aeTable.domNode);
		this._aeTable.domNode.style.display = "none"; //$NON-NLS-1$
		this._aeFilterBox = this._aeTable._filterBox;
		this._aeFilterBox.domNode.style.display = "none"; //$NON-NLS-1$
	},

	_addToolbarButtons: function(toolbar){
		var messages = this._messages;
		toolbar.addButton(this, this._generateMatrix, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/matrix.gif"), label: messages.generateMatrix, requiresSelection:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._exportQueries, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/export_co.gif"), label: messages.exportQueries, requiresSelection:true}); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	_setCSHelp: function(){
		if(this.isAE) {
			this.metanav.createContextSensitiveHelp("com.ibm.relm.explorer.web.page_AEQueries001"); //$NON-NLS-1$
		} else if(this.shared) {
			this.metanav.createContextSensitiveHelp("com.ibm.relm.explorer.web.page_SharedQueries001"); //$NON-NLS-1$
		} else {
			this.metanav.createContextSensitiveHelp("com.ibm.relm.explorer.web.page_MyQueries001"); //$NON-NLS-1$		
		}
	},

	_deleteItems: function()
	{
		var messages = this._messages;
		var items = this._getCheckedItems(true);
		if (items.length <= 0)
			return;
			
		var resourceItemIDs = [];
		var folderItemIDs = [];

		for (var i = 0; i < items.length; i++)
		{
			var item = items[i];
			if (item.rowType == this.ROWTYPE_RESOURCE)
				resourceItemIDs.push(item.id);
			else if (item.rowType == ROWTYPE_FOLDER)
				folderItemIDs.push(item.id);
		}

		var confirmMsg = ""; //$NON-NLS-1$
		if (resourceItemIDs.length > 0 && folderItemIDs.length > 0)
			confirmMsg = dojo.string.substitute(messages.confirmDelQueriesAndFolders, [resourceItemIDs.length, folderItemIDs.length]);
		else if (resourceItemIDs.length > 0)
			confirmMsg = dojo.string.substitute(messages.confirmDelQueries, [resourceItemIDs.length]);
		else
			confirmMsg = dojo.string.substitute(messages.confirmDelFolders, [folderItemIDs.length]);
		
		if (!confirm(confirmMsg)) {
			return;
		}
		
		if(! this._confirmToDelete(folderItemIDs, resourceItemIDs)){
			return;
		}

		this._deletedTypes = 0;
		//Delete the queries if any
		if (resourceItemIDs.length > 0) 
		{
			this._deletedTypes++;
			var args = {
					queryURIs: resourceItemIDs
			};
			var responseHandler = new ServiceResponseHandler(this, "_resourcesDeleted", "_remoteError"); //$NON-NLS-1$ //$NON-NLS-2$
			this._serviceClient.deleteResourceDescriptors(responseHandler, args);
			
			for(var i = 0; i < resourceItemIDs.length; i++) {
				this._closeEditorInput(resourceItemIDs[i]);
			}
		}
		
		if (folderItemIDs.length > 0) 
		{
			this._deletedTypes++;
			var folderArgs = {
				folderUUIDs: folderItemIDs
			};
			//Delete the folders
			var responseHandler = new ServiceResponseHandler(this, "_resourcesDeleted", "_remoteError"); //$NON-NLS-1$ //$NON-NLS-2$
			this._serviceClient.postDeleteFolderDescriptors(responseHandler, folderArgs);
		}
	},

	_newResource: function() {
		window.location.href = this.createQueryAction;
	},

	_editResource: function(r)
	{
    	window.location.href = "#action=com.ibm.relm.explorer.web.showExplorer&edit=true&queryUri="+r.name.value+"&queryName="+encodeURIComponent(r.name.label); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_deleteResource: function(r) {
		var messages = this._messages;
		if (!confirm(dojo.string.substitute(messages.confirmDelQuery, [r.name.label]))) {
			return;
		}

		var args = {
				queryURI: r.name.value
		};
		var responseHandler = new ServiceResponseHandler(
				this,
				"_resourceDeleted", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		var rowNode = this.getTr(r.name.value); 
		if(rowNode){
			this._pendingDeleteResourceNode = rowNode;
		}
		this._serviceClient.deleteResourceDescriptor(responseHandler, args);
		this._closeEditorInput(r.name.value);
		this._rootFolder = this._filterDeletedResource(r,this._rootFolder);
	},
	
	_closeEditorInput: function(queryUri) {
		var editorInput = this.page.getEditorInput(queryUri);
		if(editorInput) {
			this.page.getPageHelper().closeEditorInput(editorInput, false, true);
		}
		
	},

	_generateMatrix: function(){
		var items = this._getCheckedItems(false);
		if (items.length <= 0)
			return;			
		var queries = [];
		for (var i = 0; i < items.length; i++) {
			var item = items[i];
			if (item.rowType == this.ROWTYPE_RESOURCE)
				queries.push(item);
		}

		if (queries.length > 0)	{
			var wizard = new com.ibm.relm.explorer.web.explorer.matrix.CreateMatrixWizard({
				permissions: this.permissions,
				queries: queries,
				primaryTitle: this._messages.generateMatrix,
				width: "70%", //$NON-NLS-1$
				customProcessFinish: function(){
					var matrixInfo = this.container.getMatrixInfo();
					
					var url = QUERY_SERVICE_URL + "?method=generateMatrix"; //$NON-NLS-1$
					//
					var form = dojo.create("form", {"name": "generateMatrix", "action":url, "method":'post', "target":"_new"}, this.domNode); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$
					dojo.create("input", {"type":"hidden", "name":"rowVar", "value": matrixInfo.rowVar}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					dojo.create("input", {"type":"hidden", "name":"rowQueryURI", "value": matrixInfo.rowQueryURI}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					dojo.forEach(matrixInfo.rowValues.uris, function(v){
						dojo.create("input", {"type":"hidden", "name":"rowValues", "value": v}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					});
					dojo.forEach(matrixInfo.rowValues.titles||[], function(t){
						dojo.create("input", {"type":"hidden", "name":"rowTitles", "value": t}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					});
					dojo.create("input", {"type":"hidden", "name":"columnVar", "value": matrixInfo.columnVar}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					dojo.create("input", {"type":"hidden", "name":"columnQueryURI", "value": matrixInfo.columnQueryURI}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					dojo.forEach(matrixInfo.columnValues.uris, function(v){
						dojo.create("input", {"type":"hidden", "name":"columnValues", "value": v}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					});
					dojo.forEach(matrixInfo.columnValues.titles||[], function(t){
						dojo.create("input", {"type":"hidden", "name":"columnTitles", "value": t}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					});
					dojo.create("input", {"type":"hidden", "name":"relation", "value": dojo.toJson(matrixInfo.relations)}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					form.submit();
					this.domNode.removeChild(form);
				}
			});
			wizard.startup();
		}
	},

	_exportQueries: function(){
		var items = this._getCheckedItems(false);
		if (items.length <= 0)
			return;
			
		var resourceItemIDs = [];
		for (var i = 0; i < items.length; i++) {
			var item = items[i];
			if (item.rowType === this.ROWTYPE_RESOURCE) {
				resourceItemIDs.push(item.id);
			}
		}

		if (resourceItemIDs.length > 0)	{
			com.ibm.relm.common.web.ui.util.downloadFile(
				this._serviceURL + "?method=exportQueries", "queryUris", resourceItemIDs, true); //$NON-NLS-1$ //$NON-NLS-2$
		}
	},

	onResourceSelected: function(target){
		this._previousSelectedResourceUri = target._uri_;
		window.location.href = this.selectAction + target._uri_ + "&queryName="+encodeURIComponent(target._name_) + "&parameterized=" + target.resource.parameterized; //$NON-NLS-1$ //$NON-NLS-2$
	},

	/*
	 * Override for AEQueries Tab
	 */
	getTitleString: function(){
		if(this.aeResourcesTab.checked){
			return this.aeResourcesTab.label;
		}else{
			return this.inherited(arguments);
		}
	},
	_populateHeader: function(){
		this.inherited(arguments);
		var title = this.isAE ? this._label_AEResources : this.shared ? this._label_SharedResources : this._label_MyResources;
		this.metanav.setTitle(jazz.util.html.escape(title));
		if(this.isAe) this._setCSHelp();
	},
	onClickAEResources: function(){
		window.location = this.actionPrefix + "&scope=ae"; //$NON-NLS-1$
		JazzUIWorkbench.setTitle(this._label_AEResources);
		this.refreshTabs();
	},
	refreshTabs:function() {
		this.aeResourcesTab.set('checked', this.isAE); //$NON-NLS-1$
		if(this.isAE){
			this.myResourcesTab.set('checked', false); //$NON-NLS-1$
			this.sharedResourcesTab.set('checked', false); //$NON-NLS-1$
			this._aeTable.domNode.style.display = ""; //$NON-NLS-1$
			this._table.domNode.style.display = "none"; //$NON-NLS-1$
			this._aeFilterBox.domNode.style.display = ""; //$NON-NLS-1$
			this._filterBox.domNode.style.display = "none"; //$NON-NLS-1$
		}else{
			this.inherited(arguments);
			this._aeTable.domNode.style.display = "none"; //$NON-NLS-1$
			this._table.domNode.style.display = ""; //$NON-NLS-1$
			this._aeFilterBox.domNode.style.display = "none"; //$NON-NLS-1$
			this._filterBox.domNode.style.display = ""; //$NON-NLS-1$
		}
	},
	_updateActions: function(){
		if(this.isAE){
			this.metanav._toolbar.domNode.style.display = "none"; //$NON-NLS-1$
		}else{
			this.metanav._toolbar.domNode.style.display = ""; //$NON-NLS-1$
			this.inherited(arguments);
		}
	},
	onShown: function(){
		this.inherited(arguments);
		if(this.isAE){
			JazzUIWorkbench.setTitle(this._label_AEResources);
		}
	},

	showMessage: function(message){
		this.messageArea.showMessage(message);
	},
	hideMessage: function(){
		this.messageArea.hideMessage();
	}
});
})();
