/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.Editor"); //$NON-NLS-1$

//dojo.require("com.ibm.relm.explorer.web.base.internal.i18n"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.canvas.Viewer"); //$NON-NLS-1$
dojo.require("jazz.core.loader"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.helper.baseHelper"); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.helper.connectionHelper'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.helper.dropHelper'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.helper.focusFrameHelper'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.helper.styleHelper'); //$NON-NLS-1$


dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.tool.DefaultSelectionTool'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.action.CommonActions'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.tool.ResizeTracker'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.tool.DragGhostMoveTracker'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.tool.DefaultSelectionTool'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.command.CommandProcessor'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.command.CommandProvider'); //$NON-NLS-1$

dojo.require('com.ibm.relm.explorer.web.ui.internal.view.extensions.connections'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.ui.internal.view.extensions.containers'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.ui.internal.view.extensions.nodes'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.ui.internal.view.extensions.queryCache'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.ui.internal.view.extensions.viewLoader'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.ui.internal.view.extensions.xmlGenerator'); //$NON-NLS-1$

dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.componentInfo'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.connectionEndpoints'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.focus'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.jsonGenerator'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.jsonLoader'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.knob'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.paletteSupport'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.preferenceSupport'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.propertySupport'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.base.internal.canvas.extension.selectionHandles'); //$NON-NLS-1$

dojo.require('com.ibm.relm.explorer.web.ui.internal.view.nodes.ResourceNode'); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.ui.view.nodes.ResourceNode'); //$NON-NLS-1$


(function(){

	
dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.canvas.Editor", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.canvas.Viewer,
{
	componentInfo: null, // ComponentInfo object
	freeLayoutMode: true,

	actionInvokedFilter: "*", // id, class name, or "*" //$NON-NLS-1$
	paletteSelectionChangedFilter: "*", // id, class name, or "*" //$NON-NLS-1$
	propertyChangedFilter: "*", // id, class name, or "*" //$NON-NLS-1$

	commonHelpers: [], // array of class names
	editorHelpers: ["baseHelper","dropHelper"], //$NON-NLS-1$ //$NON-NLS-2$
	hlpPrefix: "com.ibm.relm.explorer.web.base.internal.helper.", // the default helper prefix //$NON-NLS-1$
	actionClasses: ["com.ibm.relm.explorer.web.base.internal.canvas.action.CommonActions"], // array of class names //$NON-NLS-1$
	resizeTrackerClass: "com.ibm.relm.explorer.web.base.internal.canvas.tool.ResizeTracker", // class name //$NON-NLS-1$
	dragMoveTrackerClass: "com.ibm.relm.explorer.web.base.internal.canvas.tool.DragGhostMoveTracker", // class name //$NON-NLS-1$

	defaultTool: "com.ibm.relm.explorer.web.base.internal.canvas.tool.DefaultSelectionTool", //$NON-NLS-1$
	defaultCommandStack: "com.ibm.relm.explorer.web.base.internal.canvas.command.CommandProcessor", //$NON-NLS-1$

	_commandStackObj: null,
	_defaultToolObj: null,
	_activeToolObj: null,

	_designTimeMethods: null,
	_helperLoaded: {},
	_componentLoaded: {},
	
	_mouseEvent: null,

	events: [
		"ContextMenu", //$NON-NLS-1$
		"MouseDown", "MouseUp", "MouseMove", "MouseOver", "MouseOut", "MouseEnter", "MouseLeave", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$
		"Click", "DblClick", "KeyDown", "KeyUp", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		"DragStart", "DragOver", "DragMove", "DragEnd", "DropStart", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
		"Drop", "DropEnd", "DragOut" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
	],

	postMixInProperties: function(){
		dojo.forEach([this.commonHelpers, this.editorHelpers], function(helpers) {
			for(var i = 0; i < helpers.length; i++){
				if(helpers[i].indexOf('.') == -1){ //$NON-NLS-1$
					helpers[i] = this.hlpPrefix + helpers[i];
				}
			}
			var helpersCopy = helpers.slice(0);
			jazz.core.loader.batch_load_async(helpersCopy, function() {
				// ignore callback
			});
		}, this);

		this.inherited(arguments);
	},

	postCreate: function(){
		if(!dojo.isIE){
			this.domNode.tabIndex = "0"; // to accept key events //$NON-NLS-1$
		}

		jazz.core.loader.batch_load_async([this.defaultTool, this.dragMoveTrackerClass, this.defaultCommandStack], function() {});
		this.loadCommonHelpers();

		var self = this;
		// setup event handlers
		for(var i = 0, len = this.events.length; i < len; i++){
			var eventName = this.events[i];
			this["handle"+eventName] = function(eventName){ //$NON-NLS-1$
				return function(e){
					if(this.getActiveTool()["handle"+eventName]){ //$NON-NLS-1$
						this.getActiveTool()["handle"+eventName](e); //$NON-NLS-1$
						
						if (e.type == "mousemove") { //$NON-NLS-1$
							self._mouseEvent = e;
						}
					}
				};
			}(eventName);
			if(eventName.indexOf("Dr") !== 0){ // skip the DnD-related events //$NON-NLS-1$
				this.connect(this.domNode, "on"+eventName.toLowerCase(), "handle"+eventName); //$NON-NLS-1$ //$NON-NLS-2$
			}
		}

		this.subscribe("btp:ActionInvoked", "dispatchCommand"); //$NON-NLS-1$ //$NON-NLS-2$

		var initializedObj = this._initializedHelperObjs = [];
		for (var j = 0; j < this.editorHelpers.length; j++) {
			var editorModule = this.editorHelpers[j];
			jazz.core.loader.load_async(editorModule, function() {
				var helperObj = dojo.getObject(editorModule);
				dojo.extend(dojo.getObject(self.declaredClass), helperObj);
				if (helperObj.initialize) {
					helperObj.initialize.call(self);
					initializedObj.push(helperObj);
				}
			});
		}

		this.inherited(arguments);
	},
	
	destroy: function(){
		var self = this;
		dojo.forEach(this._initializedHelperObjs, function(helperObj) {
			if (helperObj.cleanup) {
				helperObj.cleanup.call(self);
			}			
		});
		this._initializedHelperObjs = null;

		if(this._commandStackObj){
			this._commandStackObj.clear();
		}

		_designTimeMethods = null;
		_defaultToolObj = null;
		_activeToolObj = null;

		this.inherited(arguments);
	},

	dispatchCommand: function(message){
		if(!this.matchFilter(message, this.actionInvokedFilter)){
			return; // filter out the message
		}
		// fillter out the message from different editor
		var srcEditor = message.editor ? message.editor : ((message.src && message.src.hlp_getEditor) ? message.src.hlp_getEditor() : null);
		if (srcEditor && srcEditor != this)
			return;
		if(!this.isShowing(this)){ return; }

		
		if(!this._actionLoaded) {
			var actionClassesCopy = this.actionClasses.slice(0);
			var self = this;

			jazz.core.loader.batch_load_async(actionClassesCopy, function() {
				if(!self._actionLoaded){
					self._actionLoaded = true;
					for(var i = 0, len = self.actionClasses.length; i < len; i++){
						var props = dojo.getObject(self.actionClasses[i]);
						dojo.mixin(self, props);
					}
				}
				if(!self[message.command]){ return; }
				self[message.command](message);
			});
		} else {
			if(!this[message.command]){ return; }
			this[message.command](message);
		}
	},

	loadComponents: function(/*Array*/list){
		// summary:
		//		Loads component classes and their helpers.
		// list:
		//		An array of info ids.
		// description:
		//		Load may be performed asynchronously. That is, you should
		//		not use the loaded components immediately after loadComponents().
		//		Instead, you should use them in a dojo.addOnLoad call.
		//		If list is not specified, find info ids from this.domNode.
		if(!list){
			list = dojo.map(dojo.query('[dojoType]', this.domNode), function(node){ //$NON-NLS-1$
				return  node.getAttribute("componentInfoId"); //$NON-NLS-1$
			});
		}
		var classes = {};
		for(var i = 0, len = list.length; i < len; i++){
			var infoId = list[i];
			if(infoId.indexOf(".") != -1){ console.warn("Viewer#loadComponents: infoId is required: "+infoId); } // TODO:assert //$NON-NLS-1$ //$NON-NLS-2$
			if(this._componentLoaded[infoId]){ continue; }
			this._componentLoaded[infoId] = true;
			var info = this.hlp_getComponentInfo(infoId);
			if(!info){ continue; }

			// component
			classes[info.className] = true;

			// dependent modules
			if(info.dependencies){
				for(var j = 0, len2 = info.dependencies.length; j < len2; j++){
					classes[info.dependencies[j]] = true;
				}
			}

			// modules specified in the attributes
			if(info.attributes){
				var attrs = info.attributes;
				for(var k = 0, len3 = attrs.length; k < len3; k++){
					if(attrs[k].name.indexOf("Class") != -1){ //$NON-NLS-1$
						classes[attrs[k].value] = true;
					}
				}
			}

			this.loadComponentHelpers(infoId);
		}

		var classNames = [];
		for(var className in classes){
			classNames.push(className);
		}

		var self = this;
		jazz.core.loader.batch_load_async(classNames, function() {
			self.setupComponentHelpers(list);
		});
	},

	// load component specific helpers
	loadComponentHelpers: function(infoId){
		if(infoId.indexOf(".") != -1){console.warn("Editor#loadComponentHelpers: infoId is required: "+infoId);} // TODO:assert //$NON-NLS-1$ //$NON-NLS-2$
		if(this._helperLoaded[infoId]){ return; }
		var info = this.hlp_getComponentInfo(infoId);
		if(info && info.helpers){
			for(var i = 0, len = info.helpers.length; i < len; i++){
				jazz.core.loader.load_async(info.helpers[i], function() {});
			}
		}
	},

	loadCommonHelpers: function(){
		if(this._commonHelperLoaded){ return; }
		var arr = this.commonHelpers.concat(this.editorHelpers);
		for(var i = 0; i < arr.length; i++){
			var helper = arr[i];
			jazz.core.loader.load_async(helper, function() {});
		}
		this._commonHelperLoaded = true;
	},

	// add component specific helpers to every component
	setupComponentHelpers: function(/*Array*/list){
		for(var i = 0, len = list.length; i < len; i++){
			var infoId = list[i];
			if(infoId.indexOf(".") != -1){console.warn("Editor#setupComponentHelpers: infoId is required: "+infoId);} // TODO:assert //$NON-NLS-1$ //$NON-NLS-2$
			var info = this.hlp_getComponentInfo(infoId);
			if(!info){ continue; }
			var className = info.className;
			if(this._helperLoaded[className]){ return; }
			this._helperLoaded[className] = true;
			var impl = dojo.getObject(className);
			if(info.helpers){ // add helpers to the widget prototype
				for(var j = 0, len2 = info.helpers.length; j < len2; j++){
					var obj = dojo.getObject(info.helpers[j]);
					for(var k in obj){ if(dojo.isFunction(obj[k])){obj[k].nom = k;} }
					dojo.extend(impl, obj);
				}
			}
		}
	},

	createComponent: function(/*String*/infoId, /*Object?*/props){
		if(infoId.indexOf(".") != -1){console.warn("Editor#createComponent: infoId is required: "+infoId);} // TODO:assert //$NON-NLS-1$ //$NON-NLS-2$
		var info = this.hlp_getComponentInfo(infoId);
		var className = info ? info.className : infoId;
		if(!className){
			console.warn("Editor#createComponent: class name is not specified"); //$NON-NLS-1$
			return null;		
		}
		var ctor = dojo.getObject(className);
		if(!ctor){
			ctor = dojo.getObject(className);
		}
		if (!ctor){
			console.warn("Editor#createComponent: "+className+" not found"); //$NON-NLS-1$ //$NON-NLS-2$
			ctor = dojo.getObject(className);
			// XXX: should this just throw an error?
			return null;
		}

		// set default attribute values if any
		if(!props){ props = {}; }
		var attrs = info && info.attributes;
		for(var i = 0, len = attrs ? attrs.length : 0; i < len; i++){
			var attr = attrs[i];
			if(props[attr.name]){
				continue; // respect the value of props
			}
			if(typeof(attr.value) != "undefined"){ //$NON-NLS-1$
				var type = typeof(ctor.prototype[attr.name]);
				if(type == "number"){ //$NON-NLS-1$
					props[attr.name] = attr.value - 0;
				}else if(type == "boolean"){ //$NON-NLS-1$
					props[attr.name] = (attr.value == "true"); //$NON-NLS-1$
				}else if(!attr.value){
					props[attr.name] = ""; //$NON-NLS-1$
				}else{
					// get localized string
/*
					var s = com.ibm.relm.explorer.web.base.internal.i18n.gets(attr.value, "component_"+name.replace(/\./g, "_")+"_"); // Ex. "component_com_ibm_button_Push Button"
					if(s == attr.value){
						s = com.ibm.relm.explorer.web.base.internal.i18n.gets(attr.value, "component_"); // Ex. "component_Push Button"
					}
					props[attr.name] = s;

*/
					props[attr.name] = attr.value;
				}
			}
		}

		var widget = new ctor(props);
		widget.componentInfoId = infoId;

		this.setupWidgetForEdit(widget);
		widget.hlp_setStyles(props.__style, false);
//x		if(props.__style){
//x			for(var property in props.__style){
//x				widget.hlp_setStyle(property, props.__style[property]);
//x			}
//x		}

		return widget;
	},

	callHelperInitializers: function(widget){
		var info = widget.hlp_getComponentInfo();
		var helpers = this.commonHelpers || [];
		if(info.helpers){
			helpers = helpers.concat(info.helpers);
		}
		dojo.forEach(helpers, function(helper){
			var obj = dojo.getObject(helper);
			if(obj.initialize){ obj.initialize.call(widget); }
		});
	},

	setupWidgetsRecursively: function(widget){
		if(widget){
			this.setupWidgetForEdit(widget);
		}else{
			widget = this;
		}
		dojo.forEach(widget.getChildren(), function(w){
			this.setupWidgetsRecursively(w);
		}, this);
	},

	setupWidgetForEdit: function(widget){
		this.weakMixin(widget, dijit._Contained.prototype);
		this.mixinDesignTimeObjs(widget);
		widget.hlp_setEditArea(this);
		widget.hlp_initLiveWidget(this);
		this.callHelperInitializers(widget);
	},

	getDesignTimeObjs: function(){
		if(!this._designTimeMethods){
			this._designTimeMethods = {};
			dojo.mixin(this._designTimeMethods, com.ibm.relm.explorer.web.base.internal.helper.baseHelper);
			for(var i = 0; i < this.commonHelpers.length; i++){
				var helper = this.commonHelpers[i];
				dojo.mixin(this._designTimeMethods, dojo.getObject(helper));
			}
		}
		return this._designTimeMethods;
	},

	mixinDesignTimeObjs: function(widget){
		var cls = dojo.getObject(widget.declaredClass);
		var mp = cls.prototype; // my prototype
		var sp = cls.superclass; // superclass's prototype
		var objs = this.getDesignTimeObjs();
		for(var x in objs){
			if(x == "destroy"){ //$NON-NLS-1$
				// if the helper object has the destroy method,
				// it should be called before the widget.destroy() is called.
				if(!widget.__destructors){
					widget.__destructors = [];
				}
				widget.__destructors.push(objs.destroy);
			}else if(!widget[x] || (mp[x] && mp[x] == sp[x])){
				// x doesn't exist or x is an inherited property.
				// If the widget has x, do not mix-in the LiveWidget's x.
				// But if x is an inherited property such as addChild, override it with LiveWidget's addChild.
				// Of course, if the widget has its own addChild, it should not be overridden.
				widget[x] = objs[x];
			}
		}
		if(widget.__destructors){
			if(widget.destroy){
				widget.__destructors.push(widget.destroy);
			}
			widget.destroy = function widget_destroy(){
				alert("destroy"); //$NON-NLS-1$
				for(var i = 0, len = widget.__destructors.length; i < len; i++){
					widget.__destructors[i]();
				}
			};
		}
	},

	weakMixin: function(/*Object*/obj, /*Object*/props){
		// summary:
		//		Copies non-existing properties and methods of props to obj.
		var o = {};
		for(var x in props){
			if((o[x] === undefined || o[x] != props[x]) &&
				obj[x] === undefined){
				if(dojo.isFunction(obj[x] = props[x])){obj[x].nom = x;}
			}
		}
		return obj;
	},

	matchFilter: function(message, filter){
		if(!filter){ return false; }
		if(filter == "*"){ return true; } //$NON-NLS-1$
		var arr = filter.split(","); //$NON-NLS-1$
		var id = message.src.domNode && message.src.domNode.getAttribute("widgetId"); //$NON-NLS-1$
		var type = message.src.declaredClass;
		for(var i = 0, len = arr.length; i < len; i++){
			if(arr[i] == id || arr[i] == type){
				return true;
			}
		}
		return false;
	},

	firePropertyChanged: function(propName, oldValue, newValue, /*Object?*/hint){
		var message = {
			type: "PropertyChangedNotification", //$NON-NLS-1$
			src: this,
			propName: propName,
			oldValue: oldValue,
			newValue: newValue,
			hint: hint
		};
		dojo.publish("btp:PropertyChanged", [message]); //$NON-NLS-1$
	},

	fireSelectionChanged: function(selection){ // cf. StructuredViewer
		var message = {
			type: "SelectionChangedNotification", //$NON-NLS-1$
			src: this,
			selection: selection
		};
		dojo.publish("btp:SelectionChanged", [message]); //$NON-NLS-1$
	},

	setActiveTool: function(tool){
		if(this._activeToolObj){
			this._activeToolObj.deactivate();
		}
		this._activeToolObj = tool;
		this._activeToolObj.setEditor(this);
		this._activeToolObj.activate();
	},
	
	getActiveTool: function(){
		if(!this._activeToolObj){
			this.setActiveTool(this.getDefaultTool());
		}
		return this._activeToolObj;
	},
	
	getDefaultTool: function(){
		if(!this._defaultToolObj){
			var cls = dojo.getObject(this.defaultTool);
			this._defaultToolObj = new cls();
		}
		return this._defaultToolObj;
	},

	loadDefaultTool: function(){
		this.setActiveTool(this.getDefaultTool());
	},

	XXsetPaletteViewer: function(paletteViewer){
		this._paletteViewer = paletteViewer;
		dojo.connect(paletteViewer, "activeToolChanged", this, "activeToolChanged"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	getCommandStack: function(){
		if(!this._commandStackObj){
			var cls = dojo.getObject(this.defaultCommandStack);
			this._commandStackObj = new cls();
		}
		return this._commandStackObj;
	},
	
	setCommandStack: function(stack){
		this._commandStackObj = stack;
	},
	
	executeCommand: function(command){
		this.getCommandStack().push(command);
		this.getCommandStack().execute_it();
	},
	
	getCommandProvider: function() {
		if (!this._commandProvider) {
			this._commandProvider = com.ibm.relm.explorer.web.base.internal.canvas.command.CommandProvider();
		}
		return this._commandProvider;
	},
	
	activeToolChanged: function(msg){
		if(msg.tool){
			this.setActiveTool(msg.tool);
		}else{
			this.loadDefaultTool();
		}
	}
});

})();
