/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.action.CommonActions"); //$NON-NLS-1$

// summary:
//		Editor actions that are usually invoked from toolbar, menubar, etc.
//		'this' points to the Editor.

com.ibm.relm.explorer.web.base.internal.canvas.action.CommonActions = {
	clear: function(){
		// Recursively removeChild in the reverse order, to go bottom up.
		// Note that this.destroyDescendants() does not work here.
		// Because cleaning up of gfx nodes is performed in the removeChild().
		// But this.destroyDescendants() just calls the destroy().
		function deleteRecursively(w){
			dojo.forEach(w.getChildren(),
				function(widget){
					if(widget.getChildren){
						deleteRecursively(widget);
					}
					widget.getParent().hlp_removeChild(widget);
					widget.destroy();
				});
		}
		this.removeFocus();
		deleteRecursively(this);
		this.getCommandStack().clear();
	},
	
	copy: function() {
		this.copyFocusWidget();
	},

	paste: function() {
		this.pasteWidget();
	},

	del: function(){
		this.deleteFocusWidget();
	},

	undo: function(){
		this.getCommandStack().undo_it();
		this.removeFocus();
	},

	redo: function(){
		this.getCommandStack().execute_it();
		this.removeFocus();
	}
};
