/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2011. All
 * Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo
		.provide("com.ibm.relm.explorer.web.base.internal.canvas.command.CommandProcessor"); //$NON-NLS-1$

// ----------------------------------------------------------------------------
// Manage Command instances
// ----------------------------------------------------------------------------

// 0 1 2 0 1 2
// -------- --------
// | | | | |x| | |
// -------- --------
// ^_top=0 ^_top=1
// (empty stack) (one command)

com.ibm.relm.explorer.web.base.internal.canvas.command.CommandProcessor = function() {
	this._stack = new Array();
	this._top = 0; // stack top position
	this._current = 0; // current position

	this.push = function(cmd) {
		this._stack[this._current] = cmd;
		this._top = this._current + 1;
		for ( var i = this._top; i < this._stack.length; i++) {
			this._stack[i] = null;
		}
	};

	this.pop = function(cmd) {
		if (this._top == 0) {
			return;
		}
		this._stack[--this._top] = null;
		this._current = this._top;
	};

	this.clear = function(cmd) {
		this._top = 0;
		this._current = 0;
		for ( var i = 0; i < this._stack.length; i++) {
			this._stack[i] = null;
		}
	};

	this.execute_it = function() {
		if (!this._stack[this._current]) {
			return;
		}
		var cmd = this._stack[this._current++];
		cmd.execute();
		if (this._current == 1) {
			this.dirtied();
		}
	};

	this.undo_it = function() {
		if (this._current == 0) {
			console.debug("No further undo information"); //$NON-NLS-1$
			window.setTimeout("window.status='';", 5000); //$NON-NLS-1$
			return;
		}
		var cmd = this._stack[--this._current];
		cmd.undo();
		if (this._current == 0) {
			this.undirtied();
		}
	};
	
	this.isDirty = function(){
		return (this._top != 0);
	};

	this.dirtied = function() {
	};

	this.undirtied = function() {
	};
};
