/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.command.CompoundCommand"); //$NON-NLS-1$

// ----------------------------------------------------------------------------
// Compose multiple commands into a single command
// ----------------------------------------------------------------------------

com.ibm.relm.explorer.web.base.internal.canvas.command.CompoundCommand = function(){
	this._commands = [];

	this.execute = function(){
		for(var i = 0; i < this._commands.length; i++){
			var cmd = this._commands[i];
			cmd.execute();
		}
		if(this._lastCommand){
			this._lastCommand.execute();
		}
	};

	this.undo = function(){
		for(var i = this._commands.length - 1; i >= 0; i--){
			var cmd = this._commands[i];
			cmd.undo();
		}
		if(this._lastCommand){
			this._lastCommand.undo();
		}
	};

	this.append = function(cmd){
		this._commands[this._commands.length] = cmd;
	};
	
	this.setLastCommand = function(cmd){
		this._lastCommand = cmd;
	}
};
