/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.extension.componentInfo"); //$NON-NLS-1$

// summary:
//		Handles component definition files.
//		'this' points to the Editor.

com.ibm.relm.explorer.web.base.internal.canvas.extension.componentInfo = {
	initialize: function(){
		this.registerComponentInfo(this.componentInfo);
	},

	registerComponentInfo: function(/*Object*/conf){
		if(!conf || !conf.items){ return; }
		if(!this._componentInfo){
			this._componentInfo = {};
		}
		for(var i = 0; i < conf.items.length; i++){
			var item = conf.items[i];
			this._componentInfo[item.id] = item;
		}
	},
	
	getComponentInfoIds: function(){
		var ids = [];
		if(this._componentInfo){
			for(var id in this._componentInfo){
				ids.push(id);
			}
		}
		return ids;
	},

	getComponentInfo: function(/*String|Widget*/widget){
		var id = widget.componentInfoId || widget.declaredClass || widget;
		var info = this._componentInfo[id] || {};
		return info;
	},

	getAttributeInfo: function(/*String|Widget*/widget, /*String*/attrName){
		var info = this.getComponentInfo(widget);
		if(!info || !info.attributes){ return null; }
		var attrs = info.attributes;
		for(var i = 0, len = attrs.length; i < len; i++){
			if(attrs[i].name == attrName){
				return attrs[i];
			}
		}
		return null;
	},

	getAttributes: function(/*String|Widget*/widget){
		var info = this.getComponentInfo(widget);
		if(!info){ return null; }
		return info.attributes;
	}
};
