/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.extension.jsonGenerator"); //$NON-NLS-1$

com.ibm.relm.explorer.web.base.internal.canvas.extension.jsonGenerator = {
	generate: function(widget){
		widget = widget || this;
		var ml = '{\n'; //$NON-NLS-1$
		var children = widget.getChildren ? widget.getChildren() : null;
		if(children){
			for(var i = 0, len = children.length; i < len; i++){
				ml += (i == 0) ? "  div: [{\n" : "  }, {\n"; //$NON-NLS-1$ //$NON-NLS-2$
				ml += this.generate_1(children[i], 0);
			}
		}
		ml += '  }]\n'; //$NON-NLS-1$
		ml += '}\n'; //$NON-NLS-1$
		return ml;
	},

	// TODO: children is not supported yet.
	generate_1: function(widget, indent){
		var i, len;
		var ml = ""; //$NON-NLS-1$
		var spc = "    "; //$NON-NLS-1$
		var dojoType = widget.declaredClass;

		ml += spc + "@dojoType=\""+dojoType+"\",\n"; //$NON-NLS-1$ //$NON-NLS-2$
		ml += spc + "@id=\""+widget.id+"\",\n"; //$NON-NLS-1$ //$NON-NLS-2$
		ml += spc + "@componentInfoId=\""+widget.componentInfoId+"\""; //$NON-NLS-1$ //$NON-NLS-2$

		var attrs = widget.hlp_getAttributes() || [];
		for(i = 0, len = attrs.length; i < len; i++){
			var attr = attrs[i];
			if(attr.readonly === true){ continue; }
			var name = attr.name;
			var value = widget.hlp_getPropertyValue(name);
			if(value !== null && value !== "" && typeof(value) != "undefined"){ // if(!value) doesn't work. value can be a number. //$NON-NLS-1$ //$NON-NLS-2$
				if(typeof(value) == "string"){ //$NON-NLS-1$
					value = value.replace(/&/gm, "&amp;").replace(/</gm, "&lt;").replace(/>/gm, "&gt;").replace(/\"/gm, "&quot;"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
				}else if(typeof(value) == "object"){ //$NON-NLS-1$
					value = dojo.toJson(value).replace(/\"/g, "'"); //$NON-NLS-1$
				}
				ml += ",\n" + spc + "@"+name+"=\""+value+"\""; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			}
		}
		ml += "\n"; //$NON-NLS-1$
		return ml;
	}
};
