/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.extension.jsonLoader"); //$NON-NLS-1$

com.ibm.relm.explorer.web.base.internal.canvas.extension.jsonLoader = {
    load: function(url){
		if(!url){ return false; }
		if(url.indexOf("://") == -1){ //$NON-NLS-1$
			// local file must be relative to "com.ibm.relm.explorer.web.base.internal"
			url = dojo.moduleUrl("com.ibm.relm.explorer.web.base.internal", url).toString(); //$NON-NLS-1$
		}
		var contents = dojo._getText(url, true);
		if(!contents){ return false; }
		var root = dojo.fromJson(contents);
		if(!root.div){ return false; }

		this.containerNode.innerHTML = ""; //$NON-NLS-1$
		for(var i = 0; i < root.div.length; i++){
			var div = root.div[i];
			var props = {};
			for(var prop in div){
				if(prop.charAt(0) == "@"){ //$NON-NLS-1$
					props[prop.substring(1)] = div[prop];
				}
			}
			dojo.create("div", props, this.containerNode, "last"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		this.initCanvas();

		// Load components and their helpers (if any)
		// Load may be performed asynchronously with the XD loader
		this.loadComponents();

		dojo.addOnLoad(this, function(){
			this._instantiate();
		});
	},

	_instantiate: function(){
		dojo.parser.parse(this.domNode);

		if(this.setupWidgetsRecursively){
			this.setupWidgetsRecursively();
		}
		dojo.forEach(this.getChildren(), function(child){if(child.startup){child.startup();}});

		if(this.adjustCanvasSize){
			var _this = this;
			setTimeout(function(){
				_this.adjustCanvasSize();
			}, 0);
		}

		if(this.fireInputChanged){
			this.fireInputChanged();
		}

		return true;
	}
};
