/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.extension.knob"); //$NON-NLS-1$

// summary:
//		Creates a knob used as a selection handle or a connection endpoint
//		'this' points to the Editor.

com.ibm.relm.explorer.web.base.internal.canvas.extension.knob = {
	createKnob: function(type){
		if(typeof(type) == "object" && type.tagName){ //$NON-NLS-1$
			return type;
		}else if(type == "blackSquare"){ //$NON-NLS-1$
			var div = dojo.doc.createElement("DIV"); //$NON-NLS-1$
			div.className = "resizeKnob"; //$NON-NLS-1$
			div.style.width = "4px"; //$NON-NLS-1$
			div.style.height = "4px"; //$NON-NLS-1$
			div.style.fontSize = "1px"; //$NON-NLS-1$
			div.style.backgroundColor = "black"; //$NON-NLS-1$
			div.style.position = "absolute"; //$NON-NLS-1$
			div.style.border = "1px solid white"; //$NON-NLS-1$
			div.style.zIndex = "1100"; //$NON-NLS-1$
			return div;
		}else if(type == "whiteCircle"){ //$NON-NLS-1$
			var img = dojo.doc.createElement("IMG"); //$NON-NLS-1$
			img.className = "resizeKnob"; //$NON-NLS-1$
			img.alt = ""; //$NON-NLS-1$
			img.src = dojo.moduleUrl("btp", "widget/templates/EditArea/white-circle-knob.gif")+""; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			img.style.zIndex = "1100"; //$NON-NLS-1$
			img.style.position = "absolute"; //$NON-NLS-1$
			return img;
		}else if(type == "decoration"){ //$NON-NLS-1$
			return null;
		}else if(type.match(/\.(gif|jpg|jpeg|png)$/i)){
			var img = dojo.doc.createElement("IMG"); //$NON-NLS-1$
			img.className = "resizeKnob"; //$NON-NLS-1$
			img.alt = ""; //$NON-NLS-1$
			img.src = dojo.moduleUrl("btp", type)+""; //$NON-NLS-1$ //$NON-NLS-2$
			img.style.zIndex = "1100"; //$NON-NLS-1$
			img.style.position = "absolute"; //$NON-NLS-1$
			return img;
		}
		return null; // never reached
	}
};
