/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.extension.paletteSupport"); //$NON-NLS-1$

// summary:
//		Palette event subscriber.
//		This module is mixed-in to Editor.
//		'this' points to the Editor.

com.ibm.relm.explorer.web.base.internal.canvas.extension.paletteSupport = {
	initialize: function(){
		this.subscribe("btp:PaletteSelectionChanged", "paletteSelectionChanged"); //$NON-NLS-1$ //$NON-NLS-2$
		this.subscribe("btp:ToolOperationFinished", "toolOperationFinished"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	// ======== Topic Subscribers ====================================
	paletteSelectionChanged: function(message){
		if(message.editor != this){
			return;
		}
		if(!this.matchFilter(message, this.paletteSelectionChangedFilter)){
			return; // filter out the message
		}

		if(!this.isShowing(this)){ return; }
		this._selectedPaletteItem = message.selection;
		if(message.selection){
			this.componentSpec = {componentInfoId: message.selection.name, props: message.selection.params.props};
			if (message.selection.onItemCreate) {
				this.componentSpec.onItemCreate = message.selection.onItemCreate;
			}
			var info = this.getComponentInfo(message.selection.name);
			this.loadComponents([info.id]);
		}else{
			this.componentSpec = null;
		}
		dojo.addOnLoad(this, function(){
			this.activeToolChanged(message);
		});
	},

	toolOperationFinished: function(message){
		if(this._selectedPaletteItem){
			if(this._selectedPaletteItem.deselect){
				this._selectedPaletteItem.deselect();
				this._selectedPaletteItem = null;
			}
		}
	}
};
