/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.extension.preferenceSupport"); //$NON-NLS-1$

// summary:
//		Preference event subscriber.
//		This module is mixed-in to Editor.
//		'this' points to the Editor.

com.ibm.relm.explorer.web.base.internal.canvas.extension.preferenceSupport = {
	initialize: function(){
		this.subscribe("btp:PreferenceChanged", "preferenceChanged"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	// ======== Topic Subscribers ====================================
	preferenceChanged: function(evt){
		var workbench = evt.src;
		var showGrid = workbench.getCookieValue("General/Appearance:showGrid"); //$NON-NLS-1$
		var gridSize = workbench.getCookieValue("General/Appearance:gridSize"); //$NON-NLS-1$
		var snapTo = workbench.getCookieValue("General/Appearance:snapTo"); //$NON-NLS-1$
		if(gridSize){
			this.gridWidth = gridSize;
		}
		this.snapObjectsToGrid(snapTo);
		this.displayGrid(showGrid);
	}
};
