/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.tool.DefaultCreationTool"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.canvas.tool.AbstractTool"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.canvas.tool.DefaultCreationTool", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.canvas.tool.AbstractTool,
{
	cursor: "pointer", //$NON-NLS-1$

	handleClick: function(e){
		this.fireToolOperationFinished(); // to deselect the palette
		var refWidget = this.findRefWidget(e);
		e = dojo.mixin(e, {componentSpec: this.getEditor().componentSpec});
		var deferred = e.componentSpec.onItemCreate ? e.componentSpec.onItemCreate(e) : null;
		if (deferred) {
			deferred.then(dojo.hitch(this, function(result) {
				this.insertComponent(e, refWidget);
			}));
		} else {
			this.insertComponent(e, refWidget);
		}
		this.getEditor().loadDefaultTool();
		this.getEditor().domNode.style.cursor = "auto"; //$NON-NLS-1$
	},

	handleDrop: function(e){
		e = dojo.mixin(e, {componentSpec: this.getEditor().componentSpec});
		var deferred = e.componentSpec.onItemCreate ? e.componentSpec.onItemCreate(e) : null;
		if (deferred) {
			deferred.then(dojo.hitch(this, function(result) {
				this._createObject(e);
			}));
			e.dragStatus = "dropSuccess"; //$NON-NLS-1$
		} else {
			var ret = this._createObject(e);
			e.dragStatus = ret ? "dropSuccess" : "dropFailure"; // See DragManager.onMouseUp() //$NON-NLS-1$ //$NON-NLS-2$
		}
		this.getEditor().loadDefaultTool();
		this.getEditor().domNode.style.cursor = ""; //$NON-NLS-1$
	},

	handleMouseOver: function(e){
		this.getEditor().domNode.style.cursor = "pointer"; //$NON-NLS-1$
	},

	_createObject: function(e) {
		var targetWidget = this.getDropTargetWidget(e);
		var type = e.dragSource.type;
		var ret = null;
		if(targetWidget[type+"DropHandler"]){ //$NON-NLS-1$
			ret = targetWidget[type+"DropHandler"](e, this); //$NON-NLS-1$
		}
		if(!ret && this[type+"DropHandler"]){ //$NON-NLS-1$
			ret = this[type+"DropHandler"](e); //$NON-NLS-1$
		}
		return ret;
	},

	componentDropHandler: function(e){
		// this: drop target widget
		var ret = null;
		if(this.getEditor().componentSpec || e.componentSpec){
			var refWidget = this.findRefWidget(e);
			ret = this.insertComponent(e, refWidget);
		}
		return ret;
	},

	getComponentSpec: function(e) {
		return this.getEditor().componentSpec || e.componentSpec;
	}
});
