/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.tool.ResizeCreationTool"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.canvas.tool.AbstractDragTool"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.dnd.DragManager"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.canvas.tool.ResizeCreationTool", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.canvas.tool.AbstractDragTool,
{
	_rubberBand: null,

	handleMouseDown: function(e){
		this.inherited(arguments);
		var rubberBand = this._rubberBand;
		if(!rubberBand){
			rubberBand = this._rubberBand = dojo.doc.createElement("DIV"); //$NON-NLS-1$
			rubberBand.style.fontSize = "1px"; //$NON-NLS-1$
			rubberBand.style.position = "absolute"; //$NON-NLS-1$
			rubberBand.style.border = "1px dashed black"; //$NON-NLS-1$
		}
		this.getEditor().domNode.appendChild(rubberBand);
		rubberBand.style.top = e.layerY + "px"; //$NON-NLS-1$
		rubberBand.style.left = e.layerX + "px"; //$NON-NLS-1$
		rubberBand.style.width = "0px"; //$NON-NLS-1$
		rubberBand.style.height = "0px"; //$NON-NLS-1$
	},
	
	onMouseMove: function(e){
		this.inherited(arguments);
		var dy = e.pageY - this.pageY;
		var dx = e.pageX - this.pageX;
		var rubberBand = this._rubberBand;
		var top, left, width, height; // string
		if(dx > 0 && dy > 0){
			width = e.pageX - this.pageX + "px"; //$NON-NLS-1$
			height = e.pageY - this.pageY + "px"; //$NON-NLS-1$
		}

		if(top){ rubberBand.style.top = top; }
		if(left){ rubberBand.style.left = left; }
		if(width){ rubberBand.style.width = width; }
		if(height){ rubberBand.style.height = height; }
	},

	handleMouseOver: function(e){
		this.getEditor().domNode.style.cursor = "crosshair"; //$NON-NLS-1$
	},

	handleMouseUp: function(e){
		this.inherited(arguments);
		if(dojo.isMozilla){
			// For some reason, FF starts auto scrolling after the resize creation.
			// I don't know why, but anyway this solves the problem. Very weird.
			var _this = this;
			setTimeout(function(){
				_this.getEditor().domNode.removeChild(_this._rubberBand);
			}, 0);
		}else{
			this.getEditor().domNode.removeChild(this._rubberBand);
		}
		var width = Math.abs(e.pageX - this.pageX);
		var height = Math.abs(e.pageY - this.pageY);
		var props = {
			coords: this.coords,
			__style: {}
		};
		if(width > 0){ props.__style["width"] = width + "px"; } //$NON-NLS-1$ //$NON-NLS-2$
		if(height > 0){ props.__style["height"] = height + "px"; } //$NON-NLS-1$ //$NON-NLS-2$
		var spec = this.getEditor().componentSpec;
		if(spec){
			if(spec.props){
				dojo.mixin(spec.props, props);
			}else{
				spec.props = props;
			}
		}
		this.insertComponent(e);
		this.getEditor().domNode.style.cursor = ""; //$NON-NLS-1$
	}
});
