/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.dnd.DragGhostMoveSource"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.dnd.DragSource"); //$NON-NLS-1$

dojo.declare("com.ibm.relm.explorer.web.base.internal.dnd.DragGhostMoveSource", com.ibm.relm.explorer.web.base.internal.dnd.DragSource, { //$NON-NLS-1$
	ghost: null,

	// override
	onDragMove: function(e){
		var dx = e.pageX - this.pageX + this.offsetParent.scrollLeft;
		var dy = e.pageY - this.pageY + this.offsetParent.scrollTop;
		this.dragClone.style.top = (this.transformY + dy) + "px"; //$NON-NLS-1$
		this.dragClone.style.left = (this.transformX + dx) + "px"; //$NON-NLS-1$
		if(this.positioning == "absolute"){ //$NON-NLS-1$
			this.dragClone.style.display = ""; //$NON-NLS-1$
			this.globalChangeCursor(null);
		}else{
			this.dragClone.style.display = "none"; //$NON-NLS-1$
			this.globalChangeCursor("move"); //$NON-NLS-1$
		}
	},
	
	// override
	onDragEnd: function(e){
		if(this.positioning == "absolute"){ //$NON-NLS-1$
			this.removeClone();
		}else{
			this.globalChangeCursor(null);
		}
	},

	// override
	createDragClone: function(e){
		this.createGhost(e);
		this.dragClone = this.ghost; // this.ghost is cached, while this.dragClone is cleared on drag end.
		this.dragClone.style.display = "none"; //$NON-NLS-1$
		this.offsetParent.appendChild(this.dragClone);
	},

	// Create a dashed rectangle (ghost)
	createGhost: function(e){
		if(!this.ghost){
			var line = this.ghost = dojo.doc.createElement("DIV"); //$NON-NLS-1$
			line.className = "lwGhostFrame"; //$NON-NLS-1$
			line.style.zIndex = 1000;
			line.style.position = "absolute"; //$NON-NLS-1$
			line.style.fontSize = "1px"; //$NON-NLS-1$
			line.style.borderWidth = "1px"; //$NON-NLS-1$
			line.style.borderStyle = "dashed"; //$NON-NLS-1$
			var line2 = line.cloneNode(false);
			var line3 = line.cloneNode(false);
			var line4 = line.cloneNode(false);
			line.appendChild(line2);
			line.appendChild(line3);
			line.appendChild(line4);
		}
		var topLine = this.ghost;
		var bottomLine = topLine.childNodes[0];
		var leftLine = topLine.childNodes[1];
		var rightLine = topLine.childNodes[2];

		var w = (this.refNode._offsetWidth || this.refNode.offsetWidth) * this.zoom;
		var h = (this.refNode._offsetHeight || this.refNode.offsetHeight) * this.zoom;

		// Top Line
		topLine.style.width = w + "px"; //$NON-NLS-1$
		topLine.style.height = "1px"; //$NON-NLS-1$
		topLine.style.borderWidth = "0px 0px 1px 0px"; //$NON-NLS-1$

		// Bottom Line
		bottomLine.style.top = h + "px"; //$NON-NLS-1$
		bottomLine.style.left = "0px"; //$NON-NLS-1$
		bottomLine.style.width = w + "px"; //$NON-NLS-1$
		bottomLine.style.height = "1px"; //$NON-NLS-1$
		bottomLine.style.borderWidth = "1px 0px 0px 0px"; //$NON-NLS-1$

		// Left Line
		leftLine.style.top = "1px"; //$NON-NLS-1$
		leftLine.style.left = "-1px"; //$NON-NLS-1$
		leftLine.style.width = "1px"; //$NON-NLS-1$
		leftLine.style.height = h + "px"; //$NON-NLS-1$
		leftLine.style.borderWidth = "0px 1px 0px 0px"; //$NON-NLS-1$

		// Right Line
		rightLine.style.top = "1px"; //$NON-NLS-1$
		rightLine.style.left = w - 1 + "px"; //$NON-NLS-1$
		rightLine.style.width = "1px"; //$NON-NLS-1$
		rightLine.style.height = h + "px"; //$NON-NLS-1$
		rightLine.style.borderWidth = "0px 0px 0px 1px"; //$NON-NLS-1$
	}
});
