/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.CurvylineConnection"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.Curvyline"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc._connection"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.CurvylineConnection", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.Curvyline,
{
	startup: function(){
		if(this._started){ return; }
		this.inherited(arguments);
		this.processParams();
	},

	update: function(){
		if(!this.shape || this.points.length < 2){ return; }
		this.inherited(arguments);
		if(this.targetDecorationObj){
			var pt = this.getEnd();
			this.targetDecorationObj.setLocation(pt);

			var pt0 = this.points[this.points.length - 2];
			var dx = Math.abs(pt.x - pt0.x);
			var dy = pt.y - pt0.y;
			var angle = Math.atan(dy/dx)/Math.PI*180;
			if(pt.x - pt0.x < 0){
				angle = 180 - angle;
			}
			this.targetDecorationObj.setRotation(angle);
		}
	}
});
dojo.extend(com.ibm.relm.explorer.web.base.internal.gdc.CurvylineConnection, com.ibm.relm.explorer.web.base.internal.gdc._connection);
