/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.Image"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.AbstractNode"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.Image", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.AbstractNode,
{
	src: "", //$NON-NLS-1$

	createTargetShape: function(){
		var shape = this.group.createImage();
		if(shape.rawNode && shape.rawNode.setAttribute){
			// works for svg only
			shape.rawNode.setAttribute("title", this.title); //$NON-NLS-1$
		}
		return shape;
	},
	
	getShapeInfo: function(){
		return {width:this.width, height:this.height, src:dojo.moduleUrl("com.ibm.relm.explorer.web.base.internal", this.src)+""}; //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	getSrc: function(){
		return this.src;
	},

	setSrc: function(src){
		this.src = src;
		if(this.doRefresh && this.shape){
			this.shape.setShape({src:dojo.moduleUrl("com.ibm.relm.explorer.web.base.internal", this.src)+""}); //$NON-NLS-1$ //$NON-NLS-2$
		}
	}	
});
