/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.Surface"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Container"); //$NON-NLS-1$
dojo.require("dijit._Contained"); //$NON-NLS-1$
dojo.require("dojox.gfx"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc._gfxPatch"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.anchor.AnchorManager"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.Surface", //$NON-NLS-1$
	[dijit._Widget, dijit._Contained, dijit._Container],
{
	width: 800, // Integer
	height: 600, // Integer
	surface: null,
	group: null, // gfx group object

	postCreate: function(){
		this.containerNode = this.domNode;
		this.domNode.className = "gdcSurface"; //$NON-NLS-1$
		this.domNode.style.position = "relative"; //$NON-NLS-1$
		this.domNode.style.width = this.width + "px"; //$NON-NLS-1$
		this.domNode.style.height = this.height + "px"; //$NON-NLS-1$
		this.surface = dojox.gfx.createSurface(this.domNode, this.width, this.height);
// Surface.clipNode is no longer supported in the latest Dojo 
//		if(dojo.isIE && this.domNode.childNodes.length > 1){
//			// make the clipNode the first child of domNode so that HTML elements
//			// of child widgets can be shown on top of gfx nodes.
//			this.domNode.removeChild(this.surface.clipNode);
//			this.domNode.insertBefore(this.surface.clipNode, this.domNode.firstChild);
//		}

		this.group = this.surface.createGroup();
		if(this.addChild){
			this.connect(this, "addChild", function(w){w.onAdded && w.onAdded();}); //$NON-NLS-1$
			this.connect(this, "removeChild", function(w){w.onRemoved && w.onRemoved();}); //$NON-NLS-1$
		}
	},

	startup: function(){
		if(this._started){ return; }
		var classes = [];
		dojo.forEach(this.getDescendants(), function(widget){
			if(widget.sourceAnchorClass){
				classes.push(widget.sourceAnchorClass);
			}
			if(widget.targetAnchorClass){
				classes.push(widget.targetAnchorClass);
			}
			if(widget.sourceDecorationClass){
				classes.push(widget.sourceDecorationClass);
			}
			if(widget.targetDecorationClass){
				classes.push(widget.targetDecorationClass);
			}
		});

		var self = this;
		jazz.core.loader.batch_load_async(classes, function() {
			dojo.forEach(self.getDescendants(), function(widget){
				com.ibm.relm.explorer.web.base.internal.gdc.anchor.AnchorManager.createConnectionAnchors(widget);
			});
			dojo.forEach(self.getChildren(), function(child){if(child.startup){child.startup();}});
		});
	}
});

dojo.extend(dijit._Widget, {
	sourceAnchorClass: '', //$NON-NLS-1$
	targetAnchorClass: '', //$NON-NLS-1$
	componentInfoId: '' //$NON-NLS-1$
});
