/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.Text"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.AbstractNode"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.Text", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.AbstractNode,
{
	text: "", //$NON-NLS-1$
	align: "start", // "start", "middle", or "end" //$NON-NLS-1$
	decoration: "none", //$NON-NLS-1$
	rotated: false,
	kerning: true,
	font: "", //$NON-NLS-1$
	fill: "black", // default value //$NON-NLS-1$
	stroke: "", // default value //$NON-NLS-1$

	createTargetShape: function(){
		return this.group.createText();
	},

	getShapeInfo: function(){
		return {text:this.text, align:this.align, decoration:this.decoration,
							rotated:this.rotated, kerning:this.kerning};
	},

	// Override com.ibm.relm.explorer.web.base.internal.gdc.AbstractNode
	update: function(){
		this.inherited(arguments);
		this.setFont(this.font);
		this.adjustBaseline();
	},

	updateBB: function(){
		if(!this.domNode) return;
		var dim = this.getBB(this.text, this.font);
		this.domNode._offsetWidth = this.width = Math.round(dim.w); // [custom property]
		this.domNode._offsetHeight = this.height = Math.round(dim.h); // [custom property]
	},

	adjustBaseline: function(){
		var _this = this;
		setTimeout(function(){
			if (!_this.shape) return;
			_this.updateBB();
			// TODO: Isn't there a more sophisticated way?
			// I just want to align top.
			var h = (dojo.isIE < 9) ? Math.round(_this.height*1.1) : Math.round(_this.height*0.8);
			_this.shape.setShape({y:h});
		}, 0);
	},

// ======================= Setters/Getters =================================
	// override com.ibm.relm.explorer.web.base.internal.gdc.AbstractNode
	getWidth: function(){
		this.updateBB();
		return this.width;
	},
	
	// override com.ibm.relm.explorer.web.base.internal.gdc.AbstractNode
	getHeight: function(){
		this.updateBB();
		return this.height;
	},
	
	getText: function(){
		return this.text;
	},
	
	setText: function(/*String*/text){
		this.text = text;
		if(this.doRefresh && this.shape){
			this.shape.setShape({text:text});
		}
	},


	getAlign: function(){
		return this.align;
	},
	
	setAlign: function(/*String*/align){
		this.align = align;
		if(this.doRefresh && this.shape){
			this.shape.setShape({align:align});
		}
	},


	getDecoration: function(){
		return this.decoration;
	},
	
	setDecoration: function(/*String*/decoration){
		this.decoration = decoration;
		if(this.doRefresh && this.shape){
			this.shape.setShape({decoration:decoration});
		}
	},


	getRotated: function(){
		return this.rotated;
	},
	
	setRotated: function(/*Boolean*/rotated){
		this.rotated = rotated;
		if(this.doRefresh && this.shape){
			this.shape.setShape({rotated:rotated});
		}
	},


	getKerning: function(){
		return this.kerning;
	},
	
	setKerning: function(/*Boolean*/kerning){
		this.kerning = kerning;
		if(this.doRefresh && this.shape){
			this.shape.setShape({kerning:kerning});
		}
	},


	getFont: function(){
		return this.font;
	},

	// Example:
	// var font = {type: "font", style: "normal", variant: "normal",
	//			 weight: "normal", size: "10pt", family: "serif"};
	// var font = "normal normal normal 10pt Arial"; // "style varian weight size family"
	setFont: function(/*Object|String*/font){
		this.font = font;
		if(this.doRefresh && this.shape){
			if (font && typeof(font) == "string" && font.charAt(0) == "{"){ //$NON-NLS-1$ //$NON-NLS-2$
				// ex. "{size:12pt}"
				this.font = eval('('+font+')'); //$NON-NLS-1$ //$NON-NLS-2$
			}
			this.shape.setFont(this.font);
		}
	}
});
