/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor", //$NON-NLS-1$
	null,
{
	owner: null,
	listeners: null, // Array

	constructor: function(owner){
		this.owner = owner;
		this.listeners = [];
		this._connector = dojo.connect(owner, "nodeMoved", this, "anchorMoved"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	destroy: function(){
		dojo.disconnect(this._connector);
	},

	addAnchorListener: function(/*ConnectionWidget*/listener){
		if(dojo.indexOf(this.listeners, listener) != -1){//TODO: remove this code later
			alert("com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor#addAnchorListener: internal error: already registered"); //$NON-NLS-1$
		}
		this.listeners.push(listener);
	},

	removeAnchorListener: function(/*ConnectionWidget*/listener){
		var idx = dojo.indexOf(this.listeners, listener);
		if(idx != -1){
			this.listeners.splice(idx, 1);
		}
	},

	getConnections: function(){
		return this.listeners;
	},

	anchorMoved: function(/*Widget*/widget){
		for(var i = 0, len = this.listeners.length; i < len; i++){
			this.listeners[i].anchorMoved(widget);
		}
	},

	getLocation: function(/*{x:#,y:#}*/ref, /*ConnectionWidget*/line){
		// subclass must implement
	},

	// Returns direction of connection
	// pt is coordinate calculated by getLocation
	// subclass may override
	getDirection: function(/*{x:#,y:#}*/pt){
		if(!pt){ return null; }
		var owner = this.owner;
		
		// lm1 and rm corrsponds to left-/right-hand member of line1, respectively :
		// 		y = (owner.height/owner.width)*(x - owner.left) + owner.top
		var lm1 = owner.width*(pt.y - owner.top);
		var rm = owner.height*(pt.x - owner.left);
		
		// lm2 corrsponds to left-hand member of line2 :
		// y = -(owner.height/owner.width)*(x - owner.left) + (owner.top + owner.height)
		var lm2 = owner.width*(pt.y - owner.top - owner.height);
		
		if((lm1 < rm) && (lm2 >= -rm)){
			return "right"; //$NON-NLS-1$
		}else if((lm1 >= rm) && (lm2 >= -rm)){
			return "bottom"; //$NON-NLS-1$
		}else if((lm1 < rm) && (lm2 < -rm)){
			return "top"; //$NON-NLS-1$
		}else{
			return "left"; //$NON-NLS-1$
		}
	}, 

	getReferencePoint: function(){
		// subclass must implement
	}
});
