/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.anchor.CenterEdgeAnchor"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor"); //$NON-NLS-1$

// Summary:
//		The CenterEdgeAnchor's location is at the center of one of
//		four edges, top, right, bottom, or left edge.

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.anchor.CenterEdgeAnchor", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor,
{
	needRefPoint: false,
	/*
					p[0]
			+--------o--------+
			|   x (p0)        |
		p[3]o        +        o p[1]
			|                 |
			+--------o--------+
					p[2]
	*/
	getLocation: function(/*{x:#,y:#}*/ref, /*ConnectionWidget*/line){
		var owner = this.owner;
		var ownerNode = owner.domNode;
		var dir;
		var w = ownerNode._offsetWidth !== undefined ? ownerNode._offsetWidth : ownerNode.offsetWidth;
		var h = ownerNode._offsetHeight !== undefined ? ownerNode._offsetHeight : ownerNode.offsetHeight;
		if(owner._clickedPos){
			var p0 = owner._clickedPos;
			owner._clickedPos = null; // clear the clicked pos
			var p = [{x:w/2, y:0}, {x:w, y:h/2}, {x:w/2, y:h}, {x:0, y:h/2}];
			var min = -1;
			var idx = 0;
			for(var i = 0; i < 4; i++){
				var d = (p0.x - p[i].x)*(p0.x - p[i].x) + (p0.y - p[i].y)*(p0.y - p[i].y);
				if(min == -1 || d < min){
					min = d;
					idx = i;
				}
			}
			if(idx == 0){
				dir = "top"; //$NON-NLS-1$
			}else if(idx == 1){
				dir = "right"; //$NON-NLS-1$
			}else if(idx == 2){
				dir = "bottom"; //$NON-NLS-1$
			}else{
				dir = "left"; //$NON-NLS-1$
			}
			if(line.sourceAnchorObj == this){
				line.startDir = dir;
			}else{
				line.endDir = dir;
			}
		}
		if(line.sourceAnchorObj == this){
			dir = line.startDir;
		}else{
			dir = line.endDir;
		}

		if(dir == "top"){ //$NON-NLS-1$
			return {x:ownerNode.offsetLeft + w/2, y:ownerNode.offsetTop};
		}else if(dir == "right"){ //$NON-NLS-1$
			return {x:ownerNode.offsetLeft + w, y:ownerNode.offsetTop + h/2};
		}else if(dir == "bottom"){ //$NON-NLS-1$
			return {x:ownerNode.offsetLeft + w/2, y:ownerNode.offsetTop + h};
		}else{
			return {x:ownerNode.offsetLeft, y:ownerNode.offsetTop + h/2};
		}
	},

	getReferencePoint: function(){
		var ownerNode = this.owner.domNode;
		var w = ownerNode._offsetWidth || ownerNode.offsetWidth;
		var h = ownerNode._offsetHeight || ownerNode.offsetHeight;
		var x = ownerNode.offsetLeft + w/2;
		var y = ownerNode.offsetTop + h/2;
		return {x:x, y:y}; // center of the bounding box
	}
});
