/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.anchor.ChopboxAnchor"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor"); //$NON-NLS-1$

// Summary:
//		The ChopboxAnchor's location is found by calculating the intersection of a line drawn
//		from the center point of its owner's box to a reference point on that box.

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.anchor.ChopboxAnchor", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor,
{
	getLocation: function(/*{x:#,y:#}*/ref, /*ConnectionWidget*/line){
		var owner = this.owner;
		var w = owner.domNode._offsetWidth || owner.domNode.offsetWidth;
		var h = owner.domNode._offsetHeight || owner.domNode.offsetHeight;
		var cx = owner.domNode.offsetLeft + w/2;
		var cy = owner.domNode.offsetTop + h/2;
		var dx = (ref && ref.x) - cx;
		var dy = (ref && ref.y) - cy;
		var ratioX = (w/2) / Math.abs(dx);
		var ratioY = (h/2) / Math.abs(dy);
		var ratio = Math.min(ratioX, ratioY);
		var x = Math.round(cx + ratio * dx);
		var y = Math.round(cy + ratio * dy);
		return {x:x, y:y};
	},

	getReferencePoint: function(){
		var owner = this.owner;
		var w = owner.domNode._offsetWidth || owner.domNode.offsetWidth;
		var h = owner.domNode._offsetHeight || owner.domNode.offsetHeight;
		var x = owner.domNode.offsetLeft + w/2;
		var y = owner.domNode.offsetTop + h/2;
		return {x:x, y:y}; // center of the bounding box
	}
});
