/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.anchor.EllipseAnchor"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor"); //$NON-NLS-1$

// Summary:
//		The EllipseAnchor's location is found by calculating the intersection of a line drawn
//		from the center point of ellipse to a reference point on that box.

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.anchor.EllipseAnchor", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor,
{
	getLocation: function(/*{x:#,y:#}*/ref, /*ConnectionWidget*/line){
		var owner = this.owner;
		var cx = owner.left + owner.width/2;
		var cy = owner.top + owner.height/2;
		var dx = owner.height*((ref && ref.x) - cx);
		var dy = owner.width*((ref && ref.y) - cy);
		var r = Math.sqrt(Math.pow(dx, 2) + Math.pow(dy, 2));
		return {
			x: Math.round(cx + owner.width/2*dx/r),
			y: Math.round(cy + owner.height/2*dy/r)
		};
	},

	getReferencePoint: function(){
		var owner = this.owner;
		var x = owner.left + owner.width/2;
		var y = owner.top + owner.height/2;
		return {x:x, y:y}; // center of the bounding box
	}
});
