/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.anchor.FixedAnchor"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor"); //$NON-NLS-1$

// Summary:
//		The FixedAnchor's location is the center of the owner's box.

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.anchor.FixedAnchor", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.anchor.AbstractConnectionAnchor,
{
	needRefPoint: false,
	
	endPointDomNode: null,
	endPointShape: null,
	
	offsetH: 0,
	offsetV: 0,
	centerOrigin: true,

	getLocation: function(/*{x:#,y:#}*/ref, /*ConnectionWidget*/line){
		var owner = this.owner;
		var x, y;
		var matrix = this.endPointShape && this.endPointShape.getTransform();
		if(matrix){
			var bb = this.endPointShape.getBoundingBox();
			x = owner.left + matrix.dx + bb.x + (this.centerOrigin ? bb.width/2 : 0) + this.offsetH;
			y = owner.top + matrix.dy + bb.y + (this.centerOrigin ? bb.height/2 : 0) + this.offsetV;
		}else{
			var w = owner.domNode._offsetWidth || owner.domNode.offsetWidth;
			var h = owner.domNode._offsetHeight || owner.domNode.offsetHeight;
			x = owner.domNode.offsetLeft + w/2;
			y = owner.domNode.offsetTop + h/2;
		}
		return {x:x, y:y}; // center of the bounding box
	},

	getReferencePoint: function(){
		var owner = this.owner;
		var x = owner.left + owner.width/2;
		var y = owner.top + owner.height/2;
		return {x:x, y:y}; // center of the bounding box
	}
});
