/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.decoration.AbstractDecoration"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.decoration.AbstractDecoration", //$NON-NLS-1$
	null,
{
	owner: null, // gfx line widget
	group: null, // gfx group object
	shape: null, // gfx shape object
	rootNode: null, // root node where event handlers will be added

	constructor: function(owner, props){
		this.owner = owner;
		if(owner.stroke){
			var jsonStroke = owner.stroke;
			if(typeof(jsonStroke) == "string"){ //$NON-NLS-1$
				try {
					jsonStroke = dojo.fromJson(owner.stroke);
				}catch(e){
					// ignore
				}
			}
			this.ownerColor = (typeof(jsonStroke) == "string") ? jsonStroke : jsonStroke.color; //$NON-NLS-1$
		}else{
			this.ownerColor = "black"; //$NON-NLS-1$
		}
		this.setProps(props);
	},

	setProps: function(props){
		if(props && typeof(props) == "string"){ //$NON-NLS-1$
			props = eval('('+props+')'); //$NON-NLS-1$ //$NON-NLS-2$
		}
		dojo.mixin(this, props);
	},

	createShape: function(parent){
		// Copy widgetId to the root node of this shape
		// so that the widget can be found using dijit.getEnclosingWidget.
		// Note that the root node of this shape is not a child of this.domNode.
		this.group.rawNode.setAttribute("_widgetId", this.owner.domNode.getAttribute("widgetId")); //$NON-NLS-1$ //$NON-NLS-2$
	},

	update: function(props){
		// subclass must implement
	},

	removeShape: function(){
		// subclass must implement
	},

	restoreShape: function(){
		// subclass must implement
	},

	setLocation: function(/*{x:#,y:#}*/pt){
		// subclass must implement
	},

	setRotation: function(/*float*/angle){
		// subclass must implement
	},

	// summary: moves a shape to front of its parent's list of shapes
	moveToFront: function(){
		// subclass may want to override
		this.shape.moveToFront();
	}
});
