/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.decoration.ImageDecoration"); //$NON-NLS-1$

// Summary:
//		A decorative Figure intended to be placed on a Polyline.
//		Note that this is not a widget.

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.decoration.AbstractDecoration"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.decoration.ImageDecoration", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.decoration.AbstractDecoration,
{
	src: "", //$NON-NLS-1$
	width: 100,
	height: 100,

	constructor: function(owner, props){
	},

	createShape: function(parent){
		this.parentGroupBox = parent;
		this.group = parent.createGroup();
		this.shape = this.group.createImage({width:this.width, height:this.height, src:dojo.moduleUrl("com.ibm.relm.explorer.web.base.internal", this.src)+""}); //$NON-NLS-1$ //$NON-NLS-2$
		this.inherited(arguments);
	},

	update: function(props){
		if(!this.shape){ return; }
		this.shape.setShape({width:this.width, height:this.height, src:dojo.moduleUrl("com.ibm.relm.explorer.web.base.internal", this.src)+""}); //$NON-NLS-1$ //$NON-NLS-2$
	},

	removeShape: function(){
		var ret = this.group ? this.group.removeShape() : null;
		return ret;
	},

	// restore the removed shape
	restoreShape: function(){
		this.parentGroupBox.add(this.group);
		this.owner.recoverLostInfo(this.shape);
	},

	setLocation: function(/*{x:#,y:#}*/pt){
		this.shape.setTransform({dx:pt.x-16, dy:pt.y-19});
	},

	setRotation: function(/*float*/angle){
//		var rotate = dojox.gfx.matrix.rotategAt(angle, 0, 0);
//		this.shape.applyTransform(rotate);
	}
});
