/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.gdc.label.ConnectionEndpointLabel"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.label.AbstractLabel"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.gdc.label.ConnectionEndpointLabel", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.label.AbstractLabel,
{
	label: "label", //$NON-NLS-1$
	icon: "", // ex. "myIcon.gif,10,14" // width=10, height=14 //$NON-NLS-1$

	uDistance: 0,
	vDistance: 0,

	modulePrefix: "com.ibm.relm.explorer.web.base.internal", //$NON-NLS-1$

	imageShape: null,
	textShape: null,

	createShape: function(parent){
		this.parentGroupBox = parent;
		this.group = parent.createGroup();
		var width = 16, height = 16;
		var iconPath = this.icon;
		var arr = iconPath.split(","); //$NON-NLS-1$
		if(arr.length == 3){
			iconPath = arr[0];
			width = arr[1] - 0;
			height = arr[2] - 0;
		}
		this.imageShape = this.group.createImage({
			width: width,
			height: height,
			y: -10, // TODO: how do we determine this offset value?
			src: dojo.moduleUrl(this.modulePrefix, iconPath) + "" //$NON-NLS-1$
		});
		this.textShape = this.group.createText({
			x: width + 4,
			y: 0,
			text: this.label
		});
		this.inherited(arguments);
	},

	// Override gdc.widget.AbstractNode
	update: function(props){
		this.inherited(arguments);
		this.textShape.setShape({text:this.label});
		this.textShape.setFont(this.font).setFill("black"); //$NON-NLS-1$
	},

	removeShape: function(){
		var ret = this.group ? this.group.removeShape() : null;
		return ret;
	},

	// restore the removed shape
	restoreShape: function(){
		this.parentGroupBox.add(this.group);
		this.owner.recoverLostInfo(this.imageShape);
		this.owner.recoverLostInfo(this.textShape);
	},

	setLocation: function(/*{x:#,y:#}*/pt){
		// Shima-san's homework.
		// Adjust the position of the label so that it is placed at
		// this.uDistance away from the node, and
		// this.vDistance away from the connection.
		// Some sophisticated logic might be necessary.
		// Ideally, the behavior should be the same as or similar to
		// Draw2D's ConnectionEndpointLocator, although the concept is
		// basically different. Draw2D's locator acts as sort of constraint for
		// a figure, while this label object is a kind of decoration for
		// the line widget.
		// cf. http://help.eclipse.org/galileo/topic/org.eclipse.draw2d.doc.isv/reference/api/org/eclipse/draw2d/ConnectionEndpointLocator.html
		this.group.setTransform({dx:pt.x, dy:pt.y});
	},

	setUDistance: function(/*int*/distance){
		// Sets the distance in pixels from the connection's owner.
		this.uDistance = distance - 0;
	},

	setVDistance: function(/*int*/distance){
		// Sets the distance in pixels from the connection.
		this.vDistance = distance - 0;
	}
});
