/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.helper.connectionHelper"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.dnd.DropTarget"); //$NON-NLS-1$

// summary:
//		Make a node widget (component) "connectable".
//		'this' points to a node type widget.

com.ibm.relm.explorer.web.base.internal.helper.connectionHelper = {
	initialize: function(){
		this.hlp_setupConnectionTarget();
	},

	hlp_connectionTargets: ["connection"], // each component's helper may want to override this //$NON-NLS-1$

	hlp_setupConnectionTarget: function(){
		if(!this.hlp_connectionTargets || this.hlp_connectionTargets.length == 0){ return false; }
		var editor = this.hlp_getEditor();
		var dt = this._ct = new com.ibm.relm.explorer.web.base.internal.dnd.DropTarget(this.domNode, this.hlp_connectionTargets, this);
		var f = function(ds, dt){
			var sourceWidget = ds.data;
			var targetWidget = dt.data;
			if(sourceWidget == targetWidget){ return false; } // do not allow connection to itself
			var info = targetWidget.hlp_getComponentInfo();
			var mgr = com.ibm.relm.explorer.web.base.internal.gdc.anchor.AnchorManager;
			if(info && info.maxConnections != undefined
				&& mgr.getConnections(targetWidget).length >= info.maxConnections){ return false; }
			if(info && info.maxTargetConnections != undefined
				&& mgr.getTargetConnections(targetWidget).length >= info.maxTargetConnections){ return false; }
			return true;
		};
		dt.registerIsAcceptable("connect", f); //$NON-NLS-1$
		this._ctConns = [];
		if(this.hlp_showAllowConnectFeedback){
			this._ctConns.push(dojo.connect(dt, "showFeedback", this, "hlp_showAllowConnectFeedback")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		if(this.hlp_hideAllowConnectFeedback){
			this._ctConns.push(dojo.connect(dt, "hideFeedback", this, "hlp_hideAllowConnectFeedback")); //$NON-NLS-1$ //$NON-NLS-2$
		}
	},

	hlp_getConnectionTarget: function(/*DomNode*/elem){
		return this._ct;
	},

	hlp_canStartConnection: function(){
		var info = this.hlp_getComponentInfo();
		var mgr = com.ibm.relm.explorer.web.base.internal.gdc.anchor.AnchorManager;
		if(info && info.maxSourceConnections != undefined
			&& mgr.getSourceConnections(this).length >= info.maxSourceConnections){ return false; }
		return true;
	},

	hlp_getConnectionInfoId: function(/*DomNode*/node){
		return null;
	},

	hlp_getConnectionProps: function(/*DomNode*/node){
		return null;
	}
};
