dojo.provide("com.ibm.relm.explorer.web.base.internal.util"); //$NON-NLS-1$

// summary:
//		Utility functions.

(function(){
	var u = com.ibm.relm.explorer.web.base.internal.util;

	u.cap = function(word){
		return word.charAt(0).toUpperCase() + word.substring(1);
	};

	u.getEventCoords = function(e){
		var y = 0, x = 0;
		if(e.pageX){
			y = e.pageY;
			x = e.pageX;
		}else{
			x = e.clientX + dojo.doc.body.scrollLeft - dojo.doc.body.clientLeft;
			y = e.clientY + dojo.doc.body.scrollTop - dojo.doc.body.clientTop;
			if(dojo.doc.body.parentElement && dojo.doc.body.parentElement.clientLeft){
				var parent = dojo.doc.body.parentElement;
				x += parent.scrollLeft - parent.clientLeft;
				y += parent.scrollTop - parent.clientTop;
			}
		}
		return {x:x, y:y};
	};

	u.getDimensions = function(elem, parent){
		var top = 0, left = 0;
		var width = elem.offsetWidth; 
		var height = elem.offsetHeight;
		for(; elem != null; elem = elem.offsetParent){
			if(typeof(parent) == "object" && elem == parent //$NON-NLS-1$
				|| typeof(parent) == "string" && elem.className == parent) //$NON-NLS-1$
				break;
			top += elem.offsetTop - elem.scrollTop;
			left += elem.offsetLeft - elem.scrollLeft;
		}
		return {top:top, left:left, width:width, height:height};
	};

	u.isOrphan = function(elem){
		for(var n = elem; n; n = n.parentNode){
			if(n.tagName == "BODY") //$NON-NLS-1$
				return false;
		}
		return true;
	};
})();
