/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.le.leeditor.page.LifecycleElementEditor"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("jazz.ui.Tree"); //$NON-NLS-1$
dojo.require("jazz.ui.tree.IconItem"); //$NON-NLS-1$
dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$
dojo.require("jazz.util.ResizeNotifier"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("dojo.data.ItemFileReadStore"); //$NON-NLS-1$
dojo.require("dijit.layout._LayoutWidget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.layout.BorderContainer"); //$NON-NLS-1$
dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
dojo.require("dijit.form.TextBox"); //$NON-NLS-1$
dojo.require("dijit.form.SimpleTextarea"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.leeditor.queryparams.ParameterTable"); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Drawer'); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.Section"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.EasyMessageBox"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.StatusMessage"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.view.edit.PrefixSelectionDialog"); //$NON-NLS-1$
dojo.require('com.ibm.relm.le.leeditor.queryparams.SystemParameterUtil'); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.leeditor.queryparams.paramprompt.ParameterPromptDialog"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.view.common.QueryUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.view.common.Table"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.view.common.TableUtils"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.le.leeditor.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.le.leeditor.internal", "LifecycleElementEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.le.leeditor.queryparams", "ParameterTableMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.le.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('com.ibm.relm.explorer.web.explorer.queryparams.SparqlQueryParameters');//$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.internal.orion.SparqlPlugin"); //$NON-NLS-1$

(function(){
var SystemParameterUtil = com.ibm.relm.le.leeditor.queryparams.SystemParameterUtil;
var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var JazzUIWorkbench = PlatformUI.getWorkbench();
var PageHoverHelp = jazz.app.ua.PageHoverHelp;
var commonUtil = com.ibm.relm.common.web.ui.util;
var util = com.ibm.relm.le.ui.internal.util;
var leServiceUtils = com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils;
var ParameterTable = com.ibm.relm.le.leeditor.queryparams.ParameterTable;
var tableUtils = com.ibm.relm.le.ui.internal.view.common.TableUtils;
var queryUtils = com.ibm.relm.le.ui.internal.view.common.QueryUtils;
var SparqlQueryParameters = com.ibm.relm.explorer.web.explorer.queryparams.SparqlQueryParameters;

var ns = com.ibm.relm.le.ui.namespace;

var CLASS_ADD_COMMAND = "add-command"; //$NON-NLS-1$
var CLASS_DELETE_COMMAND = "delete-command"; //$NON-NLS-1$

//AE URI in POST response header
var RH_LOCATION = "Location"; //$NON-NLS-1$
//AE URI in GET by ID response header
var RH_CONTENT_LOCATION = "Content-Location"; //$NON-NLS-1$
var RH_ETAG = "ETag"; //$NON-NLS-1$
var RH_ARTIFACT_ELEMENT_ID = "ArtifactElementID"; //$NON-NLS-1$

//Format: $prettyName$
var PARAMETER_REG_EX = /\$[^$ ]+\$/g;
var SUPPORTED_CHAR_REG_EX = /[a-zA-Z_][a-zA-Z0-9_-]*/;
var PROPERTY_REG_EX = /[?]([A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u10000-\uEFFFF_0-9][A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u10000-\uEFFFF_0-9\u00B7\u0300-\u036F\u203F-\u2040]*)[\s;.){}[\]\$]/gi;

var PROP_TABLE_COL_ID_NAME = "name"; //$NON-NLS-1$
var PROP_TABLE_COL_ID_LINK_TO_LABEL = "linkToLabel"; //$NON-NLS-1$
var PROP_TABLE_COL_ID_LINK_TO_AE = "linkToAE"; //$NON-NLS-1$
var PROP_TABLE_RECENT_SELECTED_AE = "relm-le-prop-recent-selected-ae"; //$NON-NLS-1$
var EXPIRATION_DATE = 90;
var MAX_PROP_TABLE_RECENT_SELECTED_AE = 5;

var orionEditor = null, globalSetText = null;

dojo.declare("com.ibm.relm.le.leeditor.page.LifecycleElementEditor", //$NON-NLS-1$
	[dijit.layout._LayoutWidget, dijit._Templated],
{
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.le","leeditor/page/templates/LifecycleElementEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
	uri: null,
	_cachedProps: null, //This variable will not be used in 5.0
	_propTableOptions: null,
	_loadingElements: null,
	_aeInfo: {
		id: "", //$NON-NLS-1$
		title/*name*/: "", //$NON-NLS-1$
		description: "", //$NON-NLS-1$
		sparqlTemplate: "", //$NON-NLS-1$
		properties: [],
		parameters: []
	},

	constructor: function(args) {
		this.inherited(arguments);
		this.idId = dijit.getUniqueId('relm-LEEditor'); //$NON-NLS-1$
		this.nameId = dijit.getUniqueId('relm-LEEditor'); //$NON-NLS-1$
		this.descriptionId = dijit.getUniqueId('relm-LEEditor'); //$NON-NLS-1$
		this.sparqlId = dijit.getUniqueId('relm-LEEditor'); //$NON-NLS-1$
		this.statusId = dijit.getUniqueId('relm-LEEditorStatus'); //$NON-NLS-1$
		this._propTableOptions = {};
		this._propTableOptions[PROP_TABLE_COL_ID_NAME] = new dojo.data.ItemFileReadStore({data: {identifier: "value", items: []}}); //$NON-NLS-1$
		this._propTableOptions[PROP_TABLE_COL_ID_LINK_TO_AE] = new dojo.data.ItemFileReadStore({data: {identifier: "value", items: []}}); //$NON-NLS-1$
		this._loadingElements = [];

		orionEditor = null;
		new com.ibm.relm.common.web.ui.internal.orion.SparqlPlugin({initializer: dojo.hitch(this, this.initOrionEditor)});
	},
	
	postMixInProperties: function(){
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.le.leeditor.internal", "LifecycleElementEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._queryMessages = dojo.i18n.getLocalization("com.ibm.relm.le.leeditor.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._parameterTableMessages = dojo.i18n.getLocalization("com.ibm.relm.le.leeditor.queryparams", "ParameterTableMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._configMessages = dojo.i18n.getLocalization("com.ibm.relm.le.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function(){
		/* Declare get and set methods to support Orion Editor */
		this.queryText.get = function(property) {
			if(orionEditor === null)
				return ""; //$NON-NLS-1$
			else
				return orionEditor.getText();
		};
		
		this.queryText.set = function(property,value) {
			if(orionEditor === null)
				globalSetText = value;
			else {
				setTimeout(function() { // Defer setting of text to allow DOM to load completely
					orionEditor.setText(value);
					orionEditor.getUndoStack().reset();
				},100);
			}
		};
		
		this.inherited(arguments);
		this._widgetsToDestroy= [];

		this.connect(this.idNode, "onKeyUp", "onContentChange"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.nameNode, "onKeyUp", "onContentChange"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.descriptionText, "onKeyUp", "onContentChange"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.queryText, "onKeyUp", "onContentChange"); //$NON-NLS-1$ //$NON-NLS-2$

		this.subscribe("CREATE_AE", "setLeInfo"); //$NON-NLS-1$ //$NON-NLS-2$

		this._createContextSensitiveHelp();

		if (!this.navigateAwayHandle) {
			this.navigateAwayHandle = JazzUIWorkbench.registerBodyClickHandler(dojo.hitch(this, this._handleNavigateAway), /*priority*/ 10000);
		}

		this._drawer.setDrawerContent(this._paramPane);
		this._initializePropTable();
		this._initializeParamTable();
		this._initPrefixSelector();
//		this._initImportFromJRSButton();
		
		//this.connect(this.queryText, 'onChange', onQueryChange); //$NON-NLS-1$

		this._onResize();
		this._resizeEvent = jazz.util.ResizeNotifier.register({context: this, callback: this._onResize, priority: 100});
	},

	startup: function(){
		this.inherited(arguments);
	},

	initOrionEditor: function() {
		var self = this;
		
		// Instantiate an instance of the Orion Editor and initialize it
		require(["orion/editor/edit", "orion/editor/textMateStyler", "orion/editor/sparqlContentAssist", "orion/editor/sparqlGrammar"], function(edit, mTextMateStyler, mSPARQLContentAssist, mSparqlGrammar) { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			// Line and column number status bar
			var status = ""; //$NON-NLS-1$
			var statusReporter = function(message, isError) {
				if (isError) {
					status = "ERROR: " + message; //$NON-NLS-1$
				} else {
					status = message;
				}
				self.queryTextStatus.innerHTML = status;
			};
			
			// Instantiate the editor
			orionEditor = edit({
				parent: self.queryText,
				statusReporter: statusReporter,
				autoPairParentheses: true,
				autoPairBraces: true,
				autoPairSquareBrackets: true,
				autoPairAngleBrackets: true,
				autoPairQuotations: true,
				smartIndentation: true
			});
			
			// Add SPARQL content assist to the editor
			var contentAssist = orionEditor.getContentAssist ? orionEditor.getContentAssist() : orionEditor._contentAssist;
			contentAssist.providers.push(new mSPARQLContentAssist.SPARQLContentAssistProvider());
			
			// Add Grammar based syntax highlighter for SPARQL to the editor
			var syntaxHighlighter = {
				styler: null,
				highlight: function(editor) {
					if (this.styler) {
						this.styler.destroy();
						this.styler = null;
					}
					var textView = editor.getTextView();
					this.styler = new mTextMateStyler.TextMateStyler(textView, mSparqlGrammar.SparqlGrammar());
				}
			};

			syntaxHighlighter.highlight(orionEditor);
			if (globalSetText !== null)
			{
				orionEditor.setText(globalSetText);
				orionEditor.getUndoStack().reset();
				globalSetText = null;
			}
			
			var textView = orionEditor.getTextView();
			textView.addEventListener("KeyUp", dojo.hitch(self,self.onContentChange)); //$NON-NLS-1$
			textView.addEventListener("ModelChanged", dojo.hitch(self,self.onQueryChange)); //$NON-NLS-1$
		});
	},
	
	//disable the run button if the query string is empty
	onQueryChange: function(){
		this.queryText.value = orionEditor.getText();
		var value = this.queryText.value;
		if(value!==null && value!==undefined && dojo.trim(value) === ''){ //$NON-NLS-1$
			this.submitButton.disabled = true;
		}else{
			this.submitButton.disabled = false;
		}
	},

	_clearFields: function(){
		this._enableSaveButtons(false);
		this.idNode.set("value", this._aeInfo.id || ""); //$NON-NLS-1$ //$NON-NLS-2$
		this.nameNode.set("value", this._aeInfo.title || ""); //$NON-NLS-1$ //$NON-NLS-2$
		this.descriptionText.set("value", this._aeInfo.description || ""); //$NON-NLS-1$ //$NON-NLS-2$
		this.queryText.set("value", this._aeInfo.sparqlTemplate || ""); //$NON-NLS-1$ //$NON-NLS-2$
		this._clearProperties();
		this._clearParameters();
	},

	/*
	 * Prefix
	 */
	_initPrefixSelector: function() {
		var addPrefix = dojo.create('a', { //$NON-NLS-1$
			href: '#', //$NON-NLS-1$
			innerHTML: this._messages.AddPrefix,
			title: this._messages.AddPrefixTooltip,
			className: 'relm-Section-link' //$NON-NLS-1$
		});
		this.connect(addPrefix, 'onclick', dojo.hitch(this, function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this._handleAddPrefix();
		}));
		this._sparqlPane.setControls(addPrefix);
	},
	_handleAddPrefix: function() {
		var self = this;
		var prefixDialog = new com.ibm.relm.le.ui.internal.view.edit.PrefixSelectionDialog({
			okCallback: dojo.hitch(this,this._okPrefixDialogCallback),
			cancelCallback: dojo.hitch(this,this._cancelPrefixDialogCallback)
		});

		self._prefixDialog = new jazz.ui.Dialog({
			contentNode: prefixDialog.domNode,
			primaryTitle: self._messages.AddPredifinedPrefix,
			width: "600px", //$NON-NLS-1$
			isClosable: true
		});
	},
	_okPrefixDialogCallback: function(args){
		this._prefixDialog.close();
		this._prefixDialog.destroy();
		// refresh sparql
		var sparql = this.queryText.get("value"); //$NON-NLS-1$
		sparql = args.prefixText + sparql;
		this.queryText.set("value", sparql); //$NON-NLS-1$
		this.onContentChange();
	},
	_cancelPrefixDialogCallback: function(args){
		this._prefixDialog.close();
		this._prefixDialog.destroyRecursive();
	},
	
	/*
	 * Import from JRS
	 */
	_initImportFromJRSButton: function() {
		var importFromJRS = dojo.create('a', { //$NON-NLS-1$
			href: '#', //$NON-NLS-1$
			innerHTML: this._messages.ImportFromJRS,
			title: this._messages.ImportFromJRSTooltip,
			className: 'relm-Section-link' //$NON-NLS-1$
		});
		this.connect(importFromJRS, 'onclick', dojo.hitch(this, function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this._handleimportFromJRS();
		}));
		this._sparqlPane.addControls(importFromJRS);
	},

	_handleimportFromJRS: function(){
		var dlg = new com.ibm.relm.explorer.web.ui.internal.common.ImportQueryDialog({
			onOk: function(item){
				var uri = item.uri;

				jazz.client.xhrGet({
					url: com.ibm.relm.explorer.web.ui.jrsServiceUri + "?queryUri=" + uri, //$NON-NLS-1$
					load: function(result){
						// queryText.set clear Undo stack, so call orion editor directly
						orionEditor.setText(result);
					},
					handle: function(){
						
					}
				});

				this.close();
			}
		});
		dlg.startup();
	},


	/*
	 * Properties
	 */
	_initializePropTable: function(){
		this._propSection.setControls(this._createAddButton(this._configMessages.AddProperty, this._handleAddProperty));
		var columns = tableUtils.createPropTableColumnsEx(this._propNameChangeHandler, /*value*/null, /*type*/null, /*label*/null, /*description*/null, this._linkToLabelChangeHandler, this._linkToAEChangeHandler, this);
		this._propTableHolder.setupColumns(columns);
	},
	_createAddButton: function(label, callback, context, buttonLabel){
		callback = dojo.hitch(context || this, callback);
		var a = dojo.create("a", { //$NON-NLS-1$
			href: "#", //$NON-NLS-1$
			innerHTML: buttonLabel || this._configMessages.Add,
			className: CLASS_ADD_COMMAND,
			title: label,
			style: {
				verticalAlign: "middle", //$NON-NLS-1$
				marginLeft: "8px" //$NON-NLS-1$
			}
		});
		this.connect(a, 'onclick', function(e){ //$NON-NLS-1$
			dojo.stopEvent(e);
			callback();
		});
		return a;
	},
	_handleAddProperty: function(){
		var aeOptions = this._propTableOptions[PROP_TABLE_COL_ID_LINK_TO_AE];
		if(!aeOptions || aeOptions._arrayOfAllItems.length <= 0){
			this._showWarningMessage(this._messages.noOtherAEExists);
			return;
		}
		var self = this;
		var deleteProperty = dojo.hitch(this, this._handleDeleteProperty);
		dojo.removeClass(this._propTableArea, "hiddenParamTable"); //$NON-NLS-1$
		this.emptyPropTableMessage.style.display = "none"; //$NON-NLS-1$
		var property = {
				name: "", //$NON-NLS-1$
				linkTo: []
		};
		var data = {
				id: dojox.uuid.generateRandomUuid(),
				property: property,
				name: "", //$NON-NLS-1$
				linkToLabel: "", //$NON-NLS-1$
				linkToAE: "", //$NON-NLS-1$
	/*Only name and linkto are supported in 5.0*/
//				value: "", //$NON-NLS-1$
//				type: DEFAULT_TYPE,
//				label: "", //$NON-NLS-1$
//				description: "", //$NON-NLS-1$
				actions: [{
							iconClass: CLASS_DELETE_COMMAND,
							title: self._configMessages.configEditorRemoveProperty,
							onClick: deleteProperty
						}]
			};

		var propTableChangeHandler = dojo.hitch(this, this._propTableChangeHandler);
		var item = this._propTableHolder.addItem(data, this._propTableOptions, propTableChangeHandler);
		var nameEditBox = item.getEditBoxByColumnId(PROP_TABLE_COL_ID_NAME);
		this.connect(nameEditBox, "onClick", dojo.hitch(this, this._refreshPropTableNameOptions, nameEditBox)); //$NON-NLS-1$
		this.onContentChange();
	},
	_refreshPropTableNameOptions: function(editBox){
		var propStore = this._parseQueryTextForProperty();
		var wrapperWidget = editBox.wrapperWidget;
		if(wrapperWidget){
			var editWidget = wrapperWidget.editWidget;
			if(editWidget){
				editWidget.set("store", propStore); //$NON-NLS-1$
			}
		}else{
			//wrapperWidget has not created at first time
			editBox.editorParams.store = propStore;
		}
	},
	_parseQueryTextForProperty: function() {
		var query = this.queryText.get('value'); //$NON-NLS-1$
		var propsInSparql = query.match(PROPERTY_REG_EX) || [];
		if (!propsInSparql.length) return [];

		var props = [];
		var uniqueProps = {};

		dojo.filter(propsInSparql, function(propName) {
			var withoutDelimiters = propName.substring(1);
			var prettyName = withoutDelimiters.split(/[\s;.){}[\]\$]/)[0];
			if (!uniqueProps[prettyName]) {
				uniqueProps[prettyName] = true;
				props.push({value: prettyName, label: prettyName});
				return true;
			} else {
				return false;
			}
		});
		var propStore = new dojo.data.ItemFileReadStore({data: {identifier: "value", items: props}}); //$NON-NLS-1$
//		propStore.fetch();
		return propStore;
	},
	_propTableChangeHandler: function(data, id, newValue, rowWidget, scope){
		switch(id){
		case PROP_TABLE_COL_ID_NAME:
			this._propNameChangeHandler(data, id, newValue, rowWidget);
			break;
		case PROP_TABLE_COL_ID_LINK_TO_LABEL:
			this._linkToLabelChangeHandler(data, id, newValue, rowWidget);
			break;
		case PROP_TABLE_COL_ID_LINK_TO_AE:
			this._linkToAEChangeHandler(data, id, newValue, rowWidget);
			break;
		default:
				break;
		}
		this.onContentChange(true);
	},
	_propNameChangeHandler: function(data, id, newValue, rowWidget){
		data[id] = newValue;
		data.property.name = newValue;
	},
	_linkToLabelChangeHandler: function(data, id, newValue, rowWidget){
		var linkToAE = data[PROP_TABLE_COL_ID_LINK_TO_AE];
		data[id] = newValue;
		data.property.linkTo[0] = {id: linkToAE, label: newValue};
	},
	_linkToAEChangeHandler: function(data, id, newValue, rowWidget){
		var linkToLabel = data[PROP_TABLE_COL_ID_LINK_TO_LABEL];
		data[id] = newValue;
		data.property.linkTo[0] = {id: newValue, label: linkToLabel};
		this._addLinkToHistory(newValue);
	},
	_updateProperties: function(properties){
		var self = this;
		leServiceUtils.getAllElements(null,
				function(results){
					//getAllElements returns at least one result which has only numChildren
					if(dojo.some(results, function(ae){return ae.title && ae.id;})){
						var aes = dojo.map(results, function(ae){return {label: ae.title, value: ae.id};});
						var recentAE = self._getPropTableRecentUsedAEs();
						aes.sort(function(a, b){
							var bIndex = dojo.indexOf(recentAE, b.value);
							if(bIndex < 0){
								return 0;
							}
							var aIndex = dojo.indexOf(recentAE, a.value);
							if(aIndex >= 0){
								return aIndex - bIndex;
							}else if(aIndex < 0){
								return 1;
							}
						});
						var aeOptionsStore = new dojo.data.ItemFileReadStore({data: {identifier: "value", items: aes}}); //$NON-NLS-1$
						aeOptionsStore.fetch();
						self._propTableOptions[PROP_TABLE_COL_ID_LINK_TO_AE] = aeOptionsStore;
						self._updatePropertiesTable(properties);
					}
				},
				function(results, ioArgs){
					self.errorHandler(results, ioArgs);
				});
	},
	_updatePropertiesTable: function(properties){
		var self = this;
		var deleteProperty = dojo.hitch(this, this._handleDeleteProperty);
		dojo.removeClass(this._propTableArea, "hiddenParamTable"); //$NON-NLS-1$
		this._propTableHolder.clearItems();
		if (properties && properties.length) {
			this.emptyPropTableMessage.style.display = "none"; //$NON-NLS-1$
			dojo.forEach(properties, function(property){
				dojo.forEach(property.linkTo, function(linkTo){
					var propTableChangeHandler = dojo.hitch(self, self._propTableChangeHandler);
					var item = self._propTableHolder.addItem({
						id: dojox.uuid.generateRandomUuid(),
						property: property,
						name: property.name,
//						value: property.value,
//						type: property.type,
//						label: property.label,
//						description: property.description,
						linkToLabel: linkTo.label,
						linkToAE: linkTo.id,
						actions: [{
								iconClass: CLASS_DELETE_COMMAND,
								title: self._configMessages.configEditorRemoveProperty,
								onClick: deleteProperty
							}]
					}, self._propTableOptions, propTableChangeHandler);
					var nameEditBox = item.getEditBoxByColumnId(PROP_TABLE_COL_ID_NAME);
					self.connect(nameEditBox, "onClick", dojo.hitch(self, self._refreshPropTableNameOptions, nameEditBox)); //$NON-NLS-1$
				});
			});
		} else {
			this.emptyPropTableMessage.style.display = ""; //$NON-NLS-1$
		}
	},
	_handleDeleteProperty: function(target){
		var row = dijit.getEnclosingWidget(target);
		var name = row.data.name || ""; //$NON-NLS-1$
		if(confirm(dojo.string.substitute(this._configMessages.confirmRemoveParameter, [ name ]))){
			this._removeProperty(row);
		}
		var properties = this._propTableHolder.getData();
		if(properties && properties.length){
			this.emptyPropTableMessage.style.display = "none"; //$NON-NLS-1$
		}else{
			this.emptyPropTableMessage.style.display = ""; //$NON-NLS-1$
		}
		this.onContentChange(true);
	},
	_removeProperty: function(item){
		var selectedIndex = dojo.indexOf(this._propTableHolder.getChildren(), item);
		this._propTableHolder.removeChild(item);
		item.destroy();

		var children = this._propTableHolder.getChildren();
		var newIndex = selectedIndex < children.length ? selectedIndex : children.length - 1;
		var item = children[newIndex];
		this._propTableHolder.selectItem(item);
	},
	_clearProperties: function(){
		this.emptyPropTableMessage.style.display = ""; //$NON-NLS-1$
		dojo.removeClass(this._propTableArea, "hiddenParamTable"); //$NON-NLS-1$
		this._propTableHolder.clearItems();
	},
	_refreshProperties: function(properties) {
		//This function will not be used in 5.0
		if (!properties || !properties.length){
			var leInfo = this._getLifecycleElementInfo();

			var content = {
					sparql: leInfo.sparqlTemplate,
					size: 1,
					index: 0
				};

			//TODO set parameters to content
			var validData = this.refreshAndGetParam(leInfo);
			if(!validData){
				return;
			}
			var systemParameters = SystemParameterUtil.getSystemParameterValues();
			if(leInfo.parameterized === "true"/*We use a text string to represent the boolean value*/) { //$NON-NLS-1$
				if (!this.parameterValues || this.isParamChanged) {
					this._performPrompt(this.parameterValues,
						function(parameterValues){
							//onsubmit
							this.parameterValues = parameterValues;
							content.parameterValues = dojo.toJson(this.parameterValues);
							this._loadProperties(content);
						},
						dojo.hitch(this, "errorHandler")); //$NON-NLS-1$
				} else {
					this.parameterValues = dojo.mixin(this.parameterValues, systemParameters);
					content.parameterValues = dojo.toJson(this.parameterValues);
					this._loadProperties(content);
				}
			} else {
				content.parameterValues = dojo.toJson(systemParameters);
				this._loadProperties(content);
			}
		}else{
			this._updatePropertiesTable(properties);
		}
	},
	_loadProperties: function(content){
		//This function will not be used in 5.0
		var self = this;
		var hasBody = true;
		jazz.client.xhrPost({
			url: com.ibm.relm.le.ui.queryServiceUri,
			headers: {"Accept": "application/json"}, //$NON-NLS-1$ //$NON-NLS-2$
			preventCache: true,
			handleAs: "json", //$NON-NLS-1$
			content: content,
//			contentType: "application/json",
			handle: function(response, ioArgs){
				self.hideMessage();
			},
			load: function(response, ioArgs){
				var cachedProps = self._cachedProps ? dojo.clone(self._cachedProps) : {};
				self._cachedProps = {};
				var properties = dojo.map(response.head.vars, function(prop){
					var property = cachedProps[prop];
					if(!property){
						property = {name: prop, type: "", label: prop, parameterClass: ""}; //$NON-NLS-1$ //$NON-NLS-2$
					}
					self._cachedProps[prop] = property;
					return property;
				});
				self._updatePropertiesTable(properties);
			},
			error: dojo.hitch(this, "errorHandler") //$NON-NLS-1$
		}, hasBody);
	},
	_validateProperties: function(properties){
		var self = this;
		var invalidProperties = [];
		dojo.forEach(properties, function(property) {
			for (prop in property) {
				if (!property[prop]) {
					invalidProperties.push(self._propTableHolder.getItemById(property.id));
				}
			}
		});
		
		if (invalidProperties.length == 0) {
			return true;
		} else {
			//Flash the nodes
			dojo.forEach(invalidProperties, function(row) {
				row.domNode.focus();
				commonUtil.flashNode(row.domNode);
			}, this);
			this._showWarningMessage(this._messages.missingPropertyInfo);
			return false;
		}
	},
	_addLinkToHistory: function(aeId){
		var recentAEs = this._getPropTableRecentUsedAEs();
		var index = dojo.indexOf(recentAEs, aeId);
		if(index >= 0){
			recentAEs.splice(index, 1);
		}
		recentAEs.unshift(aeId);
		dojo.cookie(PROP_TABLE_RECENT_SELECTED_AE, dojo.toJson(recentAEs), {expires: EXPIRATION_DATE});
	},
	_addPropTableRecentUsedAE: function(ae){
		var recentAEs = this._getPropTableRecentUsedAEs();
		recentAEs.unshift(ae);
		if(recentAEs.length > MAX_PROP_TABLE_RECENT_SELECTED_AE){
			recentAEs.pop();
		}
		dojo.cookie(PROP_TABLE_RECENT_SELECTED_AE, dojo.toJson(recentAEs), {expires: EXPIRATION_DATE});
	},
	/*
	 * History of linked AE selection in Properties Table is stored in cookie.
	 * The most recent AE is the first and oldest AE is the last
	 */
	_getPropTableRecentUsedAEs: function(){
		return dojo.fromJson(dojo.cookie(PROP_TABLE_RECENT_SELECTED_AE)) || [];
	},

	/*
	 * Parameters
	 */
	_initializeParamTable: function() {
		var refreshButton = new jazz.ui.toolbar.Button({
			title: this._messages.UpdateParametersTooltip,
			imgSrc: dojo.moduleUrl("com.ibm.relm.le","leeditor/images/refresh16.gif"), //$NON-NLS-1$ //$NON-NLS-2$
			"class": "refrehIcon sectionButton", //$NON-NLS-1$ //$NON-NLS-2$
			onClick: dojo.hitch(this, function(e) { 
				dojo.stopEvent(e);
				this._refreshParameters();
			})
		});
		
		this._paramSection.setControls(refreshButton.domNode);

		this._paramTable = new ParameterTable ({
			columns: [
				{label: this._messages.paramName, width: "25%", sortable: false}, //$NON-NLS-1$
				{label: this._messages.Type, width: "25%", sortable: false}, //$NON-NLS-1$
				{label: this._messages.Label, width: "25%", sortable: false}, //$NON-NLS-1$
				{label: this._messages.Description, width: "25%", sortable: false}], //$NON-NLS-1$
			trim: jazz.ui.StyledTable.TrimStyles.PRIMARY_HEADLESS,
			showHover: true,
			rowClass: "com.ibm.relm.le.leeditor.queryparams.ParameterRow" //$NON-NLS-1$
		}, this._tableHolder);
		this._widgetsToDestroy.push(this._paramTable);

		this._paramTableOnChangeHandle = dojo.connect(this._paramTable, 'onChange', dojo.hitch(this, this.onContentChange, true)); //$NON-NLS-1$
		dojo.connect(this._paramTable, "onChange", dojo.hitch(this, function(){this.isParamChanged = true;})); //$NON-NLS-1$
	},
	/**
	 * Cope with case where the enumerations used in the parameter table can't
	 * be retrieved.
	 */
	_drawErrback: function(errObj) {
		this.messageArea.showErrorObject(errObj, true);
	},
	_clearParameters: function(){
		dojo.removeClass(this._paramTableArea, "hiddenParamTable"); //$NON-NLS-1$
		this.emptyParamTableMessage.style.display = ""; //$NON-NLS-1$
		this._paramTable.clearBody();
		this._paramTable.clearCachedData();
	},
	_refreshParameters: function(parameters) {
		if (!parameters || !parameters.length) {
			parameters = this._parseQueryText();
		}

		dojo.removeClass(this._paramTableArea, "hiddenParamTable"); //$NON-NLS-1$
		if (parameters && parameters.length) {
			this.emptyParamTableMessage.style.display = "none"; //$NON-NLS-1$
			this._paramTable.draw(parameters, dojo.hitch(this, this._drawErrback));
		} else {
			this.emptyParamTableMessage.style.display = ""; //$NON-NLS-1$
			this._paramTable.draw(parameters, dojo.hitch(this, this._drawErrback));
		}
	},
	hideParamTable: function() {
		this._paramTable.clearBody();
		dojo.addClass(this._paramTableArea, "hiddenParamTable"); //$NON-NLS-1$
	},

	_parseQueryText: function() {
		try {
			var query = this.queryText.get('value'); //$NON-NLS-1$
			var parameterNames = SparqlQueryParameters.parseQueryParameterNames(query);
			return SparqlQueryParameters.parameterNamesAsObjects(parameterNames);
		} catch  (e) {
			this._showWarningMessage(e);
		}
	},

	toggleParamPane: function() {
		if (this._drawer.get('collapsed')) //$NON-NLS-1$
			this._drawer.animateExpand();
		else
			this._drawer.animateCollapse();
	},
	/**
	* Refresh the parameter table, get the data from the parameter table and validate the data. 
	* 
	* @param {leInfo} Information about the query. Should always be passed in. Info about parameters is added to it.
	* @return (boolean) true if successful, false otherwise
	*/
	refreshAndGetParam: function(leInfo) {
		if (!leInfo) {
			throw new Error("Query info not provided to LifecycleElementEditor.refreshAndGetParam"); //$NON-NLS-1$
		}

		this._refreshParameters();

		var parameters = this._paramTable.getData();
		leInfo.parameters = parameters;
		leInfo.parameterized = (parameters && parameters.length > 0).toString();

		return this._validateParameters(parameters);
	},
	/**
	* Validates that all the required info for a parameter is provided.
	* Originally there were multiple fields to validate, but now since the type
	* is preselected to a default value, label is the only value that can be
	* missing. 
	*
	* @param (parameters[]) The parameter data to validate
	* @return (boolean) true if valid data, false otherwise
	*/
	_validateParameters: function(parameters) {
		var invalidParameters = [];
		dojo.forEach(parameters, function(parameter) {
			for (prop in parameter) {
				if (prop != "description" && !parameter[prop]) { //$NON-NLS-1$
					invalidParameters.push(parameter.name);
				}
			}
		});
		
		if (invalidParameters.length == 0) {
			return true;
		} else {
			//Flash the nodes
			dojo.forEach(invalidParameters, function(parameterName) {
				var row = this._rowFor(parameterName);
				if (row) {
					row.focus();
					commonUtil.flashNode(row);
				}
			}, this);

			//Append all incorrect parameters to error message
			//XXX: To get around visual freeze, requiring ParameterTableMessages instead of adding one message to QueryEditorMessages
			var stringOfNames = invalidParameters.join(", "); //$NON-NLS-1$
			var errorMessage = dojo.replace(this._parameterTableMessages.missingParameterInfo, [stringOfNames]);
			this._showWarningMessage(errorMessage);
			
			return false;
		}
	},
	/**
	 * [_performPrompt description]
	 * @param  {[type]}  existingParameterValues [description]
	 * @return {[type]}                          [description]
	 */
	_performPrompt: function(existingParameterValues, onsubmit, oncancel) {
		//This function will not be used in 5.0
		var isDirty = this.isDirty();

		var promptArgs = {
			width: 600,
			parameterValues: existingParameterValues,
			queryName: this.nameNode.get("value"), //$NON-NLS-1$
			isDirty: isDirty,
			_onCancel: dojo.hitch(this, oncancel),
			_onSubmit: dojo.hitch(this, onsubmit),
		};

		
		promptArgs.parameters = this._paramTable.getData();

		var d = new com.ibm.relm.le.leeditor.queryparams.paramprompt.ParameterPromptDialog(promptArgs);
		d.startup();
	},

	_createContextSensitiveHelp: function() {
		dojo.empty(this.csHelpNode);
		this._createCSHWidget("com.ibm.relm.le.page_AEQueryEditor001"); //$NON-NLS-1$
	},
	_createCSHWidget: function(uaKey) {
		var parms = {};
		parms.uaKey = uaKey;
		var pageHelp = new PageHoverHelp(parms);
		this.csHelpNode.appendChild(pageHelp.domNode);
		this._widgetsToDestroy.push(pageHelp);
	},
	_handleNavigateAway: function(url, e) {
		// Allow help links to open in a new window without ado
		if (e && e.target && (e.target.tagName == "A") && (e.target.target == "jazzhelp")) { //$NON-NLS-1$ //$NON-NLS-2$
			return false; // allow navigation
		}

		/* This may have no meaning for LifecycleElementEditor.
		 * "url" is not even string
		 */
		var currentLocation = window.location.href;
		var badLink = currentLocation.substring(0, currentLocation.indexOf("#")+1); //$NON-NLS-1$
		if (url == badLink) {
			return true;
		}

		if (this.isDirty()) {
			if (window.confirm(this._messages.navigateAway + "\n\n" + this._messages.unsavedChanges + "\n\n" + this._messages.okOrCancel)) { //$NON-NLS-1$ //$NON-NLS-2$
				this._clearFields();
			}else{
				return true; // don't navigate away
			}
		}
		
		var createQueryLocation = 'action=com.ibm.relm.le.leeditor.showLEEditor'; //$NON-NLS-1$
		//If we are trying to create a new query while in create mode, then this happens
		if (url.fragment === createQueryLocation && dojo.hash() === createQueryLocation) {
			dojo.publish("CREATE_AE"); //$NON-NLS-1$
			return false;
		}
		// Remove spell check attribute
		if(dojo.isFF !== undefined)
			dojo.body().removeAttribute("spellCheck"); //$NON-NLS-1$
		return false; // allow navigation
	},
	destroy: function() {
		jazz.util.ResizeNotifier.unregister(this._resizeEvent);

		// Remove spell check attribute
		if(dojo.isFF !== undefined)
			dojo.body().removeAttribute("spellCheck"); //$NON-NLS-1$
		if(orionEditor !== null){
			orionEditor.destroy();
		}
		if (this.navigateAwayHandle) {
			JazzUIWorkbench.unregisterBodyClickHandler(this.navigateAwayHandle);
			this.navigateAwayHandle = null;
		}
		dojo.forEach(this._widgetsToDestroy, function(w) { w.destroy(); });

		dojo.disconnect(this._paramTableOnChangeHandle);

		this.inherited(arguments);
	},
	layout: function(){
		this._content.resize();
	},
	_onResize: function(){
		var contentCell = dojo.byId("content-cell"); //$NON-NLS-1$
		if(contentCell){
			var height = (parseInt(contentCell.style.height) || parseInt(contentCell.style.minHeight));
			this.resize({h: height});
		}
	},

	setLeInfo: function(id, parent){
		this.uri = null;
		this.parentFolder = parent;
		this.hideMessage();
		var self = this;
		this._clearParameters();
		if(id){
			this._enableSaveButtons(false);
			this.saveButton.firstChild.nodeValue = this._messages.SaveQuery;
			leServiceUtils.getElementById(id,
					function(results, ioArgs){
						self.uri = ioArgs.xhr.getResponseHeader(RH_CONTENT_LOCATION);

						// keep eTag for update/delete
						self.eTag = ioArgs.xhr.getResponseHeader(RH_ETAG);

						self._aeInfo = results;
						self.idNode.set("value", results.id || ""); //$NON-NLS-1$ //$NON-NLS-2$
						self.nameNode.set("value", results.title || ""); //$NON-NLS-1$ //$NON-NLS-2$
						self.descriptionText.set("value", results.description || ""); //$NON-NLS-1$ //$NON-NLS-2$
						self.queryText.set("value", results.sparqlTemplate || ""); //$NON-NLS-1$ //$NON-NLS-2$
						self._updateProperties(results.properties);
						if(results.parameters){
							self._refreshParameters(results.parameters);
						}
						self.onContentChange();
					},
					function(results, ioArgs){
						self.errorHandler(results, ioArgs);
					});
		}else{
			//Create a new AE
			this.saveAsButton.disabled = "true"; //$NON-NLS-1$
			this.saveButton.firstChild.nodeValue = this._messages.CreateQuery;
			this._aeInfo = {
				id: "", //$NON-NLS-1$
				title/*name*/: "", //$NON-NLS-1$
				description: "", //$NON-NLS-1$
				sparqlTemplate: "", //$NON-NLS-1$
				properties: [],
				parameters: []
			};
			this.idNode.set("value", ""); //$NON-NLS-1$ //$NON-NLS-2$
			this.nameNode.set("value", ""); //$NON-NLS-1$ //$NON-NLS-2$
			this.descriptionText.set("value", ""); //$NON-NLS-1$ //$NON-NLS-2$
			this.queryText.set("value", ""); //$NON-NLS-1$ //$NON-NLS-2$
			this._updateProperties();
			this.onContentChange();
		}
	},

	initWidgets: function() {
		this._enableSaveButtons(false);
	},

	onContentChange: function(parameterChanges) {
		var self = this;
		self.hideMessage();
		var le = self._getLifecycleElementInfo();
		var isDirty = self.isDirty(parameterChanges===true);
		this._enableSaveButtons(isDirty && ( le.title && le.title != "")&&( le.sparqlTemplate && le.sparqlTemplate != ""));	 //$NON-NLS-1$ //$NON-NLS-2$
		JazzUIWorkbench.setTitle(le.title || "");//$NON-NLS-1$
	},
	
	isDirty: function(parameterChanges) {
		var org = this._aeInfo;
		var aeInfo = this._getLifecycleElementInfo();

		var diffId = org.id !== aeInfo.id;
		var diffName = org.title !== aeInfo.title;
		var diffDesc = org.description !== aeInfo.description;
		var diffSparql = org.sparqlTemplate !== aeInfo.sparqlTemplate;

		var saveEnabled = !this.saveButton.disabled;

		return (diffId || diffName || diffDesc || diffSparql || saveEnabled || parameterChanges || this._aeInfo.isDirty);
	},
	
	onQuery: function(evt){
		var self = this;
		var leInfo = this._getLifecycleElementInfo();

		var content = {
				sparql: leInfo.sparqlTemplate,
				size: 1,
				index: 0
			};

		var validData = this.refreshAndGetParam(leInfo);
		if(!validData){
			return;
		}
		var systemParameters = SystemParameterUtil.getSystemParameterValues();
		if(leInfo.parameterized === "true"/*We use a text string to represent the boolean value*/) { //$NON-NLS-1$
			if (this.parameterValues && !this.isParamChanged) {
				this.parameterValues = dojo.mixin(this.parameterValues, systemParameters);
			}
			this._performPrompt(this.parameterValues,
					function(parameterValues){
						//onsubmit
						self.parameterValues = parameterValues;
						content.parameterValues = self.parameterValues;
						self._executeQuery(content.sparql, content.parameterValues);
					},
					dojo.hitch(this, "errorHandler")); //$NON-NLS-1$
		} else {
			content.parameterValues = this.parameterValues;
			self._executeQuery(content.sparql, content.parameterValues);
		}

		dojo.stopEvent(evt);
	},

	onSave: function(evt){
		if(!this.nameNode.get("value")){ //$NON-NLS-1$
			this.nameNode.set("value", this._messages.NewQuery); //$NON-NLS-1$
		}
		this._saveLifecycleElement();
	},

	onSaveAs: function(evt){
		this._saveLifecycleElement(true);
	},

	_onCancel: function(){
		if(this.isDirty()){
			if (window.confirm(this._messages.unsavedChanges + "\n\n" + this._messages.okOrCancel)) { //$NON-NLS-1$
				this._clearFields();
			}else{
				return;
			}
		}
		this.onCancel();
	},

	/*
	 * 
	 */
	onCancel: function(){},

	_executeQuery: function(sparql, parameters){
		queryUtils.openPreviewQueryResultDialog(sparql, [parameters]);
	},

	_rowFor: function(parameterName) {
		var foundRow = null;
		
		dojo.some(this._paramTable.tbody.rows, function(row){
			if (row.parameterName == parameterName) {
				foundRow = row;
				return true;
			}
		});
		
		return foundRow;
	},

	_saveLifecycleElement: function(toCopy) {
		this.hideMessage();

		var saveMessage = com.ibm.relm.common.web.StatusMessage.show(this._queryMessages.saving);

		var leInfo = this._getLifecycleElementInfo();
		var validData = this.refreshAndGetParam(leInfo);
		if (!validData) {
			saveMessage.hide();
			return false;
		}

		var properties = this._propTableHolder.getData();
		if(!this._validateProperties(properties)){
			saveMessage.hide();
			return;
		}
		leInfo.properties = dojo.map(properties, function(property){
			return property.property;
		});

		var validData = this.refreshAndGetParam(leInfo);
		if(!validData){
			return;
		}
		var parameters = this._paramTable.getData();
		leInfo.parameters = parameters;

		if(!leInfo.id || !leInfo.title || !leInfo.sparqlTemplate){
			// error
			saveMessage.hide();
			return false;
		}

		if(toCopy) {
			this._copyLifecycleElement(leInfo);
		}else if(this.uri){
			this._updateLifecycleElement(leInfo);
		}else{
			this._createLifecycleElement(leInfo);
		}
		saveMessage.hide();
		return true;
	},
	_createLifecycleElement: function(leInfo){
		var self = this;
		//Select Folder
		var type = "leFolder"; //$NON-NLS-1$
		if(util.hasPicker(type)){
			util.openPicker(type, {folder: this.parentFolder}, null, function(value){
				self.parentFolder = value;
				self._enableSaveButtons(false);
				leServiceUtils.createChildElement(
						self.parentFolder,
						null,
						leInfo, 
						function(results, ioArgs){
							self.uri = ioArgs.xhr.getResponseHeader(RH_LOCATION);

							// keep eTag for update/delete
							self.eTag = ioArgs.xhr.getResponseHeader(RH_ETAG);

							self.saveButton.firstChild.nodeValue = self._messages.SaveQuery;
							var status = {
									type : jazz.ui.MessageBox.STATUS_TYPES.OK,
									summary : self._messages.createSuccess,
									closable : false
							};
//							self.setLeInfo(leInfo.id, self.parentFolder);
							self.messageArea.showMessage(status);
							self._aeInfo = leInfo;
						},
						function(results, ioArgs){
							self._enableSaveButtons(true);
							self.errorHandler(results, ioArgs);
						});
				this.close();
			});
		}
	},
	_updateLifecycleElement: function(leInfo){
		var self = this;
		var headers = {};
		headers[RH_ETAG] = this.eTag;
		self._enableSaveButtons(false);
		leServiceUtils.updateElement(this.uri, leInfo, {headers: headers},
				function(results, ioArgs){
					// keep eTag for update/delete
					self.eTag = ioArgs.xhr.getResponseHeader(RH_ETAG);

					var status = {
							type : jazz.ui.MessageBox.STATUS_TYPES.OK,
							summary : self._messages.saveSuccess,
							closable : false
					};
//					self.setLeInfo(leInfo.id, self.parentFolder);
					self.messageArea.showMessage(status);
					self._aeInfo = leInfo;
				},
				function(results, ioArgs){
					self._enableSaveButtons(true);
					self.errorHandler(results, ioArgs);
				});
	},
	_copyLifecycleElement: function(leInfo){
		var self = this;
		leInfo.title = dojo.string.substitute(this._messages.CopyOf, [leInfo.title]);
		this._enableSaveButtons(false);
		leServiceUtils.createChildElement(
				self.parentFolder,
				true,
				leInfo, 
				function(results, ioArgs){
					self.uri = ioArgs.xhr.getResponseHeader(RH_LOCATION);

					// keep eTag for update/delete
					self.eTag = ioArgs.xhr.getResponseHeader(RH_ETAG);

					self.saveButton.firstChild.nodeValue = self._messages.SaveQuery;
					self._enableSaveButtons(false);
					var status = {
							type : jazz.ui.MessageBox.STATUS_TYPES.OK,
							summary : self._messages.createSuccess,
							closable : false
					};
					self.nameNode.set("value", leInfo.title); //$NON-NLS-1$
					var newId = ioArgs.xhr.getResponseHeader(RH_ARTIFACT_ELEMENT_ID);
					self.idNode.set("value", newId); //$NON-NLS-1$
//					self.setLeInfo(newId, self.parentFolder); //TODO setLeInfo should be called after 95387 is fixed
					self.messageArea.showMessage(status);
					self._aeInfo = leInfo;
					dojo.mixin(self._aeInfo, {id: newId});
				},
				function(results, ioArgs){
					self._enableSaveButtons(true);
					self.errorHandler(results, ioArgs);
				});
	},

	_enableSaveButtons: function(enable){
		this.saveButton.disabled = enable ? "" : "true"; //$NON-NLS-1$ //$NON-NLS-2$
		this.saveAsButton.disabled = ""; //$NON-NLS-1$ //saveAsButton is always enabled
	},

	/**
	* This doesn't include the information about properties and parameters.
	* To get property and parameter data, call getData on the each table.
	*/
	_getLifecycleElementInfo: function() {
		var leInfo = {
				id: this.idNode.get("value"), //$NON-NLS-1$
				type: ns.ae.Ae,
				title: this.nameNode.get("value"), //$NON-NLS-1$
				description: this.descriptionText.get("value"), //$NON-NLS-1$
				sparqlTemplate: this.queryText.get("value") //$NON-NLS-1$
		};
		return leInfo;
	},

	//Messages
	hideMessage: function() {
		this.messageArea.hide();
		this.layout();
	},
	_showErrorMessage: function(message) {
		var status = {
			type : jazz.ui.MessageBox.STATUS_TYPES.ERROR,
			closable : false
		};
		if (dojo.isString(message))
			status.summary = message;
		else 
			dojo.mixin(status, message);
//		dojo.addClass(this._messageBoxContainer, "messageBoxVisible");
		this.messageArea.showMessage(status);
		this.layout();
	},
	/**
	* Displays a warning message to the user with the content being what is provided. 
	* The message can either just be a summary string or an object with the different parts of the message (summary, explanation and user action)
	*
	* @param message {String or Object}
	*/
	_showWarningMessage: function(message) {
		var status = {
			type : jazz.ui.MessageBox.STATUS_TYPES.WARNING,
			closable : true
		};
		if (dojo.isString(message))
			status.summary = message;
		else 
			dojo.mixin(status, message);
//		dojo.addClass(this._messageBoxContainer, "messageBoxVisible");
		this.messageArea.showMessage(status);
		this.layout();
	},

	_remoteError: function(error) {
		// Check if the content is still displaying
		if (!dojo.isDescendant(this.saveButton, document.body)) {
			// Not still displaying, ignore the error
			return;
		}
		this.messageArea.showMessage(this._queryMessages.invokeServiceError + error.message);
	},
	errorHandler: function(response, ioargs){
		var message = com.ibm.relm.le.ui.internal.util.getXhrErrorMessage(response, ioargs);
		this.messageArea.showMessage(message);
		if(response.responseText){
			response.responseText = null; // don't show the message in error dialog
		}
	}
});
})();