/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.le.leeditor.page.LifecycleElementList"); //$NON-NLS-1$

dojo.require("dojo.date"); //$NON-NLS-1$
dojo.require("dojo.date.stamp"); //$NON-NLS-1$
dojo.require("dojo.date.locale"); //$NON-NLS-1$

dojo.require("com.ibm.relm.le.leeditor.page.LifecycleElementListTable"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.leeditor.page.MetaNav"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.util"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("jazz.ui.FilterBox"); //$NON-NLS-1$
dojo.require("jazz.util.html"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.EasyMessageBox"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.leeditor.page.Toolbar"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.list.ListRow"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.list.FolderRow"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.list.ItemRow"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.upload.ImportUploadDialog"); //$NON-NLS-1$

dojo.require("com.ibm.relm.common.web.ui.util"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.le.leeditor.internal", "LifecycleElementListMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
var JazzUIWorkbench = net.jazz.ajax.ui.PlatformUI.getWorkbench();
var leServiceUtils = com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils;
var LifecycleElementListTable = com.ibm.relm.le.leeditor.page.LifecycleElementListTable;
var AE_LIST_MODE_EDIT = "edit"; //$NON-NLS-1$

dojo.declare("com.ibm.relm.le.leeditor.page.LifecycleElementList", //$NON-NLS-1$
		[dijit._Widget, dijit._Templated],
{
	editFolderAction:"#action=com.ibm.relm.le.leeditor.editLEFolder", //$NON-NLS-1$
	createQueryAction: "#action=com.ibm.relm.le.leeditor.showLEEditor", //$NON-NLS-1$

	// template
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.le","leeditor/page/templates/LifecycleElementList.html"), //$NON-NLS-1$ //$NON-NLS-2$

	postMixInProperties: function() {
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.le.leeditor.internal", "LifecycleElementListMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		var self = this;
		this.permissions = {};		
		leServiceUtils.getPermissions(function(results){
			dojo.forEach(results, function(p){
				if(p == "modify") self.permissions.modifyPermission = true; //$NON-NLS-1$
			});
			self._updateActions();
		},
		dojo.hitch(this, this.errorHandler));
	},

	postCreate: function(){
		this.inherited(arguments);

		this._table = new LifecycleElementListTable({
			mode: AE_LIST_MODE_EDIT,
			_filterArea: this._filterArea,
			showMessage: dojo.hitch(this, this.showMessage),
			hideMessage: dojo.hitch(this, this.hideMessage),
			_updateActions: dojo.hitch(this, this._updateActions)
		});
		this.aeTable.appendChild(this._table.domNode);
		this._populateHeader();
	},
	
	_populateHeader: function(){
		var messages = this._messages;
		this.metanav.setTitle(messages.lifecycleElement);

		var toolbar = new jazz.ui.SimpleToolbar({});
		this.metanav._toolbar = toolbar;
		this.metanav._toolbarDiv.appendChild(toolbar.domNode);
		toolbar.addButton(this, this._newResource, {showLabel: true, imgSrc: dojo.moduleUrl("com.ibm.relm.le", "leeditor/images/new_resource.gif"), label: messages.createLifecycleElement, requiresSelection:false, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._newFolder, {imgSrc: dojo.moduleUrl("com.ibm.relm.le","leeditor/images/new-folder-obj.gif"), label: this._messages.createFolder, requiresSelection:false, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._reloadResources, {imgSrc: dojo.moduleUrl("com.ibm.relm.le","leeditor/images/refresh16.gif"), label: messages.refresh, requiresSelection:false}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._deleteResources, {imgSrc: dojo.moduleUrl("com.ibm.relm.le","leeditor/images/delete_hov.gif"), label: messages.deleteQueryMsg, requiresSelection:true, requireDelete:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._moveResources, {imgSrc: dojo.moduleUrl("com.ibm.relm.le","leeditor/images/movecopy.gif"), label: messages.moveLifecycleElement, requiresSelection:true, moveCopy:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._importLifecycleElements, {imgSrc: dojo.moduleUrl("com.ibm.relm.le","leeditor/images/import_co.gif"), label: messages.importLifecycleElements, requiresSelection:false, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._exportLifecycleElements, {imgSrc: dojo.moduleUrl("com.ibm.relm.le","leeditor/images/export_co.gif"), label: messages.exportLifecycleElements, requiresSelection:true, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		this.refreshButton = this.metanav._toolbar.getItem(2);

		if(this.displayBreadcrumbs) {
			this.metanav.populateReportsBreadcrumbs();
		} else {
			this.metanav.handle.style.height = "30px"; //$NON-NLS-1$
			this.metanav.handle.style.minHeight = "30px"; //$NON-NLS-1$
		}
	},	

	/*
	 * Functions for action toolbar
	 */
	_newResource: function() {
		this.hideMessage();
		window.location.href = this.createQueryAction;
	},
	_newFolder: function() {
		this.hideMessage();
		window.location.href = this.editFolderAction + "&mode=create"; //$NON-NLS-1$
	},
	_reloadResources: function(){dojo.hitch(this._table, this._table._reloadResources)();},
	_deleteResources: function(){dojo.hitch(this._table, this._table._deleteResources)();},
	_moveResources: function(){dojo.hitch(this._table, this._table._moveResources)();},
	_importLifecycleElements: function(){dojo.hitch(this._table, this._table._importLifecycleElements)();},
	_exportLifecycleElements: function(){dojo.hitch(this._table, this._table._exportLifecycleElements)();},

	refresh: function(){
		this._table._refreshContent();
		JazzUIWorkbench.setTitle(this._messages.lifecycleElement);
	},

	_updateActions: function() {
		var toolbar = this.metanav._toolbar;
		var button = null;
		var i = 0;
		while((button = toolbar.getItem(i++)) != null) {
			var args = button.args;
			if(args.requireCreate || args.requireModify || args.requireDelete) {
				if (this.permissions.modifyPermission) {
					this._updateRequireSelection(button);
				} else {
					toolbar.disableButton(button);
				}
			}
			if(args.moveCopy) {
				this._updateRequireSelection(button);
			}
		}
	},
	
	_updateRequireSelection: function(button) {
		var toolbar = this.metanav._toolbar;
		if (button.args.requiresSelection) {
			if (this._table._getCheckedItems().length > 0)
				toolbar.enableButton(button);
			else
				toolbar.disableButton(button);
		}else{
			toolbar.enableButton(button);
		}
	},

	//Messages
	hideMessage: function() {
		this.messageArea.hide();
	},
	showMessage: function(message){
		this.messageArea.showMessage(message);
	},
	_showErrorMessage: function(message) {
		var status = {
			type : jazz.ui.MessageBox.STATUS_TYPES.ERROR,
			closable : false
		};
		if (dojo.isString(message))
			status.summary = message;
		else 
			dojo.mixin(status, message);
//		dojo.addClass(this._messageBoxContainer, "messageBoxVisible");
		this.showMessage(status);
	},
	/**
	* Displays a warning message to the user with the content being what is provided. 
	* The message can either just be a summary string or an object with the different parts of the message (summary, explanation and user action)
	*
	* @param message {String or Object}
	*/
	_showWarningMessage: function(message) {
		var status = {
			type : jazz.ui.MessageBox.STATUS_TYPES.WARNING,
			closable : true
		};
		if (dojo.isString(message))
			status.summary = message;
		else 
			dojo.mixin(status, message);
//		dojo.addClass(this._messageBoxContainer, "messageBoxVisible");
		this.showMessage(status);
	},
	_remoteError: function(error) {
		this.showMessage(error.message);
	},
	errorHandler: function(response, ioargs){
		var message = com.ibm.relm.le.ui.internal.util.getXhrErrorMessage(response, ioargs);
		this.showMessage(message);
		if(response.responseText){
			response.responseText = null; // don't show the message in error dialog
		}
	}
});
})();
