/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.le.leeditor.page.LifecycleElementListTable"); //$NON-NLS-1$

dojo.require("dojo.date"); //$NON-NLS-1$
dojo.require("dojo.date.stamp"); //$NON-NLS-1$
dojo.require("dojo.date.locale"); //$NON-NLS-1$

dojo.require("com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.leeditor.page.MoveElement"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.util"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("dijit.form.ToggleButton"); //$NON-NLS-1$
dojo.require("jazz.ui.FilterBox"); //$NON-NLS-1$
dojo.require("jazz.util.html"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.EasyMessageBox"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.leeditor.page.Toolbar"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.leeditor.queryparams.paramprompt.ParameterPromptDialog"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.list.ListRow"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.list.FolderRow"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.list.ItemRow"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.upload.ImportUploadDialog"); //$NON-NLS-1$

dojo.require("com.ibm.relm.common.web.ui.util"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.le.leeditor.internal", "LifecycleElementListMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
var leServiceUtils = com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils;
var ns = com.ibm.relm.le.ui.namespace;
var INDENT = 20;
var INDENT2 = 40;
var RH_ETAG = "ETag"; //$NON-NLS-1$
var MODE_EXECUTE = "execute"; //$NON-NLS-1$
var MODE_EDIT = "edit"; //$NON-NLS-1$

var FilterBox = jazz.ui.FilterBox;
var StyledTable = jazz.ui.StyledTable;

var ListRow = com.ibm.relm.le.ui.internal.list.ListRow;
var FolderRow = com.ibm.relm.le.ui.internal.list.FolderRow;
var ItemRow = com.ibm.relm.le.ui.internal.list.ItemRow;

dojo.declare("com.ibm.relm.le.leeditor.page.LifecycleElementListTable", //$NON-NLS-1$
		[dijit._Widget, dijit._Templated],
{
	_childMap: {},
	_colexpState: {},
	_folders: {},
	_widgets: [],
	_callCount: 0,
	_previousSelectedResourceUri: null,
	_prevSelectedRow: null,
	_refreshRequired: false,
	_uriToeTag: {},
	_uriToParamValues: {},
	mode: MODE_EDIT,
	getPermissions: null,
	
	editFolderAction:"#action=com.ibm.relm.le.leeditor.editLEFolder", //$NON-NLS-1$

	/*
	 * Expected to set by parent page widget such as LifecycleElementList
	 */
	showMessage: null,
	hideMessage: null,
	_updateActions: null,

	// template
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.le","leeditor/page/templates/LifecycleElementListTable.html"), //$NON-NLS-1$ //$NON-NLS-2$

	postMixInProperties: function() {
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.le.leeditor.internal", "LifecycleElementListMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._updatePermissions();
	},

	postCreate: function(){
		this.inherited(arguments);

		this._filterBox = new FilterBox({onChange: dojo.hitch(this, function(filter){
			this._filterText = filter && filter.toLowerCase();
			this._doFilter(this._table.domNode);
		})});
		this._filterArea.appendChild(this._filterBox.domNode);

		dojo.when(this.getPermissions, dojo.hitch(this, this._onPermission));
	},

	_onPermission: function(){
		if(dojo.isFunction(this._updateActions)) {
			this._updateActions();
		}
		this._createTable();
		this._refreshContent();
	},

	_createTable: function(){
		var messages = this._messages;
		var columns = [{label: messages.Name, width: "30%", sortable: true}, //$NON-NLS-1$
			{label: messages.CreatedBy, width: "14%", sortable: true}, //$NON-NLS-1$
			{label: messages.LastUpdated, width: "14%", sortable: true}]; //$NON-NLS-1$
		if(this.permissions.modifyPermission){
			columns.push({label: messages.Actions, width: "12%", className: "action-column" , sortable: false}); //$NON-NLS-1$ //$NON-NLS-2$
		}
		this._table = new StyledTable({columns: columns,
										trim: jazz.ui.StyledTable.TrimStyles.PRIMARY_HEADLESS, 
//										handleSort: dojo.hitch(this, this._handleSort),
//										sortBy: 0,
//										sortByAscending: true,
										showHover: true});
		this._resultsArea.appendChild(this._table.domNode);
	},

	destroy: function(){
		this._emptyTable();
		this.inherited(arguments);
	},

	_updatePermissions: function(){
		if(this.getPermissions){
			return;
		}
		var self = this;
		this.getPermissions = leServiceUtils.getPermissions();
		this.getPermissions.then(
				function(results){
					self.permissions = {};
					dojo.forEach(results, function(p){
						if(p == "modify") self.permissions.modifyPermission = true; //$NON-NLS-1$
					});
				},
				dojo.hitch(this, this.errorHandler));
	},
	_emptyTable: function() {
		if(!this._table){
			return;
		}
		var widgets = dijit.findWidgets(this._table.domNode);
		dojo.forEach(widgets, function(widget) {
			widget.destroyRecursive();
		});
		this._table.clearBody();
	},
	
	_refreshContent: function(){
		this.hideMessage();
		this._emptyTable();
		
		if(this._startLoading){
			return;
		}
		this._startLoading = true;
		
		var self = this;
		leServiceUtils.getRootElements(
			function(results){
				self._startLoading = false;
				if(dojo.isArray(results)){
					dojo.forEach(results, function(resource){
						self._uriToeTag[resource.uri] = resource.etag;
						var childRow = null;
						switch(resource.type){
						case ns.ae.Folder:
							childRow = self._createFolderRow(resource, INDENT, true);
							break;
						case ns.ae.Ae:
							childRow = self._createLERow(null, resource, INDENT, true);
							break;
						default:
							break;
						}
						if(childRow){
							dojo.place(childRow.domNode, self._table.tbody, "last"); //$NON-NLS-1$
						}
					});
				}
				self._updateActions();
			},
			dojo.hitch(this, this.errorHandler));
	},

	_createFolderRow: function(folder, padding, fShow) {
		var item = this._createFolderItem(folder);
		var folderRow = new FolderRow({
			item: item, 
			padding: padding, 
			fShow: fShow,
			_expanded: this._colexpState[item.id],
			mode: this.mode,
			permissions: this.permissions
		});
		this.connect(folderRow, "onCheck", this._handleFolderChecked); //$NON-NLS-1$
		this.connect(folderRow, "onColExp", this.onFolderColExp); //$NON-NLS-1$
		this._widgets.push(folderRow);
		if(this.mode === MODE_EDIT || this.permissions.modifyPermission){
			this._initializeFolderActions(folderRow.item, folderRow.actionBar);
		}
		return folderRow;
	},
	
	_handleFolderChecked: function() {
		this._updateActions();
	},
	
	_createFolderItem: function(folder){
		//TODO correct temporary values
		return {
			uri: folder.uri,
			id: folder.id,
			type: folder.type,
			numChildren: folder.numChildren || 0,
			creator: {
				type: "uri", //$NON-NLS-1$
				value: folder.creator
			},
			description: folder.description || "", //$NON-NLS-1$
			modified: folder.modified,
			name: {
				label: folder.title,
				type: "uri", //$NON-NLS-1$
				value: folder.title
			},
			ownedBy: folder.owner
		};
	},
	_initializeFolderActions: function(folder, containerNode) {
		var messages = this._messages;
		var toolbar = new com.ibm.relm.le.leeditor.page.Toolbar({});
		toolbar.addButton(this, dojo.hitch(this, "_createNewFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.le","ui/images/new-folder-obj.gif"), label: messages.createFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		toolbar.addButton(this, dojo.hitch(this, "_editFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.le","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		toolbar.addButton(this, dojo.hitch(this, "_deleteResource", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.le","ui/images/delete.gif"), label: messages.deleteMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		toolbar.addButton(this, dojo.hitch(this, "_moveResource", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.le","ui/images/movecopy.gif"), label: messages.moveFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		containerNode.appendChild(toolbar.domNode);
	},	
	_createNewFolder: function(folder) {
		this.hideMessage();
		window.location.href = this.editFolderAction + "&mode=create&parentUri=" + folder.uri ; //$NON-NLS-1$
	},
	
	_editFolder: function(folder) {
		this.hideMessage();
		window.location.href = this.editFolderAction + "&mode=modify&folderUri=" + folder.uri; //$NON-NLS-1$
	},

	_createLERow: function(parent, le, padding, fShow){
		var item = this._createLEItem(parent, le);
		var leRow = new ItemRow({
			item: item, 
			padding: padding, 
			fShow: fShow,
			_handleCheckBoxClick: dojo.hitch(this, this._handleResourceCheckBoxClick),
			onResourceSelected: dojo.hitch(this, this.onResourceSelected),
			mode: this.mode,
			permissions: this.permissions
		});
//		if(resource.name.value == this._previousSelectedResourceUri) {
//			this._prevSelectedRow = leRow;
//		}
		if(this.mode === MODE_EDIT || this.permissions.modifyPermission){
			this._initializeLEActions(leRow.item, leRow.actionBar);
		}
		this._doFilterForWidget(leRow);
		return leRow;
	},
	_createLEItem: function(parent, le){
		//TODO correct temporary values
		return {
			parent: parent,
			uri: le.uri,
			id: le.id,
			type: le.type,
			creator: {
				type: "uri", //$NON-NLS-1$
				value: le.creator
			},
			description: le.description || "", //$NON-NLS-1$
			modified: le.modified,
			name: {
				label: le.title,
				type: "uri", //$NON-NLS-1$
				value: le.uri
//				value: "?leId=" + le.id + "#action=relm.admin.le_editor"
			},
			ownedBy: le.owner
		};
	},
	_initializeLEActions: function(le, containerNode) {
		var messages = this._messages;
		var toolbar = new com.ibm.relm.le.leeditor.page.Toolbar({});
		toolbar.addButton(this, dojo.hitch(this, "_editResource", le), {imgSrc: dojo.moduleUrl("com.ibm.relm.le","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		toolbar.addButton(this, dojo.hitch(this, "_deleteResource", le), {imgSrc: dojo.moduleUrl("com.ibm.relm.le","ui/images/delete.gif"), label: messages.deleteLifecycleElementMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		toolbar.addButton(this, dojo.hitch(this, "_moveResource", le), {imgSrc: dojo.moduleUrl("com.ibm.relm.le","ui/images/movecopy.gif"), label: messages.moveLifecycleElement}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		containerNode.appendChild(toolbar.domNode);
	},

	_editResource: function(r){
		this.hideMessage();
		var parent = r.parent;
		var parentParam = parent ? "&parent=" + encodeURIComponent(parent) : ""; //$NON-NLS-1$ //$NON-NLS-2$
		window.location.href = "#action=com.ibm.relm.le.leeditor.showLEEditor&id="+ encodeURIComponent(r.id) + parentParam; //$NON-NLS-1$
	},

	onFolderColExp: function(folderRow, expand) {
		this.hideMessage();
		var self = this;
		var folderItem = folderRow.item;
		if(expand){
			if(folderItem.numChildren > 0){
				leServiceUtils.getElements(
						folderItem.uri,
						function(results){
							if(dojo.isArray(results)){
								var indent = folderRow.padding + INDENT2;
								var prevRow = folderRow; // place holder to insert new child
								dojo.forEach(results, function(resource){
									self._uriToeTag[resource.uri] = resource.etag;
									var childRow = null;
									switch(resource.type){
									case ns.ae.Folder:
										childRow = self._createFolderRow(resource, indent, true);
										break;
									case ns.ae.Ae:
										childRow = self._createLERow(folderItem.uri, resource, indent, true);
										break;
									default:
										break;
									}
									if(childRow){
										dojo.place(childRow.domNode, prevRow.domNode, "after"); //$NON-NLS-1$
										prevRow = childRow;
										if(!folderRow.childRows) folderRow.childRows = [];
										folderRow.childRows.push(childRow);
									}
								});
							}
						},
						dojo.hitch(this, this.errorHandler));
			}
		}else{
			dojo.forEach(folderRow.childRows, function(childRow){
				this._destroyItemRowRecursively(childRow);
			}, this);
			folderRow.childRows = [];
		}
		this.showExpando(folderRow.domNode, !expand || folderItem.numChildren > 0);
	},
	
	_destroyItemRowRecursively: function(itemRow){
		dojo.forEach(itemRow.childRows, function(childRow){
			this._destroyItemRowRecursively(childRow);
		}, this);
		itemRow.childRows = [];
		dojo.destroy(itemRow.domNode);
		itemRow.destroy();
	},
	
	_handleResourceCheckBoxClick: function(args){
		this._updateActions();
	},
	_setRowCheckedState: function(rowID, checkedState){
		var tr = this.getTr(rowID);
		if(!tr) return;
		var cb = this._getCheckboxFromTR(tr);
		cb.checked = checkedState;
	},
	_getCheckboxFromTR: function(trNode){
		if(trNode._rowType == "folder") { //$NON-NLS-1$
			return trNode.children[0].children[1]; //First child is the <td> second child of that is the input (checkbox);
		} else {
			return trNode.children[0].children[0]; //First child is the <td> first child of that is the input (checkbox);
		}
	},
	onResourceSelected: function(target){
		if(this.mode === MODE_EXECUTE){
			this._previousSelectedResourceUri = target.resource.uri;
			leServiceUtils.getElement(
					target.resource.uri,
					dojo.hitch(this, this._executeQuery),
					dojo.hitch(this, this.errorHandler)
					);
		}else if(this.mode === MODE_EDIT){
			this._previousSelectedResourceUri = target.resource.uri;
			var parent = target.resource.parent;
			var parentParam = parent ? "&parent="+encodeURIComponent(parent) : ""; //$NON-NLS-1$ //$NON-NLS-2$
			window.location.href = "#action=com.ibm.relm.le.leeditor.showLEEditor&id=" + encodeURIComponent(target.resource.id) + parentParam; //$NON-NLS-1$
		}
	},
	_executeQuery: function(results, ioArgs){
		var self = this;
		var queryInfo = {artifactElementId: results.id};
		if(dojo.isArray(results.parameters) && results.parameters.length > 0){
			dojo.mixin(queryInfo, {
				queryName: results.title,
				parameterized: "true", //$NON-NLS-1$
				parameters: results.parameters,
				parameterValues: this._uriToParamValues[ioArgs.url] || {}
			});
			this._performPrompt(queryInfo,
					function(parameterValues){
						//onsubmit
						self._uriToParamValues[ioArgs.url] = parameterValues;
						queryInfo.parameterValues = parameterValues;
						self._showQueryResult(queryInfo);
					},
					dojo.hitch(this, "errorHandler")); //$NON-NLS-1$
		}else{
			queryInfo.parameterized = "false"; //$NON-NLS-1$
			self._showQueryResult(queryInfo);
		}
	},
	_performPrompt: function(queryInfo, onsubmit, oncancel) {
		//This function will not be used in 5.0
		var promptArgs = {
				queryName: queryInfo.queryName,
				parameters: queryInfo.parameters,
				parameterValues: queryInfo.parameterValues,
				isDirty: false,
				_onCancel: dojo.hitch(this, oncancel),
				_onSubmit: dojo.hitch(this, onsubmit)
		};

		var d = new com.ibm.relm.le.leeditor.queryparams.paramprompt.ParameterPromptDialog(promptArgs);
		d.startup();
	},
	_showQueryResult: function(queryInfo){
		window.location = "#action=jazz.viewPage&id=com.ibm.relm.explorer.web.ui.page.QueryPage"; //$NON-NLS-1$
		net.jazz.ajax.ui.PlatformUI.getWorkbench().viewPage("com.ibm.relm.explorer.web.ui.page.QueryPage", function(){ //$NON-NLS-1$
			if(queryInfo){
				setTimeout(function(){dojo.publish("EXECUTE_QUERY", [queryInfo]);},1000); //$NON-NLS-1$
			}
		});
	},

	/*
	 * Delete LE or Folder 
	 */
	_deleteResource: function(r) {
		this.hideMessage();
		var messages = this._messages;
		var msg = messages.confirmDelLifecycleElement;
		if(r.type == ns.ae.Folder){
			msg = messages.confirmDelFolder;
		}
		if (!confirm(dojo.string.substitute(msg, [r.name.label]))) {
			return;
		}
		var self = this;
		var headers = {};
		headers[RH_ETAG] = this._uriToeTag[r.uri];
		leServiceUtils.deleteElement(
				r.uri,
				{headers: headers},
				function(){
					self._refreshContent(); // TODO: need optimize
				},
				dojo.hitch(this, this.errorHandler));
	},

	_deleteResources: function() {
		this.hideMessage();
		// find checked items
		var items = this._getCheckedItems(true);
		if (items.length <= 0)
			return;
			
		// folder or artifact elements
		var resourceItems = dojo.filter(items, function(item){
			return item.type == ns.ae.Ae;
		});
		var folderItems = dojo.filter(items, function(item){
			return item.type == ns.ae.Folder;
		});

		// show confirmation message
		var messages = this._messages;
		var confirmMsg;
		if (resourceItems.length > 0){
			if(folderItems.length > 0){
				confirmMsg = dojo.string.substitute(messages.confirmDelLifecycleElementsAndFolders, [resourceItems.length, folderItems.length]);
			}else{
				confirmMsg = dojo.string.substitute(messages.confirmDelLifecycleElements, [resourceItems.length]);
			}
		}else{
			confirmMsg = dojo.string.substitute(messages.confirmDelFolders, [folderItems.length]);
		}
		
		if (!confirm(confirmMsg)) {
			return;
		}
		
		var self = this;
		var uris = dojo.map(items, function(item){ 
			return item.uri; 
		});
		//TODO need to consider etag
		leServiceUtils.deleteElements(
				uris,
				function(){
					self._refreshContent();
				},
				dojo.hitch(this, this.errorHandler));
	},
	
	_moveResource: function(resource){
		this._moveResourcesCore([resource]);
	},

	_moveResources: function(){
		var items = this._getCheckedItems(true);
		if (items.length <= 0)
			return;
		this._moveResourcesCore(items);
	},
	
	_moveResourcesCore: function(items){
		this.hideMessage();
		var args = {
			items: items,
			permissions: this.permissions,
			okCallback: dojo.hitch(this,this._moveOkCallback),
			cancelCallback: dojo.hitch(this,this._moveCancelCallback)
		};
		var moveResource = new com.ibm.relm.le.leeditor.page.MoveElement(args);
		moveResource.startup();
		
		this._moveDialog = new jazz.ui.Dialog({
			contentNode: moveResource.mainDiv,
			primaryTitle: this._messages.moveLifecycleElement,
			width: "425px", //$NON-NLS-1$
			isClosable: true
		});
	},

	_moveOkCallback: function(args)	{
		this._moveDialog.close();
		this._moveDialog.destroy();
		this._refreshContent();
	},
	
	_moveCancelCallback: function(args)	{
		this._moveDialog.close();
		this._moveDialog.destroy();
	},

	/*
	 * 
	 */
	_exportLifecycleElements: function(){
		this.hideMessage();
		var items = this._getCheckedItems(false);
		if (items.length <= 0)
			return;
		var ids = dojo.map(items, function(l){
			return l.id;
		});
		
		if (ids.length > 0)	{
			var url = com.ibm.relm.le.ui.leServiceUri + "?method=export&projectAreaID=" + jazz.app.context.get().itemId; //$NON-NLS-1$			
			com.ibm.relm.common.web.ui.util.downloadFile(url, "id", ids, true); //$NON-NLS-1$
		}
	},

	/*
	 * Import Artifact Elements package via file upload
	 */
	_importLifecycleElements: function(){
		this.hideMessage();
		var d = new com.ibm.relm.le.ui.internal.upload.ImportUploadDialog({
			onClose: dojo.hitch(this, this._importCompleted)
		});
		d.startup();
	},
	
	_importCompleted: function(){
		this._refreshContent();
	},
	
	/*
	 * Internal methods
	 */
	_getCheckedItems: function() {
		if(!this._table){
			return [];
		}
		var widgets = dijit.findWidgets(this._table.domNode);
		var checkedWidgets = dojo.filter(widgets, function(widget) {
			return (widget instanceof ListRow) && widget.isChecked();
		});
		var checkedItems = dojo.map(checkedWidgets, function(widget){
			return widget.item;
		});
		return checkedItems || [];
	},

	_doFilter: function(rootNode) {
		var widgets = dijit.findWidgets(rootNode);
		dojo.forEach(widgets, function(w){
			this._doFilterForWidget(w);
		}, this);
	},
	
	_doFilterForWidget: function(widget){
		var filter = this._filterText;
		var displayType = "";//$NON-NLS-1$ 
		if(filter && filter.length > 0 && widget.item.type == ns.ae.Ae){
			var label = widget.item.name.label.toLowerCase();
			var description = widget.item.description.toLowerCase();
			if(label.indexOf(filter) < 0 && description.indexOf(filter) < 0){
				displayType = "none"; //$NON-NLS-1$
			}
		}
		widget.domNode.style.display = displayType;
	},
	
	_reloadResources: function() {
		this._refreshContent();
	},
	getTr: function(guid) {
		return dojo.query('[data-guid=' + guid + ']')[0]; //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	//Messages
	_remoteError: function(error) {
		this.showMessage(error.message);
	},
	errorHandler: function(response, ioargs){
		var message = com.ibm.relm.le.ui.internal.util.getXhrErrorMessage(response, ioargs);
		this.showMessage(message);
		if(response.responseText){
			response.responseText = null; // don't show the message in error dialog
		}
	},

	/**
	 * Toggles showing of the expando on a folder row
	 * @param {Tr} folderRow		The folder row with the expando
	 * @param {boolean} condition	True indicates showing, False indicates hiding
	 */
	showExpando: function(folderRow, condition) {
		dojo.toggleClass(folderRow, 'noChildren', !condition); //$NON-NLS-1$
	}
});
})();
