/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.le.leeditor.page.MetaNav"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.Button"); //$NON-NLS-1$
dojo.require("dijit.Dialog"); //$NON-NLS-1$

//dojo.require("com.ibm.team.reports.web.ui.ReportsConstants");
//dojo.require("com.ibm.team.reports.web.util.ReportsUtil");
dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
dojo.require("jazz.ui.Breadcrumbs"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.le.leeditor.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

//var ReportsConstants = com.ibm.team.reports.web.ui.ReportsConstants;	
//var ReportsUtil = com.ibm.team.reports.web.util.ReportsUtil;
var STATUS_TYPES = jazz.ui.MessageBox.STATUS_TYPES;
var PageHoverHelp= jazz.app.ua.PageHoverHelp;
var messages = dojo.i18n.getLocalization("com.ibm.relm.le.leeditor.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.relm.le.leeditor.page.MetaNav", //$NON-NLS-1$
	[dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.relm.le", "leeditor/page/templates/MetaNav.html"), //$NON-NLS-1$ //$NON-NLS-2$
	
	widgetsInTemplate: true,
	
	constructor: function(args) {
		this.loading = messages.loading;
		this.messages = messages;
	},
	
	setTitle: function(title) {
		// consumers of setTitle are responsible for escaping the parameter themselves
		this.heading.innerHTML = title;
		dojo.removeClass(this.heading, "loading"); //$NON-NLS-1$
	},

	populateQueriesBreadcrumbs: function(shared) {
//		this.breadcrumbs.segments = [];
//		this.breadcrumbs.segments.push({ label: messages.reports, href: ReportsUtil.getReportsWelcomeHref()});
//		
//		if(shared=="true"){
//			this.breadcrumbs.segments.push({ label: messages.sharedReports, href: ReportsUtil.getReportsListHref(shared)});
//		} else if(shared=="false"){
//			this.breadcrumbs.segments.push({ label: messages.myReports, href: ReportsUtil.getReportsListHref(shared)});
//		}
//		this.breadcrumbs.refresh();
	},
	
	populateResourcesBreadcrumbs: function() {
//		this.breadcrumbs.segments = [];
//		this.breadcrumbs.segments.push({ label: messages.reports, href: ReportsUtil.getReportsWelcomeHref()});
//		this.breadcrumbs.segments.push({ label: messages.listOfResources, href: ReportsUtil.getResourcesListHref()});	
//		this.breadcrumbs.refresh();
	},
	
	_handleHeaderMessageClick: function(e) {
		e.preventDefault();
		if (!e || !e.target || !e.target.__jazzMessage) return;

		var message = e.target.__jazzMessage;
		var text = message.message;
		if (message.details) {
			text += "\n\n"; //$NON-NLS-1$
			text += message.details;
		}
		alert(text);
	},
	
	clearValidationMessage: function(force) {
		this.validationMessageSpan.className = "validationMessageEmpty"; //$NON-NLS-1$
	},
	
	insertTypeIcon: function(typeIcon){
		this.leftHeadingWrapper.insertBefore(typeIcon, this.heading);
	},
	
	clearMessage: function () {
		this.messageBox.hideMessage();
	},
	
	displayErrorMessage: function (msg) {
		this.displayMessage(msg, STATUS_TYPES.ERROR);
	},
	
	displayMessage: function (msg, type) {
		this.messageBox.showMessage({ 
		   type: type,
		   summary: msg,
		   closable: true
		});
	},
	
	createContextSensitiveHelp: function(uaKey) {
		dojo.empty(this.csHelpNode);
		if (this.pageHelp) {
			this.pageHelp.destroy();
		}
		var parms= {};
		parms.uaKey= uaKey;
		this.pageHelp= new PageHoverHelp(parms);
		this.csHelpNode.appendChild(this.pageHelp.domNode);
	}, 
	
	destroy: function() {
		if (this.pageHelp) {
			this.pageHelp.destroy();
		}
		this.inherited(arguments);
	}	
});

})();
