/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.le.leeditor.page.MoveElement"); //$NON-NLS-1$

dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("com.ibm.relm.le.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.view.edit.FolderSelectDialogContent"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.le.leeditor.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() { // module container
var leServiceUtils = com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils;

/**
 * Widget to move a report or folder
 */
dojo.declare("com.ibm.relm.le.leeditor.page.MoveElement", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
	templatePath: dojo.moduleUrl("com.ibm.relm.le", "leeditor/page/templates/MoveElement.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,
	
	postMixInProperties: function(args) {
		this.inherited(arguments);
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.le.leeditor.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function(){
		this.inherited(arguments);
		this.messageBox = new jazz.ui.MessageBox();
		this._messageBoxContainer.appendChild(this.messageBox.domNode);
	},
	
	destroy: function(){
		this.messageBox.destroy();
		this.inherited(arguments);
	},
			
	_moveOrCopyChanged: function(ev){
		this._updateEnablement();
	},

	_updateEnablement: function() {
		this._okButton.disabled = (!this._moveButton.checked && !this._copyButton.checked);
	},

	onOk: function() {
		var self = this;
		self._okButton.disabled = true;
		self._cancelButton.disabled = true;
		var uris = dojo.map(self.items, function(item) { return item.uri; });
		var destination = this._folderSelection.getValues();
		var f = this._moveButton.checked ? "moveElements" : "copyElements"; //$NON-NLS-1$ //$NON-NLS-2$
 		leServiceUtils[f](uris, destination).then(function(results){
 			self._updateEnablement();
			if (self.okCallback != null)
				self.okCallback();
		}, function(error){
			// error
			var status = {
					type : jazz.ui.MessageBox.STATUS_TYPES.ERROR,
					summary : error.message,
					closable : false
				};
				dojo.addClass(self._messageBoxContainer, "messageBoxVisible"); //$NON-NLS-1$
				self.messageBox.showMessage(status);
				self._cancelButton.disabled = false;
				self._updateEnablement();
		});
	},
	
	onCancel: function() {
		if (this.cancelCallback != null)
			this.cancelCallback();
	}
});

})();