/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.le.leeditor.queryparams.paramprompt.ArtifactPrompt"); //$NON-NLS-1$

dojo.require("com.ibm.relm.le.leeditor.queryparams.paramprompt.DataPrompt"); //$NON-NLS-1$
dojo.require("dijit.form.TextBox"); //$NON-NLS-1$

(function(){
var CLASS_EDIT_COMMAND = "edit-command"; //$NON-NLS-1$
var util = com.ibm.relm.le.ui.internal.util;

dojo.declare(
	"com.ibm.relm.le.leeditor.queryparams.paramprompt.ArtifactPrompt", //$NON-NLS-1$
	[com.ibm.relm.le.leeditor.queryparams.paramprompt.DataPrompt], 
{
	templatePath: dojo.moduleUrl('com.ibm.relm.le','leeditor/queryparams/paramprompt/templates/ArtifactPrompt.html'), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,

	postCreate: function(){
		this.inherited(arguments);

		var self = this;
		var anchor = dojo.create("a", { //$NON-NLS-1$
			href: "#", //$NON-NLS-1$
			title: this.messages.selectArtifact,
			className: "dijitInline actionIcon" //$NON-NLS-1$
		});
		this.connect(anchor, "onclick", function(e){ //$NON-NLS-1$
			dojo.stopEvent(e);
			self.openSelectArtifactDialog(anchor);
		});
		dojo.create("span", { //$NON-NLS-1$
			className: "dijitInline " + CLASS_EDIT_COMMAND //$NON-NLS-1$
		}, anchor);
		
		this.selectArtifactAction.appendChild(anchor);
	},

	fillValue: function(value) {
		this.input.set("value", value.value); //$NON-NLS-1$
	},
	
	getValue: function() {
		return {
			type: "string", //$NON-NLS-1$
			value: this.input.get("value") //$NON-NLS-1$
		};
	},

	openSelectArtifactDialog: function(){
		var type = "artifact"; //$NON-NLS-1$
		if(util.hasPicker(type)){
			var self = this;
			util.openPicker(type, this.input.get("value"), this.messages.selectArtifactDialogTitle, function(value){ //$NON-NLS-1$
				self.input.set("value", value.uri || value); //$NON-NLS-1$
				this.close();
			});
		}
	}
});
})();