/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.le.leeditor.queryparams.paramprompt.DatePrompt"); //$NON-NLS-1$

dojo.require("com.ibm.relm.le.leeditor.queryparams.paramprompt.DataPrompt"); //$NON-NLS-1$
dojo.require("dijit.form.DateTextBox"); //$NON-NLS-1$

(function(){

	dojo.declare(
		"com.ibm.relm.le.leeditor.queryparams.paramprompt.DatePrompt", //$NON-NLS-1$
		[com.ibm.relm.le.leeditor.queryparams.paramprompt.DataPrompt], 
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.le','leeditor/queryparams/paramprompt/templates/DatePrompt.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: true,
			
			postMixInProperties: function(){
				this.dateFormat = dojo.date.locale._parseInfo().bundle["dateFormat-short"]; //$NON-NLS-1$
				this.dateLabel = dojo.replace(this.messages.dateLabel, [this.label, this.dateFormat]);
			},
			fillValue: function(value) {
				this.input.set('value', value.value); //$NON-NLS-1$
			},
			
			getValue: function() {
				var date = this.input.get('value'); //$NON-NLS-1$
				return {
					type: "date", //$NON-NLS-1$
					value: !date ? "" : dojo.date.stamp.toISOString(date) //$NON-NLS-1$
				};
			}
		});

})();