/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.ple.web.rtc.RtcPreviewSummaryItem"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.ple.web.rtc", "RtcPreviewDialogMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

	dojo.declare(
		"com.ibm.relm.ple.web.rtc.RtcPreviewSummaryItem", //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			messages: dojo.i18n.getLocalization("com.ibm.relm.ple.web.rtc", "RtcPreviewDialogMessages"), //$NON-NLS-1$ //$NON-NLS-2$

			/**
			 * The diff type this item summarizes
			 * @type {String}
			 */
			type: '', //$NON-NLS-1$

			/**
			 * The state of the items this item is summarizing. 
			 *
			 * False means that the items are showing, and that the hide option is available
			 * @type {Boolean}
			 */
			showing: true,

			constructor: function(args, node) {
				this.type = args.type;
				this.number = args.number;
				this.typeLabel = this.messages[this.type];
				var summary;
				if (args.showToggle) {
					var linkTemplate = '<a href="#" dojoAttachPoint="toggleLink" title="${messages.hideTitle}">${messages.hide}</a>'; //$NON-NLS-1$
					summary = dojo.replace(this.messages.summaryTemplateToggle, [this.typeLabel, this.number, linkTemplate]);
				} else {
					summary = dojo.replace(this.messages.summaryTemplate, [this.typeLabel, this.number]);
				}
				this.templateString = '<li><img src="${_blankGif}" alt="${typeLabel}" title="${typeLabel}" class="ple-icon ple-icon-${type}Component">' + summary + '</li>'; //$NON-NLS-1$ //$NON-NLS-2$
			},

			postCreate: function() {
				this.connect(this.snapLink, 'click', function(e) { //$NON-NLS-1$
					e && dojo.stopEvent(e);
					this.snapDiffType(this.type);
				});
			},

			snapDiffType: function(type) {
				//No-op
			},

			_setShowingAttr: function(/*boolean*/ showing) {
				if (!this.showToggle) return;

				if (showing) {
					dojo.attr(this.toggleLink, 'title', this.messages.hideTitle); //$NON-NLS-1$
					dojo.attr(this.toggleLink, 'innerHTML', this.messages.hide); //$NON-NLS-1$
				} else {
					dojo.attr(this.toggleLink, 'title', this.messages.showTitle); //$NON-NLS-1$
					dojo.attr(this.toggleLink, 'innerHTML', this.messages.show); //$NON-NLS-1$
				}
				this.showing = showing;
			}
		});

})();