/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.common.web.ui.DialogHelpHeader"); //$NON-NLS-1$

dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require('jazz.app.ua.PageHoverHelp'); //$NON-NLS-1$

(function(){
	dojo.declare(
		"com.ibm.relm.common.web.ui.DialogHelpHeader", //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.common.web','ui/templates/DialogHelpHeader.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,

			mainMessage: '', //$NON-NLS-1$
			contentHelpId: '', //$NON-NLS-1$
			mainHtmlMessage: '', //$NON-NLS-1$
			backgroundClass: 'relm-DialogHelpHeader-defaultBackground', //$NON-NLS-1$
			
			attributeMap: {
				mainHtmlMessage : {
					node : 'mainHtmlMessageNode', //$NON-NLS-1$
					type: "innerHTML" //$NON-NLS-1$
				},
				content: {
					node: 'containerNode', //$NON-NLS-1$
					type: "innerHTML" //$NON-NLS-1$
				}
			},

			postCreate: function() {
				this.inherited(arguments);
				
				this._csHelpWidgets = [];
				
				if (this.mainMessage) {
					var textNode = document.createTextNode(this.mainMessage);
					this.mainMessageText.appendChild(textNode);
				}
				if (this.contentHelpId) {
					this._createContextSensitiveHelp(this.contentHelpId);
				}
				else if (this.mainHtmlMessage) {
					this.mainHtmlMessageNode.innerHTML = this.mainHtmlMessage;
				}
			},
			
			destroy: function() {
				dojo.forEach(this._csHelpWidgets, function(w) { w.destroy; });
				this.inherited(arguments);
			},
			
			_createContextSensitiveHelp: function(csHelpId) {
				dojo.empty(this.csHelpNode);
				this._createCSHWidget(csHelpId);
			},

			_createCSHWidget: function(uaKey) {
				var parms = {};
				parms.uaKey = uaKey;
				var pageHelp = new jazz.app.ua.PageHoverHelp(parms);
				this.csHelpNode.appendChild(pageHelp.domNode);
				this._csHelpWidgets.push(pageHelp);
			}
		}
	);

})();