/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.ple.web.ui.ExportProductDialog"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.ple.web.ui", "ExportProductDialogMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('jazz.ui.Dialog');//$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.DialogStatusMessage');//$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.util');//$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Site'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.StatusMessage'); //$NON-NLS-1$

(function(){

	dojo.declare(
		"com.ibm.relm.ple.web.ui.ExportProductDialog", //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','ui/templates/ExportProductDialog.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: true,

			messages: dojo.i18n.getLocalization("com.ibm.relm.ple.web.ui", "ExportProductDialogMessages"), //$NON-NLS-1$ //$NON-NLS-2$
			
			site: null,

			constructor: function(args) {
				this.defaultFileName = (args.site.itemVersion || args.site.configVersion).name; //$NON-NLS-1$
			},

			postCreate: function() {
				this.dialog = new jazz.ui.Dialog({
					primaryTitle: this.messages.dialogTitle,
					// secondaryTitle: this.site.product.name,
					width: '400px', //$NON-NLS-1$
					contentNode: this.domNode,
					destroyContents: true
				});

				this.dialog.startup();
			},

			_onSubmit: function(e) {
				e && dojo.stopEvent(e);
				var self = this;

				var message = com.ibm.relm.common.web.StatusMessage.show(this.messages.exportingStatus);

				var	fileName = this._fileNameInput.value;
				var fileFormat = this._formatSelect.options[this._formatSelect.selectedIndex].value;

				jazz.client.xhrPost({
					url: net.jazz.ajax._contextRoot + '/ple/export', //$NON-NLS-1$
					handleAs: 'json', //$NON-NLS-1$
					content: {
						site: com.ibm.relm.ple.web.ui.Site.siteToJsonSite(this.site),
						fileName: fileName,
						fileFormat: fileFormat
					},
				
					load: function (result) {
						com.ibm.relm.common.web.ui.util.downloadFile('/ple/export', 'id', [result.id], false, true); //$NON-NLS-1$ //$NON-NLS-2$
						self.dialog.close();
					},
				
					error: function(error, ioArgs) {
						self.messageBox.showXhrError(ioArgs.xhr, true);
					},

					handle: function() {
						message.hide();
					}
				});
			},

			_onCancel: function() {
				this.dialog.close();
			}
		});

})();