/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.common.web.ui.LqeAuthDialog'); //$NON-NLS-1$

dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.common.web.ui', 'LqeAuthDialogMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require('jazz.ui.Dialog'); //$NON-NLS-1$

(function(){
	dojo.declare(
		'com.ibm.relm.common.web.ui.LqeAuthDialog', //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.common.web','ui/templates/LqeAuthDialog.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,
			lqeAuthUrl: '', //$NON-NLS-1$
			onClose: null,
			messages: dojo.i18n.getLocalization('com.ibm.relm.common.web.ui', 'LqeAuthDialogMessages'), //$NON-NLS-1$ //$NON-NLS-2$

			postCreate: function() {
				this.inherited(arguments);

				this._dialog = new jazz.ui.Dialog({
					primaryTitle: this.messages.lqeAuthDialogTitle,
					width: Math.min(dijit.getViewport().w - 100, 900) + 'px', //$NON-NLS-1$
					destroyContents: true,
					contentNode: this.domNode,
					closable: false,
					onClose: this.onClose,
					iconClass: 'relm-icon-lqe' //$NON-NLS-1$
				});

			},

			_onDone: function(e) {
				dojo.stopEvent(e);
				this._dialog.close();
			},

			uninitialize: function() {
				this.inherited(arguments);
			}
		}
	);

})();