dojo.provide('com.ibm.relm.ple.web.ui.TreeMenuFactory'); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.ple.web.ui', 'TreeMenuFactoryMessages'); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeSelection'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.MoveReusePlaceState'); //$NON-NLS-1$
dojo.require('jazz.ui.Menu'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.productedit.EditPropertiesDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.productedit.RenameResourceDialog'); //$NON-NLS-1$
dojo.require('relm.app.Permissions'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.StreamManagement'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.advanced.AdvancedSettings'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.ReplaceBaselineDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.RtcSettings'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.picker.AddUrlDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.ExportProductDialog');//$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Goto'); //$NON-NLS-1$

(function(){

var messages = dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui', 'TreeMenuFactoryMessages'); //$NON-NLS-1$ //$NON-NLS-2$

var productapi = com.ibm.relm.ple.web.ui.productapi;
var TreeSelection = com.ibm.relm.ple.web.ui.TreeSelection;
var MoveReusePlaceState = com.ibm.relm.ple.web.ui.MoveReusePlaceState;
var Permissions = relm.app.Permissions;
var StreamManagement = com.ibm.relm.ple.web.rtc.StreamManagement;
var AdvancedSettings = com.ibm.relm.ple.web.advanced.AdvancedSettings;
var Goto = com.ibm.relm.ple.web.ui.Goto;

// Start out as a flag saying this hasn't bee loaded yet.
var AnalysisUtil = false;
var ViewUtils = false;

jazz.core.loader.load_async('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil', function() { //$NON-NLS-1$
	// Replace the flag with the actual object once loaded.
	AnalysisUtil = dojo.getObject('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil'); //$NON-NLS-1$
});

jazz.core.loader.load_async('com.ibm.relm.explorer.web.ui.view.util.ViewUtils', function() { //$NON-NLS-1$
	// Replace the flag with the actual object once loaded.
	ViewUtils = dojo.getObject('com.ibm.relm.explorer.web.ui.view.util.ViewUtils'); //$NON-NLS-1$
});

function createConfigVersionUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createConfiguration, //$NON-NLS-1$
		iconClass: 'ple-icon-createConfigVersion', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			productapi.createConfigVersion(TreeSelection.getSelectedSite());
		}
	});
}

function createProductUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createProduct,
		iconClass: 'ple-icon-createProduct', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			productapi.createProduct(TreeSelection.getSelectedSite());
		}
	});
}

function addArtifactUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.addArtifactLink,
		disabled: disabled,
		iconClass: 'ple-icon-addArtifact', //$NON-NLS-1$
		onClick: function() {
			var picker = new com.ibm.relm.ple.web.ui.picker.LqeArtifactPicker({
				selectedSite: TreeSelection.getSelectedSite(),
				filterProducts: true,
				showAddAndClose: true
			});

			picker.startup();
		}
	});
}

function addConfigurationUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.associateConfiguration,
		disabled: disabled,
		iconClass: 'ple-icon-associateConfiguration', //$NON-NLS-1$
		onClick: function() {
			dojo.publish('ple.pick_configuration', [TreeSelection.getSelectedSite()]); //$NON-NLS-1$
		}
	});
}

function createCopyOfConfigurationUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createCopyOfConfiguration,
		disabled: disabled,
		iconClass: 'ple-icon-copyConfigVersion', //$NON-NLS-1$
		onClick: function() {
			productapi.createCopyOfConfiguration(TreeSelection.getSelectedSite());
		}
	});
}

// Same as create a copy, just different label
function createModifiableCopyOfConfigurationUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createModifiableCopyOfConfiguration,
		disabled: disabled,
		iconClass: 'ple-icon-copyConfigVersion', //$NON-NLS-1$
		onClick: function() {
			productapi.createCopyOfConfiguration(TreeSelection.getSelectedSite());
		}
	});
}

function replaceConfigurationUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.replaceVersion,
		disabled: disabled,
		iconClass: 'ple-icon-replaceConfigVersion', //$NON-NLS-1$
		onClick: function() {
			productapi.useVersionOfConfiguration(TreeSelection.getSelectedSite());
		}
	});
}

function patchBaselineUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.patchBaseline,
		disabled: disabled,
		iconClass: 'ple-icon-patchBaseline', //$NON-NLS-1$
		onClick: function() {
			productapi.patchBaselineOfConfiguration(TreeSelection.getSelectedSite());
		}
	});
}

function addUrlUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.addHyperlink,
		iconClass: 'ple-icon-addHyperlink', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var picker = new com.ibm.relm.ple.web.ui.picker.AddUrlDialog({
				site: TreeSelection.getSelectedSite()
			});

			picker.startup();
		}
	});
}

/**
 * The Properties menu item shouldn't be shown for variability parameters, but
 * is shown as enabled otherwise (even on immutable products) so you can at
 * least see them (the dialog itself governs whether the Save button is
 * enabled).
 */
function editProperties() {
	return new dijit.MenuItem({
		label: messages.editProperties,
		iconClass: 'ple-icon-edit', //$NON-NLS-1$
		onClick: function() {
			dojo.publish('ple.edit_properties'); //$NON-NLS-1$
		}
	});
}

function editDimensions() {
	return new dijit.MenuItem({
		label: messages.editDimensions,
		iconClass: 'ple-icon-dimension', //$NON-NLS-1$
		onClick: function() {
			var d = new com.ibm.relm.ple.web.ui.branch.EditBranchDialog({
				site: TreeSelection.getSelectedSite(),
				servicePath: '/ple/edit_dimensions' //$NON-NLS-1$
			});
			d.startup();
		}
	});
}

function renameUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.rename,
		iconClass: 'ple-icon-rename', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var dialog = com.ibm.relm.ple.web.productedit.RenameResourceDialog({
				site: TreeSelection.getSelectedSite()
			});
			dialog.startup();
		}
	});
}

function compareTrees() {
	return new dijit.MenuItem({
		label: messages.compareWithPreviousConfiguration,
		iconClass: 'ple-icon-compare', //$NON-NLS-1$
		onClick: function() {
			var site = TreeSelection.getSelectedSite();
			Goto.gotoCompare(site);
		}
	});
}

function showAuditHistory() {
	return new dijit.MenuItem({
		label: messages.showAuditHistory,
		iconClass: 'ple-icon-history', //$NON-NLS-1$
		onClick: function() {
			var site = TreeSelection.getSelectedSite();

			if (site.emptyPart) {
				Goto.gotoShowHistory(null, site.contextPartUri);
			}
			else {
				Goto.gotoShowHistory(site.itemVersion.uri);
			}
		}
	});
}

function findUse() {
	return new dijit.MenuItem({
		label: messages.findUse,
		iconClass: 'ple-icon-findUse', //$NON-NLS-1$
		onClick: function() {
			var site = TreeSelection.getSelectedSite();
			var resourceVersion = site.configVersion || site.itemVersion;
			Goto.gotoFindUse(resourceVersion.uri);
		}
	});
}

function findArtifactUse() {
	return new dijit.MenuItem({
		label: messages.findUseInProducts,
		iconClass: 'ple-icon-findUse', //$NON-NLS-1$
		onClick: function() {
			var link = TreeSelection.getSelectedSite().link;
			dojo.publish('ple.find_artifact_use', [link.uri, link.privateBaseline]); //$NON-NLS-1$
		}
	});
}

function checkOutUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.checkOut,
		iconClass: 'ple-icon-checkOut', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var selectedSite = TreeSelection.getSelectedSite();
			productapi.checkOutProduct(selectedSite);
		}
	});
}

function checkInUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.checkIn,
		iconClass: 'ple-icon-checkIn', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var site = TreeSelection.getSelectedSite();

			if (site.contextConfigVersionUri) {
				productapi.checkInProduct(site);
				return;
			}

			dojo.publish('ple.create_snapshot'); //$NON-NLS-1$
		}
	});
}

function addProductOrConfigVersionUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.addProduct,
		disabled: disabled,
		iconClass: 'ple-icon-addProduct', //$NON-NLS-1$
		onClick: function() {
			var site = TreeSelection.getSelectedSite();

			var picker = new com.ibm.relm.ple.web.ui.picker.ProductPicker({
				selected: site
			});

			picker.startup();
		}
	});
}

function createBranchUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createBranch,
		disabled: disabled,
		iconClass: 'ple-icon-createBranch', //$NON-NLS-1$
		onClick: function() {
			dojo.publish('ple.create_branch', [TreeSelection.getSelectedSite()]); //$NON-NLS-1$
		}
	});

}

function removeAnythingUnless(disabled) {
	var selectedSites = TreeSelection.getAllSelectedSites();
	var canDelete = false;
		if (selectedSites.length == 1) {
			var site = selectedSites[0];
			var resourceVersion = site.itemVersion || site.configVersion || site.emptyPart;
			if (!(resourceVersion.isImmutable || site.emptyPart || site.link || site.isInBaseline)) {
				canDelete = true;
			}
	}

	return new dijit.MenuItem({
		label: canDelete ? messages.deleteProduct : messages.removeProduct,
		iconClass: canDelete ? 'ple-icon-delete' : 'ple-icon-remove', //$NON-NLS-1$ //$NON-NLS-2$
		disabled: disabled,
		onClick: function() {
			dojo.publish('ple.remove_anything', [selectedSites]); //$NON-NLS-1$
		}
	});
}

function removeChildConfigUnless(disabled) {
	var selectedSites = TreeSelection.getAllSelectedSites();

	return new dijit.MenuItem({
		label: messages.removeProduct,
		iconClass: 'ple-icon-remove', //$NON-NLS-1$ 
		disabled: disabled,
		onClick: function() {
			dojo.publish('ple.remove_child_config', [selectedSites]); //$NON-NLS-1$
		}
	});
}

function replaceBranchUnless(disabled) {
	var selected = TreeSelection.getSelectedSite();

	return new dijit.MenuItem({
		label: messages.replaceBranch,
		iconClass: 'ple-icon-replaceBranch', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			dojo.publish('ple.use_branch', [selected]); //$NON-NLS-1$
		}
	});
}

function replaceVersionUnless(disabled) {
	var selectedSite = TreeSelection.getSelectedSite();

	return new dijit.MenuItem({
		label: messages.replaceVersion,
		iconClass: 'ple-icon-replaceItemVersion', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			dojo.publish('ple.replace_version', [selectedSite]); //$NON-NLS-1$
		}
	});
}

/**
 * This is for DOORS baselines, not configuration baselines
 */
function replaceDoorsBaselineUnless(disabled) {
	var selected = TreeSelection.getSelectedSite();

	return new dijit.MenuItem({
		label: messages.replaceBaseline,
		iconClass: 'ple-icon-replaceBaseline', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var d = new com.ibm.relm.ple.web.ui.pages.ReplaceBaselineDialog({
				site: selected
			});
			d.startup();
		}
	});
}

function moveUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.moveMenuLabel,
		iconClass: 'ple-icon-move', //'cut-enabled', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			MoveReusePlaceState.saveSelectionForMove();
		}
	});
}

function reuseUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.reuseMenuLabel,
		iconClass: 'ple-icon-reuse', //'copy-enabled' //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			MoveReusePlaceState.saveSelectionForReuse();
		}
	});
}

function placeUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.placeMenuLabel,
		iconClass: 'ple-icon-place', //'paste-enabled', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			MoveReusePlaceState.placeSavedSelection();
		}
	});
}

function openAnyLinkInNewWindow(menuItemLabel) {
	return new dijit.MenuItem({
		label: menuItemLabel,
		iconClass: 'ple-icon-artifactLink', //$NON-NLS-1$
		onClick: function() {
			var hyperlinkItem = TreeSelection.getSelectedSite().link;
			if (hyperlinkItem) window.open(hyperlinkItem.uri);

		}
	});
}

function openHyperlinkInNewWindow(argument) {
	return openAnyLinkInNewWindow(messages.openLinkInNewWindow);
}

function openArtifactInNewWindow(argument) {
	return openAnyLinkInNewWindow(messages.openArtifactInNewWindow);
}

function startAnalysis() {
	return new dijit.MenuItem({
		label: messages.startAnalysis,
		iconClass: 'ple-icon-impactAnalysis', //$NON-NLS-1$
		onClick: function(event) {
			var selected = TreeSelection.getSelectedSite();
			var target = (event.ctrlKey) ? "_blank" : "_self" ; //$NON-NLS-1$ //$NON-NLS-2$
			if (selected.type == 'link') { //$NON-NLS-1$
				AnalysisUtil.createAnalysisForResource(selected.link.oslcConceptUri, selected.contextConfigVersionUri, target);
			}
			else if (selected.type == 'product') {//$NON-NLS-1$
				AnalysisUtil.createAnalysisForResource(selected.product.uri, selected.contextConfigVersionUri, target);
			}
			else if (selected.type == 'configVersion') { //$NON-NLS-1$
				
				AnalysisUtil.createAnalysisForResource(selected.configVersion.uri, null, target);
			}
		}
	});
}

function importUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.importProducts,
		iconClass: 'ple-icon-import', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var site = TreeSelection.getSelectedSite();
			productapi.importProducts(site);
		}
	});
}

function exportUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.exportProduct,
		iconClass: 'ple-icon-download', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var site = TreeSelection.getSelectedSite();
			var d = new com.ibm.relm.ple.web.ui.ExportProductDialog({site: site});
			d.startup();
		}
	});
}

function redactUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.redactVersion,
		iconClass: 'ple-icon-redact', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var sites = TreeSelection.getAllSelectedSites();
			dojo.publish('ple.redact', [sites]); //$NON-NLS-1$
		}
	});
}

function createItemVersionInConfigVersionUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createProduct,
		iconClass: 'ple-icon-createProduct', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			productapi.createProduct(TreeSelection.getSelectedSite());
		}
	});
}

function createBaselineUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createBaseline,
		iconClass: 'ple-icon-createBaseline', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			productapi.createBaseline(TreeSelection.getSelectedSite());
		}
	});
}

function replaceWithChildren(disabled) {
	return new dijit.MenuItem({
		label: messages.replaceWithChildren,
		iconClass: 'ple-icon-replaceWithChildren', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			productapi.replaceWithChildren(TreeSelection.getSelectedSite());
		}
	});
}

function replaceWithNewConfiguration(disabled) {
	return new dijit.MenuItem({
		label: messages.replaceWithWithNewConfiguration,
		iconClass: 'ple-icon-replaceWithConfiguration', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			productapi.replaceWithNewConfigVersion(TreeSelection.getSelectedSite());
		}
	});
}

function newConfigVersionContextMenu() {
	var site = TreeSelection.getSelectedSite();
	var configVersion = site.configVersion;

	var canModify = Permissions.canProductsModify();
	var canAddProperty = Permissions.canProductsAddProperty();
	var canSnapshot = Permissions.canProductsCreateSnapshot();
	var canBranch = Permissions.canProductsBranch();
	var isChild =  !!site.parentResourceVersion;
	var isImmutable = configVersion.isImmutable;
	var isPlaceReady = MoveReusePlaceState.isPlaceReady();
	var isInBaseline = site.isInBaseline;
	var canExport = !!AdvancedSettings.product_export;

	var menu = new jazz.ui.Menu();

	if (!isImmutable) {
		canModify && menu.addMenuItem(createConfigVersionUnless());
		canModify && menu.addMenuItem(createItemVersionInConfigVersionUnless());

		menu.needsSeparator = true;
		canModify && menu.addMenuItem(createCopyOfConfigurationUnless());
		canSnapshot && menu.addMenuItem(createBaselineUnless());

		menu.needsSeparator = true;
		canModify && menu.addMenuItem(addProductOrConfigVersionUnless());
		canAddProperty && menu.addMenuItem(addArtifactUnless());
		canAddProperty && menu.addMenuItem(addUrlUnless());

		menu.needsSeparator = true;
	}

	if (isImmutable) {
		// This is a baseline
		canModify && menu.addMenuItem(createModifiableCopyOfConfigurationUnless());
		canModify && menu.addMenuItem(patchBaselineUnless());

		menu.needsSeparator = true;
		canModify && isChild && !isInBaseline && menu.addMenuItem(replaceConfigurationUnless());
		!!AnalysisUtil && menu.addMenuItem(startAnalysis());
		!!ViewUtils && menu.addMenuItem(ViewUtils.createMenuItemToOpenViewForSelectedArtifact( {uri:configVersion.uri, type: configVersion.type})); //$NON-NLS-1$

		menu.needsSeparator = true;
		menu.addMenuItem(findUse());
		menu.addMenuItem(compareTrees());

		menu.needsSeparator = true;
		canModify && menu.addMenuItem(reuseUnless());

		if (canModify) {
			menu.needsSeparator = true;
			if (isChild || !isImmutable) menu.addMenuItem(removeAnythingUnless());
			canExport && menu.addMenuItem(exportUnless());	
		} 
	}
	else {
		if (canModify && isChild) {
			menu.addMenuItem(replaceConfigurationUnless());	

			if (configVersion.children) menu.addMenuItem(replaceWithChildren());

			menu.needsSeparator = true;
		}

		!!AnalysisUtil && menu.addMenuItem(startAnalysis());
		!!ViewUtils && menu.addMenuItem(ViewUtils.createMenuItemToOpenViewForSelectedArtifact( {uri:configVersion.uri, type: configVersion.type})); //$NON-NLS-1$
		menu.needsSeparator = true;
		menu.addMenuItem(findUse());
		menu.addMenuItem(compareTrees());

		menu.needsSeparator = true;
		canModify && isChild && menu.addMenuItem(moveUnless());
		canModify && menu.addMenuItem(reuseUnless());
		canModify && isPlaceReady && menu.addMenuItem(placeUnless());

		menu.needsSeparator = true;
		// in the case of child configurations being used in checked-in items we cannot
		// determine if we can delete the configuration or not as they could still be  mutable
		// we therefore show Remove and Delete menu items and provide errors when the delete fails
		canModify && isChild && menu.addMenuItem(removeChildConfigUnless());
		canModify && menu.addMenuItem(removeAnythingUnless());
		canModify && menu.addMenuItem(renameUnless());

		menu.needsSeparator = true;
		canModify && menu.addMenuItem(importUnless());
		canModify && canExport && menu.addMenuItem(exportUnless());

		menu.needsSeparator = true;
		if (canBranch) menu.addMenuItem(editDimensions());
		menu.addMenuItem(editProperties());
	}

	menu.startup();
	return menu;
}

function newEmptyPartContextMenu() {
	var canModify = Permissions.canProductsModify();

	var site = TreeSelection.getSelectedSite();
	var isInBaseline = site.isInBaseline;
	var isPartForConfigVersion = site.emptyPart.isPartForConfigVersion;

	var menu = new jazz.ui.Menu();
	var needsSeparator = false;

	if (!isInBaseline && canModify) {
		menu.addChild(replaceVersionUnless());
		needsSeparator = true;
		
	}

	if (!isPartForConfigVersion) {
		if (needsSeparator) menu.addChild(new dijit.MenuSeparator());
		menu.addChild(showAuditHistory());
		needsSeparator = true;
	}

	if (!isInBaseline && canModify) {
		if (needsSeparator) menu.addChild(new dijit.MenuSeparator());

		menu.addChild(moveUnless());
		menu.addChild(new dijit.MenuSeparator());
		menu.addChild(removeAnythingUnless());
	}

	menu.startup();
	return menu;
}

/**
 * Smarter wrapper around .addChild that will add a pending menu separator
 * before adding a child menu item. This is done in cases where some menu
 * items are optional and possibly a whole section is optional. The
 * .needsSeparator flag is set on the menu in that case, and the next menu
 * item that's added will first add a separator. If no menu items in that
 * section were added no separator is added for that section.
 * 
 * @param {object} menuItem the menu item to add. 
 */
jazz.ui.Menu.prototype.addMenuItem = function (menuItem) {
	if (this.needsSeparator) {
		this.addChild(new dijit.MenuSeparator());
		delete this.needsSeparator;
	}

	this.addChild(menuItem);
};

function newProductContextMenu() {
	var menu = new jazz.ui.Menu();

	var selectedSite = TreeSelection.getSelectedSite();
	var itemVersion = selectedSite.product;
	var isVariabilityParams = itemVersion.conditionVariables !== undefined;
	var isChild =  !!selectedSite.parentResourceVersion;
	//TODO: Remove these two when prototype no longer needed
	var hasGlobalConfiguration = itemVersion["http://jazz.net/ns/vvc#configuration_fake_global"] !== undefined; //$NON-NLS-1$
	var hasExternalConfiguration = itemVersion["http://jazz.net/ns/vvc#configuration_fake"] !== undefined; //$NON-NLS-1$
	var isImmutable = TreeSelection.store.getValue(itemVersion, 'isImmutable'); //$NON-NLS-1$
	var isPlaceReady = MoveReusePlaceState.isPlaceReady();
	var canModify = Permissions.canProductsModify();
	var canSnapshot = Permissions.canProductsCreateSnapshot();
	var canBranch = Permissions.canProductsBranch();
	var canAddProperty = Permissions.canProductsAddProperty();
	var canExport = !!AdvancedSettings.product_export;
	var canRedact = Permissions.canProductsRedact();
	var isInBaseline = selectedSite.isInBaseline;

	if (!isVariabilityParams && canModify && !isInBaseline) {
		menu.addChild(createConfigVersionUnless());
		menu.addChild(createProductUnless());
		menu.addChild(new dijit.MenuSeparator());
	}

	if (!isInBaseline) {
		if (isImmutable) {
			canModify && menu.addChild(checkOutUnless());
		}
		else {
			canSnapshot && menu.addChild(checkInUnless());
		}
		
		canBranch && menu.addChild(createBranchUnless());

		if (canModify || canSnapshot || canBranch) { //If none of these are apply, then this whole section is empty, so don't want a separator under it
			menu.addChild(new dijit.MenuSeparator());
		}
	}

	if (StreamManagement.isEnabled() && !isVariabilityParams) {
		var submenuItem = new dijit.PopupMenuItem({
			label: messages.streamManagement,
			popup: StreamManagement.createMenuForSelectedSites(),
			iconClass: 'ple-icon-rtc' //$NON-NLS-1$
		});

		menu.addChild(submenuItem);
		menu.addChild(new dijit.MenuSeparator());
	}

	if (!isVariabilityParams) {
		canModify && !isInBaseline && menu.addChild(addProductOrConfigVersionUnless());
		canAddProperty && !isInBaseline && menu.addChild(addArtifactUnless());
		canAddProperty && !isInBaseline && menu.addChild(addUrlUnless());

		if ((canModify || canAddProperty) && !isInBaseline) menu.addChild(new dijit.MenuSeparator());
	}

	if (canModify && !isInBaseline && isChild) {
		menu.addChild(replaceVersionUnless());
		menu.addChild(replaceBranchUnless());
		menu.addChild(replaceWithNewConfiguration());
		menu.addChild(new dijit.MenuSeparator());
	}

	!!AnalysisUtil && menu.addChild(startAnalysis());
	!!ViewUtils && menu.addChild(ViewUtils.createMenuItemToOpenViewForSelectedArtifact( {uri:itemVersion.uri, type: itemVersion.type})); //$NON-NLS-1$

	menu.addChild(new dijit.MenuSeparator());

	menu.addChild(findUse());
	menu.addChild(showAuditHistory());

	menu.addChild(new dijit.MenuSeparator());

	canModify && !isInBaseline && isChild && menu.addChild(moveUnless());
	canModify && menu.addChild(reuseUnless());
	canModify && !isInBaseline && isPlaceReady && menu.addChild(placeUnless());

	menu.needsSeparator = true;

	canModify && !isInBaseline && menu.addMenuItem(removeAnythingUnless());
	canModify && !isInBaseline && menu.addMenuItem(renameUnless());

	menu.needsSeparator = true;

	canModify && !isInBaseline && menu.addMenuItem(importUnless());
	canModify && canExport && menu.addMenuItem(exportUnless());
	canModify && canRedact && menu.addMenuItem(redactUnless());

	if (!isVariabilityParams) {
		menu.needsSeparator = true;
		menu.addMenuItem(editProperties());
	}

	menu.startup();

	return menu;
}

function newArtifactContextMenu() {
	var site = TreeSelection.getSelectedSite();

	var canDeleteProperty = Permissions.canProductsDeleteProperty();
	var canModify = Permissions.canProductsModify();
	var artifact = site.link;

	var menu = new jazz.ui.Menu();

	menu.addChild(openArtifactInNewWindow());

	menu.addChild(new dijit.MenuSeparator());

	if (artifact.isDoorsBaseline) {
		canModify && menu.addChild(replaceDoorsBaselineUnless());
	}
	menu.addChild(findArtifactUse());
	!!AnalysisUtil && menu.addChild(startAnalysis());

	menu.addChild(new dijit.MenuSeparator());
	canModify && !site.isInBaseline && menu.addChild(moveUnless());
	canModify && menu.addChild(reuseUnless());

	if (canDeleteProperty && !site.isInBaseline) {
		menu.addChild(new dijit.MenuSeparator());
		menu.addChild(removeAnythingUnless());
	}

	menu.startup();

	return menu;
}

/**
 * Factory to create new dijit.Menus pre-populated with the proper menu items
 * for the currently selected item in the tree. Can be used from the page level toolbar
 * or the tree itself.
 */
dojo.mixin(com.ibm.relm.ple.web.ui.TreeMenuFactory, {

	/**
	 * Returns a brand new dijit.Menu. The caller must destroy this when done.
	 * The menu items will be linked to the currently selected items or items
	 * in the TreeSelection.
	 *
	 * @return {dojo.Menu}            [description]
	 */
	newContextMenuForSelected: function () {
		var type = TreeSelection.getSelectedType();

		switch (type) {
		case 'product': //$NON-NLS-1$
			return newProductContextMenu();

		case 'configVersion': //$NON-NLS-1$
			return newConfigVersionContextMenu();

		case 'link': //$NON-NLS-1$
			return newArtifactContextMenu();

		case 'emptyPart': //$NON-NLS-1$
			return newEmptyPartContextMenu();

		default:
			throw new Error('Unknown type in tree: ' + type); //$NON-NLS-1$
		}
	}

});

})();
