/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.ui.branch.DimensionItem'); //$NON-NLS-1$

dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.ple.web.ui.branch', 'DimensionItemMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('jazz.ui.tree.AbstractItem'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.StatefulRow'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch._ForceWatchCallbacksMixin'); //$NON-NLS-1$

(function(){

	dojo.declare(
		'com.ibm.relm.ple.web.ui.branch.DimensionItem', //$NON-NLS-1$
		[ jazz.ui.tree.AbstractItem ],
		{
			model: null,

			shouldRemoveStatefulRow: null,

			constructor: function() {
				this.untitledValueCount = 1;
			},

			buildRendering: function() {
				this.domNode = dojo.create('div', { //$NON-NLS-1$
					className: 'ple-DimensionItem' //$NON-NLS-1$
				});

				this.stateful = new com.ibm.relm.ple.web.ui.branch.StatefulRow({
					model: this.model,
					shouldRemoveStatefulRow: this.shouldRemoveStatefulRow,
					imgClass: null //this.model.shared ? 'ple-icon-dimensionShared' : '' //$NON-NLS-1$ //$NON-NLS-2$
				});

				this.stateful.placeAt(this.domNode);
			},

			getFocusNode: function() {
				return this.stateful._labelNode;
			},

			rename: function() {
				this.stateful.rename();
			},

			uninitialize: function() {
				this.stateful.destroyRecursive();

				// probably not needed, but ensures no cycles
				delete this.delegate;
			}
		}
	);
})();