/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.ple.web.ui.branch.HeaderItem"); //$NON-NLS-1$

dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("jazz.ui.tree.AbstractItem"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.ple.web.ui.branch", "HeaderItemMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

dojo.declare("com.ibm.relm.ple.web.ui.branch.HeaderItem", [jazz.ui.tree.AbstractItem, dijit._Templated], { //$NON-NLS-1$
	label: '',	// The label to show on the node //$NON-NLS-1$

	templateString: '<div class="ple-HeaderItem"><img src="${_blankGif}" class="${iconClass}"> <span dojoAttachPoint="_label" class="label">${label}</span></div>', //$NON-NLS-1$
	
	messages: dojo.i18n.getLocalization("com.ibm.relm.ple.web.ui.branch", "HeaderItemMessages"), //$NON-NLS-1$ //$NON-NLS-2$

	_spinnerSrc: dojo.moduleUrl('com.ibm.relm.common.web','ui/images/spinner.gif'), //$NON-NLS-1$ //$NON-NLS-2$
	iconClass: '', //$NON-NLS-1$

	update: function() {
		this._label.innerHTML = this.label;
	},

	_setLoadingAttr: function(isLoading) {
		dijit.setWaiState(this.domNode, 'busy', isLoading); //$NON-NLS-1$

		this._loadingImg && dojo.destroy(this._loadingImg);
		delete this._loadingImg;

		if (!isLoading) return;

		this._loadingImg = dojo.create('img', { //$NON-NLS-1$
			alt: this.messages.loading,
			'aria-busy': 'true', //$NON-NLS-1$ //$NON-NLS-2$
			src: this._spinnerSrc,
			className: 'ple-icon ple-iconMarginLeft' //$NON-NLS-1$
		});
		dojo.place(this._loadingImg, this.domNode, 'last'); //$NON-NLS-1$
	},

	setLabel: function(newLabel) {
		this.label = newLabel;
		this.update();
	},

	getFocusNode: function() {
		return this._label;
	}

});

})();