/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.ui.branch.ManageDimensionsPage'); //$NON-NLS-1$

dojo.require('net.jazz.ajax.ui.PlatformUI'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.FloatingMessageBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.EasyMessageBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.DimensionEditor'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.Button'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.Section'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.picker.ProductPicker'); //$NON-NLS-1$
dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.ple.web.ui.branch', 'ManageDimensionsPageMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization('com.ibm.relm.ple.web.admin', 'SettingsPageMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization('com.ibm.relm.ple.web.ui.branch', 'CreateBranchDialogMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.formatting'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.StatusMessage'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.ProductBreadcrumbs'); //$NON-NLS-1$
dojo.require('jazz.ui.StyledTable'); //$NON-NLS-1$
dojo.require('jazz.util.html'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Drawer'); //$NON-NLS-1$
dojo.require('jazz.ui.StyledBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.AutoHeightBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeSelection'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.tree.TreeRefresh'); //$NON-NLS-1$

(function(){

	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var formatting = com.ibm.relm.ple.web.ui.formatting;
	var html = jazz.util.html;

	dojo.declare(
		'com.ibm.relm.ple.web.ui.branch.ManageDimensionsPage', //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			_updatingSrc: dojo.moduleUrl('com.ibm.relm.ple.web','ui/images/updating.gif'), //$NON-NLS-1$ //$NON-NLS-2$

			templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','ui/branch/templates/ManageDimensionsPage.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: true,

			// Need to borrow messages from Settings page to use "Discard
			// Changes?" after the new message cutoff date for this release.
			messages: dojo.mixin(
				dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui.branch', 'ManageDimensionsPageMessages'), //$NON-NLS-1$ //$NON-NLS-2$
				dojo.i18n.getLocalization('com.ibm.relm.ple.web.admin', 'SettingsPageMessages'), //$NON-NLS-1$ //$NON-NLS-2$
				dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui.branch', 'CreateBranchDialogMessages')), //$NON-NLS-1$ //$NON-NLS-2$

			// We just keep this as a static for easy checking from the component menu
			// to know if to show this as visually dirty. Not clean since we shouldn't use
			// global data for an "instance" of this page, but since each page is created once,
			// this works as a quick hack.
			dirty: false,
			selectedProduct: null,

			referenceBoxTrim: jazz.ui.StyledBox.TrimStyles.BLUE,

			constructor: function(args, node)
			{
				// cache the hitched version so that we don't need to keep creating new functions and closures
				this._onDirtyDimensionsCallback = dojo.hitch(this, this._onDirtyDimensions);
			},

			postCreate: function() {
				this.inherited(arguments);

				var PlatformUI = net.jazz.ajax.ui.PlatformUI;
				var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
				ActionRegistry.registerAction('ple.manage_dimensions', this, 'loadDimensionsAction'); //$NON-NLS-1$ //$NON-NLS-2$

				this._drawer.setDrawerContent(this._drawerContent);

				this._drawerAutoHeight = new com.ibm.relm.common.web.ui.AutoHeightBox(this._drawer.domNode, {
					listenOnPage: 'com.ibm.relm.ple.web.ui.branch.ManageDimensionsPage' //$NON-NLS-1$
				});

				this._setBranches();
				this._setAffectedProducts();

				PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this._onBeforeUnload));
			},

			onShow: function() {
				PlatformUI.getWorkbench().setTitle(this.messages.pageTitle);
			},

			_onBeforeUnload: function(e) {
				if (!this._saveButton.disabled) {
					// Show the unsaved page.
					 
					function showUnsavedPage() {
						document.location.href = '#' + dojo.objectToQuery({ //$NON-NLS-1$
							action: 'ple.manage_dimensions' //$NON-NLS-1$
						});
					}

					// Chrome won't allow us to change the page during this event, so
					// wait until it is over (after the user clicks Don't Reload).
					setTimeout(showUnsavedPage, 0);
					// Most other browser let us do it now. This action safe to do twice:
					// the second time just stays on the page.
					showUnsavedPage();

					// This message may not be shown if the browser is anal about security, but
					// this result must still be truthy.
					return this.messages.confirmRefreshSettingsPrompt;
				}
			},

			_setAffectedProducts: function(otherProducts) {
				this._affectedProductsTable && dojo.destroy(this._affectedProductsTable);

				this._affectedProductsTable = dojo.create('table', { //$NON-NLS-1$
					className: 'ple-ManageDimensions-referenceTable', //$NON-NLS-1$
					width: '100%' //$NON-NLS-1$
				});

				if (!otherProducts || !otherProducts.length) {
					var emptyTr = dojo.create('tr', null, this._affectedProductsTable); //$NON-NLS-1$
					dojo.create('td', { //$NON-NLS-1$
						className: 'j-hint', //$NON-NLS-1$
						innerHTML: html.escape(this.messages.noAffectedProducts)
					}, emptyTr);

					this._affectedProductsBox.containerNode.appendChild(this._affectedProductsTable);
					return;
				}

				for (var i = 0; i < otherProducts.length; i++) {
					var product = otherProducts[i];
					var productHtml = formatting.formatProductIconAndTitleForItem(product);
					var tr = dojo.create('tr', null, this._affectedProductsTable); //$NON-NLS-1$
					dojo.create('td', { //$NON-NLS-1$
						innerHTML: productHtml
					}, tr);
				}

				this._affectedProductsBox.containerNode.appendChild(this._affectedProductsTable);
			},

			_setBranches: function(branchNames) {
				this._branchesTable && dojo.destroy(this._branchesTable);

				if (!branchNames) {
					this._branchesBox.domNode.style.display = 'none'; //$NON-NLS-1$
					return;
				}

				this._branchesBox.domNode.style.display = ''; //$NON-NLS-1$

				var header = dojo.replace(this.messages.branchesOfProductXHeader, [this.selectedProduct.name]);
				this._branchesBox.set('primaryTitle', header); //$NON-NLS-1$

				this._branchesTable = dojo.create('table', { //$NON-NLS-1$
					className: 'ple-ManageDimensions-referenceTable', //$NON-NLS-1$
					width: '100%' //$NON-NLS-1$
				});

				for (var i = 0; i < branchNames.length; i++) {
					var name = branchNames[i];

					var tr = dojo.create('tr', null, this._branchesTable); //$NON-NLS-1$
					dojo.create('td', { //$NON-NLS-1$
						innerHTML: !name ? this.messages.noDimensionsBranchName : html.escape(name)
					}, tr);
				}


				this._branchesBox.containerNode.appendChild(this._branchesTable);
			},

			setDirty: function(dirty) {
				com.ibm.relm.ple.web.ui.branch.ManageDimensionsPage.dirty = dirty;

				PlatformUI.getWorkbench().setPageDirty('com.ibm.relm.ple.web.ui.pages.ProductsWelcomePage', dirty); //$NON-NLS-1$

				if (dirty) {
					this._saveButton.disabled = false;
					this._cancelButton.disabled = false;
				}
				else {
					this._saveButton.disabled = true;
					this._cancelButton.disabled = true;
				}
			},

			_onDirtyDimensions: function(propName, oldDirty, newDirty) {
				this.setDirty(newDirty);
				
				var self = this;
				setTimeout(function() {
					self._updateAffectedProducts();
				}, 0);
			},

			_updateAffectedProducts: function() {
				if (this._affectedXhr) {
					this._affectedXhr.cancel();
					this._affectedXhr = null;
				}

				var modifiedDimensionUris = this._editor.getDirtyDimensionUris();
				if (!modifiedDimensionUris) {
					// nothing is dirty, so be sure to clear this.
					self._setAffectedProducts();
					return;
				}

				this._updatingAffectedProductsImg.style.display = ''; //$NON-NLS-1$

				var self = this;
				this._affectedXhr = jazz.client.xhrGet({
					url: net.jazz.ajax._contextRoot + '/ple/dimension_find_use', //$NON-NLS-1$
					handleAs: 'json', //$NON-NLS-1$
					content: {
						dimensionUris: dojo.toJson(modifiedDimensionUris)
					},
					failOk: true,
				
					load: function (itemVersions) {
						self._setAffectedProducts(itemVersions);
					},
				
					error: function(error, ioArgs) {
						// Ignore error. This happens on .cancel too.
						// Just won't see Quick Info
						self._setAffectedProducts();
					},

					handle: function() {
						self._updatingAffectedProductsImg.style.display = 'none'; //$NON-NLS-1$
					}
				});
			},

			loadDimensionsAction: function(jazzEvent) {
				if (!jazzEvent.product) {
					if (!this._editor) this.set('selectedProduct', null); //$NON-NLS-1$

					if (this._saveButton.disabled) {
						// If not dirty, set the same product again to force a refresh.
						var selectedProduct = this.selectedProduct;
						this.set('selectedProduct', selectedProduct); //$NON-NLS-1$
					}
				}
				else {
					var message = com.ibm.relm.common.web.StatusMessage.show(this.messages.loadingProduct);

					if (this._editor) {
						this._selectedNode.style.display = 'none'; //$NON-NLS-1$
						this._editor.showLoading();
					}

					var self = this;
					jazz.client.xhrGet({
						handleAs: 'json', //$NON-NLS-1$
						url: net.jazz.ajax._contextRoot + '/ple/get_resource_version', //$NON-NLS-1$
						content: {
							itemVersionUri: jazzEvent.product
						},

						handle: function() {
							message.hide();
						},

						load: function (product) {
							dojo.publish(jazz.ui.PageTemplate.StatusMessage.HIDE);
							self.set('selectedProduct', product); //$NON-NLS-1$
						},

						error: function(error, ioArgs) {
							self._errorBox.showXhrError(ioArgs.xhr);
							self._drawerAutoHeight.resize();
						}
					});
				}
			},

			onCancel: function(e) {
				var selectedProduct = this.selectedProduct;
				this.set('selectedProduct', selectedProduct); //$NON-NLS-1$
			},

			onSave: function(e) {
				this._saveButton.disabled = true;
				this._cancelButton.disabled = true;

				this._errorBox.hideMessage();
				this._drawerAutoHeight.resize();

				try {
					var scopedDimensions = this._editor.getUpdatedCreatedDimensions(true);
				}
				catch (e) {
					if (e.missingGreaterThan) {
						this._errorBox.showErrorObject({
							summary: dojo.replace(this.messages.valueXHasNoPrecedence, [e.missingGreaterThan.title])
						}, true);

						this._saveButton.disabled = false;
						this._cancelButton.disabled = false;
						this._drawerAutoHeight.resize();
						return;
					}
					else {
						throw e;
					}
				}

				var message = com.ibm.relm.common.web.StatusMessage.show(this.messages.saving);

				this._editor.set('enabled', false); //$NON-NLS-1$

				var self = this;
				jazz.client.xhrPost({
					url: net.jazz.ajax._contextRoot + '/ple/dimensions', //$NON-NLS-1$
					handleAs: 'json', //$NON-NLS-1$
					content: {
						shared: dojo.toJson(scopedDimensions.shared),
						conceptUri: !this.selectedProduct ? null : this.selectedProduct.conceptUri,
						local: dojo.toJson(scopedDimensions.local)
					},

					handle: function() {
						message.hide();
						self._editor.set('enabled', true); //$NON-NLS-1$
					},

					load: function (newScopedDimensions) {
						self.setDirty(false);
						self._setAffectedProducts();

						self._successBox.showMessage({
							type: jazz.ui.MessageBox.STATUS_TYPES.OK,
							 summary: self.messages.savedDimensions,
							 hideStatusMessage: true
						});
						self._successBox.hideLater();

						var oldSelected = self._editor.getSelectedDimension();
						self._editor.setDimensions(newScopedDimensions);
						self._editor.setSelectedDimension(oldSelected);

						self._setBranches(newScopedDimensions.productBranchNames);

						// If there is a tree selection, we want it refreshed
						// to show possible branch changes. If there is none, that's
						// fine too.
						var site = com.ibm.relm.ple.web.ui.TreeSelection.getSelectedSite();
						var path = site ? site.path : null;

						com.ibm.relm.ple.web.ui.tree.TreeRefresh.refresh({
							selectPath: path,
							noGoto: true
						});
					},

					error: function(error, ioArgs) {
						self._saveButton.disabled = false;
						self._cancelButton.disabled = false;
						self._errorBox.showXhrError(ioArgs.xhr);
						self._drawerAutoHeight.resize();
					}
				});
			},

			_setSelectedProductAttr: function(product) {
				this.setDirty(false);
				this._errorBox.hideMessage();
				this.selectedProduct = product;

				if (!product) {
					this._clearNode.style.display = 'none'; //$NON-NLS-1$
					this._noneNode.style.display = ''; //$NON-NLS-1$
					this._selectedNode.style.display = 'none'; //$NON-NLS-1$
					this._loadDimensions();
					return;
				}

				this._clearNode.style.display = ''; //$NON-NLS-1$
				this._noneNode.style.display = 'none'; //$NON-NLS-1$
				dojo.empty(this._selectedNode);
				var productHtml = formatting.formatProductItemIconAndTitleForItem(product);
				var productAllBranchesHtml = dojo.replace(this.messages.productXAllBranches, [productHtml]);
				this._selectedNode.innerHTML = productAllBranchesHtml;
				this._selectedNode.style.display = ''; //$NON-NLS-1$

				this._loadDimensions(product.conceptUri);
			},

			_loadDimensions: function(conceptUri) {
				if (this._editor) {
					this._editor.destroyRecursive();
				}

				this._editor = new com.ibm.relm.ple.web.ui.branch.DimensionEditor();
				dojo.style(this._editor.domNode, {
					top: '80px', //$NON-NLS-1$
					left: '5px', //$NON-NLS-1$
					right: '10px', //$NON-NLS-1$
					bottom: '10px' //$NON-NLS-1$
				});
				this._editor.placeAt(this._editorContainer);

				this._editor.watch('dirty', this._onDirtyDimensionsCallback); //$NON-NLS-1$

				var self = this;
				jazz.client.xhrGet({
					url: net.jazz.ajax._contextRoot + '/ple/dimensions', //$NON-NLS-1$
					handleAs: 'json', //$NON-NLS-1$
					content: {
						conceptUri: conceptUri
					},

					load: function (scopedDimensions) {
						self._saveButton.disabled = true;
						self._cancelButton.disabled = true;
						self._editor.setDimensions(scopedDimensions);
						self._setBranches(scopedDimensions.productBranchNames);
						self._setAffectedProducts();
					},

					error: function(error, ioArgs) {
						self._errorBox.showXhrError(ioArgs.xhr);
						self._drawerAutoHeight.resize();
						self._editor.setDimensions({
							shared: [],
							local: []
						});
					}
				});
			},

			_onClear: function(e) {
				dojo.stopEvent(e);

				if (!this._saveButton.disabled) {
					if (!window.confirm(this.messages.confirmRefreshSettingsPrompt)) return;
				}
				
				this.set('selectedProduct', null); //$NON-NLS-1$
				this._errorBox.hideMessage();
				this._drawerAutoHeight.resize();
			},

			_showPickProduct: function() {
				var page = this;

				if (!this._saveButton.disabled) {
					if (!window.confirm(this.messages.confirmRefreshSettingsPrompt)) return;
				}

				var dialog = new com.ibm.relm.ple.web.ui.picker.ProductPicker({
					collapseVersions: true,
					dialogTitle: this.messages.selectAProductDialogTitle,
					submitButtonLabel: this.messages.selectProductButton,
					iconClass: 'ple-icon-product', //$NON-NLS-1$
					onOk: function(resource) {
						page.set('selectedProduct', resource); //$NON-NLS-1$
						this.close();
					}
				});

				dialog.startup();
			},

			uninitialize: function() {
				this._drawerAutoHeight.destroy();
			}
		}
	);

})();