/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 /*******************************************************************************
  * Licensed Materials - Property of IBM
  * (c) Copyright IBM Corporation 2012. All Rights Reserved.
  *
  * Note to U.S. Government Users Restricted Rights:
  * Use, duplication or disclosure restricted by GSA ADP Schedule
  * Contract with IBM Corp.
  *******************************************************************************/
 
 dojo.provide("com.ibm.relm.ple.web.ui.branch.ValueOrderingRow"); //$NON-NLS-1$
 
 dojo.require("dojo.i18n"); //$NON-NLS-1$
 dojo.require('com.ibm.relm.common.web.ui.EasyMessageBox');//$NON-NLS-1$
 dojo.requireLocalization("com.ibm.relm.ple.web.ui.branch", "BranchDialogMixinMessages"); //$NON-NLS-1$ //$NON-NLS-2$
 dojo.require('dojo.fx'); //$NON-NLS-1$
 dojo.require('com.ibm.relm.common.web.ui.RequiredMarker'); //$NON-NLS-1$
 dojo.require('jazz.util.html'); //$NON-NLS-1$
 
 (function(){
 	var html = jazz.util.html;

 	dojo.declare(
 		"com.ibm.relm.ple.web.ui.branch.ValueOrderingRow", //$NON-NLS-1$
 		[ dijit._Widget, dijit._Templated ],
 		{
 			templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','ui/branch/templates/ValueOrderingRow.html'), //$NON-NLS-1$ //$NON-NLS-2$
 			widgetsInTemplate: true,

 			messages: dojo.i18n.getLocalization("com.ibm.relm.ple.web.ui.branch", "BranchDialogMixinMessages"), //$NON-NLS-1$ //$NON-NLS-2$

 			colspan: 4,

 			orderingOptions: null,
 			value: null,

 			constructor: function(args, node) {
 				this.orderingoptions = args.orderingOptions || [];
 				this.helpText = args.valueName
 					? dojo.replace(this.messages.orderingHelpText, [jazz.util.html.escape(args.valueName)])
 					: this.messages.orderingHelpTextNoTitle;
 			},

 			buildRendering: function() {
 				this.inherited(arguments);

 				this._drawOrderingOptions(this.orderingOptions);
 			},

 			_drawOrderingOptions: function(orderingOptions, selectedValue) {
 				dojo.empty(this.orderingSelect);

 				dojo.create('option', { //$NON-NLS-1$
 					value: 'unassigned', //$NON-NLS-1$
 					selected: 'unassigned' === selectedValue, //$NON-NLS-1$
 					innerHTML: html.escape(this.messages.unassigned)
 				}, this.orderingSelect);

 				dojo.create('option', { //$NON-NLS-1$
 					value: 'unordered', //$NON-NLS-1$
 					selected: 'unordered' === selectedValue, //$NON-NLS-1$
 					innerHTML: html.escape(this.messages.unordered)
 				}, this.orderingSelect);

 				orderingOptions.forEach(function(option) {
 					// TODO: stupid dojo.isArray to work around this data
 					// maybe coming from a dojo store. I want to kill the
 					// stores on the dimension pages to simplify.
 					var currentValue = dojo.isArray(option.id) ? option.id[0] : option.id;
 					var isSelected = currentValue === selectedValue;

 					dojo.create('option', { //$NON-NLS-1$
 						selected: isSelected,
 						value: currentValue,
 						innerHTML: dojo.isArray(option.name) ? option.name[0] : option.name
 					}, this.orderingSelect);
 				}, this);
 			},

 			postCreate: function() {
 				this._defaultHeight = dojo.position(this._animationWrapper).h;
 				dojo.style(this._animationWrapper, 'height', '0'); //$NON-NLS-1$ //$NON-NLS-2$
 				this.connect(this.orderingSelect, 'onchange', this.validateSelection.bind(this)); //$NON-NLS-1$

 				if (this.value && this.value !== 'unassigned') { //$NON-NLS-1$
 					dojo.addClass(this.orderingMessage, 'ple-ValueOrderingRow-messageBoxOk'); //$NON-NLS-1$
 				}
 			},

 			updateOrderingOptions: function(valueName, orderingOptions) {

 				if (this.orderingSelect.selectedIndex !== -1) {
 					var selectedValue = this.orderingSelect.options[this.orderingSelect.selectedIndex].value;
 				}

 				this.helpText.innerHTML = valueName
 					? dojo.replace(this.messages.orderingHelpText, [jazz.util.html.escape(valueName)])
 					: this.messages.orderingHelpTextNoTitle;

 				this._drawOrderingOptions(orderingOptions, selectedValue);
 				this.validateSelection();
 			},

 			/**
 			 * Reveals this row, which should already by in the DOM.
 			 * @param  {boolean} animated true to animate the reveal, otherwise it is drawn immediately.
 			 */
 			show: function(animated) {
 				if (this.expanded) return;

 				if (animated) {
	 				dojo.fx.wipeIn({
	 					node: this._animationWrapper,
	 					duration: 300,
	 					onEnd: this._toggleExpanded.bind(this)
	 				}).play();
	 			}
	 			else {
	 				this._animationWrapper.style.height = 'auto'; //$NON-NLS-1$
	 			}
 			},

 			/**
 			 * Animates the hiding of this row.
 			 * @param  {boolean} andDestroy if true, destroys self after the animation.
 			 */
 			hide: function(andDestroy) {
 				if (!this.expanded) return;

 				dojo.fx.wipeOut({
 					node: this._animationWrapper,
 					duration: 200,
 					onEnd: function() {
 						this._toggleExpanded();
 						if (andDestroy) this.destroyRecursive();
 					}.bind(this)
 				}).play();
 			},

 			_toggleExpanded: function() {
 				this.expanded = !this.expanded;
 			},

			onChange: function(greaterThan) {
			   //No-op, for connecting
			},

 			validateSelection: function() {
 				// XXX: this is a bit messy since it's sending events, _setting the internal value, changing
 				// visual state. This method has no clear purpose. I'd refactor, but too risky for late 5.0.
			 	var value = this.orderingSelect.value;

			 	if (value === 'unassigned') { //$NON-NLS-1$
			 		value = null;
			 	}

			 	if (this.value === value) return;

		 		dojo.toggleClass(this.orderingMessage, 'ple-ValueOrderingRow-messageBoxOk', !!value); //$NON-NLS-1$
		 		this._set('value', value); //$NON-NLS-1$

		 		this.onChange(value);
 			},

 			_setValueAttr: function(value) {
 				for (var i = 0; i < this.orderingSelect.options.length; i++) {
 					var option = this.orderingSelect.options[i];

 					if (option.value === value) {
 						this.orderingSelect.selectedIndex = i;
 						this._set('value', value); //$NON-NLS-1$
 						this.validateSelection();
 						return;
 					}
 				}
 			}
 		});
 
 })();