/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.configure.ui.internal.ArtifactElementConfirmationDialog'); //$NON-NLS-1$

dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.configure.ui.internal", "ConfigurePageMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require('jazz.ui.Dialog'); //$NON-NLS-1$

(function(){
	dojo.declare(
		'com.ibm.relm.configure.ui.internal.ArtifactElementConfirmationDialog', //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.configure','ui/internal/templates/ArtifactElementConfirmationDialogContent.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,
			onClose: null,
			messages: dojo.i18n.getLocalization('com.ibm.relm.configure.ui.internal', 'ConfigurePageMessages'), //$NON-NLS-1$ //$NON-NLS-2$

			postCreate: function() {
				this.inherited(arguments);
				this._dupIdList.innerHTML = this.dupIdList;
				this._dialog = new jazz.ui.Dialog({
					primaryTitle: this.messages.aeConfirmDialogTitle,
					width: Math.min(dijit.getViewport().w - 100, 900) + 'px', //$NON-NLS-1$
					destroyContents: true,
					contentNode: this.domNode,
					closable: true,
					onClose: this.onClose
				});

			},
			
			onOk: function(option){
			},
			
			onCancel: function(){
			},
			
			_onOk: function(){
				this._dialog.close();
				this.onOk(this.autoidButton.checked ? "autoId" : "overwrite");//$NON-NLS-1$ //$NON-NLS-2$
			},
			
			_onOptionChanged: function(){
				this.okButton.disabled = false;
			},

			_onCancel: function(){
				this._dialog.close();
				this.onCancel();
			},

			_onDone: function(e) {
				dojo.stopEvent(e);
				this._dialog.close();
			},

			uninitialize: function() {
				this.inherited(arguments);
			}
		}
	);

})();