/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.configure.ui.internal.ConfigurePage"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.ActionRegistry"); //$NON-NLS-1$
dojo.require("com.ibm.relm.configure.ui.internal.DeploySamples"); //$NON-NLS-1$


dojo.requireLocalization("com.ibm.relm.configure.ui.internal", "ConfigurePageMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

var PlatformUI;
var ActionRegistry		= null; // initialize later

dojo.declare(
	"com.ibm.relm.configure.ui.internal.ConfigurePage", //$NON-NLS-1$
	dijit._Widget,
{
	_deploySample: null,
	
	postMixInProperties: function() {
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.configure.ui.internal", "ConfigurePageMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	buildRendering: function() {
		this.inherited(arguments); 
		// create main area
		this._mainArea = dojo.create("div", {"class":"com-ibm-relm-configure"}, this.domNode); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
	},

	postCreate: function(){
		// register actions
		PlatformUI = net.jazz.ajax.ui.PlatformUI;
		ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
		ActionRegistry.registerAction("com.ibm.relm.configure.DeploySamples", this, "deploySamples"); //$NON-NLS-1$ //$NON-NLS-2$		
		this.inherited(arguments);
	},
	
	setMainContent: function(node){
		var me = this._mainArea;
		for(var c; c = me.lastChild;){ // intentional assignment
			me.removeChild(c);
		}
		me.appendChild(node);
	},
	
	deploySamples: function(kwArgs){
		if(!this._deploySample){
			this._deploySample = new com.ibm.relm.configure.ui.internal.DeploySamples(kwArgs);
			this._deploySample.startup();
		}
		this.setMainContent(this._deploySample.domNode);
	},
	
	destroy: function(){
		if(this._deploySample) this._deploySample.destroy();
		this.inherited(arguments);
	}
	
});

})();