/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("relm.app.ui.internal.application.AdminApplication"); //$NON-NLS-1$

dojo.require("com.ibm.team.app.web.internal.AdminApplication"); //$NON-NLS-1$
dojo.require("relm.app.ui.internal.application.AdminMenu"); //$NON-NLS-1$

/**Need to require this class to load the web initializers*/
// Jay: For 4.0.4 I took this out. Doesn't seem needed. Doesn't seem to cause
// problems, but uses some delicate code that I'd rather not debug if it
// doesn't load right (fragile when it comes to the order it loads in).
// dojo.require("relm.app.core.internal.WebUiInitializers"); //$NON-NLS-1$
dojo.require("jazz.app.ua.internal.client"); //$NON-NLS-1$

//Add csrf token in custom header
dojo.require("relm.app.PreventCSRF"); //$NON-NLS-1$

dojo.declare("relm.app.ui.internal.application.AdminApplication", com.ibm.team.app.web.internal.AdminApplication, { //$NON-NLS-1$

	_fnGetTopicPrefix: null,
	
	postCreate: function() {
		// Hack to change the info center for CLM topics
		var self = this;
		this._fnGetTopicPrefix = jazz.app.ua.internal.client.getTopicPrefix; 
		jazz.app.ua.internal.client.getTopicPrefix = function (id) {
			if (id.indexOf("com.ibm.team") !== -1) { //$NON-NLS-1$
				// Return the public CLM info center
				var def = new dojo.Deferred();
				def.callback("http://www.ibm.com/support/knowledgecenter/SSYMRC_5.0.1"); //$NON-NLS-1$
				return def;
			}
			return self._fnGetTopicPrefix(id);
		};
		
		this.inherited(arguments);
	},
	
	_adminMenuProvider: function() {
		return new relm.app.ui.internal.application.AdminMenu({showProjectProperties: false});
	}
	
});

}());