/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("relm.app.ui.internal.application.AdminMenu"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.ui.internal.admin.AdminMenu"); //$NON-NLS-1$
dojo.require("jazz.app.context"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("relm.app.ui.internal.application", "ApplicationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var messages = dojo.i18n.getLocalization("relm.app.ui.internal.application", "ApplicationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("relm.app.ui.internal.application.AdminMenu",  //$NON-NLS-1$
	com.ibm.team.repository.web.ui.internal.admin.AdminMenu, {
	
	_populateMenu: function() {
		if (!this.domNode) {
			return;
		}
		var curUrl = new dojo._Url(location.href),
			query = curUrl.query ? "?" + curUrl.query : "", //$NON-NLS-1$ //$NON-NLS-2$
			adminBase = dojo.baseUrl + "../../admin" + query + "#"; //$NON-NLS-1$ //$NON-NLS-2$

			if (this._loading) {
			// remove the message that indicates that the message is loading
			this.remove(this._loading);
			this._loading.destroy();
			this._loading = null;
		}

		// Call inherited
		this.inherited(arguments);
		
		// Add the ProjectArea specific admin menu items if applicable.
		if (this.showProjectProperties) {
			var context = jazz.app.context.get() || {};
			this.addItemByArgs({
				label: messages.importSamples,
				href: adminBase + "action=com.ibm.relm.configure.DeploySamples&itemId=" + context.itemId //$NON-NLS-1$
			}, 7);
			
			this.addItemByArgs({
				label: messages.settings,
				href: adminBase + "action=jazz.viewPage&id=com.ibm.relm.ple.web.admin.SettingsPage" //$NON-NLS-1$
			}, 8);
		}
		
		// Remove the reports and templates link
		// See https://jazz.net/jazz04/resource/itemName/com.ibm.team.workitem.WorkItem/27976
		var items = this.getItems();
		var reportsItem = null;
		var templatesItem = null;
		if (items && items.length) {
			for (var i = 0; i < items.length; i++) {
				var item = items[i];
				if (item.href && item.href.indexOf("com.ibm.team.reports.reportsManagementPage") !== -1) { //$NON-NLS-1$
					reportsItem = item;
				}else if (item.href && item.href.indexOf("com.ibm.team.process.ProcessTemplateManagement") !== -1) { //$NON-NLS-1$
					templatesItem = item;
				}
			}
		}
		if (reportsItem) {
			this.remove(reportsItem);			
		}
		if (templatesItem) {
			this.remove(templatesItem);			
		}
	}
});

}());