/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
if (dojo.isIE >= 8 && dojo.isIE < 10) {
	// Workaround for IE8 standards mode
	dojo.doc.namespaces.add('v', 'urn:schemas-microsoft-com:vml'); //$NON-NLS-1$ //$NON-NLS-2$
	var css = dojo.doc.createStyleSheet();
	css.addRule('v\\:rect', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:roundrect', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:line', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:polyline', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:curve', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:arc', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:oval', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:image', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:shape', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:group', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:skew', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:stroke', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:fill', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:imagedata', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:textpath', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
	css.addRule('v\\:path', "behavior: url(#default#VML);"); //$NON-NLS-1$ //$NON-NLS-2$
}

(function() {
dojo.provide("relm.app.ui.internal.application.RELMApplication"); //$NON-NLS-1$


dojo.require("relm.app.core.internal.Workarounds"); //$NON-NLS-1$

// This must come after Workarounds
dojo.require("relm.app.core.internal.WebUiInitializers"); //$NON-NLS-1$

dojo.require("rmps.core.RootServices"); //$NON-NLS-1$
dojo.require("rmps.core.BackendScr"); //$NON-NLS-1$
dojo.require("com.ibm.team.app.web.RepositoryApplication"); //$NON-NLS-1$
dojo.require("jazz.app.auth"); //$NON-NLS-1$
dojo.require("jazz.app.proxy"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("dojo.io.iframe"); //$NON-NLS-1$

dojo.require("jazz.client.xhr"); //$NON-NLS-1$

dojo.require("rmps.ui.ErrorReportController"); //$NON-NLS-1$

dojo.require("rmps.core.user.UserClient"); //$NON-NLS-1$
dojo.require("relm.app.core.util"); //$NON-NLS-1$
dojo.require("relm.app.ui.internal.util.UrlUtil"); //$NON-NLS-1$

dojo.require("dojox.xml.DomParser"); //$NON-NLS-1$

dojo.require("relm.app.ui.internal.application.AdminMenu"); //$NON-NLS-1$

//dojo.require("com.ibm.team.vvc.shared.web.ui.context.ConfigurationContextBannerButton"); //$NON-NLS-1$
//dojo.require("rmps.core.util.ContextUtils"); //$NON-NLS-1$
//dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.viewletServiceRoot"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.client.internal.AdminClient"); //$NON-NLS-1$

dojo.requireLocalization("relm.app.ui.internal.application", "ApplicationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var messages = dojo.i18n.getLocalization("relm.app.ui.internal.application", "ApplicationMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var PlatformUI = net.jazz.ajax.ui.PlatformUI;

var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var AdminClient            = com.ibm.team.repository.web.client.internal.AdminClient;

// Automatically shows the LQE auth dialog after any auth challenges from LQE.
dojo.require('com.ibm.relm.common.web.ui.LqeAuthInterceptor'); //$NON-NLS-1$

dojo.require('relm.app.Permissions'); //$NON-NLS-1$

// Pre-require all of these. The IA WebUiInitializer will try to include them
// all in an async request, but this leads to a race condition between running
// an action in the browser address bar, and actually loading these pages
// (which will register new actions). Declaring them here means they will
// always be available, though we pay the cost of loading them early. This is
// the RELM specific set. It will be different for DM. Ideally this these
// would load at runtime based on the plugin.xml information, but without a
// way to synchronously load them, that causes too many problems (race
// conditions.)
dojo.require('relm.iahost.IAResourcePickerProvider'); //$NON-NLS-1$
dojo.require('relm.iahost.DiagramMenuProvider'); //$NON-NLS-1$
dojo.require('relm.iahost.HostDiagramUtilityProvider'); //$NON-NLS-1$
dojo.require('relm.iahost.WelcomePageProvider'); //$NON-NLS-1$
dojo.require('dm.analysis.app.ui.internal.impactanalysis.application.MenuInitializer'); //$NON-NLS-1$
dojo.require('dm.analysis.app.ui.internal.impactanalysis.application.WelcomeInitializer'); //$NON-NLS-1$
dojo.require('dm.analysis.app.ui.internal.impactanalysis.application.AnalysisPageInitializer'); //$NON-NLS-1$
dojo.require('relm.viewlets.internal.ViewletsInitializer'); //$NON-NLS-1$

//Checks if upgrade is in progress. If it is, then it prevents loading of the RELM UI
dojo.require('com.ibm.relm.ple.web.ui.pages.UpgradeInProgressPage');//$NON-NLS-1$

//Monitors for when reports page is selected and preemptivly checks lqe authorization at that time
dojo.require("com.ibm.relm.explorer.web.ui.internal.reports.LqeReportAuthorizer"); //$NON-NLS-1$

//Overrides dojo.i18n.getLocalization to allow for renaming of term product
dojo.require('com.ibm.relm.common.web.ui.ProductNameCache'); //$NON-NLS-1$

//Add csrf token in custom header
dojo.require("relm.app.PreventCSRF"); //$NON-NLS-1$

//This adds the project ID header to all xhr requests for RELM
//Also add csrf token in custom header
jazz.client.internal.addRequestInterceptor(function(request) {
	var projectId = jazz.app.context.get().itemId;
	var headers = request.args.headers;
	if (projectId) {
		headers["X-jazz-project-id"] = projectId; //$NON-NLS-1$
	}
});

dojo.declare("relm.app.ui.internal.application.RELMApplication",  //$NON-NLS-1$
	com.ibm.team.app.web.RepositoryApplication, {

	name: messages.productName,
	iconSmall: dojo.moduleUrl("relm.app", "graphics/RELM_16.png"), //$NON-NLS-1$ //$NON-NLS-2$
	iconLarge: dojo.moduleUrl("relm.app", "graphics/RELM_24.png"), //$NON-NLS-1$ //$NON-NLS-2$

	_setup: false,

	applicationContext: null,

	_fnGetTopicPrefix: null,
	gettingStartedLink: 'http://www.ibm.com/support/knowledgecenter/SS2L6K_5.0.1/com.ibm.rational.relm.doc/topics/c_getting_started.html', //$NON-NLS-1$
	
	postCreate: function() {
		// Hack to change the info center for CLM topics
		var self = this;
		this._fnGetTopicPrefix = jazz.app.ua.internal.client.getTopicPrefix; 
		jazz.app.ua.internal.client.getTopicPrefix = function (id) {
			/* If the UA_KEY requires CSH info from DM */
			if (id.indexOf("com.ibm.xtools") !== -1) { //$NON-NLS-1$
				// Return the public CLM info center
				var def = new dojo.Deferred();
				def.callback("http://www.ibm.com/support/knowledgecenter/SSB2MU_8.1.1"); //$NON-NLS-1$
				return def;
			}
			/* If the UA_KEY requires CSH info from CLM */
			else if (id.indexOf("com.ibm.team") !== -1 || id.indexOf("com.ibm.jazz") !== -1) { //$NON-NLS-1$ //$NON-NLS-2$
				// Return the public CLM info center
				def = new dojo.Deferred();
				def.callback("http://www.ibm.com/support/knowledgecenter/SSYMRC_5.0.1"); //$NON-NLS-1$
				return def;
			}

			return self._fnGetTopicPrefix(id);
		};

		//Register the listener to watch for goign to a page in the reports section
		com.ibm.relm.explorer.web.ui.internal.reports.LqeReportAuthorizer.registerReportPageListener();
		
		this.inherited(arguments);
	},

	constructor: function(args) {

		// ensure the web URI is correct
		var webUri = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "web"); //$NON-NLS-1$
		var uri = String(window.location);
		if (uri.search(new RegExp("^" + webUri, "i")) !== 0) { //$NON-NLS-1$ //$NON-NLS-2$
			// redirect to web URI
			var pathPrefix = new dojo._Url(webUri).path;
			var idx = uri.search(new RegExp(pathPrefix, "i")); //$NON-NLS-1$
			window.location = webUri + uri.substr(idx + pathPrefix.length);
		} else {
			if (this._isSetup()) {
				// TMA: Hack to avoid cross-domain blocks. We call AdminClient.getUserRoles first, since
				// any TeamServerClient.invokeService calls will fail when not authenticated
				// See WI: https://jazz.net/jazz/resource/itemName/com.ibm.team.workitem.WorkItem/202484
				var srh = new ServiceResponseHandler(this, "_fetchUserRolesSuccess", "_fetchInitDataFailure"); //$NON-NLS-1$ //$NON-NLS-2$
				AdminClient.getUserRoles(srh);
			}
		}
	},
	
	_fetchUserRolesSuccess: function() {
		this.fetchInitData();
	},
	
	_isSetup: function() {
		if (net.jazz.ajax.viewletServiceRoot()) {
			return true;
		}
		this.ui._homeMenu.style.display = this.ui._searchArea.style.display = "none"; //$NON-NLS-1$
		this.config.showLoginLogout = false;
		this.onFailure(null, messages.setupError);
		return false;
	},
	
	start: function() {
		this.config.user.uri = this.config.user.userId ? rmps.core.user.UserClient.getUserUri(this.config.user.userId) : "";  //$NON-NLS-1$

		// Setting help uri
		dojo.setObject("com.ibm.team.repository.web.helpuri", messages.helpUrl); //$NON-NLS-1$

		// check if we should go to landing page
		var context = jazz.app.context.get();
		if (context && !context.name) {
			// Go to home link
			window.location.href = this.getHomeLink();
			return;
		}
			
		//Check status of RELM upgrade
		com.ibm.relm.ple.web.ui.pages.UpgradeInProgressPage.checkUpgradeStatus();

		var self = this;
		var args = arguments;
		relm.app.Permissions.initForCurrentUser().then(function() {
			self.inherited(args);
		}, 
		function(errorObject) {
			self.onFailure(null, errorObject.summary, true);
		});
	},
	
	getHomeLink: function(){
		return rmps.core.RootServices.getUri(rmps.core.Namespaces.JDB, "dashboards");	//$NON-NLS-1$
	},

	initContext: function() {
		var errorReport = new rmps.ui.ErrorReportController();
		errorReport.startup();
		
		try {
			var deferred= this.getCurrentContext();
		}
		catch (e) {
			// XXX: This is copied wholesale from RepositoryApplication.js.
			// Normally it is the first to call getCurrentContext and handles
			// this, but this DM class overrides that method (and this one)
			// without such protections. It seems like this can be improved
			// to not override so much and not need to duplicate this, but
			// it's not clear which of these init parts are still needed, and
			// which are just DM leftovers.
			console.error(e);
			
			// A TypeError is almost always a null dereference. If it is, the messages
			// won't make any sense ("xyz is null"), so there's no need to show.
			// Double check that TypeError class is defined first (should be in all browsers)
			// just to be safe.
			if (!TypeError || !(e instanceof TypeError)) {
				this.onFailure(null, e.message);
			}

			// redirect to '/web' if the URI isn't well-formed or project is missing.
			var href = net.jazz.ajax.contextRoot() + "/web"; //$NON-NLS-1$
			if (window.location.search) {
				href += window.location.search;
			}
			location.href = href;
			return;
		}
		
		var parentMethod= dojo.hitch(this, this.getInherited("initContext", arguments)); //$NON-NLS-1$
		
		var self= this;
		dojo.when(deferred, function(){
			var initUi = function() {
				parentMethod();
				if (self.ui.containerNode.firstChild) {
					self.ui.containerNode.insertBefore(errorReport.domNode, self.ui.containerNode.firstChild);
				} else {
					self.ui.containerNode.appendChild(errorReport.domNode);
				}
			};
			var checkCalDeferred = self.checkCAL();
			
			new dojo.DeferredList([checkCalDeferred], false, true).then(initUi, function(message) {
				message && self.onFailure(null, message, true);
			});
			
		});
	},
	
	checkCAL: function() {		
		var deferred = new dojo.Deferred();
		var self = this;
		jazz.client.xhrGet({
			url: net.jazz.ajax._contextRoot + "/process-cal-check", //$NON-NLS-1$
			content: {
				context: self.context
			},
			handleAs: "json", //$NON-NLS-1$
			load: function(data, ioargs){
				if (data.granted) {
					deferred.callback();
				}
				else {
					// self.onFailure(ioargs.xhr, data.message || messages.missingCal, true);
					deferred.errback(data.message || messages.missingCal);
				}
			},
			error: function(data, ioargs) {
				deferred.errback(messages.missingCalGeneral);
			}
		});
		return deferred;
	},

	getCurrentContext: function() {
		if(this.applicationContext){
			return this.applicationContext;
		}
		this.applicationContext = this.inherited(arguments);
		/*Required to track the baseline changes while working */
		if (this.applicationContext.name) {
			var self = this;
			var args = {
				url: rmps.core.RootServices.getUri(rmps.core.Namespaces.JP_0_6, "projectAreas"), //$NON-NLS-1$
				/*
				* Handle as XML (not parasable text) due to that dojo bug:
				*
				* http://bugs.dojotoolkit.org/ticket/14290
				*
				* But make sure to deal with the behaviour differences in XML manipulation
				*
				*/
				handleAs: "xml", //$NON-NLS-1$
				load: function(doc, ioArgs) {

				/*
				* Required for WebKit browsers (Safari, Chrome, etc). We do not use the prefix when getting the elements by tag name (when using the
				* method getElementsByTagName). Thus, in order to maintain the same behavior on all browsers versions, we use our method, till 14290
				* is resolved
				*
				*/
					var getNode = function(parentNode, tagName) {
						var list = [];
						var childNodes = parentNode.childNodes;

						/*no need to check for childNodes being defined */
						var length = childNodes.length;

						for(var index = 0; index < length; index++) {
							var current = childNodes[index];
							if (current.tagName === tagName) {
								list.push(current);
							}
						}
						return list;
					};

					var projectsMainNode = getNode(doc, "jp06:project-areas")[0]; //$NON-NLS-1$

					var projects = getNode(projectsMainNode, "jp06:project-area"); //$NON-NLS-1$

					var pas = [];
					for (var i = 0, p; p = projects[i]; ++i) {
						var c = {};
						pas.push(c);
						c.name = p.getAttribute("jp06:name"); //$NON-NLS-1$

						c.archived = getNode(p, "jp06:archived")[0].childNodes[0].nodeValue === true; //$NON-NLS-1$
						c.uri = getNode(p, "jp06:url")[0].childNodes[0].nodeValue; //$NON-NLS-1$
						var segments = c.uri.split('/'); //$NON-NLS-1$
						c.itemId = segments[segments.length - 1];
						if (c.name === self.applicationContext.name) {
							self.context = c.uri;
						}
					}
					self.config.projectAreas = pas;

				}
			};
			jazz.client.xhrGet(args);
		}

		return this.applicationContext;
	},

	_adminMenuProvider: function() {
		return new relm.app.ui.internal.application.AdminMenu({showProjectProperties: this.context !== null});
	}
	
});

})();
