/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.editor.AddComponentInfo"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() { 

dojo.declare("com.ibm.relm.explorer.web.ui.internal.editor.AddComponentInfo", [dijit._Widget] , { //$NON-NLS-1$

	messages:null,
	
	postCreate: function(){
		this.inherited(arguments);

		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$

		var table = dojo.create("table", { //$NON-NLS-1$
			style: {
				padding: "5px", //$NON-NLS-1$
				width: "100%" //$NON-NLS-1$
			}
		});
		var trComponentInfo = dojo.create("tr", {}, table); //$NON-NLS-1$
		var tdComponentInfoHeading = dojo.create("td", { //$NON-NLS-1$
			style: {
				whiteSpace: "nowrap", //$NON-NLS-1$
				paddingBottom: "0.5em" //$NON-NLS-1$
			}
		}, trComponentInfo);
		var compIdId = "compField"; //$NON-NLS-1$
		dojo.create("label", { //$NON-NLS-1$
			className: "j-label", //$NON-NLS-1$
			"for": compIdId, //$NON-NLS-1$
			innerHTML: this.messages.componentInfoId
		}, tdComponentInfoHeading);
		dojo.create("span", { //$NON-NLS-1$
			className: "j-required", //$NON-NLS-1$
			innerHTML: "*" //$NON-NLS-1$
		}, tdComponentInfoHeading);
		var tdComponentInfoIdValue = dojo.create("td", { //$NON-NLS-1$
			style: {
				width: "100%", //$NON-NLS-1$
				paddingLeft: "10px", //$NON-NLS-1$
				paddingBottom: "0.5em" //$NON-NLS-1$
			}
		}, trComponentInfo);
		this.compIdField = dojo.create("input", { //$NON-NLS-1$
			id: compIdId,
			'aria-required':'true', //$NON-NLS-1$ //$NON-NLS-2$
			style: {
				width: "100%" //$NON-NLS-1$
			}
		}, tdComponentInfoIdValue);
		this.connect(this.compIdField, "onkeypress", function(event){//$NON-NLS-1$
			if(event.keyCode === dojo.keys.ENTER){
				this.onOk(event);
			}
		});


		dojo.place(table, this.domNode, "first"); //$NON-NLS-1$
	},
	
	getValues: function(){
		return {
			componentInfoId: dojo.trim(this.compIdField.value)
		};
	},
	
	onOk: function(event){
		
	}


});

com.ibm.relm.explorer.web.ui.internal.editor.AddComponentInfo.openDialog = function(componentInfoItems, callback2){

	var contentWidget = new com.ibm.relm.explorer.web.ui.internal.editor.AddComponentInfo();
	// show dialog
	new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
		dialogContent: contentWidget,
		primaryTitle: contentWidget.messages.AddComponentInfo,
		onOpen: function(){
			dijit.focus(contentWidget.compIdField);
		},
		validate: function(values, callback){
			var componentInfoId = values["componentInfoId"]; //$NON-NLS-1$
			if(componentInfoId && componentInfoId.length>0){
				for(var i = 0; i < componentInfoItems.length; i++) {
					if(componentInfoItems[i].id == componentInfoId) {
						alert(contentWidget.messages.errComponentInfoIdExists);
						return;
					}
				}
				callback();
			}
		},
		onOK: function(values){
			var componentInfoId = values["componentInfoId"]; //$NON-NLS-1$
			var compInfoItem = {
					 id: componentInfoId, 
					 classType: "", //$NON-NLS-1$
					 attributes: []
			};
			callback2(compInfoItem);
		}
	});
};

})();