/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.editor.AddQuery"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() { 

	var nodeUtils = com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils;
	var _defaultSparql = nodeUtils.INITIAL_SPARQL_CONTENT;

dojo.declare("com.ibm.relm.explorer.web.ui.internal.editor.AddQuery", [dijit._Widget] , { //$NON-NLS-1$

	messages:null,
	
	postCreate: function(){
		this.inherited(arguments);

		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$

		var table = dojo.create("table", { //$NON-NLS-1$
			style: {
				padding: "5px", //$NON-NLS-1$
				width: "100%" //$NON-NLS-1$
			}
		});
		var trQuery = dojo.create("tr", {}, table); //$NON-NLS-1$
		var tdQueryHeading = dojo.create("td", { //$NON-NLS-1$
			style: {
				whiteSpace: "nowrap", //$NON-NLS-1$
				paddingBottom: "0.5em" //$NON-NLS-1$
			}
		}, trQuery);
		var queryIdId = "queryField"; //$NON-NLS-1$
		dojo.create("label", { //$NON-NLS-1$
			className: "j-label", //$NON-NLS-1$
			"for": queryIdId, //$NON-NLS-1$
			innerHTML: this.messages.queryId
		}, tdQueryHeading);
		dojo.create("span", { //$NON-NLS-1$
			className: "j-required", //$NON-NLS-1$
			innerHTML: "*" //$NON-NLS-1$
		}, tdQueryHeading);
		var tdQueryValue = dojo.create("td", { //$NON-NLS-1$
			style: {
				width: "100%", //$NON-NLS-1$
				paddingLeft: "10px", //$NON-NLS-1$
				paddingBottom: "0.5em" //$NON-NLS-1$
			}
		}, trQuery);
		this.queryIdField = dojo.create("input", { //$NON-NLS-1$
			id: queryIdId,
			style: {
				width: "100%" //$NON-NLS-1$
			}
		}, tdQueryValue);


		dojo.place(table, this.domNode, "first"); //$NON-NLS-1$
	},
	
	getValues: function(){
		return {
			queryId: this.queryIdField.value
		};
	}


});

com.ibm.relm.explorer.web.ui.internal.editor.AddQuery.openDialog = function(queries, callback2){
	// create edit icon dialog content
//	var params = config.params;
	var contentWidget = new com.ibm.relm.explorer.web.ui.internal.editor.AddQuery();

	// show dialog
	new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
		dialogContent: contentWidget,
		primaryTitle: contentWidget.messages.AddQuery,
		onOpen: function(){
			dijit.focus(contentWidget.queryIdField);
		},
		validate: function(values, callback){
			var queryId = values["queryId"]; //$NON-NLS-1$
			if(queryId && queryId.length>0){
				for(var i = 0; i < queries.length; i++) {
					if(queries[i].id == queryId) {
						alert(contentWidget.messages.errQueryIdExists);
						return;
					}
				}
				callback();
			}else if(query && queryId === ""){ //$NON-NLS-1$
				// empty string for default query
				if(confirm(contentWidget.messages.confirmCreateDefaultQuery)) {
					for(var i = 0; i < queries.length; i++) {
						if(queries[i].id === "") { //$NON-NLS-1$
							alert(contentWidget.messages.errQueryIdExists);
							return;
						}
					}
					callback();
				}
			}
		},
		onOK: function(values){
			var queryId = values["queryId"]; //$NON-NLS-1$
			queries.push({
					 id: queryId, 
					 params: {},
					 sparql: _defaultSparql
			});
			callback2(queryId);
		}
	});
};

})();