/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.editor.SectionDialog"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojox.gfx"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.sections.Connection"); //$NON-NLS-1$

(function() {
com.ibm.relm.explorer.web.ui.internal.editor.SectionDialog = {
	openGeneralDialog: function(editor, dummy, okCallback, offsetX, offsetY){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.General({_configEditor: editor});
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelGeneral, okCallback, offsetX, offsetY);
	},

	openQueryDialog: function(editor, selectedIndex, okCallback, offsetX, offsetY){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.Query({_configEditor: editor});
		if(selectedIndex >= 0) sectionWidget.setSelectedIndex(selectedIndex);
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelQuery, okCallback, offsetX, offsetY);
		if(selectedIndex < 0) sectionWidget.setSelectedIndex(selectedIndex);
	},

	openResourceDialog: function(editor, resInfoOrIndex, okCallback, offsetX, offsetY){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.Resource({_configEditor: editor});
		if(isNaN(resInfoOrIndex)){
			sectionWidget.setSelected({resourceInfo: resInfoOrIndex});
		}else{
			sectionWidget.setSelectedIndex(resInfoOrIndex);
		}
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelResource, okCallback, offsetX, offsetY);
	},
	
	openConnectionDialog: function(editor, selectedIndex, okCallback, offsetX, offsetY){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.Connection({_configEditor: editor});
		sectionWidget.setSelectedIndex(selectedIndex);
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelConnection, okCallback, offsetX, offsetY);
	},

	openBackgroundDialog: function(editor, dummy, okCallback, offsetX, offsetY){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.Background({_configEditor: editor});
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelBackground, okCallback, offsetX, offsetY);
	},

	openComponentInfoDialog: function(editor, dummy, okCallback, offsetX, offsetY){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.ComponentInfo({_configEditor: editor});
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelComponentInfo, okCallback, offsetX, offsetY);
	}

};

var openSectionDialog = function(sectionWidget, title, okCallback, offsetX, offsetY){
	var content = new dijit.layout.ContentPane();
	dojo.style(content.domNode, {
		"maxHeight": "480px", //$NON-NLS-1$ //$NON-NLS-2$
		"overflow": "auto" //$NON-NLS-1$ //$NON-NLS-2$
	});
	content.set("content", sectionWidget); //$NON-NLS-1$
	if (dojo.isFunction(sectionWidget.getValues)) {
		content.getValues = function() {
			return sectionWidget.getValues();
		};
	}

	// show dialog
	var dialog = new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
		dialogContent: content,
		primaryTitle: title,
		width: "", //$NON-NLS-1$
		onOpen: function(){
//			dijit.focus(contentWidget.shapeLabelField);
		},
		validate: function(values, callback){
			if(sectionWidget.validate && !sectionWidget.validate(values)) {
				return;
			}
			callback();
		},
		onOK: function(values){
			okCallback(values);
		}
	});
	offsetX = dojo.number.parse(offsetX);
	if(!isNaN(offsetX)){
		dojo.style(dialog.domNode, "left", dialog.domNode.offsetLeft + offsetX + "px"); //$NON-NLS-1$ //$NON-NLS-2$
	}
	offsetY = dojo.number.parse(offsetY);
	if(!isNaN(offsetY)){
		dojo.style(dialog.domNode, "top", dialog.domNode.offsetTop + offsetY + "px"); //$NON-NLS-1$ //$NON-NLS-2$
	}
};

})();