/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.editor.sections.Layout"); //$NON-NLS-1$

dojo.require("dijit._Templated");//$NON-NLS-1$
dojo.require("dijit.form.SimpleTextarea"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.sections._SectionMixin"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var messages = {};

dojo.declare("com.ibm.relm.explorer.web.ui.internal.editor.sections.Layout", [dijit._Widget, dijit._Templated, com.ibm.relm.explorer.web.ui.internal.editor.sections._SectionMixin], { //$NON-NLS-1$
	
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/editor/sections/templates/ConfigFormLayout.html"),  //$NON-NLS-1$  //$NON-NLS-2$

	postMixInProperties: function(){
		messages = this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$  //$NON-NLS-2$
	},
	
	postCreate: function() {
		var titleNode = dojo.create("span");  //$NON-NLS-1$
		titleNode.appendChild(dojo.doc.createTextNode(messages.LabelLayout));
	
		this.inherited(arguments);
		var layout = this.getConfig().layout;
		if(!layout) layout = ""; //$NON-NLS-1$
		this.layoutTextArea.set("value", layout);  //$NON-NLS-1$

		this.connect(this.layoutTextArea, "onChange", function(newVal) {  //$NON-NLS-1$
			var config = this.getConfig();
			if(config.layout != newVal){
				this._updateDirty(config.layout, newVal); 
				config.layout = newVal; 
			}
		});
	},
	
	setEditMode: function(editMode) {
		if(!editMode) return;
		
		var mode = editMode.layout;
		
		if(mode.layoutSection == false) {
			this.layoutSection.style.display = "none";  //$NON-NLS-1$
		} else {
			this.layoutSection.style.display = "";  //$NON-NLS-1$
		}
		if(mode.layoutDescriptionRow == false) {
			this.layoutDescriptionRow.style.display = "none";  //$NON-NLS-1$
		} else {
			this.layoutDescriptionRow.style.display = "";  //$NON-NLS-1$
		}
	},

	startup: function() {
		
	},
	
	destroy: function() {
		this.inherited(arguments);
	}
	
	
});


})();

