/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.editor.sections._ParameterEditMixin"); //$NON-NLS-1$

dojo.require("jazz.core.loader"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.EditorUtils"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "QueryUtilsMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

var load_async = jazz.core.loader.load_async;
var util = com.ibm.relm.explorer.web.ui.internal.util;
var editorUtils = com.ibm.relm.explorer.web.ui.internal.editor.EditorUtils;
var queryMessages = dojo.i18n.getLocalization('com.ibm.relm.explorer.web.ui.internal', 'QueryUtilsMessages'); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.relm.explorer.web.ui.internal.editor.sections._ParameterEditMixin", null, { //$NON-NLS-1$
	acceptQueryVariables: true,
	targetqueryId: null,
	
	hasPicker: function(propName) {
		return util.hasPicker(propName);
	},

	openPicker: function(propType, propValue, callback) {
		util.openPicker(propType, propValue, null, callback);
	},
	
	addOrEditByPicker: function(propName, propType, propValue, data) {
		if (util.hasPicker(propType)) {
			var self = this;
			util.openPicker(propType, propValue, null, function(newValue) {
				self._onEditByPicker(data, propName, newValue);
			}, this);
			return true;
		} else {
			this._onNormalEditParam(propName, propType, propValue, data);
		}
	},

	_onEditByPicker: function(data, propName, newValue) {
	},

	_onNormalEditParam: function(propName, propType, propValue, data) {
	},
	
	addOrEditGeneralParameter: function(componentParams, targetParams, targetParamName, callback) {
		load_async("com.ibm.relm.explorer.web.ui.internal.editor.AddParameterContent", dojo.hitch(this, function() { //$NON-NLS-1$
			var candidates = targetParamName ? this._getPredefinedOptions(targetParamName) : [];
			if (this.acceptQueryVariables) {
				var queryVariables = editorUtils.getQueryVariables(this._configEditor.getDiagramEditor(), this.targetqueryId);
				if (queryVariables && queryVariables.length > 0) {
					dojo.forEach(queryVariables, function(v) {
						if (v.name.charAt(0) == "?") v.name = v.name.substr(1); //$NON-NLS-1$
						v.cascadeLevel = 1;
					});
					candidates = candidates.concat({name: queryMessages.queryResultTitle, value: "", cascadeType: "group"});  //$NON-NLS-1$ //$NON-NLS-2$
					candidates = candidates.concat(queryVariables);
				}
			}
			com.ibm.relm.explorer.web.ui.internal.editor.AddParameterContent.openDialog(targetParams, callback, 
					{nameOptions: componentParams, valueOptions: candidates}, targetParamName, targetParamName != null);
		}));
	},
	
	_getPredefinedOptions: function(targetParamName) {
		switch (targetParamName) {
		case "overflow":  //$NON-NLS-1$
			return [{name:queryMessages.overflowClip, value:"clip"},			//$NON-NLS-1$ 
					{name:queryMessages.overflowExpand, value:"expand"},		//$NON-NLS-1$ 
					{name:queryMessages.overflowOverflow, value:"overflow"}];	//$NON-NLS-1$ 
		case "startDir": //$NON-NLS-1$
		case "endDir": //$NON-NLS-1$
			return [{name:queryMessages.dirTop, value:"top"},	//$NON-NLS-1$  
			        {name:queryMessages.dirLeft, value:"left"},//$NON-NLS-1$  
			        {name:queryMessages.dirBottom, value: "bottom"},	//$NON-NLS-1$ 
			        {name:queryMessages.dirRight, value: "right"}];	//$NON-NLS-1$  

		default:
			return [];
		}
	}
});

})();
