/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.hover.GfxRichResourceHover"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.hover._GfxRichHoverMixin"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "HoverMessages"); //$NON-NLS-1$ //$NON-NLS-2$


(function(){
	
var dummy = new jazz.ui.ResourceLink({uri:"http://jazz.net/",label:"dummy"});	 //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.relm.explorer.web.ui.internal.hover.GfxRichResourceHover",  //$NON-NLS-1$
		[net.jazz.ui._RichHover, dijit._Templated, com.ibm.relm.explorer.web.ui.internal.hover._GfxRichHoverMixin], {
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/hover/templates/GfxRichResourceHover.html"), //$NON-NLS-1$ //$NON-NLS-2$
	
	postMixInProperties: function() {
		this.presentationUri = this.uri;
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "HoverMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	createContents: function(){
		// add my own content
		var own = this.createOwnContents();
		this.ownContentArea.appendChild(own);

		return this.domNode;
	},
	
	destroy: function() {
		this._contentWidget && this._contentWidget.destroy();
		this.inherited(arguments);
	},

	togglePreview: function(ev){
		var shown = this._previewShown;
		if(!shown && !this._fechedCompactRendering){				
			this._fetchCompactRendering();
			this._fechedCompactRendering = true;
		}
		shown = !shown;
		this._toggleShowMore(!shown);
		dojo.stopEvent(ev);
	},
	
	_toggleShowMore: function(showMore){
		this.previewArea.style.display = showMore ? "none" : ""; //$NON-NLS-1$ //$NON-NLS-2$
		showMore ? dojo.replaceClass(this.previewLink, "showPreview", "hidePreview") : dojo.replaceClass(this.previewLink, "hidePreview", "showPreview"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		this.moreLinkMessage.innerHTML = showMore ? this._messages.showMore : this._messages.showLess;
		this._previewShown = !showMore;	
		this.position();
	},

	open: function(){
		if(this.previewArea){
			this._toggleShowMore(true);
		}
		this.content = this.domNode;
		this.inherited(arguments);
		// fake net.jazz.ui._RichHover to put its content into previewArea
		this.content = this.previewArea;
	},
	
	// fake net.jazz.ui._RichHover
	// if we don't override, hover will be destroyed when closed
	disable: function(){
		this.inherited(arguments);
		this._disableOnClose = false;
	},
	
	isEnabled: function() {
		var popup = dijit.popup.getTopPopup();
		if (popup && popup.widget instanceof dijit.Menu) {
			// Never show a hover while a menu is active.
			return false;
		}

		return this.inherited(arguments);
	},

	onLoad: function(){
	}	
});

})();