/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.hover.HoverContent"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "HoverMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var utils = com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils;

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.hover.HoverContent", //$NON-NLS-1$
	[ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/hover/templates/HoverContent.html"), //$NON-NLS-1$ //$NON-NLS-2$
	contentInfo: null,
	
	postMixInProperties: function() {
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "HoverMessages");		 //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function(){
		this.inherited(arguments);
		this.setContentInfo(this.contentInfo);
	},
	
	setContentInfo: function(contentInfo){
		this.contentInfo = contentInfo;
		if(utils.OPEN_LINK_TARGET == "") { //$NON-NLS-1$
			this.titleCell.innerHTML = "<a href='" + contentInfo.uri + "'>" + (contentInfo.title || this._messages.noTitle) + "</a>"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		} else {
			this.titleCell.innerHTML = "<a href='" + contentInfo.uri + "' target='" + utils.OPEN_LINK_TARGET + "'>" + (contentInfo.title || this._messages.noTitle) + "</a>"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		}
		this.summaryCell.innerHTML = contentInfo.summary;
		dojo.style(this.summaryRow, "display", contentInfo.summary ? "" : "none");//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
	}	
});

})();
