/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/


(function()  {
dojo.provide("com.ibm.relm.explorer.web.ui.internal.reports.ReportWizard"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("jazz.ui.Wizard"); //$NON-NLS-1$
dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.reports.ReportTemplateSelectionStep"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.reports.SpecifyParameterWizardStep"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ReportMessages"); //$NON-NLS-1$ //$NON-NLS-2$

//var wizardStepHeader = jazz.ui.wizard.WizardStepHeader;
//var wizardStep = jazz.ui.wizard.WizardStep;

dojo.declare("com.ibm.relm.explorer.web.ui.internal.reports.ReportWizard",  //$NON-NLS-1$
		[jazz.ui.Wizard, dijit._Widget, dijit._Templated] ,{
	// set by caller
	viewId: "", 		// ID of view ... last segment of view uri //$NON-NLS-1$
	queriesInView: [], 	// array of {containerId, containerName, sparql}  
	// variables set by steps 
	_selectedReport: null, // step 1
	_reportParameters: [], // step 2
	
	//
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web",  "ui/internal/reports/templates/ReportWizard.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,
		
	step1: null,
	step2: null,
	
	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ReportMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function() {

		// Step 1
		this.step1 = new com.ibm.relm.explorer.web.ui.internal.reports.ReportTemplateSelectionStep({
			wizard: this
		});
		this.addStep(this.step1);
		// Step 2
		this.step2 = new com.ibm.relm.explorer.web.ui.internal.reports.SpecifyParameterWizardStep({
			wizard: this
		});
		this.addStep(this.step2);
		
		this.selectStep(1);

	}	
	
});

}) ();