/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("relm.app.ui.internal.util.UrlUtil"); //$NON-NLS-1$

relm.app.ui.internal.util.UrlUtil = {

	OWNNING_APPLICATION_KEY: "owningApplicationKey", //$NON-NLS-1$

	DEBUG: "debug", //$NON-NLS-1$

	WHOAMI: "whoami", //$NON-NLS-1$

    getParamater: function(/*String */ url, /*String */ key) {
    	var query= new dojo._Url(url).query;
    	var object= dojo.queryToObject(new dojo._Url(url).query);
    	return object[key];
    },

    getActionArgument: function(argument){
    	/*Checking for argument being string is the caller responsibility */
    	var hash= window.location.hash;
    	if(!hash){
    		return null;
    	}
		var index= hash.indexOf(argument+ "="); //$NON-NLS-1$
		if(index== -1){
			return null;
		}
		var arg= hash.substring(index+argument.length+1, hash.length);
		if(arg){
			index= arg.indexOf("&"); //$NON-NLS-1$
			if(index>-1){
				return arg.substring(0, index);
			}
		}
    	return arg;
    },

	/*Extract the parameters for a given URI, or the current url */
    extractParameter: function(uri){
    	if(!uri){
    		uri = window.location;
    	}
    	var extracted= {};
    	var qstr = uri.search.substr(1);
    	if (qstr.length) {
			var qparts = qstr.split("&"); //$NON-NLS-1$
			for (var x = 0; x < qparts.length; x++) {
				var tp = qparts[x].split("="); //$NON-NLS-1$
				extracted[tp[0]]= decodeURIComponent(tp[1]);
			}
		}
		return extracted;
    },

    getSegmentsForUri: function(uri){
		var segment = uri.substring(1).indexOf('/');	//$NON-NLS-1$
		if (segment >= 0) {
			return uri.substring(segment + 3).split('/'); //$NON-NLS-1$
		} else {
			return new String[0];
		}
    },

    getBaseContextForUri: function(uri){
		var segments= relm.app.ui.internal.util.UrlUtil.getSegmentsForUri(uri);
		var url= new dojo._Url(uri);
		var seg1= segments[0];
		var seg2= segments[1];
		return url.scheme+ "://"+ seg1+ "/"+ seg2; //$NON-NLS-1$ //$NON-NLS-2$
    },

    getWhoamiForUri: function(uri){
    	var UrlUtil= relm.app.ui.internal.util.UrlUtil;
		return UrlUtil.getBaseContextForUri(uri)+ "/"+ UrlUtil.WHOAMI; //$NON-NLS-1$
    }
};
