/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.Clipboard"); //$NON-NLS-1$

(function(){

// utilities
com.ibm.relm.explorer.web.ui.internal.view.Clipboard = {
	_useSystemClipboard: false,	
	getAvailableDataFormats: function(dataFormats){
		return dojo.filter(dataFormats, function(format) {
			return this.getData(format);
		}, this);
	},

	getData: function(dataFormat){
		if (this._useSystemClipboard && window.clipboardData) {
			return window.clipboardData.getData(dataFormant);
		}
		return this.__clipboardData ? this.__clipboardData[dataFormat] : null;
	},
	
	setData: function(dataFormat, data){
		if (this._useSystemClipboard && window.clipboardData) {
			window.clipboardData.setData(dataFormat, data);
			return;
		}
		if (!this.__clipboardData)
			this.__clipboardData = {};
		this.__clipboardData[dataFormat] = data;

		this.fireClipboardChanged([dataFormat]);
	},
	
	clearData: function(dataFormats){
		if (this._useSystemClipboard && window.clipboardData) {
			window.clipboardData.clearData(dataFormats);
			return;
		}
		if (!this.__clipboardData)
			return;
		dojo.forEach(dataFormats, function(format) {
			if (this.__clipboardData[format])
				delete this.__clipboardData[format];
		}, this);
		
		this.fireClipboardChanged(dataFormats);
	},
	
	fireClipboardChanged: function(dataFormats) {
		var message = {
				type: "ClipboardChangedNotification", //$NON-NLS-1$
				clipboard: this,
				dataFormats: dataFormats
			};
		dojo.publish("btp:ClipboardChanged", [message]); //$NON-NLS-1$
	}
};

})();

