/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.DiagramEditRoot"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.Clipboard"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.conf.componentInfo"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.canvas.DiagramEditor"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.decoration.DefaultPresets"); // without this, arrow decoration won't be shown //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.NodeContainerLinkTracker"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.connections.BaseConnection"); // without this, error loading connection //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.connections.RoundConnection"); // without this, error loading connection //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.connections.LineConnection"); // without this, error loading connection //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.extensions.viewLoader");  //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.extensions.nodes");  //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.extensions.containers");  //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.extensions.connections");  //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.extensions.xmlGenerator"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.extensions.queryCache");  //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.helper");  //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes.contextMenuHelper");  //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.CommandProvider"); //$NON-NLS-1$

//dojo.require("rmpw.diagrams.render.RenderRoot"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.RelmRenderRoot"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "DiagramPageMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

var commandProvider = com.ibm.relm.explorer.web.ui.internal.view.edit.CommandProvider;
var util = com.ibm.relm.explorer.web.ui.internal.util;
var clipboard = com.ibm.relm.explorer.web.ui.internal.view.Clipboard;

/*
 * DiagramEditRoot is our own EditRoot which create DiagramEditor. 
 * DiagramEditRoot is created in DiagramLayer.
 * viewer property of DiagramLayer holds an instance of DiagramEditRoot
 */
dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.DiagramEditRoot", //$NON-NLS-1$
	com.ibm.relm.explorer.web.ui.internal.view.RelmRenderRoot,
{
	viewUri: null,
	editor: null,
	bgGroup: null,

	constructor: function(args) {
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "DiagramPageMessages");		 //$NON-NLS-1$ //$NON-NLS-2$

		this.viewUri = args.viewUri;
		this.webBaseUri = args.webBaseUri;
		this.diagramLayer = args.diagramLayer;		
		this.createPolicies();
		this.delayedLayoutTimeout = 1 * (util.getURLOption("delayedLayout") || 10); //$NON-NLS-1$
		this.delayedUpdate = util.getURLOption("delayedUpdate") !== "false";//$NON-NLS-1$//$NON-NLS-2$
		console.debug("delayedUpdate = " + this.delayedUpdate);//$NON-NLS-1$
		this.createDiagramEditor(args.editMode);
	},

	createDiagramEditor: function(editMode){
		var viewUri = this.viewUri;
		var url = viewUri;
		if(!this.editor){
			var helpers;
			var tracker;
			var extensions;
			if(editMode){
				tracker = "com.ibm.relm.explorer.web.base.internal.canvas.tool.DragGhostMoveTracker";//$NON-NLS-1$
				helpers = ["com.ibm.relm.explorer.web.ui.internal.view.helper", //$NON-NLS-1$
							"styleHelper", //$NON-NLS-1$
							"dropHelper", //$NON-NLS-1$
							//connectionHelper is necessary only if we allow user to make connection by drag and drop				              
							//"connectionHelper", //$NON-NLS-1$
							"focusFrameHelper" //$NON-NLS-1$
							];
				extensions = [
							"paletteSupport", //$NON-NLS-1$
							"componentInfo", //$NON-NLS-1$
							"focus", //$NON-NLS-1$
							"knob", //$NON-NLS-1$
							"selectionHandles", //$NON-NLS-1$
							//"connectionEndpoints", //$NON-NLS-1$
							"connectableEndpoints", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.xmlGenerator", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.editor", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.viewLoader", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.nodes", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.containers", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.connections", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.containerlink", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.queryCache", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.artifactElementCache", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.nodes.contextMenuHelper" //$NON-NLS-1$
							];
			}else{
				tracker = "com.ibm.relm.explorer.web.base.internal.canvas.tool.DragMoveTracker";//$NON-NLS-1$
				helpers = ["styleHelper", //$NON-NLS-1$
							"focusFrameHelper" //$NON-NLS-1$
							];			
				extensions = [
							"componentInfo", //$NON-NLS-1$
							"focus", //$NON-NLS-1$
							//"connectionEndpoints", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.xmlGenerator", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.viewLoader", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.nodes", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.containers", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.connections", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.containerlink", //$NON-NLS-1$
							"com.ibm.relm.explorer.web.ui.internal.view.extensions.artifactElementCache" //$NON-NLS-1$
							];
			}
			this.editor = new com.ibm.relm.explorer.web.base.internal.canvas.DiagramEditor({
				_editMode: editMode,
				startup: function(){
					// override startup to do nothing.
					// because starting up DiagramViewer causes invalid
					// behavior in _connections #TODO
				},
				messages: this._messages,
				surface: this.surface,
				group: this.viewport.contents,
				src: url,
				webBaseUri: this.webBaseUri,
				dragMoveTrackerClass: tracker,
				createConnectionTrackerClass: "com.ibm.relm.explorer.web.ui.internal.view.edit.NodeContainerLinkTracker", //$NON-NLS-1$
				// extensions will be loaded in
				// com.ibm.relm.explorer.web.base.internal.canvas.Viewer
				// predefined extensions are in
				// com.ibm.relm.explorer.web.base.internal.canvas.extension
				// package
				extensions: extensions,
				// helpers will be loaded in
				// com.ibm.relm.explorer.web.base.internal.canvas.Editor
				// predefined helpers are in
				// com.ibm.relm.explorer.web.base.internal.helper package
				commonHelpers: helpers, 
				// componentInfo will be loaded in
				// com.ibm.relm.explorer.web.base.internal.canvas.Editor,
				// and will be used by createComponent method
				componentInfo: com.ibm.relm.explorer.web.conf.componentInfo,
				nodeMoved: function(){},
				commands: "*", //$NON-NLS-1$
				_commandProvider: commandProvider,
				clipboard: clipboard,
				delayedUpdate: this.delayedUpdate
			}, this.container);
			
			this._onConfigLoadedHandler = dojo.connect(this.editor, "onConfigLoaded", dojo.hitch(this, this._onConfigLoaded));//$NON-NLS-1$
	
			// store node position after drag move  TODO: need to modify
//			var self = this;
			this.editor.connect(this.editor, "handleDragEnd", function(e){ //$NON-NLS-1$
				// 'this.viewer' is DiagramEditor
				var focusWidget = dijit.getEnclosingWidget(e.target);
				if(focusWidget && this._layout && this._layout.nodes[focusWidget.id]){
					this._layout.nodes[focusWidget.id].top = focusWidget.top;
					this._layout.nodes[focusWidget.id].left = focusWidget.left;
				}
			});
			
			// setup for delayed loading of node contents
			this._viewPortHandle = dojo.connect(this.viewport, "onViewportChanged", dojo.hitch(this, this.updateResorceNodes)); //$NON-NLS-1$
		}else{
			this.editor.load(url);
		}
		this.editor._delayedLayoutTimeout = this.delayedLayoutTimeout;
	},
	
	_onConfigLoaded: function(config, scopes){
		if(!this.editor) {
			// already destroyed
			return;
		}
		this.onConfigLoaded(config, scopes);
	},

	onConfigLoaded: function(config){
		
	},

	loadDiagram: function(viewUri) {
		this.viewUri = viewUri;
		if(this.editor) {
			this.editor.load(viewUri);
			var commandProcessor = this.editor.getCommandStack();
			if(commandProcessor){
				commandProcessor.clear();
			}
		}
	},
	
	reloadLocal: function(configSource){
		if(this.editor) {
			this.editor.reloadLocal(configSource);
		}
	},
	
	getSelectionController: function() {
		return this.policies.selectionScope;
	},
	
	getAcceleratorController: function() {
		return this.policies.acceleratorScope;
	},
	
	destroy: function() {
		this.inherited(arguments);
		if (this.editor){
			dojo.disconnect(this._onConfigLoadedHandler);						
			this.editor.destroyRecursive();
			this.editor = null;
		}
		if (this._commandController) {
			this._commandController.destroy();
		}
		
		dojo.disconnect(this._connectCommandStack);
		
		if (this._viewPortHandle) {
			dojo.disconnect(this._viewPortHandle);
			delete this._viewPortHandle;
		}
	},
		
	getCommandController: function( attachPoint ) {
		if(!this._commandController) {			
			var repository = new rmpw.common.vcs.Repository();
			var commandStack = new rmpw.common.command.CommandStack(repository);
			this._connectCommandStack = dojo.connect(commandStack, "postExecuteHook", dojo.hitch(this, function() { //$NON-NLS-1$
				this.getInvalidationController().performInvalidation();
			}));
	    	this._commandController = this.configuration.commandControllerClass ? new this.configuration.commandControllerClass(this, 
	    			attachPoint, commandStack) : new rmpw.diagrams.edit.CommandController(this, attachPoint, commandStack);
		}
		return this._commandController;
	},
	
	registerCommands: function( surface, commands ){
//		var commandController = this.getCommandController( surface );
//		
//		for( cmd in commands ){
//		   commandController.registerCommand( new commands[cmd]() );
//		}
	},
	
	// TODO (MG): move to domain specific root rather than diagram root
	getCommandPackage: function() {
		return this.commandPackage;
	},
	
    configure: function( config ){
		this.registerCommands( config.canvas, config.commandList );
	    
	    this.inherited(arguments);
	},

	execute: function( command, data ){
		if( data == null ){ data = new Object(); }
		data.viewer = this;
//		this.getCommandController().commandStack.execute( command, data );	
	},
	
	/**
	 * TODO (MG): the diagram should be destroyed at a higher level to avoid
	 * 		this manual resetting business.
	 */
	clear: function() {
		// Don't clear if we're consructing
		if (this._constructing) {
			return;
		}
		
		for (var key in this.policies) {
			var policy = this.policies[key];
			if (policy.destroy) {
				policy.destroy();
			}
		}
		this.inherited(arguments);
		this.policies = [];
		this.createPolicies();
	},

	createPolicies: function() {
	},
	
	updateResorceNodes: function() {
		if (this.editor.updateResorceNodes) {
			this.editor.updateResorceNodes();
		}
	}});

}) ();