/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.DiagramView"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.layout.StackContainer"); //$NON-NLS-1$
dojo.require("dijit.layout.TabContainer"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.Workbench"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.client.session.Session"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.DiagramViewInput"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.Layout"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.Table"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.ConfigTextEditor"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.ConfigFormEditor"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.queryparams.SystemParameterUtil"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.EnumerationUtils"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.SetParametersTable"); //$NON-NLS-1$


dojo.require("com.ibm.relm.explorer.web.ui.internal.reports.ReportWizard"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.EditSideBar"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "DiagramViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.common.web.ui.editor", "PageHelperMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require("jazz.core.loader"); //$NON-NLS-1$

(function(){

var paramUtil = com.ibm.relm.explorer.web.explorer.queryparams.SystemParameterUtil;
var enumUtils = com.ibm.relm.explorer.web.ui.internal.view.common.EnumerationUtils;
var util = com.ibm.relm.explorer.web.ui.internal.util;
var messages = dojo.i18n.getLocalization("com.ibm.relm.common.web.ui.editor", "PageHelperMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var JazzUIWorkbench = net.jazz.ajax.ui.PlatformUI.getWorkbench();

function isEmptyObject(obj){
	for(var o in obj){
		return false;
	}
	return true;
}
/*
 * DiagramView is a toplevel widget of view hierarchy.
 * DiagramView 
 *    -(layout)-> Layout 
 *                 -(viewer)-> DiagramWidget 
 *                               -(diagramLayer)-> DiagramLayer 
 *                                                   -(viewer)-> DiagramEditRoot 
 *                                                                -(editor)-> DiagramEditor
 */
var _Layout = "layout";//$NON-NLS-1$ 
var _DiagramWidget = _Layout + ".viewer";//$NON-NLS-1$ 
var _DiagramLayer = _DiagramWidget + ".diagramLayer";//$NON-NLS-1$ 
var _DiagramEditRoot = _DiagramLayer + ".viewer";//$NON-NLS-1$ 
var _DiagramEditor = _DiagramEditRoot + ".editor";//$NON-NLS-1$ 

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.DiagramView", //$NON-NLS-1$
	[ dijit._Widget, dijit._Templated, dijit._Container ],
{
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/templates/DiagramView.html"), //$NON-NLS-1$ //$NON-NLS-2$
	addButtonIcon: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/templates/add.gif"), //$NON-NLS-1$ //$NON-NLS-2$
	_collapsedIconSrc: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/grey-twistie-closed.png").toString(), //$NON-NLS-1$ //$NON-NLS-2$
	_expandedIconSrc: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/grey-twistie-open.png").toString(), //$NON-NLS-1$ //$NON-NLS-2$
	
	title: "", //$NON-NLS-1$
	_descriptionPopup: null,
	page: null,
	permissions: null,
	
	_editorInput: null,
	_dirty: false,
	
	_keptParams: null,
	_keptHash: null,

	attributeMap: {
		title: { node: "titleNode", type: "innerHTML" } //$NON-NLS-1$ //$NON-NLS-2$
	},

	constructor: function() {
		this._keptParams = [];
		
	},

	postMixInProperties: function() {
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "DiagramViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		if(!this.title)
			this.title = this._messages.defaultTitle;
		
		// switch reporting function
		var queryString = dojo.doc.location.search;
		if(queryString.length > 1){
			queryString = queryString.substring(1);
			if(dojo.queryToObject(queryString)["useRPE"] === "true"){ //$NON-NLS-1$ //$NON-NLS-2$
				this._useRPE = true;
			}
		}
	},
	
	postCreate: function(){
		this.inherited(arguments);
		
		var queryString = dojo.doc.location.search;
		if(queryString.length > 1){
			queryString = queryString.substring(1);
			if(dojo.queryToObject(queryString)["editForm"] === "true"){ //$NON-NLS-1$ //$NON-NLS-2$){
				this.formPage = new com.ibm.relm.explorer.web.ui.internal.editor.ConfigFormEditor({title: this._messages.detail});
				this.formPage.setPermissions(this.permissions);
				this.formPage.setMessageArea(this.messageArea);
				this.connect(this.formPage, "onClose", this.onFormPageClosed); //$NON-NLS-1$
				this.connect(this.formPage, "onSwitch", this.onSwitchToSource); //$NON-NLS-1$
				this.connect(this.formPage, "onSaveCompleted", this.onFormPageSaveCompleted); //$NON-NLS-1$
				this.stackContainer.addChild(this.formPage);
			}
			if(dojo.queryToObject(queryString)["editSrc"] === "true"){ //$NON-NLS-1$ //$NON-NLS-2$
				this.sourcePage = new com.ibm.relm.explorer.web.ui.internal.editor.ConfigTextEditor({title: this._messages.source});
				this.connect(this.sourcePage, "onClose", this.onSourcePageClosed); //$NON-NLS-1$
				this.connect(this.sourcePage, "onSwitch", this.onSwitchToForm); //$NON-NLS-1$
				this.connect(this.sourcePage, "onSaveCompleted", this.onSourcePageSaveCompleted); //$NON-NLS-1$
				this.stackContainer.addChild(this.sourcePage);
			}
		}
		
		// enable/disable edit button
		if(!this._canEdit()) {
			this.editButton.domNode.style.display = "none"; //$NON-NLS-1$
		}
		if(util.checkURLOption("printButton")){//$NON-NLS-1$
			this.printButton.domNode.style.display = ""; //$NON-NLS-1$
		}
		this.refreshDiagram();

		this.connect(this.stackContainer, "selectChild", this._onSelectChild); //$NON-NLS-1$

		this._editorInput = new com.ibm.relm.explorer.web.ui.internal.view.DiagramViewInput({id: this.viewUri.split("/").pop(), resourceUri: this.viewUri}); //$NON-NLS-1$
		this._editorInput.editor = this;
	},
	
	_updateParameterPane: function(table){
		var config = this._getConfig();
		if(config){
			var parameters = [];
			for(var name in config.params){
				var param = config.params[name];
				param = this._getParam(name, param);
				if (param)
					parameters.push(param);
			}

			// collect parameters from each container
			var self = this;
			var editor = this._getDiagramEditor();
			var deferreds = [];
			editor.getContainerSet().forEach(function(container){
				var deferred = new dojo.Deferred();
				container._getUserSpecifiedParams(function(params) {
					for(var name in params) {
						var param = self._getParam(name, params[name]);
						if (param) {
							param.containerId = params[name].containerId;
							param.containerTitle = params[name].containerTitle;
							parameters.push(param);
						}
					}
					deferred.callback();
				});
				deferreds.push(deferred);
			});
			
			dojo.when(new dojo.DeferredList(deferreds), function() {
				table.setParameters(parameters);
			});
		}		
	},
	
	_setContainerTitleToParam: function(container, param) {
		var deferred = new dojo.Deferred();
		container._getTitle(function(title) {
			param.containerTitle = title;
			deferred.callback(title);
		});
		return deferred;
		
	},
	
	_getParam: function(name, param) {
		if (!param) return null;
		var value = param["value"]; //$NON-NLS-1$
		var type = param["type"]; //$NON-NLS-1$
		var label = param["label"]; //$NON-NLS-1$
		if (!label) label = name;
		if(type === undefined) {
			// maybe URL parameter
			return null;
		}
		
		var newParam = {
				name : name,
				label: label,
				value: value,
				type: type,
				description: param["description"], //$NON-NLS-1$
				mandatory: param["mandatory"],//$NON-NLS-1$
		};
		
		var isSystemParam = type.substr(0, 7) == "system:"; //$NON-NLS-1$
		if(isSystemParam) {
			newParam.value = paramUtil.getValues(type.substr(7)).displayValue;
			newParam.readonly = true;
		} else if (type == "enum") { //$NON-NLS-1$
			newParam.enumtype = param.enumtype;
			enumUtils.updateParamByValue(newParam, param.value);
		}

		return newParam;
	},
	
	destroy: function(){
		if(this.layout) {
			this.layout.destroy();
			delete this.layout;
		}
		if (this._editorInput)
			delete this._editorInput;
		if (this._descriptionPopup)
			delete this._descriptionPopup;
		this.inherited(arguments);
	},
	
	refreshDiagram: function(noReload){
		if(dojo.doc.location.hash != this._keptHash){
			this._keptHash = null;
			this._keptParams = []; // clear
		}
		var currentPage = this.stackContainer.selectedChildWidget;
		if((!this.sourcePage || currentPage != this.sourcePage) && (!this.formPage || currentPage != this.formPage)){
			var doFocusOn = true;
			if(!this.layout){
				this.layout = new com.ibm.relm.explorer.web.ui.internal.view.Layout({ viewUri: this.viewUri , diagramView: this});
				this.layout.startup();
				this.layout.layout();
				if(this.formPage){
					this.formPage.setDiagramView(this);
				}
				var diagramEditor = this._getDiagramEditor();
				if(dojo.isFunction(diagramEditor.setMessageArea)){
					diagramEditor.setMessageArea(this.messageArea);
				}
				this.sidebarContainer.setDiagramView(this);
				this.sidebarContainer.setContent(this.layout, true);
				this.sidebarContainer.viewer = this.layout;
				this.connect(this._getDiagramLayer(), "onConfigLoaded", this._onConfigLoaded); //$NON-NLS-1$
			} else if(!noReload) {
				// call DiagramEditRoot.loadDiagram
				this._getDiagramEditRoot().loadDiagram(this.viewUri);
			} else {
				doFocusOn = false;
			}
			if(doFocusOn){
				this._doFocusOn();
			}
		}
	},

	_doFocusOn: function(){
		var diagramEditor = this._getDiagramEditor();
		if(diagramEditor){
			var hash = dojo.doc.location.hash;
			if(hash && hash.length > 1){
				hash = encodeURI(hash);
				var params = dojo.queryToObject(hash.substring(1));
				if(params.focusOn || params.focusOnText){
					this._prevSearchText = params.focusOnText;
					if(!this._resourceLoadedHandler){
						this._resourceLoadedHandler = this.subscribe("com.ibm.relm.explorer.web.VIEW_LAYOUT_COMPLETED", dojo.hitch(this, function(message) { //$NON-NLS-1$
							if (message && message == diagramEditor) {
								this._resourceLoaded({focusOn: params.focusOn, focusOnText: params.focusOnText});
							}
						}));
					}
				}
			}
		}
	},
	
	refreshDiagramLocal: function(focusOn){
		var source = this._getConfig();
		this._getDiagramEditRoot().reloadLocal(source);
		if(focusOn){
			this._doFocusOn();
		}
	},
	
	showFormEditor: function(){
		this.openEditorFromView = true;
		this._onEdit();
	},
	
	_setDescription: function(description){
		if (this._descriptionPopup) {
			delete this._descriptionPopup;
			this._descriptionPopup = null;
		}
		if(description && description.length > 0) {
			dojo.addClass(this.titleNode, 'jazz-app-ua-TextHoverHelp'); //$NON-NLS-1$
			this._descriptionPopup = new jazz.ui.HoverPopup({
				around: this.titleNode,
				html: description,
				openDelay: 300
			});
		}
	},
	
	_resourceLoaded: function(params){
		this.unsubscribe(this._resourceLoadedHandler);
		this._resourceLoadedHandler = null;

		if(params.focusOn || params.focusOnText){
			var editor = this._getDiagramEditor();
			var allResourceNodes = editor.getAllResourceNodes();
			console.log("num of resource node " + allResourceNodes.length); //$NON-NLS-1$
			var foundNode = null;
			if(params.focusOn){
				for(var i =0; i < allResourceNodes.length; i++){
					var node = allResourceNodes[i];
					if(node.uri === params.focusOn){
						foundNode = node;
						break;
					}
				}
			}
			if(!foundNode && params.focusOnText){
				for(var i =0; i < allResourceNodes.length; i++){
					var node = allResourceNodes[i];
					if(dojo.isFunction(node.findText) && node.findText(params.focusOnText).length > 0){
						foundNode = node;
						break;
					}
				}
			}
			console.log("focus on " + foundNode); //$NON-NLS-1$
			if(foundNode){
				this._panToNode(foundNode, editor);
			}
		}
	},
	
	_onConfigLoaded: function(config, scopes){
		if (scopes) {
			dojo.forEach(scopes, function(scope) {
				if (scope == "parameters") //$NON-NLS-1$
					this._onParameterUpdated();
			}, this);
			return;
		}
		
		this.onConfigUpdated();
		
		// eval parameters
		this._onParameterUpdated();
		
		// update edit button
		this.editButton.domNode.style.display = this._editMode || !this._canEdit() ? "none" : "";//$NON-NLS-1$//$NON-NLS-2$
		
		var _config = this._getDiagramConfig();
		this.onConfigLoaded();
		this._editorInput._viewConfigLoaded(_config);
	},

	_onParameterUpdated: function() {
		var config = this._getDiagramConfig();
		var params = config.params;
		var isParamExist = params && !isEmptyObject(params);

		var viewParams = {};
		this._getDiagramEditor().getContainerSet().forEach(function(container){
			var p = {};
			var containerParams = container.getParameters();
			for (key in containerParams) {
				if (containerParams[key].isuserparam)
					p[key] = containerParams[key];
			}
			if (!isEmptyObject(p))
				viewParams[container.getId()] = p;
		});
		
		if (!isParamExist)
			isParamExist = !isEmptyObject(viewParams);
		
		if(isParamExist){
			if(!this._editMode){
				var checkParamRequired = this._checkUserGivenParamRequired(params);
				if (!checkParamRequired) {
					for (key in viewParams) {
						if (this._checkUserGivenParamRequired(viewParams[key], params)) {
							checkParamRequired = true;
							break;
						}
					}
				}
				if(checkParamRequired) {
					this._onSetParameters();
				}else {
					var needReload = this._needReload(params, viewParams, this._keptParams);
					if (needReload) 
						setTimeout(dojo.hitch(this, this.refreshDiagramLocal), 0); // avoid recursive
				}
			}
		}
		this.setParamButton.set('enabled', isParamExist);//$NON-NLS-1$
	},
	
	_needReload: function(params, viewParams, keptParams) {
		var self = this;
		var needReload = false;
		
		var qparams = null;
		var hash = dojo.doc.location.hash;
		if(hash && hash.length > 1) {
			qparams = dojo.queryToObject(hash.substring(1));
		}

		dojo.forEach(keptParams, function(kp){
			var name = kp.name;
			if (qparams && !kp.containerId) {
				// query parameter takes priority over kept parameter.
				for (var key in qparams) {
					if (key == name) {
						kp.value = qparams[key];
						break;
					}
				}
			}
			if (kp.containerId) {
				var vps = viewParams[kp.containerId];
				if(vps && vps[name]){
					if(!self._isValueSame(vps[name], kp)){
						vps[name].value = kp.value;
						needReload = true;
					}
				}
			} else if(params[name]){
				if(!self._isValueSame(params[name], kp)){
					params[name].value = kp.value;
					needReload = true;
				}
			}
		});
		return needReload;
	},
	
	_isValueSame: function(p1, p2) {
		if (p1.type != p2.type) return false;
		var type = p1.type;
		
		var isSystemParam = type && type.substr(0, 7) == "system:"; //$NON-NLS-1$
		if (isSystemParam) {
			return true;
		}
		
		if (type == "date") { //$NON-NLS-1$
			if (!dojo.isString(p1.value))
				return dojo.date.stamp.toISOString(p1.value) == dojo.date.stamp.toISOString(p2.value);
		} else if (type == "enum") { //$NON-NLS-1$
			return enumUtils.equals(p1, p2);
		}
		return p1.value == p2.value;
	},
	
	onConfigUpdated: function(){
		// update title and description
		var config = this._getDiagramConfig();
		var diagramName = config.diagramName;
		this.titleNode.innerHTML = jazz.util.html.escape(diagramName);
		this._setDescription(config.description);
		JazzUIWorkbench.setTitle(diagramName);
		this._editorInput._viewConfigUpdated(config);
	},
	
	onConfigLoaded: function(){
		// for listeners
		this.page.pageHelper.openEditor(this);
	},
	
	_checkUserGivenParamRequired : function(params, supplementalParams) {
		for(var name in params) {
			var param = params[name];
			var sparam = supplementalParams ? supplementalParams[name] : null;
			if(param["mandatory"] && (param["value"] === undefined || param["value"] === "")) { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
				if(!sparam || (sparam["value"] === undefined || sparam["value"] === "")) { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
					return true;
				}
			}
		}
		return false;
	},
	
	_getConfig: function(){
		var config = null;
		if(this.formPage){
			config = this.formPage.getConfig();
		}
		if(!config){
			config = this._getDiagramConfig();
		}
		return config;
	},
	
	_getDiagramWidget: function(){
		return dojo.getObject(_DiagramWidget, false, this);
	},
	
	_getDiagramLayer: function(){
		return dojo.getObject(_DiagramLayer, false, this);
	},
	
	_getDiagramEditRoot: function(){
		return dojo.getObject(_DiagramEditRoot, false, this);
	},
	
	_getDiagramEditor: function(){
		return dojo.getObject(_DiagramEditor, false, this);
	},
	
	// for public access
	getDiagramEditor: function(){
		return this._getDiagramEditor();
	},
	
	_getDiagramConfig: function(){
		var diagramEditor = this._getDiagramEditor();
		if(diagramEditor){
			return diagramEditor.getConfig ? diagramEditor.getConfig() : null;
		}
		return null;
	},
	
	_onReload: function(ev){
		this._clearCachedResult();
		this.refreshDiagram();
	},

	_clearCachedResult: function() {
		var editor = this._getDiagramEditor();
		if(editor) {
			if (editor._clearCachedResult) editor._clearCachedResult();
			if (editor.clearCache) editor.clearCache();
		}
	},
	
	_onSelectChild: function(){
		var selectedTab = this.stackContainer.selectedChildWidget;
		// check if switch from source but source page is dirty state
		if(this.sourcePage && selectedTab != this.sourcePage && this.selectedTab == this.sourcePage && this.sourcePage.isDirty()){
			if (!confirm(this._messages.navigateAway + "\n\n" + this._messages.unsavedChanges + "\n\n" + this._messages.okOrCancel)) { //$NON-NLS-1$ //$NON-NLS-2$
				this.stackContainer.selectChild(this.sourcePage);
				return;
			}
			this.sourcePage.clearContent();
		} 
		// 
		if(selectedTab == this.sourcePage){
			this.onSwitchToSource();
		}else if(selectedTab == this.formPage){
			this.onSwitchToForm();
		}else if(selectedTab == this.diagramPage){
			this.onSwitchToDesign();
		}
		// keep the current page
		this.selectedTab = this.stackContainer.selectedChildWidget;
	},
		
	_onEdit: function(){
		this.showEditorTab(true);
	},
	
	_onFormEdit: function(){
		if(!this.formPage){
			return;
		}
		//this.stackContainer.selectChild(this.formPage);
		var config = this._getDiagramConfig();
		if(config){
			// config has been loaded already by design page
			// reuse it
			this.formPage.setConfig(config);
			return;
		}
		JazzUIWorkbench.showMessage(this._messages.loading);
		var self = this;
		jazz.client.xhrGet({
			url: this.viewUri,
			preventCache: true,
			load: function(response, ioArgs){
				JazzUIWorkbench.hideMessageArea();
				self.getDiagramEditor()._eTag = ioArgs.xhr.xhr.getResponseHeader("ETag"); //$NON-NLS-1$

				// load configuration
				var config = new com.ibm.relm.explorer.web.ui.internal.view.loader.Config();
				config.viewUri = self.viewUri;
				config.load(response, []);
				self.formPage.setConfig(config);
				//self.stackContainer.selectChild(self.formPage);
			},
			error: function(response, ioargs){
				JazzUIWorkbench.hideMessageArea();
				console.error(response.message);
				var message = com.ibm.relm.explorer.web.ui.internal.util.getXhrErrorMessage(response, ioargs);
				JazzUIWorkbench.showMessage(message);
				response.responseText = null; // don't show the message in error dialog
			},
			headers: {"Accept": "text/json"}, //$NON-NLS-1$ //$NON-NLS-2$
			handleAs: "json" //$NON-NLS-1$ 
		});
	},
	
	_onSaveAndClose: function(ev){
		this._onSaveCore(true);
	},
	
	_onSave: function(ev){
		this._onSaveCore(false);
	},
	
	_onSaveCore: function(closeOnSave){
		this._keptParams = []; // clear
		
		this._clearDirty();
		var selectedTab = this.stackContainer.selectedChildWidget;
		if(selectedTab == this.sourcePage){
			this.sourcePage.save();
		}else if(selectedTab == this.formPage){
			this.formPage.save();
		}else{
			this._doSave(closeOnSave);
		}
	},
	
	_doSave: function(closeOnSave){
		// put save request to server
		JazzUIWorkbench.showMessage(this._messages.saving);
		var config = this._getDiagramConfig();
		var self = this;
		this.saveButton.disabled = true;
		this.saveAndCloseButton.disabled = true;
		jazz.client.xhrPut({
			url: config.viewUri,
			headers: {
				"Content-Type": "text/json", //$NON-NLS-1$ //$NON-NLS-2$
				"Etag": this.getDiagramEditor()._eTag //$NON-NLS-1$
			},
			putData: this.getConfigForSave(config),
			handle: function() {
				self.saveButton.disabled = false;
				self.saveAndCloseButton.disabled = false;
				JazzUIWorkbench.hideMessageArea();
			},
			load: function(response, ioArgs) {
				self.getDiagramEditor()._eTag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
				self._onSaveCompleted(closeOnSave);
			},
			error: function(response, ioargs) {
				console.error(response.message);
				var message = com.ibm.relm.explorer.web.ui.internal.util.getXhrErrorMessage(response, ioargs);
				self.messageArea.showMessage(message);
			}
		});
	},

	getConfigForSave:function(config){
		// remove system parameter values in saved configuration
		var configClone = dojo.clone(config);
		var params = configClone.params;
		for(var name in params) {

			var param = params[name];
			var type = param.type;
			if(type && type.indexOf("system:") == 0) { //$NON-NLS-1$
				param.value = ""; //$NON-NLS-1$
			}
		}
		return dojo.toJson(configClone);
		
	},
	
	_onCancel: function(ev){
		var isDirty = this._isDirty();
		if(isDirty && !confirm(dojo.string.substitute(messages.confirmCloseIfDirty, [this._getConfig().diagramName]))) {
			return;
		}
		var reloaded = this.showEditorTab(false);
		this.stackContainer.selectChild(this.diagramPage);
		if(this.formPage){
			this.formPage.cancelEdit();
		}
		if(isDirty){
			this._clearDirty();
			this.updateDirty();
			this.refreshDiagram(reloaded);
		}
	},
	
	_isDirty: function(){
		if(!this._editMode){
			return false;
		}
		if(this.formPage && this.formPage.isDirty()){
			return true;
		}
		var editor = this._getDiagramEditor();
		if(editor){
			var commandProcessor = editor.getCommandStack();
			if(commandProcessor.isDirty()){
				return true;
			}
		}
		return this._dirty;
	},
	
	isDirty: function() {
		return this._isDirty();
	},
	
	updateDirty: function() {
		this._dirty = this._isDirty();
		com.ibm.relm.common.web.ui.editor.PageHelper.updateDirtyStatus(this.getEditorInput().getPageId());
		this.dirtyStateChanged(this._dirty);
		
	},
	
	dirtyStateChanged: function(isDirty) {
		// handler is connected
	},
	
	setDirty: function(dirty) {
		this._dirty = dirty;
		this.updateDirty();
	},
	
	_clearDirty: function() {
		this._dirty = false;
		var editor = this._getDiagramEditor();
		if(editor){
			var commandProcessor = editor.getCommandStack();
			commandProcessor.clear();
		}

	},
	
	_onSetParameters: function(ev){
		var table = new com.ibm.relm.explorer.web.ui.internal.view.common.SetParametersTable();
		this._updateParameterPane(table);
		var self = this;
		new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
			primaryTitle: this._messages.setParameters,
			headerContent: {
				mainMessage: this._messages.paramDialogTitle,
				mainHtmlMessage: this._messages.paramDialogText
			},
			dialogContent: table,
			width: "570px", //$NON-NLS-1$
			isClosable: true,
			validate: function(values, callback) {
				// check if mandatory parameter is set or not
				if(!this._checkParams()){
					alert(self._messages.cancelMessage);
					return;
				}
				// all parameter is set correctly
				callback();
			},
			onOK: dojo.hitch(this, function(){
				var config = this._getConfig();
				var editor = this._getDiagramEditor();
				dojo.forEach(table.parameters, function(p){
					if (p.containerId) {
						var container = editor.findContainer(p.containerId);
						if (container) {
							var params = container.getParameters();
							if (p.type == "enum") { //$NON-NLS-1$
								enumUtils.updateParamByValue(params[p.name], p.value);
							} else {
								params[p.name].value = p.value;
							}
						}
					} else {
						config.params[p.name].value = p.value;
					}
				});
				if(!this._editMode){
					this._keptParams = table.parameters;
					this._keptHash = dojo.doc.location.hash;
				}
				table.setParameters(null); // clear
				this.refreshDiagramLocal();
			}),
			_checkParams: function(){
				// check if mandatory parameter is set or not
				return dojo.every(table.parameters, function(p){
					var hasvalue = (!p.mandatory) || (p.type == "boolean") || p.value; //$NON-NLS-1$
					if (!hasvalue && p.containerId) {
						for (var i = 0; i < table.parameters.length; i++) {
							var p2 = table.parameters[i];
							if (!p2.containerId && p2.name == p.name) {
								hasvalue = p2.value;
								break;
							}
						}
					}
					return hasvalue;
				});
			}
		});
	},
	
	_onPrint: function(ev){
		var scale = this._getDiagramLayer().getScale();
		window.open(this.viewUri + "?relm.printView=true&relm.ajaxmodule=true&relm.hideToolbar=true&relm.zoomLevel=" + scale*100);//$NON-NLS-1$
	},
	
	_onReport: function(ev){
		var self = this;
		// get all named queries used in this view
		var viewUri = this.viewUri;
		var viewId = viewUri.split("/").pop(); //$NON-NLS-1$
		var editor = this._getDiagramEditor();
		var allContainers = editor.getContainerSet();
		var queries = dojo.filter(allContainers.map(function(w){
			var containerNode = w._domNode;
			var containerId = containerNode ? containerNode.getAttribute("id") : null; //$NON-NLS-1$
			if(containerId && dojo.isFunction(w.getQuery)){
				var containerName = containerNode.getAttribute("name"); //$NON-NLS-1$
				var query = w.getQuery();
				if(query && query.sparql){
					return dojo.mixin({
						containerId: containerId,
						containerName: containerName
					}, query);
				}
			}
			return null;
		}), function(q){
			return q;
		});

		// open wizard
		var wizard = new com.ibm.relm.explorer.web.ui.internal.reports.ReportWizard({
			_selectedReport: this._selectedReport,
			_reportParameters: this._reportParameters,
			primaryTitle: this._messages.printView,
			viewId: viewId, 
			queriesInView: queries, 
			customProcessFinish: function(){
				if(!self._useRPE){
					// report UUID
					var reportResultURL = "#action=com.ibm.team.reports.viewReport&reportUUID=" + this._selectedReport.reportUUID; //$NON-NLS-1$
					
					// parameters
					dojo.forEach(this._reportParameters, function(param){
						reportResultURL += "&parameterName=" + encodeURIComponent(param.name) + "&parameterValue=" + encodeURIComponent(param.queryUrl || param.value); //$NON-NLS-1$ //$NON-NLS-2$
					});
					// avoid problem described in WI89673
					reportResultURL += "&parameterName=_dummy_&parameterValue=_dummy_";//$NON-NLS-1$
					
					// open report view
					window.location.href = reportResultURL;
				}else{
					var publishServiceUri = net.jazz.ajax._contextRoot + "/relmui/publish"; //$NON-NLS-1$
					var queryUrls = dojo.map(this._reportParameters, function(p){
						return p.queryUrl;
					});
					var queryString = "?queryEndpoints=" + encodeURIComponent(dojo.toJson(queryUrls)) + "&reportID=" + encodeURIComponent(this._selectedReport.reportId); //$NON-NLS-1$ //$NON-NLS-2$
					window.open(publishServiceUri + queryString);
				}
				self._reportParameters = this._reportParameters; // keep to reuse.
				self._selectedReport = this._selectedReport; // keep to reuse.
			}
		});
		wizard.startup();
	},
	
	_findDialog: null,
	_prevSearchText: null,
	_onFind: function(ev){
		if(!this._findDialog){
			// Create Dialog
			var self = this;
			var editor = this._getDiagramEditor();
			var content = dojo.create("div", {style:"margin: 10px;"}); //$NON-NLS-1$ //$NON-NLS-2$
			var textBox = dojo.create("input", {name:"findText", style:"width: 100%"}, content); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			var div = dojo.create("div", {style:"text-align: right; white-space: nowrap; padding: 5px 0;"}, content); //$NON-NLS-1$ //$NON-NLS-2$
			var messageArea = dojo.create("span", {style:"float:left;"}, div); //$NON-NLS-1$ //$NON-NLS-2$
			var findButton = dojo.create("input", {type:"button", value:this._messages.find}, div); //$NON-NLS-1$ //$NON-NLS-2$ 
			var closeButton = dojo.create("input", {type:"button", value:this._messages.close}, div); //$NON-NLS-1$ //$NON-NLS-2$ 
			var dialog = this._findDialog = new jazz.ui.Dialog({
				primaryTitle: this._messages.findTextTitle, 
				contentNode:content, 
				modal:false, 
				closable: false, 
				width: "400px" //$NON-NLS-1$
			});
			dijit.focus(textBox);
			if(this._prevSearchText){
				textBox.value = this._prevSearchText;
			}
			// Cache all resource nodes
			var allResourceNodes = [];
			if(dojo.isFunction(editor.getAllResourceNodes)){
				// getAllResourceNodes is asynclonously activated 
				allResourceNodes = editor.getAllResourceNodes();
			}
			
			// Event handlers for the dialog
			dialog.connect(closeButton, "onclick", function(){ //$NON-NLS-1$
				dialog.close();
			});
			var searchText = null;
			var foundResourceNode = [];
			var index = 0;

			// Nodes get stale if they are reloaded while dialog is open.
			if(!this._findHandler){
				this._findHandler = this.subscribe("com.ibm.relm.explorer.web.VIEW_LAYOUT_COMPLETED", dojo.hitch(this, function(message) { //$NON-NLS-1$
					editor = this._getDiagramEditor();
					if (message && message == editor) {
						allResourceNodes = editor.getAllResourceNodes();
						searchText = null;
					}
				}));
			}

			var findFunction = function(){
				messageArea.innerHTML = ""; //$NON-NLS-1$
				if(!textBox.value) return;
				if(textBox.value != searchText){
					// first search
					self._prevSearchText = searchText = textBox.value;
					foundResourceNode = [];
					index = 0;
					if(searchText){
						foundResourceNode = dojo.filter(allResourceNodes, function(node){
							return dojo.isFunction(node.findText) && node.findText(searchText).length > 0;
						});
					}
				}else{
					// search next
					if(++index >= foundResourceNode.length){
						index = 0;
					}
				}
				if(foundResourceNode.length == 0){
					messageArea.innerHTML = self._messages.notFound;
					return;
				}
				found = foundResourceNode[index];
				self._panToNode(found, editor);
				dijit.focus(textBox);
			};
			dialog.connect(textBox, "onkeypress", function(ev){ //$NON-NLS-1$
				if(ev.keyCode == dojo.keys.ENTER){
					findFunction();
				}
			});
			dialog.connect(findButton, "onclick", findFunction); //$NON-NLS-1$
			dialog.connect(dialog, "close", function(){ //$NON-NLS-1$
				dialog.destroy();
				self._findDialog = null;
			});
		}
	},
	
	_panToNode: function(node, editor){
		editor.removeFocus();
		editor.setFocus(node);
		var viewport = this._getDiagramWidget().viewport;
		var surfaceWidth = viewport.surface.rawNode.attributes["width"].value;//$NON-NLS-1$
		var surfaceHeight = viewport.surface.rawNode.attributes["height"].value;//$NON-NLS-1$
		var nodeOffset = this._getAbsolutePosition(node.group, 0, 0);
		var panX = nodeOffset.x;
		var panY = nodeOffset.y;
		if(viewport.contents.matrix){
			panX *= viewport.contents.matrix.xx;
			panY *= viewport.contents.matrix.yy;
		}
		if(panX > 0 && panX < surfaceWidth){
			panX = 0;
		}else{
			panX = surfaceWidth/2 - panX;
		}
		if(panY > 0 && panY < surfaceHeight){
			panY = 0;
		}else{
			panY = surfaceHeight/2 - panY;
		}
		viewport.pan(panX, panY);
	},
	
	_getAbsolutePosition: function(node, x, y){
		var parentPos;
		if(node.parent){
			parentPos = this._getAbsolutePosition(node.parent, x, y);
		}else{
			parentPos = {x: 0, y: 0};
		}
		if(node.matrix){
			return {x: (parentPos.x + node.matrix.dx/node.matrix.xx), y: (parentPos.y + node.matrix.dy/node.matrix.yy)};
		}
		return {x: parentPos.x, y: parentPos.y};
	},
	
	_onSliderChanged: function(newValue){
		this._getDiagramEditor().group.setTransform([dojox.gfx.matrix.scaleAt(newValue/100, 0, 0)]);
	},
	
	_onSaveCompleted: function(/* boolean */ exitEditMode){
		this.updateDirty();
		if(exitEditMode){
			// exit edit mode
			var reloaded = this.showEditorTab(false);
			this.stackContainer.selectChild(this.diagramPage);
			// reload diagram view
			this.refreshDiagram(reloaded);// showEditorTab reloaded the diagram content
		}
	},
	
	onSourcePageSaveCompleted: function(){
		this._onSaveCompleted(true);
	},
	
	onSourcePageClosed: function(){
		this.stackContainer.selectChild(this.diagramPage);
		if(this.openEditorFromView) {
			this.openEditorFromView = false;
			window.location.href = "#action=com.ibm.relm.explorer.web.showViewList"; //$NON-NLS-1$
			return;
		}
		// reload configurations
		if(this.sourcePage && this.sourcePage.configUpdated){
			this.refreshDiagram();
			this.sourcePage.configUpdated = false;
		}
	},
	
	onFormPageSaveCompleted: function(){
		this._onSaveCompleted(true);
	},
	
	onFormPageClosed: function(){
		this.stackContainer.selectChild(this.diagramPage);
		if(this.openEditorFromView) {
			this.openEditorFromView = false;
			if(this.formPage.returnToShared) {
				window.location.href = "#action=com.ibm.relm.explorer.web.showViewList&scope=shared"; //$NON-NLS-1$
			} else {
				window.location.href = "#action=com.ibm.relm.explorer.web.showViewList&scope=personal"; //$NON-NLS-1$
			}
			return;
		}
		// reload configurations
		if(this.formPage.configUpdated){
			this.refreshDiagram();
			this.formPage.configUpdated = false;
		} else {
			// in case IE8, do refreshDiagram
			if(dojo.isIE < 9 ) {
				this.refreshDiagram();
			}
		}
	},
	
	onSwitchToSource: function(){
		if(this.sourcePage){
			if(this._isDirty()){
				if (!confirm(this._messages.navigateAway + "\n\n" + this._messages.unsavedChanges + "\n\n" + this._messages.okOrCancel)) { //$NON-NLS-1$ //$NON-NLS-2$
					if(this.formPage && this.selectedTab == this.formPage) 
						this.switchToForm();
					else
						this.stackContainer.selectChild(this.diagramPage);
					return;
				}
			}
			this.sourcePage.setDiagramTitle(this.title);
			if(!this.sourcePage.isDirty()){
				this.sourcePage.load(this.viewUri);
			}
		}
	},
	
	switchToForm: function(params){
		if(this.formPage){
			this.stackContainer.selectChild(this.formPage);
			this.formPage.setSelectedTab(params);
		}
	},
	
	onSwitchToForm: function(){
		this._onFormEdit();
	},
	
	onSwitchToDesign: function(){
		if(this.formPage && this.formPage.isDirty()){
			if(this._editMode){
				this.refreshDiagramLocal();
			}else{
				this.refreshDiagram();
			}
		}
	},
	
	resize: function(size){
		// temporary fix.
		var bounds = dojo.position(this.domNode);
		if(size){
			bounds.h = size.h;
			this.top.resize(bounds);
		}
		bounds.h -= (this.formPage || this.sourcePage) ? 90 : 60;
		this.layout.resize(bounds);
	},

	showEditorTab: function(show) {
		show = show && this._canEdit() ? true : false; // always boolean 
		if(show === this._editMode) 
			return false;

		this._editMode = show;
		
		this.printButton.domNode.style.display = !show && util.checkURLOption("printButton") ? "" : "none"; //$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$
		this.reportButton.domNode.style.display = show ? "none" : "";//$NON-NLS-1$//$NON-NLS-2$
		this.editButton.domNode.style.display = show || !this._canEdit() ? "none" : "";//$NON-NLS-1$//$NON-NLS-2$
		this.saveButton.style.display = show ? "" : "none";//$NON-NLS-1$//$NON-NLS-2$
		this.saveAndCloseButton.style.display = show ? "" : "none";//$NON-NLS-1$//$NON-NLS-2$
		this.cancelButton.style.display = show ? "" : "none";//$NON-NLS-1$//$NON-NLS-2$
		this.stackContainer.tablist.domNode.style.display = show && (this.formPage || this.sourcePage) ? "" : "none";//$NON-NLS-1$//$NON-NLS-2$
		this.stackContainer.layout();
		var editor = this._getDiagramEditor();
		if(editor){
			var commandProcessor = editor.getCommandStack();
			if (this._commandProcessorHandle) this.disconnect(this._commandProcessorHandle);
			this._commandProcessorHandle = this.connect(commandProcessor, "execute_it", this.updateDirty); //$NON-NLS-1$
		}
		this.resize();

		// refresh editor 
		this.layout.setEditMode(show);
		this.sidebarContainer.showSidebar(show);
		return true;
	},
	
	_canEdit: function(){
		if(this.permissions.modifyPermission) 
			return true;
		var config = this._getConfig();
		if(config && config.ownedBy === com.ibm.team.repository.web.client.session.getAuthenticatedContributorUri())
			return true;
		return false;
	},
	
	getEditorInput: function() {
		return this._editorInput;
	}
	
});

})();