/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.DiagramViewInput"); //$NON-NLS-1$

dojo.require("com.ibm.relm.common.web.ui.editor.EditorInput"); //$NON-NLS-1$
dojo.require("dojox.encoding.digests.MD5"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

var runningCount = 1;

dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.DiagramViewInput", com.ibm.relm.common.web.ui.editor.EditorInput, { //$NON-NLS-1$
	
	projectId: null,
	resourceUri: null,
	_name: null,
	_id: null,
	resourceInfo: null,
	viewConfig: null,
	
	constructor: function(params) {
		this.addState('action', "com.ibm.relm.explorer.web.showDiagram"); //$NON-NLS-1$ //$NON-NLS-2$
		this.addState('viewUri', params.resourceUri); //$NON-NLS-1$
		
		// integrated the remaining parameters into the EditorInput.
		dojo.mixin(this, params);
		
		this.resourceInfo = {};
	},
	
	isLoaded: function() {
		var loaded;
		if (this.viewConfig) {
			loaded = true;
		} else {
			loaded = false;
		}
		return loaded;
	},
	
	_viewConfigLoaded: function(config) {
		this.viewConfig = config;
		this._name = config.diagramName;
		this.addState('viewName', this._name); //$NON-NLS-1$
		this.resourceInfo.uri = this.resourceUri;
		this.resourceInfo.shortName = this._name;
	},
	
	_viewConfigUpdated: function(config) {
		this.viewConfig = config;
		this._name = config.diagramName;
		this.addState('viewName', this._name); //$NON-NLS-1$
		this.resourceInfo.shortName = this._name;
	},
	
	_loadTargetResource: function (infos)
	{
		this.targetElement = infos[0];
	},
	
	
	getId: function() {
		if (this._id === null ) {
			if(dojo.isString(this.resourceUri) && this.resourceUri.length > 0) {
				this._id = this.resourceUri;
			} else if (this.getState('id')) { //$NON-NLS-1$
				this._id = this.getState('id'); //$NON-NLS-1$
//			} else {
//				// make a fake, unique ID to distinguish from other new inputs
//				this._id = dojox.encoding.digests.MD5(this.declaredClass + ',' + runningCount);
//				runningCount += 1;
			}
		}
		return this._id;
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/view.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	getName: function() { 
		
		return this._name;
	},
	
	setName: function (name) {
		this._name = name;
	},
	
	getTooltip: function() {
//		return this.getName() || ''; //$NON-NLS-1$
		return this.viewConfig.description || ""; //$NON-NLS-1$
	},
	
	getBasePresentationUri: function() {
//		return AnalysisUtil.getAnalysisProfileUri(this.resourceUri);
		return ""; //$NON-NLS-1$
	}
	
});

}());
