/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.RelmDiagramOutlineDM"); //$NON-NLS-1$

dojo.require("rmpw.jazz.ui.ModelDiagramOutline"); //$NON-NLS-1$

/*
 * Created in DiagramWidget
 */
dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.RelmDiagramOutlineDM", rmpw.jazz.ui.ModelDiagramOutline, { //$NON-NLS-1$
	updateOutlineShape: function(mapping) {
		if (mapping.policies.outlineRenderer) {
			mapping.policies.outlineRenderer.updateOutlineShape(this._contentGroup);
		}
	},
	
	postCreate: function(){
		// hack to avoid dojo.connect(this.pannableLayer.viewer.rootLayer.viewer.viewport, "onEndPan", this, "_pLayerMoved"); in rmpw.panner.Outline
		var rootLayer = this.pannableLayer.viewer.rootLayer;
		if(rootLayer){
			this.pannableLayer.viewer.rootLayer = null;
			this.inherited(arguments);
			this.pannableLayer.viewer.rootLayer = rootLayer;
			// instead dojo.connect, use this.connect
			this.viewPortRecreated();
		}
	},
	
	setScale: function(scale, cx, cy, origin) {
		if(arguments[3] === undefined) {
			// Outline._onResize calls pannableLayer.setScale with origin = undefined. 
			// It results in ModelDiagramOutline.setScale with origin = undefined.
			// That causes loosing position in outline.
			// This is just work-around for the problem.
			arguments[3] = true; 
		}
		this.inherited(arguments);
	},
	
	_pLayerMoved: function(x, y) {
		if (!this._movingPLayer && this._ratio && this._offset) {
			if (this._relocateAnimation) {
				this._stopRelocateMove = true;
			}
			
			// locate content
			if (this._relocateAnimation || this._centerAnimation || this._centerPause) {
				var ol = this._view.offsetLeft + this._view.clientLeft;
				var ot = this._view.offsetTop + this._view.clientTop;
				this._setLocation(x * this._ratio + ol, y * this._ratio + ot);
			} else {
				// work-around for https://jazz.net/jazz04/resource/itemName/com.ibm.team.workitem.WorkItem/22603
				var loc = this.pannableLayer.viewer.viewport.getOffset();
				this._setLocation(loc.x * this._ratio + this._offset.l, loc.y * this._ratio + this._offset.t);
			}
		}
	},
	
	movePanContainerNode: function(x, y) {
		var trans = this._scalingGroup.getTransform();
		if(trans){
			x -= trans.dx;
			y -= trans.dy;
		}
		this._translateGroup.setTransform(dojox.gfx.matrix.translate(x, y));
	},
	
	restore: function(){
		// _setLocation which will call movePanContainerNode use _scalingGroup.getTransform()
		// but the _scalingGroup will be updated in setScale which will be called later
		// so, need this call after the call by setTimeout()
		setTimeout(dojo.hitch(this, function(){
			// might have to be fixed if DM defect 22603 is fixed
			this._setLocation(this._offset.l, this._offset.t);
		}), 0);
	},
	
	viewPortRecreated: function(){
		this.restore();
		// reconnect to new viewport
		this.connect(this.pannableLayer.viewer.rootLayer.viewer.viewport, "onEndPan", "_pLayerMoved");//$NON-NLS-1$//$NON-NLS-2$
	}
});

})();