/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.RelmRenderRoot"); //$NON-NLS-1$

dojo.require("rmpw.diagrams.render.RenderRoot"); //$NON-NLS-1$
dojo.require("rmpw.diagrams.render.Viewport"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.RelmViewport"); //$NON-NLS-1$

/*
 * Super class of DiagramEditRoot
 */
dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.RelmRenderRoot", rmpw.diagrams.render.RenderRoot, { //$NON-NLS-1$

	_editMode: false,
	
	constructor: function(args) {
		this._editMode = args.editMode;

		this.surface.whenLoaded(dojo.hitch(this, this._whenLoaded2));
	},
	
	_whenLoaded2: function(surface) {
        // create viewport
		this.rearFeedbackLayer = surface.createGroup();
		if(this._editMode) {
			this.viewport = new rmpw.diagrams.render.Viewport(surface, this.container);
		} else {
			this.viewport = new com.ibm.relm.explorer.web.ui.internal.view.RelmViewport(surface, this.container);
		}
		this.feedbackLayer = surface.createGroup();
		this.attachListeners();
		
		this.configure( this.configuration );
	},
	
	_whenLoaded: function(surface) {
		// dummy for super class call
	}

});

})();
