/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.RelmViewport"); //$NON-NLS-1$

dojo.require("rmpw.diagrams.render.Viewport"); //$NON-NLS-1$

/*
 * Created in RelmRenderRoot
 */
dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.RelmViewport", rmpw.diagrams.render.Viewport, { //$NON-NLS-1$

	pan: function(dx, dy) {
		
		if(dx || dy) {
			var offset = this._adjustOffset(dx, dy);
			dx = offset.dx;
			dy = offset.dy;
		}

		this.inherited(arguments);
	},

	adjustPan: function(location) {
		var left = location.x;
		var top = location.y;
		var diagramLoc = this.getOffset();
		var dx = location.x - diagramLoc.x;
		var dy = location.y - diagramLoc.y;
		var offset = this._adjustOffset(dx, dy);

		left += offset.dx - dx;
		top += offset.dy - dy;
			
		return {x: left, y: top};
	},

	_adjustOffset: function(dx, dy) {
		var scale = this.getZoom();
		var diagramLoc = this.getOffset();
		var bb = this.surface.children[1].getBoundingBox();
		var diagramWidth = bb.width * scale;
		var diagramHeight = bb.height * scale;
		var bounds = dojo.position(this.container);
		if(dx < 0) {
			// move left
			if(bounds.w > diagramWidth) {
				// diagram is smaller than edit area
				var left = diagramLoc.x + dx;
				if(left < 0) dx -= left;
			} else {
				var right = diagramLoc.x +diagramWidth + dx;
				if(right < bounds.w) dx = dx + (bounds.w - right);
			}
		} else {
			// move right
			if(bounds.w > diagramWidth) {
				// diagram is smaller than edit area
				var right = diagramLoc.x +diagramWidth + dx;
				if(right > bounds.w) dx = dx - (right - bounds.w);
			} else {
				var left = diagramLoc.x + dx;
				if(left > 0) dx -= left;
			}
			
		}
		
		if(dy < 0) {
			// move up
			if(bounds.h > diagramHeight) {
				// diagram is smaller than edit area
				var top = diagramLoc.y + dy;
				if(top < 0) dy -= top;
			} else {
				var bottom = diagramLoc.y + diagramHeight + dy;
				if(bottom < bounds.h) dy = dy + (bounds.h - bottom);
			}
		} else {
			// move down
			if(bounds.h > diagramHeight) {
				// diagram is smaller than edit area
				var bottom = diagramLoc.y + diagramHeight + dy;
				if(bottom > bounds.h) dy = dy - (bottom - bounds.h);
			} else {
				var top = diagramLoc.y + dy;
				if(top > 0) dy -= top;
			}
			
		}
		return {dx: dx, dy: dy};
	}
});

})();
