/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){

dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.ViewAjaxModule"); //$NON-NLS-1$

dojo.require("ibm_ilog.diagram.base");//$NON-NLS-1$
dojo.require("ibm_ilog.diagram.util.MultilineText");//$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.Layout"); //$NON-NLS-1$
// RELMApplication.js does
dojo.require('com.ibm.relm.common.web.ui.LqeAuthInterceptor'); //$NON-NLS-1$

var getURLHash=com.ibm.relm.explorer.web.ui.internal.util.getURLHash;
var getURLOption=com.ibm.relm.explorer.web.ui.internal.util.getURLOption;
var projectId = null;

jazz.client.internal.addRequestInterceptor(function(request) {
	if(!request.args.headers){
		request.args.headers = {};
	} 
	var headers = request.args.headers;
	if (projectId) {
		headers["X-jazz-project-id"] = projectId; //$NON-NLS-1$
	}
});

dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.ViewAjaxModule", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
	widgetsInTemplate: true,
	templateString: "<div dojoAttachPoint='containerNode' style='position:absolute;width:100%;height:100%;border:0;padding:0;margin:0;overflow:hidden;'><div dojoAttachPoint='layoutDiv'></div></div>", //$NON-NLS-1$

	postCreate: function() {
		// set authenticated contributor
		this._setAuthenticatedContributor();
		
		this.inherited(arguments);
		
		// for actions
		var baseUri = getURLHash("relm.baseUri"); //$NON-NLS-1$
		console.debug("ajax-module: relm.baseuri = " + baseUri);//$NON-NLS-1$
		projectId = getURLHash("relm.projectId"); //$NON-NLS-1$
		
		// open RELM View
		if(!this.viewUri){
			this.viewUri = getURLOption("viewUri"); //$NON-NLS-1$
		}
		var initialZoomLevel = (getURLHash("relm.zoomLevel") || 100.0) / 100.0; //$NON-NLS-1$
		if(initialZoomLevel < 0.2) initialZoomLevel = 0.2;
		else if(initialZoomLevel > 200.0) initialZoomLevel = 200.0;
		var showOutline = getURLHash("relm.showOutline") === "true"; //$NON-NLS-1$//$NON-NLS-2$
		var hideToolbar = getURLHash("relm.hideToolbar") === "true"; //$NON-NLS-1$//$NON-NLS-2$
		var printView = getURLHash("relm.printView") === "true"; //$NON-NLS-1$//$NON-NLS-2$
		console.debug("ajax-module: open uri[" + this.viewUri + "]");//$NON-NLS-1$//$NON-NLS-2$
		// if <base> exists, markers like "url(#dojox...)" in svg don't work expectedly.
		dojo.query("head base").forEach(dojo.destroy);//$NON-NLS-1$
		//
		var layout = new com.ibm.relm.explorer.web.ui.internal.view.Layout({
			viewUri: this.viewUri, 
			webBaseUri: baseUri, 
			printView: printView,
			initialZoomLevel: initialZoomLevel,
			hideToolbar: hideToolbar,
			outlineState: showOutline}, 
			this.layoutDiv);
		this.layout = layout;
		this.connect(window, "onresize", function(){//$NON-NLS-1$
			layout.resize();
		});
		layout.resize();
	},
	
	destroy: function(){
		this.layout.destroy();
		this.inherited(arguments);		
	},
	
	
	/*
	 * make com.ibm.team.repository.web.client.session.getAuthenticatedContributor() works in iframe
	 */
	_setAuthenticatedContributor: function() {	
		var url = net.jazz.ajax._contextRoot + "/service/com.ibm.team.repository.common.internal.IContributorRestService/currentContributor";//$NON-NLS-1$
		var args = {
			url: url,
			handleAs: "json",//$NON-NLS-1$
			headers: {
				"Accept": "text/json"//$NON-NLS-1$//$NON-NLS-2$
			}
		};
		var deferred = jazz.client.xhrGet(args);

		deferred.addCallback(dojo.hitch(this, function(response) {
			var contributor = dojo.getObject("soapenv:Body.response.returnValue.value", false, response);//$NON-NLS-1$
			dojo.setObject("com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR", contributor);//$NON-NLS-1$
			return response; 
		}));			
		
		return deferred;
	}
	
});

})();

