/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.ViewClient"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.ExplorerClient"); //$NON-NLS-1$
dojo.require("jazz.app.context"); //$NON-NLS-1$

(function() { // module container
	// View Client
	com.ibm.relm.explorer.web.ui.internal.view.ViewClient = new com.ibm.relm.explorer.web.explorer.page.ServiceClient({
	
			SERVICE_URI : com.ibm.relm.explorer.web.ui.configServiceUri, //$NON-NLS-1$
			
			/**
			 * Fetch descriptors. This method will supply the
			 * projectAreaUUID.
			 */
			getResourceDescriptors : function(responseHandler, args) {
				if (args == undefined) {
					args = {};
				}
				if (args.projectAreaUUID == undefined) {
					var currentProjectArea = jazz.app.context.get();
					args.projectAreaUUID = currentProjectArea.itemId || ""; //$NON-NLS-1$
				}
				this._invokeFolderService(responseHandler, "getConfigDescriptors",  //$NON-NLS-1$
						args);
			},
			/**
			 * Fetch descriptors under null project area root folder
			 * projectAreaUUID.
			 */
			getResourceDescriptorsUnderNonProjectAreaRootFolder : function(responseHandler, args) {
				if (args == undefined) {
					args = {};
				}
				args.projectAreaUUID = ""; //$NON-NLS-1$
				this._invokeFolderService(responseHandler, "getConfigDescriptorsUnderNonProjectAreaRootFolder",  //$NON-NLS-1$
						args);
			},
			/**
			 * Delete the given query descriptor.
			 */
			deleteResourceDescriptor : function(responseHandler, queryId, args) {
				this._invokeFolderService(responseHandler,
						"postDeleteConfigDescriptor", queryId, args); //$NON-NLS-1$
			},
			/**
			 * Delete the given query descriptors.
			 */
			deleteResourceDescriptors : function(responseHandler, args) {
				this._invokeFolderService(responseHandler,
						"postDeleteConfigDescriptors", args); //$NON-NLS-1$
			},

			/**
			 * Move/Copy the given query descriptors.
			 */
			moveResourceDescriptors : function(responseHandler, args) {
				this._invokeFolderService(responseHandler,
						"postMoveConfigDescriptors", args); //$NON-NLS-1$
			},
			copyResourceDescriptors : function(responseHandler, args) {
				this._invokeFolderService(responseHandler,
						"postCopyConfigDescriptors", args); //$NON-NLS-1$
			}
	});
})();
