/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.DialogHelpHeader"); //$NON-NLS-1$


dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "CommonMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var Dialog= jazz.ui.Dialog;

dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog", Dialog, { //$NON-NLS-1$

	messages: null,

	contentNode: null,

	primaryTitle: null,

	headerContent: null,
	dialogContent: null,

	_okClicked: null,

	constructor: function(args) {
		this.primaryTitle= args.primaryTitle;
		this.headerContent = args.headerContent;
		this.dialogContent= args.dialogContent;
	},

	postMixInProperties: function() {
		this.messages= dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "CommonMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.inherited(arguments);
	},

	postCreate: function() {
		this._okClicked= false;
		dojo.addClass(this.domNode, "com-ibm-relm-explorer-web com-ibm-relm-explorer-web-ButtonDialog"); //$NON-NLS-1$
		var _contentNode= this.contentNode;
		if (_contentNode == null) {
			_contentNode= dojo.create("div", null); //$NON-NLS-1$
			this.contentNode= _contentNode;
		}
		// Header
		if(this.headerContent && this.headerContent.mainMessage){
			if(!this.headerContent.backgroundClass){
				this.headerContent.backgroundClass = "relm-DialogHelpHeader-viewBackground"; //$NON-NLS-1$
			}
			this._helpHeader = new com.ibm.relm.common.web.ui.DialogHelpHeader(this.headerContent, dojo.create("div", null, _contentNode));//$NON-NLS-1$
		}
		
		// Content
		var _dialogContentContainer= dojo.create("div", {className: "dialogButtonContent"}, _contentNode, null); //$NON-NLS-1$ //$NON-NLS-2$
		var _dialogContent= this.dialogContent;
		if (_dialogContent != null && _dialogContent.domNode != null) {
			_dialogContentContainer.appendChild(_dialogContent.domNode);
			this.connect(_dialogContent, "onOk", this._onOK); //$NON-NLS-1$
			this.connect(_dialogContent, "onKeyPress", function(ev){ //$NON-NLS-1$
				// Prevent submission caused by lack of form tag on IE
				if(ev.keyCode === dojo.keys.ENTER && ev.target.tagName == "INPUT"){ //$NON-NLS-1$
					dojo.stopEvent(ev);
				}
			});
		}
		
		// Button Area
		var _dialogButtonContainer= dojo.create("div", {className: "dialogButtonContainer"}, _contentNode, null); //$NON-NLS-1$ //$NON-NLS-2$
		var _okButton= dojo.create("button", {innerHTML: this.messages.LABEL_OK}, _dialogButtonContainer, null); //$NON-NLS-1$
		this.okButton = _okButton;
		this.connect(_okButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			if (this._okClicked === true) {
				return ;
			}
			this._onOK(event);
		}));
		var _cancelButton= dojo.create("button", {innerHTML: this.messages.LABEL_CANCEL}, _dialogButtonContainer, null); //$NON-NLS-1$
		this.connect(_cancelButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.onCancel(event);
		}));
		if (_dialogContent != null) {
			var funcName= "setOkButtonDisabled"; //$NON-NLS-1$
			var func= _dialogContent[funcName];
			if (func != null && dojo.isFunction(func)) {
				this.connect(_dialogContent, funcName, this._setOkButtonDisabled);
				_dialogContent.updateEnablement();
			}
		}

		//Set focus to first input element to prevent "browser go prev" by back space key
		var _firstTextInput = dojo.query('input:not([type]):not([readonly="readonly"]), ' + //$NON-NLS-1$
										'input[type="text"]:not([readonly="readonly"]), ' + //$NON-NLS-1$
										'input[type="password"]:not([readonly="readonly"]), ' + //$NON-NLS-1$
										'input[type="file"]:not([readonly="readonly"]), ' + //$NON-NLS-1$
										'textarea:not([readonly="readonly"])', this.dialogContent.domNode); //$NON-NLS-1$
		if(_firstTextInput && _firstTextInput.length > 0){
			this.focusNode = _firstTextInput[0];
		}else{
			this.focusNode = this.okButton;
		}
		this.connect(this.domNode, "onkeypress", function(ev){ //$NON-NLS-1$
			if(ev.keyCode === dojo.keys.BACKSPACE
			&& !this._isTextInput(ev.target)){
				dojo.stopEvent(ev);
			}
		});

		this.inherited(arguments); //$NON-NLS-1$
	},
	
	_setOkButtonDisabled: function(fDisable){
		this.okButton.disabled = fDisable;
	},

	_isTextInput: function(node){
		if(node){
			var tagName = node.tagName.toLowerCase();
			var type = node.type ? node.type.toLowerCase() : null;
			return (tagName === "input" && (type === "text" || type === "password" || type === "file")) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
				|| (tagName === "textarea"); //$NON-NLS-1$
		}
		return false;
	},

	_getValues: function() {
		var _dialogContent= this.dialogContent;
		if (_dialogContent != null) {
			var funcName= "getValues"; //$NON-NLS-1$
			var func= _dialogContent[funcName];
			if (func != null && dojo.isFunction(func)) {
				return dojo.hitch(_dialogContent, funcName)();
			}
		}
		return null;
	},

	_onOK: function(event) {
		var values= this._getValues();
		this.validate(values, dojo.hitch(this, function() {
			this.onOK(values);
			this._okClicked= true;
			this.close(event); // cause destroy()
		}));
	},

	validate: function(values, callback) {
		callback();
	},

	onOK: function(values) {
		if(dojo.isFunction(this.onOk)){
			this.onOk(values);
		}
	},
	
	onCancel: function(event) {
		this.close(event);
	},
	
	close: function(event) {
		// remove focus from edit controls to destroy hover for validation message (IE)
		this.domNode.focus();
		
		this.inherited(arguments);
	},

	/*
	 * destroy is called from _onClose in StyledBox which is the super class of jazz.ui.Dialog
	 */
	destroy: function(preserveDom) {
		if(this._helpHeader){
			this._helpHeader.destroy();
			this._helpHeader = null;
		}
		var widget= this.dialogContent;
		if (widget && widget.domNode != null) {
			widget.destroyRecursive(preserveDom);
		}
		this.inherited(arguments);
	}
});

})();
