/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012,2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.ColorPicker"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$
dojo.require("dojox.widget.ColorPicker"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ColorUtilsMessages"); //$NON-NLS-1$ //$NON-NLS-2$


dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.common.ColorPicker", //$NON-NLS-1$
	com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog,
{
	// override default values
	isClosable: true,

	//
	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ColorUtilsMessages"); //$NON-NLS-1$  //$NON-NLS-2$
		this.primaryTitle = this.messages.colorPickerDialog;
		this.inherited(arguments);
	},
	
	postCreate: function(){
		var colorpicker = new dojox.widget.ColorPicker({
			getValues: function() {
				return this.getValue("value"); //$NON-NLS-1$
			}
		});
		colorpicker.attr("value", this.value); //$NON-NLS-1$
		this.dialogContent = colorpicker;
		this.width = colorpicker.width;
		this.inherited(arguments);
	}
});