/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.ColorUtils"); //$NON-NLS-1$

(function(){

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ColorPicker"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ColorUtilsMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ColorNameMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ColorUtilsMessages"); //$NON-NLS-1$  //$NON-NLS-2$
dojo.mixin(messages, dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ColorNameMessages")); //$NON-NLS-1$ //$NON-NLS-2$

com.ibm.relm.explorer.web.ui.internal.view.common.ColorUtils = {};

var colorUtils = com.ibm.relm.explorer.web.ui.internal.view.common.ColorUtils;
dojo.mixin(colorUtils, 
{
	openColorPickerDialog : function (color, okcallback, scope) {
		return new com.ibm.relm.explorer.web.ui.internal.view.common.ColorPicker({
			value: color,
			onOK: dojo.hitch(scope, okcallback)
		});
	},
	
	loadColorSelectDropdown: function(comboBoxWidget) {
		var _colors = [];
		_colors.push({value: "black", label: messages.colorNameBlack}); //$NON-NLS-1$
		_colors.push({value: "white", label: messages.colorNameWhite}); //$NON-NLS-1$
		_colors.push({value: "blue", label: messages.colorNameBlue}); //$NON-NLS-1$
		_colors.push({value: "red", label: messages.colorNameRed}); //$NON-NLS-1$
		_colors.push({value: "green", label: messages.colorNameGreen}); //$NON-NLS-1$
		_colors.push({value: "lime", label: messages.colorNameLime}); //$NON-NLS-1$
		_colors.push({value: "maroon", label: messages.colorNameMaroon}); //$NON-NLS-1$
		_colors.push({value: "navy", label: messages.colorNameNavy}); //$NON-NLS-1$
		_colors.push({value: "silver", label: messages.colorNameSilver}); //$NON-NLS-1$
		_colors.push({value: "yellow", label: messages.colorNameYellow}); //$NON-NLS-1$
		_colors.push({value: "aqua", label: messages.colorNameAqua}); //$NON-NLS-1$
		_colors.push({value: "fuchsia", label: messages.colorNameFuchsia}); //$NON-NLS-1$
		_colors.push({value: "olive", label: messages.colorNameOlive}); //$NON-NLS-1$
		_colors.push({value: "teal", label: messages.colorNameTeal}); //$NON-NLS-1$
		_colors.push({value: "purple", label: messages.colorNamePurple}); //$NON-NLS-1$
		_colors.push({value: "gray", label: messages.colorNameGray}); //$NON-NLS-1$
		var tmplStore = new dojo.store.Memory({
			data: _colors
			});
		comboBoxWidget.set("labelAttr", "label"); //$NON-NLS-1$ //$NON-NLS-2$
		comboBoxWidget.set("searchAttr", "value"); //$NON-NLS-1$ //$NON-NLS-2$
		comboBoxWidget.set("store", tmplStore); //$NON-NLS-1$
		
	}
	
});
})();
