/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.le.ui.internal.view.common.FolderPicker"); //$NON-NLS-1$

dojo.require("com.ibm.relm.le.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.view.edit.FolderSelectDialogContent"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.le.ui.internal", "PropertyDialogUtilsMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

dojo.declare(
	"com.ibm.relm.le.ui.internal.view.common.FolderPicker", //$NON-NLS-1$
	com.ibm.relm.le.ui.internal.view.common.ButtonDialog,
{
	// override default values
	isClosable: true,
	width: "400px",//$NON-NLS-1$
	
	//
	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.le.ui.internal", "PropertyDialogUtilsMessages"); //$NON-NLS-1$  //$NON-NLS-2$
		this.primaryTitle = this.dialogTitle || this.messages.folderTitle;
		this.inherited(arguments);
	},
	
	postCreate: function(){
		var content = new com.ibm.relm.le.ui.internal.view.edit.FolderSelectDialogContent({folder: this.folder});
		this.dialogContent = content;
		this.inherited(arguments);
	}
});
})();