/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.LinkPathUtils"); //$NON-NLS-1$

(function(){
	
com.ibm.relm.explorer.web.ui.internal.view.common.LinkPathUtils = {};

var linkPathUtils = com.ibm.relm.explorer.web.ui.internal.view.common.LinkPathUtils;
dojo.mixin(linkPathUtils, 
{
	getLinkPathTitle: function(link) {
		var title = ""; //$NON-NLS-1$
		var parent = link.linkpath[link.linkpath.length - 2];
		if (link.target.elementId) {
			var parentContainer = link.target._viewer.findContainer(parent.id);
			if (parentContainer && parentContainer.elementId) {
				dojo.forEach(parentContainer._linkProperties, function(linkprop) {
					if (linkprop.id == link.target.elementId && linkprop.sourceProperty == parent.linktype) {
						title = linkprop.label;
					}
				});
				return title;
			}
		}
		return title;
	},
	
	getLinkPathText: function(link, titieKey) {
		var label = ""; //$NON-NLS-1$
		if (dojo.isArray(link)) {
			var first = true;
			dojo.forEach(link, function(node) {
				if (first) first = false;
				else label += " > "; //$NON-NLS-1$
				label += node[titieKey]; //$NON-NLS-1$ //$NON-NLS-2$
			});
		}  else {
			label = link;
		}
		return label;
	}
});

})();