/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.le.ui.internal.view.common.QueryUtils"); //$NON-NLS-1$

(function(){

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.leeditor.page.QueryResult"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.ConfigUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.le.ui.internal", "QueryUtilsMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var messages = dojo.i18n.getLocalization("com.ibm.relm.le.ui.internal", "QueryUtilsMessages"); //$NON-NLS-1$  //$NON-NLS-2$
	
com.ibm.relm.le.ui.internal.view.common.QueryUtils = {};

var configUtils = com.ibm.relm.le.ui.internal.ConfigUtils;
var queryUtils = com.ibm.relm.le.ui.internal.view.common.QueryUtils;

dojo.mixin(queryUtils, 
{
	openPreviewQueryResultDialog : function(sparql, paramsArray) {
		// eval params in the sparql
		sparql = configUtils.evalParamsArray(sparql, paramsArray);
		var parameters = configUtils.getParameterValuesFromParamArray(paramsArray);
		var queryInfo = {sparql: sparql, parameterValues: parameters, parameterized: "true"}; //$NON-NLS-1$

		// create QueryResult widget 
		var queryResult = new com.ibm.relm.le.leeditor.page.QueryResult({enableEdit: false, _userSelectedPageSize: 10, previewMode: true});
		queryResult.setQueryInfo(queryInfo);
		
		// open dialog
		this._queryResultDialog = new com.ibm.relm.le.ui.internal.view.common.ButtonDialog({
			primaryTitle: messages.queryResultTitle,
			dialogContent: queryResult,
			width: "1000px", //$NON-NLS-1$
			isClosable: true
		});
	}	
});
})();
