/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.Select"); //$NON-NLS-1$

dojo.require("dijit.form._FormWidget"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.common.Select", //$NON-NLS-1$
	dijit.form._FormValueWidget,
{
	// summary:
	//		simple widget to render HTML SELECT element so that it can be used in InlineEditBox
	
	optionsArray: null,
	
	buildRendering: function(){
		var select = dojo.create('select'); //$NON-NLS-1$
		this.focusNode = select;
		this.domNode = select;
		if(this.optionsArray == null) {
			this.optionsArray = [];
		}
		var self = this;
		this.connect(select, "onchange", function(e){ //$NON-NLS-1$
			self.set("value", select.value); //$NON-NLS-1$
		});
	},
	
	postCreate: function(){
		this.inherited(arguments);
		
		this.setOptions(this.optionsArray);
	},
	
	setOptions: function(options){
		this.optionsArray = options;
		var select = this.domNode;
		select.options.length = 0;
		dojo.forEach(options, function(opt, idx){
			select.options[idx] = new Option(opt.label, opt.value);
			if(opt.selected === true){
				select.options[idx].selected = true;
			}
		});		
	}
});