/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.SelectParameterTable"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() { 

dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.common.SelectParameterTable",  //$NON-NLS-1$
			[dijit._Widget, dijit._Templated], {
	
	widgetsInTemplate: true,
	
	templateString: "<div class='com-ibm-relm-explorer-common-SelectParameterTable' align='center'><table dojoAttachPoint='_paramTable' selectable='true' style='table-layout: fixed; width: 400px;'></table></div>",//$NON-NLS-1$
	
	openViewInfo: null,
	params: null,
	selectedParamIndex: null,

	constructor: function(args) {
		dojo.mixin(this, args);

		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		
	},
	
	postCreate: function(){
		this.inherited(arguments);
		dojo.style(this.domNode, {"table-layout": "fixed"}); //$NON-NLS-1$//$NON-NLS-2$ 
		this._initTable();
		if(this.params) {
			this.setParameters(this.params);
		}
	},

	destroy: function(){
		this.inherited(arguments);		
	},
	
	_initTable: function() {

		var tr = dojo.create("tr", {}, this._paramTable); //$NON-NLS-1$
		dojo.create("th", {innerHTML: this._messages.select, style:{width: "20%"}, align: "center"}, tr); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		dojo.create("th", {innerHTML: this._messages.paramName, style:{width: "40%", whiteSpace: "noWrap"}}, tr); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		dojo.create("th", {innerHTML: this._messages.paramType, style:{width: "40%", whiteSpace: "noWrap"}}, tr); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		
	},
	
	setParameters: function(params){
		var self = this;

		if(this.params && this.paramUriIdx) {
			dojo.forEach(this.paramUriIdx, function(i) {
				self.addRow(params[i], i);
			});
		}
	},
	
	addRow: function(param, i) {

		var self = this;
		if(this.selectedParamIndex == null) this.selectedParamIndex = i;
		var tr = dojo.create("tr", {"class": "com-ibm-relm-explorer-common-SelectParameterRow"}, this._paramTable); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		var td = dojo.create("td", {align: "center"}, tr); //$NON-NLS-1$ //$NON-NLS-2$
		var div = dojo.create("div", {}, td); //$NON-NLS-1$
		var radio = new dijit.form.RadioButton({
			name: "paramSelect", //$NON-NLS-1$
			value: i,
			checked: (this.selectedParamIndex == i) ? true : false
		}, div);
		this.connect(radio, "onClick", function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			self.selectedParamIndex = i;
		});
		dojo.create("td", {innerHTML: param.name, title: param.description}, tr); //$NON-NLS-1$
		var typeStr = (param.type == "product") && this._messages.product || (param.type == "artifact") && this._messages.artifact;  //$NON-NLS-1$ //$NON-NLS-2$
		dojo.create("td", {innerHTML: typeStr}, tr); //$NON-NLS-1$
		
	},
	
	getValues: function() 
	{
		this.params[this.selectedParamIndex].value = this.resource.uri;
		return {openViewInfo: this.openViewInfo, params: this.params};
	},

	
});

})();