/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2014. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.SelectServerDialogContent"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.ComboBox");  //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() { // module container

/**
 * Widget to select a view
 */
var SelectServerDialogContent = dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.common.SelectServerDialogContent", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$

	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/common/templates/SelectServerDialogContent.html"), //$NON-NLS-1$ //$NON-NLS-2$
		
		servers: null,
		
		constructor: function(args) {
			dojo.mixin(this, args);

			this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
				
		postCreate: function() {
			this.inherited(arguments);
			
			this._selectedServer = null;
			this.loadPresetSelectDropdown(this._serverCombo);
			this.updateEnablement();
		},
		
		loadPresetSelectDropdown: function(comboBoxWidget) {
			var serverList = [];
			for(var i = 0; i < this.servers.length; i++) {
				serverList.push({value: this.servers[i], label: this.servers[i]}); //$NON-NLS-1$
			}
			var tmplStore = new dojo.store.Memory({
				data: serverList
				});
			comboBoxWidget.set("labelAttr", "label"); //$NON-NLS-1$ //$NON-NLS-2$
			comboBoxWidget.set("searchAttr", "label"); //$NON-NLS-1$ //$NON-NLS-2$
			comboBoxWidget.set("store", tmplStore); //$NON-NLS-1$
			
		},
		
		
		getValues: function() 
		{
			return {server: this._serverCombo.get("value")}; //$NON-NLS-1$
		},
		

		updateEnablement: function() {
			this._updateEnablement();
		},
		
		_updateEnablement: function() {
			this.setOkButtonDisabled( !this._serverCombo.get("value")); //$NON-NLS-1$
		},
		
		setOkButtonDisabled: function(disable) {
			// dummy for event handler
		},
		
		destroy: function() {
			this.inherited(arguments);
		}
	}
);


})();