/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.SelectionDialog"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojox.gfx"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.SelectViewDialogContent"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.SelectServerDialogContent"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.SelectParameterTable"); //$NON-NLS-1$

(function() {
	
com.ibm.relm.explorer.web.ui.internal.view.common.SelectionDialog = {
	openViewSelectionDialog: function(title, projectArea, targetResource, okCallback){
		var selectionWidget = new com.ibm.relm.explorer.web.ui.internal.view.common.SelectViewDialogContent({
				projectArea: projectArea,
				targetResource: targetResource
			});
		openSelectionDialog(selectionWidget, title, {}, okCallback);
	},
	
	openServerSelectionDialog: function(title, servers, okCallback){
		var selectionWidget = new com.ibm.relm.explorer.web.ui.internal.view.common.SelectServerDialogContent({
				servers: servers
			});
		openSelectionDialog(selectionWidget, title, {}, okCallback);
	},

	openParameterSelectionDialog: function(title, headerContent, openViewInfo, params, paramUriIdx, resource, okCallback) {
		var selectParameterWidget = new com.ibm.relm.explorer.web.ui.internal.view.common.SelectParameterTable({
			openViewInfo: openViewInfo,
			params: params,
			paramUriIdx: paramUriIdx,
			resource: resource
		});
		openSelectionDialog(selectParameterWidget, title, headerContent, okCallback);
	}

};
	
var openSelectionDialog = function(selectionWidget, title, headerContent, okCallback){
	dojo.style(selectionWidget.domNode, {
		"maxHeight": "300px", //$NON-NLS-1$ //$NON-NLS-2$
		"overflow": "auto" //$NON-NLS-1$ //$NON-NLS-2$
	});

	// show dialog
	new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
		dialogContent: selectionWidget,
		primaryTitle: title,
		headerContent: headerContent,	
		width: "", //$NON-NLS-1$
		validate: function(values, callback){
			if(selectionWidget.validate && !selectionWidget.validate(values)) {
				return;
			}
			callback();
		},
		onOK: function(values){
			okCallback(values);
		}
	});
};

})();