/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.UserPreferenceUtils"); //$NON-NLS-1$

(function(){
	
com.ibm.relm.explorer.web.ui.internal.view.common.UserPreferenceUtils = {};

var userUtils = com.ibm.relm.explorer.web.ui.internal.view.common.UserPreferenceUtils;
var EXPIRATION_DATE = 90;
var OUTLINE_COOKIE = "relm-userpref-outline"; //$NON-NLS-1$
var HIGHLIGHT_COOKIE = "relm-userpref-highlight"; //$NON-NLS-1$
var MOUSE_WHEEL_COOKIE = "relm-userpref-mousewheel"; //$NON-NLS-1$
var STOP_LOADING_COOKIE = "relm-userpref-stoploading"; //$NON-NLS-1$

dojo.mixin(userUtils,
{
	setOutlineState: function(state){
		dojo.cookie(OUTLINE_COOKIE, state, {expires: EXPIRATION_DATE});
	},
	getOutlineState: function(){
		return dojo.cookie(OUTLINE_COOKIE) === "true"; //$NON-NLS-1$
	},

	setHighlightState: function(state) {
		dojo.cookie(HIGHLIGHT_COOKIE, state, {expires: EXPIRATION_DATE});
	},
	getHighlightState: function(){
		return dojo.cookie(HIGHLIGHT_COOKIE) === "true"; //$NON-NLS-1$
	},

	setMouseWheelState: function(state) {
		dojo.cookie(MOUSE_WHEEL_COOKIE, state, {expires: EXPIRATION_DATE});
	},
	getMouseWheelState: function(){
		return dojo.cookie(MOUSE_WHEEL_COOKIE) === "true"; //$NON-NLS-1$
	},

	setStopLoadingState: function(state){
		dojo.cookie(STOP_LOADING_COOKIE, state, {expires: EXPIRATION_DATE});
	},
	getStopLoadingState: function(){
		return dojo.cookie(STOP_LOADING_COOKIE) === "true"; //$NON-NLS-1$
	}
});
})();
