/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.ViewSelect"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.TextBox"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util");//$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.SelectionDialog"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewSelectMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function()  {

var SelectionDialog = com.ibm.relm.explorer.web.ui.internal.view.common.SelectionDialog;

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.common.ViewSelect", //$NON-NLS-1$
	[dijit._Widget, dijit._Templated],
{
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/common/templates/ViewSelect.html"), //$NON-NLS-1$ //$NON-NLS-2$
	projectAreaUUID: null,
	dialogTitle: null,
	showId: false,
	_selectedView: null,
	
	getTitle: function(){
		return  this._selectedView ? this._selectedView.title : null;
	},
	
	getId: function(){
		return  this._selectedView ? this._selectedView.viewid : null;
	},
	
	getUri: function(){
		return  this._selectedView ? this._selectedView.uri : null;
	},
	
	getSelectedView: function() {
		return this._selectedView;
	},
	
	get: function(name) {
		if(name == "value" ) { //$NON-NLS-1$
			if( this.showId ) {
				return this._viewTextBox.value;
			} else {
				return this._selectedView;
			}
		}
		
		return this.inherited(arguments);
	},
	
	set: function(name, value) {
		if(name == "value") { //$NON-NLS-1$
			this._selectedView = {viewid: value};
			this._selectedViewChanged();
		}
		this.inherited(arguments);
	},
	
	postMixInProperties: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewSelectMessages"); //$NON-NLS-1$  //$NON-NLS-2$
		this.inherited(arguments);
	},
	
	postCreate: function(){
		this.inherited(arguments);
		if(this.readOnly != undefined) {
			this._viewTextBox.readOnly = this.readOnly;
		}
	},
	
	_onOpenViewSelectionDialog: function() {
		SelectionDialog.openViewSelectionDialog(
				this.dialogTitle || this.messages.defaultDialogTitle, 
				this.projectAreaUUID || null, 
				null, // <- default : all views
				dojo.hitch(this,this._okDialogCallback));
	},

	_okDialogCallback: function(values) {
		this._selectedView = values.view;
		this._selectedViewChanged();
	},
	
	_selectedViewChanged: function() {
		if(this.showId || !this._selectedView.title) {
			this._viewTextBox.value = this._selectedView.viewid; //$NON-NLS-1$
		} else {
			this._viewTextBox.value = this._selectedView.title; //$NON-NLS-1$
		}
		this.onChange();
	},
	
	setProjectArea: function(projectAreaUUID){
		this.projectAreaUUID = projectAreaUUID;
	},
	
	setDisabled: function(fDisable) {
		this._viewTextBox.disabled = fDisable;
		this._selectButton.disabled = fDisable;
	},
	
	onChange:function() {
		
	}
	
	
	
});

}) ();