/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.connections.BaseConnection"); //$NON-NLS-1$
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.connections.BaseConnectionRouter"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.PolylineConnection"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.decoration.PathDecoration"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.router.ManhattanConnectionRouter"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.connections.BaseConnection", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.PolylineConnection,
{
	router: "com.ibm.relm.explorer.web.ui.internal.view.connections.BaseConnectionRouter", //$NON-NLS-1$
	targetDecorationClass: "com.ibm.relm.explorer.web.base.internal.gdc.decoration.PathDecoration", //$NON-NLS-1$
	sourceDecorationClass: "com.ibm.relm.explorer.web.base.internal.gdc.decoration.PathDecoration", //$NON-NLS-1$
	targetDecorationProps: {
		preset:'filled_arrow_s' //$NON-NLS-1$
	},
	allowOverwrap: false,

	calculateAngle: function(pt0, pt1){
		return 0;
	},
	
	update: function(){
		var pts = this.points;
		if(!this.shape || pts.length < 2){ return; }
		this.inherited(arguments);
		if(this.routerObj){
			this.routerObj.allowOverwrap = this.allowOverwrap;
		}
		/* PolylineConnection#update handled target decoration */
//		if(this.targetDecorationObj){
//			var dir = pts[pts.length-1].dir;
//			this._setDecorationRotation(this.targetDecorationObj, dir);
//		}
		if(this.sourceDecorationObj){
			var dir = pts[0].dir;
			this._setDecorationRotation(this.sourceDecorationObj, dir);
		}
	},
	
	_setDecorationRotation: function(decoObj, dir){
		if(dir == "right"){ //$NON-NLS-1$
			decoObj.setRotation(180);
		}else if(dir == "left"){ //$NON-NLS-1$
			decoObj.setRotation(0);
		}else if(dir == "top"){ //$NON-NLS-1$
			decoObj.setRotation(90);
		}else if(dir == "bottom"){ //$NON-NLS-1$
			decoObj.setRotation(270);
		}				
	}

		
});

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.connections.BaseConnectionRouter", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.router.ManhattanConnectionRouter,
{
	baseDelta: 20,
	allowOverwrap: false,

	update: function(){
		var pts = this.owner.points;
		if(pts.length < 2){ return; }
		var p1 = pts[0];
		var p2 = pts[pts.length-1];
		this.delta = this.baseDelta;
		if(!this.allowOverwrap) {
			this.delta += Math.max(Math.abs(p1.x - p2.x), Math.abs(p1.y - p2.y)) / 100; 
		}
		this.inherited(arguments);
	}
});

dojo.extend(com.ibm.relm.explorer.web.ui.internal.view.connections.BaseConnection, com.ibm.relm.explorer.web.base.internal.gdc._connection);