/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.connections.RoundConnection"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.Curvyline"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc._connection"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.decoration.PathDecoration"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.connections.RoundConnection", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.gdc.Curvyline,
{
	targetDecorationClass: "com.ibm.relm.explorer.web.base.internal.gdc.decoration.PathDecoration", //$NON-NLS-1$
	sourceDecorationClass: "com.ibm.relm.explorer.web.base.internal.gdc.decoration.PathDecoration", //$NON-NLS-1$
	targetDecorationProps: {
		preset:'filled_arrow_s' //$NON-NLS-1$
	},

	startup: function(){
		if(this._started){ return; }
		this.inherited(arguments);
		this.processParams();
	},

	calculateAngle: function(pt0, pt1){
		return 0;
	},
	
	update: function(){
		var pts = this.points;
		if(!this.shape || pts.length < 2){ return; }
		this.inherited(arguments);
		if(this.targetDecorationObj){
			var dir = pts[pts.length-1].dir;
			this._setDecorationRotation(this.targetDecorationObj, dir);
		}
		if(this.sourceDecorationObj){
			var dir = pts[0].dir;
			this._setDecorationRotation(this.sourceDecorationObj, dir);
		}
	},
	
	_setDecorationRotation: function(decoObj, dir){
		if(dir == "right"){ //$NON-NLS-1$
			decoObj.setRotation(180);
		}else if(dir == "left"){ //$NON-NLS-1$
			decoObj.setRotation(0);
		}else if(dir == "top"){ //$NON-NLS-1$
			decoObj.setRotation(90);
		}else if(dir == "bottom"){ //$NON-NLS-1$
			decoObj.setRotation(270);
		}				
	}
});

dojo.extend(com.ibm.relm.explorer.web.ui.internal.view.connections.RoundConnection, com.ibm.relm.explorer.web.base.internal.gdc._connection);