/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.AddOffsetColorContent"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dijit.form.ComboBox"); //$NON-NLS-1$

dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ColorUtils"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "AddOffsetColorContentMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() { 

	var colorUtils = com.ibm.relm.explorer.web.ui.internal.view.common.ColorUtils;

dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.edit.AddOffsetColorContent", [dijit._Widget, dijit._Templated] , { //$NON-NLS-1$

	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/edit/templates/AddOffsetColorDialog.html"),  //$NON-NLS-1$  //$NON-NLS-2$
	
	messages:null,
	
	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "AddOffsetColorContentMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function(){
		this.inherited(arguments);

	},

	_editColor: function(evt) {
		var self = this;
		var color = self.colorField.get("value"); //$NON-NLS-1$
		
		colorUtils.openColorPickerDialog(color, self._okColorPickerCallback, self);

	},

	_okColorPickerCallback: function(color)
	{
		var self = this;
		self.colorField.set("value", color); //$NON-NLS-1$
	},

	getValues: function(){
		return {
			offset: parseFloat(this.offsetField.value),
			color: this.colorField.value
		};
	}


});

com.ibm.relm.explorer.web.ui.internal.view.edit.AddOffsetColorContent.openDialog = function(colors, callback2, contentParams){
	// create edit icon dialog content
	var contentWidget = new com.ibm.relm.explorer.web.ui.internal.view.edit.AddOffsetColorContent(contentParams);
	

	// show dialog
	new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
		dialogContent: contentWidget,
		primaryTitle: contentWidget.messages.AddOffsetColor,
		onOpen: function(){
			dijit.focus(contentWidget.offsetField);
		},
		validate: function(values, callback){
			var offset = values["offset"]; //$NON-NLS-1$
			if(!isNaN(offset)){
				if( offset < 0 || offset > 1) {
					alert(contentWidget.messages.errOffsetValueRange);
				} else {
					var color = values["color"]; //$NON-NLS-1$
					if(color && color.length > 0 ) {
						callback();
					} else {
						alert(contentWidget.messages.errColorEmpty);
					}
				}
			}else{
				alert(contentWidget.messages.errOffsetEmpty);
			}
		},
		onOK: function(values){
			var offset = values["offset"]; //$NON-NLS-1$
			var color = values["color"]; //$NON-NLS-1$
			
			colors.push({offset: offset, color: color});
			callback2();
		}
	});
};

})();