/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementCreationTool"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.canvas.tool.DefaultCreationTool"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.base.internal.canvas.command.CompoundCommand"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.canvas.command.EditCommand"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementCreationTool", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.canvas.tool.DefaultCreationTool,
{
	createInsertComponentCommand: function(e, refWidget, targetWidget, widget) {
		var editor = this.getEditor();
		var componentSpec = this.getComponentSpec();
		var title = componentSpec.props.name;
		var containerId = editor.createUniqueContainerId ? editor.createUniqueContainerId(title) : "containerId"; //$NON-NLS-1$

		var compoundCommand = new com.ibm.relm.explorer.web.base.internal.canvas.command.CompoundCommand();
		var editCommand = com.ibm.relm.explorer.web.base.internal.canvas.command.EditCommand;
		compoundCommand.append(new editCommand.SetPropertyValueCommand(widget, "id", containerId)); //$NON-NLS-1$
		compoundCommand.append(this.inherited(arguments));

		return compoundCommand;
	},
	
	insertComponent: function(e, refWidget){
		this.inherited(arguments);

		var editor = this.getEditor();
		var containerParams = this.getComponentSpec().props.containerParams;
		if (!containerParams)
			return;

		for (var key in containerParams) {
			var param = containerParams[key];
			if (param.isuserparam) {
				editor.onConfigLoaded(editor.config, ["parameters"]); //$NON-NLS-1$
				break;
			}
		}
	}
});
