/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementEditUtils"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementParameterContent"); //$NON-NLS-1$

//value types
var VALUE_TYPE_RESOURCE = "resource"; //$NON-NLS-1$
var VALUE_TYPE_STRING = "string"; //$NON-NLS-1$
var VALUE_TYPE_BOOLEAN = "boolean"; //$NON-NLS-1$
var VALUE_TYPE_NUMBER = "number"; //$NON-NLS-1$
var VALUE_TYPE_DATETIME = "datetime"; //$NON-NLS-1$

(function(){
	
com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementEditUtils = {};

var leEditUtils = com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementEditUtils;

dojo.mixin(leEditUtils, 
{

	editLifecycleElementParams: function(container, params) {
		var deferred = new dojo.Deferred();
		if(dojo.isString(params)) params = dojo.fromJson(params);

		var element = container.elementObject;
		if (!element) {
			var self = this;
			container._viewer.getArtifactElement(container.elementId, function(element) {
				container.elementObject = element;
				self._openLifecycleElementParamsDialog(container, element, params, deferred);
			});
		} else {
			this._openLifecycleElementParamsDialog(container, element, params, deferred);
		}
		return deferred;
	},

	_openLifecycleElementParamsDialog: function(container, element, params, deferred) {
		com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementParameterContent.openDialog(element, params, function(result) {
			deferred.callback(result);
		});
	},
	
	editArtifactElement: function(elementId, parent, mode) {
		var parentParam = parent ? "&parent="+encodeURIComponent(parent) : ""; //$NON-NLS-1$ //$NON-NLS-2$
		var href = "#action=com.ibm.relm.le.leeditor.showLEEditor&id=" + encodeURIComponent(elementId) + parentParam; //$NON-NLS-1$
		if (mode == "tab") { //$NON-NLS-1$
			window.open(href);
		} else {
			window.location.href = href;
		}
	}
});
})();
