/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.PalettePane"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.Section"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.Palette"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementPalette"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "PaletteMessages"); //$NON-NLS-1$ //$NON-NLS-2$

/**
 * Widget to show/edit page properties
 */
dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.edit.PalettePane",  [ dijit._Widget, dijit._Templated ], { //$NON-NLS-1$
	templateString: '<div dojoAttachPoint="paletteContainer" data-dojo-attach-point="mainContent" class="palette-pane"></div>', //$NON-NLS-1$
	widgetsInTemplate: true,
	diagramView: null,

	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "PaletteMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.contentTitle = this.messages.elementCategoryTitle;
		this.inherited(arguments);
	},

	postCreate : function() {
		this.inherited(arguments);

		// setup default palette
		var viewElementsPalette = new com.ibm.relm.explorer.web.ui.internal.view.edit.Palette();
		this._addPaletteSection(this.messages.viewElementsSectionTitle, viewElementsPalette, true);

		// setup palette for Lifecycle Elements
		var artifactElementsPalette = new com.ibm.relm.explorer.web.ui.internal.view.edit.LifecycleElementPalette({diagramView: this.diagramView});
		this._addPaletteSection(this.messages.artifactElementsSectionTitle, artifactElementsPalette, false);
	},
	
	/**
	 * Add a section that contains palette items
	 */
	_addPaletteSection: function(title, palette, initiallyCollapsed) {
		var section = new com.ibm.relm.common.web.ui.Section({canCollapse: true, inSidebar: true, showHelp: false, label: title, initiallyCollapsed: initiallyCollapsed});
		this.paletteContainer.appendChild(section.domNode);

		// setup palette
		palette.setEditorProvider(this.diagramView);
		palette.startup();

		section.containerNode.appendChild(palette.domNode);
	},
});