/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.ProjectAreaSelectionDialogContent"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.CheckBox"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ProjectAreaSelect"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ProjectAreaSelectionDialogContentMessages"); //$NON-NLS-1$ //$NON-NLS-2$


(function() { // module container

	/**
	 * Widget to Edit parameter
	 */
	dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.edit.ProjectAreaSelectionDialogContent", //$NON-NLS-1$
					[ dijit._Widget, dijit._Templated ], 
		{ 
		widgetsInTemplate: true,
		
		templatePath : dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/edit/templates/ProjectAreaSelectionDialogContent.html"), //$NON-NLS-1$ //$NON-NLS-2$

		postMixInProperties : function(args) {
			this.inherited(arguments);
			this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ProjectAreaSelectionDialogContentMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate : function() {
			
			this.inherited(arguments);
			
			this.updateEnablement();

		},
		
		_archivedCheckboxClicked: function() {
			var fIncludeArchived = this.checkBox_archived.checked;
			this.comboBox_projectArea.refreshList(fIncludeArchived);
		},
		
		getValues: function() {
			return this.comboBox_projectArea.getUri();
		},
		
		updateEnablement: function() {
			this._updateEnablement();
		},
		
		_updateEnablement: function() {
			this.setOkButtonDisabled( !this.comboBox_projectArea.getUri()); //$NON-NLS-1$
		},
		
		setOkButtonDisabled: function(disable) {
			// dummy for event handler
		}


	});
})();
