/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2007,
 * 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.ResourceNodeAttributeContent"); //$NON-NLS-1$

dojo.require("dijit.form.ComboBox"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.EditorUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.SectionDialog"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "PropertiesPaneMessages"); //$NON-NLS-1$ //$NON-NLS-2$


(function() { // module container
	var editorUtils = com.ibm.relm.explorer.web.ui.internal.editor.EditorUtils;
	/**
	 * Widget to show property pane
	 */
	dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.edit.ResourceNodeAttributeContent", [ dijit._Widget, dijit._Templated ], { //$NON-NLS-1$
		templatePath : dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/internal/view/edit/templates/ResourceNodeAttributeContent.html"), //$NON-NLS-1$ //$NON-NLS-2$
		widgetsInTemplate: true,
		diagramView: null,
		
		postMixInProperties: function(){
			this.editorMessages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "PropertiesPaneMessages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.inherited(arguments);
		},
		
		postCreate:function(){
			this.inherited(arguments);
		},
		
		setWidget: function(widget){
			this._target = widget;
			var resInfo = editorUtils.getResourceInfo(widget);
			dojo.html.set(this.nodeTypeText, resInfo ? resInfo.name : "");//$NON-NLS-1$
		},
		
		_editNode: function(ev){
			dojo.stopEvent(ev);
			if(!this._target || !this._target.resource) return;
			// open dialog
			var config = dojo.clone(this.diagramView._getConfig());
			var resInfo = editorUtils.getResourceInfo(this._target, config) || -1; // Create a new node definition if it is applied system default node (= getResourceInfo returns null)
			var self = this;
			var updateInDialog = false;
			com.ibm.relm.explorer.web.ui.internal.editor.SectionDialog.openResourceDialog({
				getConfig: function(){ return config; },
				getDiagramEditor: function(){ return self.diagramView._getDiagramEditor(); },
				_updateDirty: function() {
					updateInDialog = true;
				}
			}, 
			resInfo, 
			function(){
				dojo.mixin(self.diagramView._getConfig(), config);
				if(updateInDialog) {
					self.diagramView.setDirty(true);
				}
				self.diagramView.refreshDiagramLocal();
			}
			);
			//this.diagramView.switchToForm({tabName: "resource", resourceInfo: resInfo});
		}
	});
})();