/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.SideBarContent"); //$NON-NLS-1$

dojo.require("dijit.layout.AccordionContainer");//$NON-NLS-1$
dojo.require('jazz.app.ua.PageHoverHelp'); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "SideBarContentMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
/**
 * Base class for a container of rightside bar
 */
dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.edit.SideBarContent", [dijit.layout.AccordionContainer], { //$NON-NLS-1$
	
	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "SideBarContentMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._csPageHelpWidgets = [];
		this._contentPanes = {};
		this.inherited(arguments);
	},
	
	postCreate: function() {
		this.inherited(arguments);
		this._initContents();
	},

	_initContents: function() {
		var noComponentsMsg = this.messages.noComponents;
		this._panecontents = this._createSideBarContents();
		dojo.forEach(this._panecontents, function(contentInfo) {
			var  contentPane = new dijit.layout.ContentPane({
				title: contentInfo.content.contentTitle, 
				content: noComponentsMsg
			});
			contentPane.set("content", contentInfo.content);//$NON-NLS-1$

			this.addChild(contentPane);
			this._contentPanes[contentInfo.id] = contentPane;
		}, this);
	},
	
	_createSideBarContents: function() {
	},

	_getContentPane: function(id) {
		return this._contentPanes[id];
	},

	setupContextSensitiveHelp: function() {
		dojo.forEach(this._panecontents, function(contentInfo) {
			var contentPane = this._getContentPane(contentInfo.id);
			if (contentInfo.contentHelpId) this._createContextSensitiveHelp(contentPane, contentInfo.contentHelpId);
		}, this);
	},
	
	_createContextSensitiveHelp: function(pane, helpId) {
		if(pane._csHelpAdded == true) {
			return;
		}
		var fHelp = false;
		if(pane._buttonWidget) {
			pane._buttonWidget.titleNode.appendChild(this._createCSHWidget(helpId));
			fHelp = true;
		}
		pane._csHelpAdded = fHelp;
	},

	_createCSHWidget: function(uaKey) {
		var parms = {};
		parms.uaKey = uaKey;
		var pageHelp = new jazz.app.ua.PageHoverHelp(parms);
		this._csPageHelpWidgets.push(pageHelp);
		return  pageHelp.domNode;
	},

	destroy: function() {
		dojo.forEach(this._csPageHelpWidgets, function(w) { w.destroy; });
		this._panecontents = null;
		this._contentPanes = null;
		this._csPageHelpWidgets = null;
		this.diagramView = null;
		this.inherited(arguments);
	}
});

})();
