/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2007,
 * 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.TextAttributeContent"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.edit.AttributeContent"); //$NON-NLS-1$

(function() { // module container

	/**
	 * Widget to show property pane
	 */
	dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.edit.TextAttributeContent", [ com.ibm.relm.explorer.web.ui.internal.view.edit.AttributeContent ], { //$NON-NLS-1$
		
		getAttributeOrder: function(){
			return [
			        "text",		//$NON-NLS-1$ 
			        "font",		//$NON-NLS-1$ 
			        "decoration",	//$NON-NLS-1$ 
			        "fill",		//$NON-NLS-1$ 
			        "stroke",	//$NON-NLS-1$ 
			        "left",		//$NON-NLS-1$ 
			        "top",		//$NON-NLS-1$ 
			        "href", 	//$NON-NLS-1$ 
			        "action"];	//$NON-NLS-1$ 
		},
		
		getOptions: function(attrName){
			var options = [{name: "weight", value: [{label: this.messages.bold, value: "bold"},  //$NON-NLS-1$ //$NON-NLS-2$
			      						        	{label: this.messages.normal, value: "normal"}]}, //$NON-NLS-1$
			      			{name: "style", value: [{label: this.messages.italic, value: "italic"},  //$NON-NLS-1$ //$NON-NLS-2$
			      		                        {label: this.messages.normal, value: "normal"}]}, //$NON-NLS-1$
			      		    {name: "variant", value: [{label: this.messages.normal, value: "normal"},  //$NON-NLS-1$ //$NON-NLS-2$
			      		                        {label: this.messages.smallCaps, value: "small-caps"}]} //$NON-NLS-1$
            ];
			for(var i = 0; i < options.length; i++) {
				if(options[i].name == attrName){
					return options[i].value;
				}
			}
			return null;
		}
	});
	
})();