/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.extensions.containers"); //$NON-NLS-1$

(function(){
	
/*
 * Created in DiagramEditRoot
 */
com.ibm.relm.explorer.web.ui.internal.view.extensions.containers = {
	/*
	 * Manage containers
	 */
	_initContainers: function(){
		if(!this._containers){
			this._containers = new dijit.WidgetSet();
		}
	},
	
	addContainer: function(widget){
		this._initContainers();
		this._containers.add(widget);
	},
	
	removeContainer: function(widgetid){
		this._initContainers();
		this._containers.remove(widgetid);
	},
	
	findContainer: function(id){
		this._initContainers();
		var containers = this._containers.filter(function(w){
			if(w.getId) {
				if(id == w.getId()) return true;
			}
			return false;
		}).toArray();
		if(containers.length > 0) 
			return containers[0]; // id must be unique
		return null;
	},
	
	getContainerSet: function(){
		this._initContainers();
		return this._containers; 
	},	
	
	createUniqueContainerId: function(prefix) {
		for (var i = 1; ; i++) {
			var id = prefix + '_' + i; //$NON-NLS-1$
			if (!this.findContainer(id)) {
				return id;
			}
		}
		return null; //$NON-NLS-1$
	}
};

})();