/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.helper"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer"); //$NON-NLS-1$

com.ibm.relm.explorer.web.ui.internal.view.helper = {
	initialize: function(){
		// don't allow drop object into a node except for NodeContainer
		if(this instanceof com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer){
			// default hlp_dropTargets is registerd in dropHelper.js 
		}else{
			this.hlp_dropTargets = null;
		}
		
		this.hlp_updateEditMode();
	},
	
	hlp_updateEditMode: function(){
		if(dojo.isFunction(this.editModeChanged)){
			this.editModeChanged(this.hlp_getEditor()._editMode);
		}		
	},
	
	/*
	 * Called after hlp_addChild is called. hlp_addChild is a method called from commands
	 */
	hlp_afterAddChild: function(parent, widget){
		this.hlp_updateEditMode();
		
		widget._viewer = parent.hlp_getEditor();
		if(widget instanceof com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer){
			widget.reload();
			widget._viewer.fireLoadResource(); // for reload connections
			widget._viewer.addContainer(widget);
		}
		for(var n = widget; n; n =  n.getParent()){
			if(dojo.isFunction(n.layout)){
				n.layout();
			}
			if(!dojo.isFunction(n.getParent)) break;
		}
	},
	
	/*
	 * Called after hlp_removeChild is called. hlp_removeChild is a method called from commands
	 */
	hlp_afterRemoveChild: function(parent, widget){
		if(widget instanceof com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer){
			// clean up child nodes and connections
			widget.destroyDescendants();
			widget._viewer.removeContainer(widget.id);
		}
		if(parent instanceof com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer){
			parent.layout();
		}
	}
};
