/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes._ActionsMixin"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes._LinksMixin"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes._ConnectionLineMixin"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.Rect"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.Image"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.anchor.ChopboxAnchor");//$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.xmlutils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.ConfigUtils"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.Workbench"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.hover.GfxRichHover"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.policies.OutlineRenderer"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.layout.DefaultLayout"); //$NON-NLS-1$
dojo.require("jazz.app.ua.internal.HelpDOMNode");//$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.explorer.queryparams.SystemParameterUtil'); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "NodesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var utils = com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils;
var configUtils = com.ibm.relm.explorer.web.ui.internal.ConfigUtils;
var xmlutils = com.ibm.relm.explorer.web.ui.internal.xmlutils;
var systemParameterUtil = com.ibm.relm.explorer.web.explorer.queryparams.SystemParameterUtil;
var util = com.ibm.relm.explorer.web.ui.internal.util;


var errorIconURL = dojo.moduleUrl("com.ibm.relm.explorer.web","ui/internal/view/images/error.gif"); //$NON-NLS-1$ //$NON-NLS-2$
//var infoIconURL = dojo.moduleUrl("com.ibm.relm.explorer.web","ui/internal/view/images/page-help-hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var loadingIconURL = dojo.moduleUrl("com.ibm.relm.explorer.web","ui/internal/view/images/loading.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var artifactElementIconURL = dojo.moduleUrl('com.ibm.relm.explorer.web', 'ui/images/artifactelement.gif'); //$NON-NLS-1$ //$NON-NLS-2$

var ICONCLASS_QUERY = "query-icon"; //$NON-NLS-1$
var ICONCLASS_COPY = "copy-icon"; //$NON-NLS-1$
var ICONCLASS_PASTE = "paste-icon"; //$NON-NLS-1$
var ICONCLASS_DELETE = "delete-icon"; //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer", //$NON-NLS-1$
	[com.ibm.relm.explorer.web.base.internal.gdc.Rect, 
	 com.ibm.relm.explorer.web.ui.internal.view.nodes._ActionsMixin,
	 com.ibm.relm.explorer.web.ui.internal.view.nodes._LinksMixin,
	 com.ibm.relm.explorer.web.ui.internal.view.nodes._ConnectionLineMixin],
{
	_domNode: null,
	_viewer: null,
	_queryParams: null,
	containerParams: null,
	executionParams: null,
	uiParams: null,
	_layoutManager: null,
	_params: [],
	_uiParams: [],
	_specifiedDimension: {},
	_containerId: "", //$NON-NLS-1$
	fill: "", // override Rect's default value = "white" //$NON-NLS-1$
	stroke: "", // don't show border //$NON-NLS-1$
	_nodeType: null, 
	connectable: true,
	
	postMixInProperties: function() {
		this.inherited(arguments);
		this.sourceAnchorClass = "com.ibm.relm.explorer.web.base.internal.gdc.anchor.ChopboxAnchor"; //$NON-NLS-1$
		this.targetAnchorClass = "com.ibm.relm.explorer.web.base.internal.gdc.anchor.ChopboxAnchor"; //$NON-NLS-1$
	},

	// attributes setter
	getHidden: function() {
		return !this._layoutManager || this._layoutManager.hidden;
	},
	
	getTitle: function() {
		var ret = this.getId();
		this._getTitle(function(title) {
			ret = title;
		});
		return ret;
	},
	
	_getTitle: function(callback) {
		var defaultTitle = this.getId();
		if (this._viewer && this.elementId) {
			this._viewer.getArtifactElementTitle(this.elementId, function(aeTitle) {
				callback(aeTitle);
			}, function(err) {
				callback(defaultTitle);
			});
		} else {
			callback(defaultTitle);
		}
	},
	
	setBaseQueryId: function(queryId){
		this._query = null;
		this.queryTemplate = null;
		this.baseQueryId = queryId;
		if(this._getEditMode()){
			this.setWidth(this._specifiedDimension.width, true);
			this.setHeight(this._specifiedDimension.height, true);
		}
	},
	
	setQueryParams: function(params){
		this._queryParams = (params || "").split(",");//$NON-NLS-1$ //$NON-NLS-2$
		this._query = null;
	},
	
	setId: function(id) {
		var oldId = this._containerId;
		
		this._containerId = id;
		this._updateConnectable();

		if (this._viewer && this._viewer.updateLinkNode) 
			this._viewer.updateLinkNode(oldId, id);
	},
	
	setWidth: function(width, internal){
		this.inherited(arguments);
		if(!internal && this._getEditMode()){
			this._specifiedDimension.width = width; 
		}
	},
	
	setHeight: function(height, internal){
		this.inherited(arguments);
		if(!internal && this._getEditMode()){
			this._specifiedDimension.height = height; 
		}
	},
	
	setNodeType: function(nodeType){
		this._nodeType = nodeType;
	},
	
	// attributes getter
	getWidth: function(onlyExplicit){
		if(onlyExplicit){
			return this._specifiedDimension.width;
		}
		return this.inherited(arguments);
	},
	
	getHeight: function(onlyExplicit){
		if(onlyExplicit){
			return this._specifiedDimension.height;
		}
		return this.inherited(arguments);
	},

	getLayout: function(){
		return this.layoutManager || (this._domNode && this._domNode.getAttribute("layout")); //$NON-NLS-1$
	},
	
	getVspacing: function(){
		return this.vspacing || this.spacing || this._layoutManager.defaultSpacing;
	},
	
	getHspacing: function(){
		return this.hspacing || this.spacing || this._layoutManager.defaultSpacing;
	},
	
	getId: function(){
		if(this._containerId == "") { //$NON-NLS-1$
			if(this._domNode) {
				this._containerId  = this._domNode.getAttribute("id") || ""; //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
		
		return this._containerId; 
	},
	
	getQueryParams: function(){
		return (this._queryParams || []).join(",");//$NON-NLS-1$
	},
	
	getNodeType: function(){
		return this._nodeType;
	},
	
	//
	postCreate: function(){
		this.inherited(arguments);

		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "NodesMessages");		 //$NON-NLS-1$ //$NON-NLS-2$

		if (this.elementId)
			this.paramUses = {defaultUse: "execution", ui: "ui"}; //$NON-NLS-1$ //$NON-NLS-2$
		else
			this.paramUses = {};

		if (this._initLinkInformation) 
			this._initLinkInformation();

		var domNode = this._domNode;
		if(domNode){
			if(this.showGrid) this.showGrid = xmlutils.getBooleanValue(this.showGrid);
			if(this.pack) this.pack = xmlutils.getBooleanValue(this.pack);
			if(this.allowOverwrap) this.allowOverwrap = xmlutils.getBooleanValue(this.allowOverwrap);
			if(this.expandChild) this.expandChild = xmlutils.getBooleanValue(this.expandChild);
			
			this._specifiedDimension = {width: domNode.getAttribute("width"), height: domNode.getAttribute("height")}; //$NON-NLS-1$ //$NON-NLS-2$
			this.setLeft(this.x || this.left || 0);
			this.setTop(this.y || this.top || 0);
			this.setWidth(this.width || 0, true); // IE
			this.setHeight(this.height || 0, true); // IE
			
			this.setNodeType(domNode.getAttribute("nodeType"));//$NON-NLS-1$
			
			if(!this.baseQueryId && this._viewer.config._defaultQueryId){
				// see Config#_migrate10()
				this.baseQueryId = this._viewer.config._defaultQueryId;
			}
			
			var qp = domNode.getAttribute("queryParams"); //$NON-NLS-1$
			if(qp !== null){
				this._queryParams = (qp || "").split(","); //$NON-NLS-1$ //$NON-NLS-2$
			}
			
			this._params = this._getParams();
			this._uiParams = this._getUiParams();
			
			this._viewer.addContainer(this);
		}else{
			this._specifiedDimension = {width: this.width, height: this.height}; // drag and drop from palette 			
		}

		this.setLayoutManager(this.getLayoutManager());
		this.createPolicies();

		// one time setup after creation
		this._initHandle = this.connect(this, "setup", dojo.hitch(this, function() { //$NON-NLS-1$
			this.disconnect(this._initHandle);
			delete this._initHandle;

			if (dojo.isFunction(this.onCreate)) {
				this.onCreate(this);
				delete this.onCreate;
			}
		}));
	},
	
	uninitialize: function() {
		this.clearConnections();
		this._removeIcon();
		this.destroyDescendants();
		this.inherited(arguments);
		this._viewer.removeContainer(this.id);		
		if(this._helpNode) {
			this._helpNode.destroy();
			delete this._helpNode;
		}
		if(this.hover) {
			this.hover.destroy();
			delete this.hover;
		}
		this._layoutManager = null;
		this._domNode = null;
		this.connectable = false;
	},

	addChild: function(/*dijit/_WidgetBase*/ widget, /*int?*/ insertIndex){
		if(this._infoIcon && widget != this._infoIcon){
			if(this._infoIcon == this.iconNode){
				this._removeIcon();
			}else 
			if(this._infoIcon.domNode){
				this._infoIcon.destroy();
			}
			this._infoIcon = null;
		}
		this.inherited(arguments);		
	},
	
	update: function(props){
		this.inherited(arguments);
	},

	createPolicies: function() {
//		this.createPolicy(com.ibm.relm.explorer.web.ui.internal.view.policies.OutlineRenderer);
	},
	
	_getParams: function(){
		
		return utils.getParamValue(this.getParameters());
	},
	
	_getUiParams: function(){
		
		return utils.getParamValue(this.getUiParams());
	},
	
	getParameters: function() {
		if(!this.containerParams) {
			this.containerParams = this._getParameters(this.paramUses.defaultUse);
		}
		return this.containerParams;
	},
	
	getUiParams: function() {
		if(!this.uiParams && this.paramUses.ui) {
			this.uiParams = this._getParameters(this.paramUses.ui);
		}
		return this.uiParams;
	},
	
	_getParameters: function(use) {
		var params = {};
		if(this._domNode) {
			var self = this;
			dojo.forEach(xmlutils.getChildNodesByName("param", self._domNode), function(param){ //$NON-NLS-1$
				var paramUse = null;
				var containerParam = {};
				var name = null;
				dojo.forEach(param.attributes, function(attr) {
					if (attr.name == "name") { //$NON-NLS-1$
						name = attr.value;
					} else if(attr.name == "use") { //$NON-NLS-1$
						paramUse = attr.value;
					} else {
						if (attr.name == "mandatory" || attr.name == "isuserparam") {//$NON-NLS-1$ //$NON-NLS-2$
							if (attr.value == "true") containerParam[attr.name] = true; //$NON-NLS-1$
						} else {
							containerParam[attr.name] = attr.value;
						}
					}
				});
	
				if (containerParam.type == "enum") { //$NON-NLS-1$
					containerParam.value = dojo.fromJson(containerParam.value); 
				} else if (containerParam.value && containerParam.value.length > 0) {
					switch(containerParam.type) {
					case "boolean": containerParam.value = containerParam.value.toLowerCase() == "true"; break; //$NON-NLS-1$ //$NON-NLS-2$
					case "number": containerParam.value = Number(containerParam.value); break; //$NON-NLS-1$
					case "date": containerParam.value = new Date(containerParam.value); break; //$NON-NLS-1$
					default: break;
					}
				}
				if (use == paramUse || (!paramUse && use == self.paramUses.defaultUse))
					if (name) params[name] = containerParam;
			});
		}
		return params;
	},
	
	setParameters: function(params) {
		this.containerParams = params;
		this._params = this._getParams(); // update _params
		this._query = null; // clear evaluated query 
	},
	
	setUiParams: function(params) {
		this.uiParams = params;
		this._uiParams = this._getUiParams(); // update _params
	},
	
	showContextMenu: function(x, y) {
		if (x && y) {
			return this.inherited(arguments);
		}
		else {
			// XXX: assumes there is a _viewer property to find the top shape layer.
			var pos = utils.shapePosition(this.shape, this._viewer);
			x = pos.x;
			y = pos.y;

			// Normally an unpositioned menu pops up below the node, but since
			// NodeConatiners are very tall, this can push the menu off the
			// page. It's better to first the menu to be at the top of the
			// container.
			return this.inherited(arguments, [x, y]);
		}
	},

	_getEditActions: function() {
		var self = this;
		var clipboard = this._viewer ? this._viewer.clipboard : null;
		var actions = [];
		actions.push({
			nodeWidget: this,
			actionType: 'copy', //$NON-NLS-1$
			label: self.messages.copyContainer,
			iconClass: ICONCLASS_COPY,
			action: function(){
				var message = {
					type: "ActionInvokedNotification", //$NON-NLS-1$
					src: self,
					command: "copy", //$NON-NLS-1$
					arg: null
				};
				dojo.publish("btp:ActionInvoked", [message]); //$NON-NLS-1$
			},
			validate: function() {
				return !self.preventSave;
			}
		});
		actions.push({
			nodeWidget: this,
			actionType: 'paste', //$NON-NLS-1$
			label: self.messages.paste,
			iconClass: ICONCLASS_PASTE,
			action: function(){
				var message = {
						type: "ActionInvokedNotification", //$NON-NLS-1$
						src: self,
						command: "paste", //$NON-NLS-1$
						arg: null
					};
					dojo.publish("btp:ActionInvoked", [message]); //$NON-NLS-1$
			},
			validate: function() {
				return clipboard && clipboard.getAvailableDataFormats(["layout"]).length > 0; //$NON-NLS-1$
			}
		});
		actions.push({
			nodeWidget: this,
			actionType: 'remove', //$NON-NLS-1$
			label: self.messages.removeContainer,
			iconClass: ICONCLASS_DELETE,
			action: function(){
				self.removeContainer();
			}
		});
		return actions;
	},
	
	_getAllActions: function() {
		var self = this;
		var actions = [];
		if(this.getQuery(true) || this.elementId){
			actions.push({
				nodeWidget: this,
				actionType: 'showQuery', //$NON-NLS-1$
				label: self.messages.showQuery,
				iconClass: ICONCLASS_QUERY,
				action: function(targetWidget, event){
					if(self._getEditMode()) {
						if(!confirm(self.messages.confirmExecuteAction)) return; 	
					}
					self.openQueryEditor(event.ctrlKey);
				}
			});
		}
		return actions;
	},
	
	createTargetShape: function(){
		var shape = this.inherited(arguments);
		
		var self = this;
		this._createActionBar([
			{
				src: dojo.moduleUrl("relm.app", "graphics/icons/view_menu.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title: this.messages.menu,
				width: 16,
				onclick: function(iconShape){
					var pos = utils.shapePosition(iconShape, self._viewer);
					self.showContextMenu(pos.x, pos.y + pos.h);
				}
			}
		]);
		return shape;
	},

	openQueryEditor: function(openInNewTab){
		var actionURL = "#action=jazz.viewPage&id=com.ibm.relm.explorer.web.ui.page.QueryPage";//$NON-NLS-1$
		var self = this;
		var queryInfo = self._getQueryInfo();
		if(openInNewTab) {
			var msg = dojo.toJson({reason: util.STR_MESSAGE_REASON_SHOWQUERY, queryInfo: queryInfo}); //$NON-NLS-1$
			var newWindow = window.open(actionURL, "_blank"); //$NON-NLS-1$ //$NON-NLS-2$
			if(dojo.isIE) {
				// for IE
				var origin = document.location.protocol + "//" + document.location.host; //$NON-NLS-1$
				newWindow.document.onreadystatechange = 
				function() {
					if(this.readyState=="loaded"||this.readyState=="complete"){ //$NON-NLS-1$ //$NON-NLS-2$
						setTimeout(function(){newWindow.postMessage(msg, origin);}, 1000);  //$NON-NLS-1$
					}
				};
			} else {
				newWindow.addEventListener("load",  //$NON-NLS-1$
					function(event){
						newWindow.postMessage(msg, document.location.origin);  //$NON-NLS-1$
					},
					false
				);
			}
		} else {
			window.location = actionURL; //$NON-NLS-1$ 
			net.jazz.ajax.ui.PlatformUI.getWorkbench().viewPage("com.ibm.relm.explorer.web.ui.page.QueryPage", function(){ //$NON-NLS-1$

				if(queryInfo){
					setTimeout(function(){dojo.publish("EXECUTE_QUERY", [queryInfo]);},1000); //$NON-NLS-1$
				}
			});		
		}
	},
	
	_getQueryInfo: function() {
		var self = this;
		var queryInfo = null;
		var queries = self.getQueries(true);
		if(dojo.isArray(queries) && queries.length === 1){
			var query = queries[0];
			if(query && query.sparql){
				queryInfo = {sparql: query.sparql};
				if(query.parameterValues){
					queryInfo.parameterValues = query.parameterValues;
					queryInfo.parameterized = "true";//$NON-NLS-1$
				}
			}
		}else if(self.elementId){
			queryInfo = {artifactElementId: self.elementId};
			queryInfo.parameterValues = self._getParametersForArtifactElement();
			queryInfo.parameterized = "true";//$NON-NLS-1$
		}
		queryInfo.fixedParameter = "true"; //$NON-NLS-1$
		return queryInfo;
	},
	
	removeContainer: function() {
		var self = this;
		var containerId = self.getId();
		if(confirm(dojo.string.substitute(self.messages.confirmRemoveContainer, [containerId]))){
			var message = {
				type: "ActionInvokedNotification", //$NON-NLS-1$
				src: self,
				command: "del", //$NON-NLS-1$
				arg: null
			};
			dojo.publish("btp:ActionInvoked", [message]); //$NON-NLS-1$
		}

	},
	
	_getQueryFromTemplate: function(template, useClientSideStringTemplate){
		var baseQuery = template.sparql;				
		// replace %s in base query
		dojo.forEach(this._queryParams || [], function(param){
			baseQuery = baseQuery.replace("%s", param); //$NON-NLS-1$
		});
		// replace by params defined in 1. <container> 2. <view> 3. <queryTemplate> 
		var configParams = utils.getParamValue(this._viewer.config.params);
		var queryParams = utils.getParamValue(template.params);
		var paramArray = [this._params, configParams, queryParams];
		baseQuery = configUtils.evalParamsArray(baseQuery, paramArray, null, !useClientSideStringTemplate);
		if(baseQuery.indexOf("%s") >= 0){ //$NON-NLS-1$
			baseQuery = null;
		}
		var parameters = configUtils.getParameterValuesFromParamArray(paramArray);
		return {sparql: this._modifyQuery(baseQuery), parameterValues: parameters};
		
	},

	_modifyQuery: function(query) {
		if (!query || !this.isDownstream()) {
			return query;
		}
	
		var self = this;
		var values = [];
		dojo.forEach(this.getUpstream(), function(link) {
			var parentNode = self._viewer.findContainer(link.id);
			if (!parentNode) {
				return;
			}
			dojo.forEach(parentNode.getChildren(), function(node) {
				if (node instanceof com.ibm.relm.explorer.web.ui.internal.view.nodes.ResourceNode) {
					if (node.uri) {
						values.push("(<" + node.uri + ">)"); //$NON-NLS-1$ //$NON-NLS-2$
					}
				}
			});
		});
		
		if (values.length > 0) {
			query += "VALUES (?source) { " + values.join(" ") + "}"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return query;
		}
		return ""; //$NON-NLS-1$
	},
	
	getQuery: function(useClientSideStringTemplate){
		if(useClientSideStringTemplate){
			if(!this.queryTemplate){
				this.queryTemplate = this._viewer.config.getQueryTemplate(this.baseQueryId);
				if(!this.queryTemplate){
					return null;
				}
			}
			return this._getQueryFromTemplate(this.queryTemplate, true);
		}
		if(!this._query){
			if(!this.queryTemplate && this.baseQueryId){
				this.queryTemplate = this._viewer.config.getQueryTemplate(this.baseQueryId);
			}
			if(this.queryTemplate){
				// sparql might be null ... e.g. %s is not resolved
				this._query = this._getQueryFromTemplate(this.queryTemplate);
			} else if (this.elementId) {
				var parameters = this._getParametersForArtifactElement();
				var queryTemplate = {elementId: this.elementId, parameters: parameters};
				if (this.isDownstream && this.isDownstream() && this._getLinkedQueries) {
					this._query = this._getLinkedQueries(this._viewer);
					dojo.forEach(this._query, function(q) {dojo.mixin(q, queryTemplate);});
				} else {
					this._query = queryTemplate;
				}
			}
		}
		return this._query;
	},

	_getUserSpecifiedParams: function(callback) {
		var id = this.getId();
		var parameters = null;
		var params = this.getParameters();
		for (var name in params) {
			if (params[name].isuserparam) {
				if (!parameters) parameters = {};
				parameters[name] = dojo.clone(params[name]);
				parameters[name].containerTitle = id;
				parameters[name].containerId = id;
			}
		}
		
		if (!this._viewer || !this.elementId || !parameters) {
			callback({});
			return;
		}

		this._viewer.getArtifactElement(this.elementId, function(element) {
			for (name in element.parameters) {
				var elementParam = element.parameters[name];
				var param = parameters[elementParam.name];
				if (param) {
					param.containerTitle = element.title;
					param.label = elementParam.label;
					param.type = elementParam.type;
					param.description = elementParam.description;

					if (elementParam.parameterClass == "system") {//$NON-NLS-1$
						param.type = elementParam.parameterClass + ":" + param.type; //$NON-NLS-1$
					} else if (elementParam.parameterClass == "enum") {//$NON-NLS-1$
						param.type = elementParam.parameterClass;
						param.enumtype = elementParam.type;
					}
				}
			}
			callback(parameters);
		}, function(err) {
			callback(parameters);
		});
	},

	_getParametersForArtifactElement: function(){
		var parameters = {};
		var executionParams = this.getParameters();
		if (executionParams) {
			// "Specified in View" parameters can be replaced by view parameters.
			var configParams = utils.getParamValue(this._viewer.config.params);
			for (var name in executionParams) {
				parameters[name] = {};
				if (executionParams[name].isuserparam && !this._params[name] && configParams[name])
					parameters[name].value = configParams[name];
				else
					parameters[name].value = this._params[name] || executionParams[name].value;
				parameters[name].type = executionParams[name].type;
			}
		}
	
		var systemParameters = systemParameterUtil.getSystemParameterValues();
		for (var name in parameters) {
			var parameter = parameters[name];
			// update date values
			if (parameter.value != undefined && !dojo.isString(parameter.value)) {
				if (parameter.type == "date" && parameter.value) { //$NON-NLS-1$
					if (parameter.value.value)
						parameter.value = parameter.value.value;
					else
						parameter.value = dojo.date.stamp.toISOString(parameter.value);
				} else if (dojo.isObject(parameter.value)) {
				} else {
					parameter.value = parameter.value.toString();
				}
			}

			// update system parameters
			if (parameter.type.substr(0, 7) == "system:") { //$NON-NLS-1$
				var type = parameter.type.substr(7);
				var values = systemParameters["system"]; //$NON-NLS-1$
				if (values && values.value && values.value[type]) {
					dojo.mixin(parameter, values.value[type]);
				}
			}
		}

		var unknownTypes = ["product", "artifact", "projectArea"]; //$NON-NLS-2$ //$NON-NLS-1$ //$NON-NLS-3$
		for (var name in parameters) {
			var parameter = parameters[name];
			if (dojo.indexOf(unknownTypes, parameter.type) >= 0)
				parameter.type = "string"; //$NON-NLS-1$   // FIXME
		}

		return parameters;
	},
	
	setQueryTemplate: function(queryTemplate){
		this.queryTemplate = queryTemplate;
	},
	
	getQueries: function(useClientSideStringTemplate){		
		if(dojo.isArray(this.queryTemplates)){
			var self = this;
			return dojo.map(this.queryTemplates, function(template){
				return dojo.mixin({component: template.component}, self._getQueryFromTemplate(template, useClientSideStringTemplate));
			});
		}
		var q = this.getQuery(useClientSideStringTemplate);
		if (dojo.isArray(q))
			return q;
		return q ? [q] : null;
	},
	
	setQueryTemplates: function(queryTemplates){
		this.queryTemplates = queryTemplates;
		if(dojo.isArray(queryTemplates)){
			this.queryTemplate = queryTemplates[0];
		}
	},
	
	setLayoutManager: function(l){
		if(l){
			l._container = this;
		}
		this._layoutManager = l;
	},
	
	setup: function(keepChildren){
		if(!this._layoutManager){
			return;
		}
		this._removeIcon();
		
		this._updateConnectable();
		this._layoutManager.setup(keepChildren);
		
		if(!this.hasChildren() && !this._query && this._getEditMode() && !this.preventSave){
//			if(!this._helpNode){
//				var parms = {uaKey: "com.ibm.relm.explorer.web.text_Views_Containers001"};//$NON-NLS-1$
//				this._helpNode = new jazz.app.ua.internal.HelpDOMNode(parms);
//			}
//			this.showIcon(infoIconURL, null, this._helpNode);
//			this._infoIcon = this.iconNode;
		}
	},
	
	layout: function(){
		this._layoutRequest = null;
		if(!this._layoutManager || this.iconNode){
			return;
		}

		dojo.forEach(this.getChildren(), function(c){ 
			if(dojo.isFunction(c.setLayoutReady)) c.setLayoutReady(true); 
		});

		this._layoutManager.layout();

		if (this._getEditMode() && this.setupContainerConnectionLine)
			this.setupContainerConnectionLine(this._viewer);

		dojo.forEach(this.getChildren(), function(c){ 
			if(dojo.isFunction(c.setLayouted)) c.setLayouted(); 
		});
		this.setLayoutReady(true);
		dojo.publish("com.ibm.relm.explorer.web.CONTAINER_LAYOUT_COMPLETED", [{self: this, owner: this._viewer}]); //$NON-NLS-1$
	},
	
	_layoutRequest: null,
	requestLayout: function(delayedTime){
		if(this._layoutRequest){
			clearTimeout(this._layoutRequest);
		}
		this._layoutRequest = setTimeout(dojo.hitch(this, this.layout), !isNaN(delayedTime) ? delayedTime : 10);
	},
	
	reload: function(params){
		if(params){
			if (this.elementId) {
				var parameters = this.getParameters();
				if (!parameters)
					return;
		
				// In case of artifact element, only "Specified in View" parameters can be replaced.
				this._params = {};
				for (var name in parameters) {
					if (params[name] != undefined && parameters[name].isuserparam)
						this._params[name] = params[name];
					else
						this._params[name] = parameters[name].value;
				}
				dojo.safeMixin(this._uiParams, params);
			} else {
				dojo.safeMixin(this._params, params);
			}
			this._query = null;
		}
		this.setup();
		this.layout();
	},
	
	nodeMoved: function(/*Widget*/widget){
		dojo.forEach(this.getChildren(), function(w){
			if(w.nodeMoved) {
				w.nodeMoved();
			}
		});
		if(this._viewer)
			this._viewer.nodeMoved(this);
	},

	showIcon: function(iconUrl, message, helpBox){
		if(iconUrl){
			if(!this.iconNode || this.iconNode.src != iconUrl){
				this._removeIcon();
				this.iconNode = this._viewer.createComponent("image", {src: iconUrl, left: 0, top: 0, preventSave: true, movable: false, notDeletable: true, _viewer: this._viewer}); //$NON-NLS-1$
				this.addChild(this.iconNode);
				if(this.hover) {
					this.hover.destroy();
					this.hover = null;
				}
				if(helpBox){
					this.hover = utils._createRichHover(this.iconNode, function(){
						return helpBox.domNode;
					});
				}else if(message){
					var summary = message.summary;
					this.hover = utils._createRichHover(this.iconNode, function(){
						var div = dojo.create("div", { style: {whiteSpace: "pre"}}); //$NON-NLS-1$//$NON-NLS-2$
						var content = summary;
						var detail = message.details && message.details.length > 0 && message.details[0].message;
						if(detail){
							content += "<div>" + detail + "</div>"; //$NON-NLS-1$ //$NON-NLS-2$
						}
						div.innerHTML = content;
						return div;
					});
				}
			}
		}else{
			this._removeIcon();
		}
	},
	
	_removeIcon: function(){
		if(this.iconNode){
			this.removeChild(this.iconNode);
			this.iconNode.destroy();
			delete this.iconNode;
			delete this._infoIcon;
		}		
	},
	
	setLoading: function(loading){
		if(loading){
			this.showIcon(loadingIconURL);
		}else{
			this.showIcon();
		}
	},
	
	setError: function(error, message){
		if(error){
			this.showIcon(errorIconURL, message);
		}else{
			this.showIcon();
		}
	},
	
	getLayoutManager: function(){
		var layoutType = this.getLayout();
		if(layoutType){
			if(layoutType.indexOf('.') < 0){ //$NON-NLS-1$
				layoutType = "com.ibm.relm.explorer.web.ui.internal.view.layout." + layoutType; //$NON-NLS-1$
			}
			try {
	    		dojo.require(layoutType);
	    		var ctor = dojo.getObject(layoutType);
	    		if(ctor){
	    			return new ctor();
	    		}					
			}catch(e){
				console.error(e);
			}
		}
		return new com.ibm.relm.explorer.web.ui.internal.view.layout.DefaultLayout();
	},
	
	createShape: function() {
		if (this.getHidden()) return;
		this.inherited(arguments);
	},
	
	getOutputTagName: function(){
		return this.componentInfoId;
	},
	
	editModeChanged: function(editMode){
		if(this.shape){
			if(!this.getFill()){
				if(!this.getHidden() && editMode){
					this.shape.setFill([255, 255, 255, 0.1]); 
				}else{
					this.shape.setFill(""); //$NON-NLS-1$
				}
			}
			if(!this.getStroke()){
				if(!this.getHidden() && editMode){
					this.shape.setStroke({color: "#aaaaaa", style: "ShortDot"}); //$NON-NLS-1$ //$NON-NLS-2$
				}else{
					this.shape.setStroke(""); //$NON-NLS-1$
				}
			}
		}		
	},
	
	/*
	 * Called when drag and drop in View
	 * see DragMoveTracker.onDragEnd
	 */
	componentMoveHandler: function(e, tool, movedWidget){
		if(!this._getEditMode()) 
			return false;
		var lm = this._layoutManager; 
		if(lm && lm.componentMoveHandler){
			lm.componentMoveHandler(e, tool, movedWidget);
			return true;
		}
		return false;
	},
	
	/*
	 * Called when drag and drop from palette.
	 * see DefaultCreatetionTool.handleDrop
	 */
	componentDropHandler: function(e, tool){
		var lm = this._layoutManager; 
		if(lm && lm.componentDropHandler){
			lm.componentDropHandler(e, tool);
			return true;
		}
		return false;
	},
	
	getCaretRect: function(e){
		var lm = this._layoutManager; 
		if(lm && lm.getCaretRect){
			return lm.getCaretRect(e);
		}
		return null;
	},
	
	destroyQueryResultChildren: function(){
		dojo.forEach(this.getChildren(), function(widget){
			if(widget.preventSave && widget.destroyRecursive){
				widget.destroyRecursive();
			}
		}); 
	},
	
	_getEditMode: function(){
		if (this.getHidden())
			return false;
		
		if(this.hlp_getEditor){
			return this.hlp_getEditor()._editMode;
		}
		return false;
	},
	
	getDecorationIcon: function() {
		return (this.elementId && this._getEditMode()) ? artifactElementIconURL : null;
	},
	
	_updateConnectable: function() {
		var id = this.getId();
//		this.connectable = !this.getHidden() && id && id.length > 0;
		this.connectable = !this.getHidden() && id && id.length > 0 && this.elementId;
	},
	
	hlp_beforeRemoveChild: function(parent, widget) {
		// preserve current domNode for undoing the remove action
		var source = this.hlp_getEditor().generate(widget);
		var layout = dojox.xml.parser.parse(source).firstChild;
		if (layout) {
			this._domNode = layout.firstElementChild;
		}
	}
});

})();