/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.ConfigUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.hover.GfxRichHover"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.hover.GfxRichResourceHover"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.AbstractLine"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.SelectionDialog"); //$NON-NLS-1$
dojo.require("jazz.ui.Menu"); //$NON-NLS-1$
dojo.require("jazz.ui.menu.MenuItem"); //$NON-NLS-1$
dojo.require("jazz.util.html"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "utilMessages"); //$NON-NLS-1$ //$NON-NLS-2$


(function(){

jazz.core.loader.batch_load_async([
	'com.ibm.relm.explorer.web.ui.internal.hover.PropHoverContent', //$NON-NLS-1$
	'com.ibm.relm.explorer.web.ui.internal.hover.HoverContent'], function() { //$NON-NLS-1$
	// no op	

	// FIXME: This class has a circular dependency with NodeUtils. This cause problems with the Jazz loader, so defer loading of these.
});


var prefixesLoaded = false;

var PREDEFINED_PREFIXES_AND_NS = [
	{ prefix: "dcterms", namespace: "http://purl.org/dc/terms/"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "rdf", namespace: "http://www.w3.org/1999/02/22-rdf-syntax-ns#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "rdfs", namespace: "http://www.w3.org/2000/01/rdf-schema#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "xsd", namespace: "http://www.w3.org/2001/XMLSchema#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "ldp", namespace: "http://www.w3.org/ns/ldp#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "oslc", namespace: "http://open-services.net/ns/core#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "oslc_am", namespace: "http://open-services.net/ns/am#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "oslc_asset", namespace: "http://open-services.net/ns/asset#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "oslc_cm", namespace: "http://open-services.net/ns/cm#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "oslc_qm", namespace: "http://open-services.net/ns/qm#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "oslc_rm", namespace: "http://open-services.net/ns/rm#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "oslc_config", namespace: "http://open-services.net/ns/config#"}, //$NON-NLS-1$ //$NON-NLS-2$
	{ prefix: "rtc_cm", namespace: "http://jazz.net/xmlns/prod/jazz/rtc/cm/1.0/"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "rqm_qm", namespace: "http://jazz.net/ns/qm/rqm#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "pd", namespace: "http://jazz.net/ns/pd#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "pd_ext", namespace: "http://jazz.net/ns/pd/extensions#"}, //$NON-NLS-1$ //$NON-NLS-2$
	{ prefix: "dm_diagram", namespace: "http://jazz.net/ns/dm/diagram#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "dm_document", namespace: "http://jazz.net/ns/dm/document#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "dm_linktypes", namespace: "http://jazz.net/ns/dm/linktypes#"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "foaf", namespace: "http://xmlns.com/foaf/0.1/"}, //$NON-NLS-1$//$NON-NLS-2$
	{ prefix: "prov", namespace: "http://www.w3.org/ns/prov#"} //$NON-NLS-1$ //$NON-NLS-2$
	];
                    
var PREDEFINED_PREFIXES = "";//$NON-NLS-1$
var PREDEFINED_PREFIX = "";//$NON-NLS-1$
var LINK_QUERY_SPARQL = "";//$NON-NLS-1$
var HOVER_LINK_QUERY_SPARQL = "";//$NON-NLS-1$
var CALC_STATUS_QUERY_SPARQL = "";//$NON-NLS-1$
var INITIAL_SPARQL_CONTENT = "";//$NON-NLS-1$

var DEFAULT_CONNECTION_COMPONENT = "baseConnection"; //$NON-NLS-1$

var DEFAULT_LINK_TARGET = "_blank"; //$NON-NLS-1$

var _messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "utilMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var connectionDirCache = {};

var configUtils = com.ibm.relm.explorer.web.ui.internal.ConfigUtils;
var SelectionDialog = com.ibm.relm.explorer.web.ui.internal.view.common.SelectionDialog;

var nodeUtils = {};

var BR_PLACEHOLDER = "_relm_br_"; //$NON-NLS-1$ 

dojo.mixin(nodeUtils, {
	reset: function(){
		PREDEFINED_PREFIXES = dojo.map(PREDEFINED_PREFIXES_AND_NS, function(ns){
			return "PREFIX " + ns.prefix + ": <" + ns.namespace + ">"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		});

		PREDEFINED_PREFIX = PREDEFINED_PREFIXES.join('\n') + '\n'; //$NON-NLS-1$ //$NON-NLS-2$

		LINK_QUERY_SPARQL = 
			PREDEFINED_PREFIX + 
			"SELECT *\n" + //$NON-NLS-1$
			"WHERE {\n" + //$NON-NLS-1$
			"  {\n" + //$NON-NLS-1$
			"  		${linksPart}  " + //$NON-NLS-1$
			"  }\n" + //$NON-NLS-1$
			"}"; //$NON-NLS-1$

		HOVER_LINK_QUERY_SPARQL = 
			PREDEFINED_PREFIX + 
			"SELECT *\n" + //$NON-NLS-1$
			"WHERE {\n" + //$NON-NLS-1$
			"  {\n" + //$NON-NLS-1$
			"  		${linksPart}  " + //$NON-NLS-1$
			"  }\n" + //$NON-NLS-1$
			"  OPTIONAL { \n" + //$NON-NLS-1$
			"  		?target dcterms:identifier ?targetId .\n" + //$NON-NLS-1$
			"  }\n" + //$NON-NLS-1$
			"  OPTIONAL { \n" + //$NON-NLS-1$
			"		{\n" + //$NON-NLS-1$
			"  		?target dcterms:title ?targetTitle .\n" + //$NON-NLS-1$
			"		} UNION {\n" + //$NON-NLS-1$
			"  		?target foaf:name ?targetTitle .\n" + //$NON-NLS-1$
			"		}\n" + //$NON-NLS-1$
			"  }\n" + //$NON-NLS-1$
			"}"; //$NON-NLS-1$

		CALC_STATUS_QUERY_SPARQL = 
			PREDEFINED_PREFIX + 
			"SELECT *\n" + //$NON-NLS-1$
			"WHERE {\n" + //$NON-NLS-1$
			"  {\n" + //$NON-NLS-1$
			"  		${linksPart}  " + //$NON-NLS-1$
			"  }\n" + //$NON-NLS-1$
			"  OPTIONAL { \n" + //$NON-NLS-1$
			"  		?target dcterms:identifier ?targetId .\n" + //$NON-NLS-1$
			"  }\n" + //$NON-NLS-1$
			"  OPTIONAL { \n" + //$NON-NLS-1$
			"  		?target dcterms:title ?targetTitle .\n" + //$NON-NLS-1$
			"  }\n" + //$NON-NLS-1$
			"  OPTIONAL { \n" + //$NON-NLS-1$
			"  		?target \n" + //$NON-NLS-1$
			"				oslc_cm:inprogress ?status_inprogress ;\n" + //$NON-NLS-1$
			"				oslc_cm:fixed ?status_fixed ;\n" + //$NON-NLS-1$
			"				oslc_cm:closed ?status_closed ;\n" + //$NON-NLS-1$
			"				oslc_cm:status ?status .\n" + //$NON-NLS-1$
			"  }\n" + //$NON-NLS-1$
			"}"; //$NON-NLS-1$

		INITIAL_SPARQL_CONTENT =
			"# Sample SPARQL \n" + //$NON-NLS-1$
		   	"PREFIX dcterms: <http://purl.org/dc/terms/>\n" + //$NON-NLS-1$
			"PREFIX oslc: <http://open-services.net/ns/core#>\n" + //$NON-NLS-1$
			"PREFIX oslc_cm: <http://open-services.net/ns/cm#>\n" + //$NON-NLS-1$
		    "\n" + //$NON-NLS-1$
		    "SELECT * \n" + //$NON-NLS-1$
		    "WHERE {\n" + //$NON-NLS-1$
		    "   ?resource \n" + //$NON-NLS-1$
		    "       dcterms:identifier ?id;\n" + //$NON-NLS-1$
		    "       dcterms:title ?title;\n" + //$NON-NLS-1$
		    "       dcterms:contributor ?contributor;\n" + //$NON-NLS-1$
		    "       dcterms:modified ?modified;\n" + //$NON-NLS-1$
			"       OPTIONAL { \n" + //$NON-NLS-1$
			"           ?resource oslc:shortTitle ?shortTitle .\n" + //$NON-NLS-1$
		    "       }\n" + //$NON-NLS-1$
			"       OPTIONAL { \n" + //$NON-NLS-1$
		    "           ?resource oslc_cm:status ?status .\n" + //$NON-NLS-1$
		    "       }\n" + //$NON-NLS-1$
		    "       OPTIONAL {\n" + //$NON-NLS-1$
		    "           ?resource dcterms:description ?description .\n" + //$NON-NLS-1$
		    "       }\n" + //$NON-NLS-1$
		    "#  FILTER regex (str(?title), \"^Plan\")\n" + //$NON-NLS-1$
		    "   ?resource a ?type;\n" + //$NON-NLS-1$
		    "}\n" + //$NON-NLS-1$
		    "ORDER BY ASC(?title)\n" + //$NON-NLS-1$
		    "LIMIT 10\n" ; //$NON-NLS-1$

		nodeUtils.PREDEFINED_PREFIX = PREDEFINED_PREFIX;
		nodeUtils.OPEN_LINK_TARGET = DEFAULT_LINK_TARGET;
		nodeUtils.INITIAL_SPARQL_CONTENT = INITIAL_SPARQL_CONTENT;
	},
	
	loadPredefinedPrefixesAndNamespaces: function(includesNS){
		includeNS = includesNS || true;
		if(!prefixesLoaded){
			var deferred = new dojo.Deferred();
			jazz.client.xhrGet({
				url: com.ibm.relm.explorer.web.ui.queryServiceUri + "?method=vocabularies", //$NON-NLS-1$
				handleAs: "json", //$NON-NLS-1$
				load: function(data){
					if(data){
						PREDEFINED_PREFIXES_AND_NS = data;
						nodeUtils.reset();
					}
				},
				handle: function(){
					deferred.callback(includesNS ? PREDEFINED_PREFIXES_AND_NS : PREDEFINED_PREFIXES);
				}
			});
			// only try loading the prefixes once otherwise fall back to the defaults only
			prefixesLoaded = true;
			return deferred;
		} 
		else 
			return (includesNS ? PREDEFINED_PREFIXES_AND_NS : PREDEFINED_PREFIXES);
	},
	
	loadPredefinedPrefixes: function(){
		return this.loadPredefinedPrefixesAndNamespaces(false);
	},
	
	getPredefinedPrefixesAndNamespaces : function(){
		return PREDEFINED_PREFIXES_AND_NS;
	},
	
	makeUriPrefixed: function(uri){
		var all = this.getPredefinedPrefixesAndNamespaces();
		for(var i=0; i<all.length; i++){
			var ns = all[i].namespace;
			if(uri.indexOf(ns) == 0){
				return all[i].prefix + ":" + uri.substring(ns.length);//$NON-NLS-1$
			}
		}
		return null;
	},
	
	setOpenInSameWindow: function() {
		this.OPEN_LINK_TARGET = ""; //$NON-NLS-1$
	},
	
	setOpenInNewWindow: function() {
		this.OPEN_LINK_TARGET = "_blank"; //$NON-NLS-1$
	},
	
	replaceAll: function(string, from, to){
		if (!string) return string;
		return string.split(from).join(to);
	},

	createRichHover: function(nodeWidget, item){
		if (item.props && item.props.length > 0) {
			// create another hover in this case
			return this._createRichHoverFromProps(nodeWidget, item);
		}
		
		var r = item.resource;
		return this._createRichHover(nodeWidget, function(){
			var shortTitle = r["shortTitle"] || {}; //$NON-NLS-1$
			var title = r["title"] || {}; //$NON-NLS-1$
			var contentInfo = {
				title: shortTitle.value || title.value || "", //$NON-NLS-1$
				uri: nodeWidget.uri
			};
			if(shortTitle.value && title.value){
				contentInfo["summary"] = title.value; //$NON-NLS-1$
			}
			// create a new rich hover with the target or
			// if rich hover already exists then set the target item to the rich hover
			this._contentWidget = new com.ibm.relm.explorer.web.ui.internal.hover.HoverContent({
				contentInfo: contentInfo
			});
			return this._contentWidget.domNode;
		});	
	},
	
	_createRichHoverFromProps: function(nodeWidget, item){
		
		var r = item.resource;
		var config = nodeWidget._viewer.config;
		var uri = nodeWidget.uri;
		var containerParams = nodeWidget.getParent && nodeWidget.getParent()._params;
		var props = dojo.map(item.props, function(prop){
			var p = prop;
			return {
				label: prop.label,
				layout: prop.layout,
				variable: prop.name, 
				query: function(callback, errorCallback){
					var sparql = null;
					var dummySparqlResult = null;
					var parameterValues = null;
					if (p.baseQueryId == "__node_property__"){//$NON-NLS-1$
						var target = r[p.name]; 
						dummySparqlResult= [{ 
							targetTitle: { value: (target && target.value) || " " } //$NON-NLS-1$ //$NON-NLS-2$
						}];						
					} else if (p.baseQueryId && uri) {
						// build SPARQL from link query
						var queryTemplate = config.getQueryTemplate(p.baseQueryId);
						var linkQuery = queryTemplate && queryTemplate.sparql;
						if(linkQuery){
							linkQuery = nodeUtils.replaceAll(linkQuery, "${source}", uri); //$NON-NLS-1$
							// replace by params defined in 1. <container> 2. <view> 3. <queryTemplate>
							var configParams = nodeUtils.getParamValue(config.params);
							var queryParams = nodeUtils.getParamValue(queryTemplate.params);
							var paramArray = [containerParams, configParams, queryParams];
							linkQuery = configUtils.evalParamsArray(linkQuery, paramArray, null, true);
							parameterValues = configUtils.getParameterValuesFromParamArray(paramArray);
						}
						sparql = linkQuery;
					} else {
						// prepare dummy result for pre-defined property name
						if ("shortTitle" == p.name) { //$NON-NLS-1$
							var shortTitle = r["shortTitle"]; //$NON-NLS-1$
							dummySparqlResult= [{ 
								targetTitle: { type: "literal", value: (shortTitle && shortTitle.value) || "" }, //$NON-NLS-1$ //$NON-NLS-2$
								target:      { type: "uri", value: uri } }]; //$NON-NLS-1$
						} else if ("titleWithLink" == p.name) { //$NON-NLS-1$
							var title = r["title"]; //$NON-NLS-1$
							dummySparqlResult= [{ 
								targetTitle: { type: "literal", value: (title && title.value) || "" }, //$NON-NLS-1$ //$NON-NLS-2$
								target:      { type: "uri", value: uri } }]; //$NON-NLS-1$
						} else if ("title" == p.name) { //$NON-NLS-1$
							var title = r["title"]; //$NON-NLS-1$
							dummySparqlResult= [{ 
								targetTitle: { type: "literal", value: (title && title.value) || "" } //$NON-NLS-1$ //$NON-NLS-2$
							}];
						} else if ("resourceType" == p.name) { //$NON-NLS-1$
							var resourceType = r["resourceType"]; //$NON-NLS-1$
							dummySparqlResult= [{ 
								targetTitle: { type: "literal", value: (resourceType && resourceType.value) || "" } //$NON-NLS-1$ //$NON-NLS-2$
								 }];
						}
						// when the "name" is not pre-defined one, build SPARQL //$NON-NLS-1$
						if (!dummySparqlResult){
							sparql = nodeUtils._buildSparql(uri, [{type:p.name}], HOVER_LINK_QUERY_SPARQL);
						}
					}
					
					if (sparql) {
						// execute sparql via xhr
						var content ={ 
							category: "linksInHover", //$NON-NLS-1$
							sparql: sparql,
							format: false
						};
						if(parameterValues){
							content.parameterValues = dojo.toJson(parameterValues);
						}
						var queryServiceUrl = com.ibm.relm.explorer.web.ui.queryServiceUri;
						jazz.client.xhrPost({
							url: queryServiceUrl,
							headers: {"Accept":"application/json"}, //$NON-NLS-1$ //$NON-NLS-2$
							content: content, 
							handleAs: "json", //$NON-NLS-1$
							load: function(response, ioargs){
								var links = response.results.bindings;
								callback(links, response, ioargs);
							},
							error: function(response, ioargs){
								errorCallback(response.message, response);
							} });
					} else {
						if (dummySparqlResult) {
							callback(dummySparqlResult);
						} else {
							errorCallback("Unresolved hover property name: " + p.name); //$NON-NLS-1$
						}
					}
				}
			};
		});
		
		return this._createRichHover(nodeWidget, function(){
			// create a new rich hover with the target or
			// if rich hover already exists then set the target item to the rich hover
			this._contentWidget = new com.ibm.relm.explorer.web.ui.internal.hover.PropHoverContent({
				contentInfo: { props: props }
			});
			return this._contentWidget.domNode;
		});
	},
	
	_createRichHover: function(nodeWidget, createContents){
		if(!nodeWidget.group){
			return null;
		}
		var hover = null;
		var props = {
				owner: nodeWidget,
				shape: nodeWidget.group,
				around: nodeWidget.group.rawNode,
				orientation: nodeWidget.hoverOrientation,
				createOwnContents: dojo.hitch(hover, createContents)				
		};
		if (nodeWidget.uri) {
			dojo.mixin(props, {
				uri: nodeWidget.uri, 
				lazyFetch: true				
			});
			hover = new com.ibm.relm.explorer.web.ui.internal.hover.GfxRichResourceHover(props);
		}else{
			hover = new com.ibm.relm.explorer.web.ui.internal.hover.GfxRichHover(props);
		}
		hover.connect(nodeWidget, "destroy", function(){ //$NON-NLS-1$
			hover.destroy();
		});
		return hover;
	},
	
	createHoverActions: function(group, actionInfo, owner){
		var spacing = 1, defaultSize = 12, margin = 2;
		group.rawNode.style.cursor = "pointer"; //$NON-NLS-1$
		
		var bar = group.createGroup();
		
		var x_sum = margin;
		dojo.forEach(actionInfo, function(info, idx){
			// add action icon
			var w = info.width || defaultSize;
			var icon = bar.createImage({
				x: x_sum+spacing,
				y: margin,
				width: w,
				height: defaultSize,
				src: info.src
			});
			x_sum += w+2*spacing;
			owner.connect(icon.rawNode, "onclick", function(){ //$NON-NLS-1$
				info.onclick(icon);
			});
			icon.rawNode.setAttribute("title", info.title); //$NON-NLS-1$
			
			// add hover feedback shape
			owner.connect(icon.rawNode, "onmouseover", function(){ //$NON-NLS-1$
				if(!owner._hoverShape){
					owner._hoverShape = bar.createRect({
						r: 2
					}).setStroke("#F48A0E").setFill("#FDDCA7"); //$NON-NLS-1$ //$NON-NLS-2$
					owner._hoverShape.moveToBack();
				}
				var bb = icon.getBoundingBox();
				owner._hoverShape.setShape({
					x: bb.x-spacing,
					y: bb.y-spacing,
					width: bb.width+2*spacing,
					height: bb.height+2*spacing
				});
				owner._hoverShape.rawNode.style.display = ""; //$NON-NLS-1$
			});
			owner.connect(icon.rawNode, "onmouseout", function(){ //$NON-NLS-1$
				if(owner._hoverShape){
					owner._hoverShape.rawNode.style.display = "none"; //$NON-NLS-1$
				}
			});
		});
		var figHeight = defaultSize + margin*2;
		group.createRect({
			x: 0,
			y: 0,
			width: x_sum + margin, 
			height: figHeight,
			r: 2
		}).setFill({
			type: "linear", x1: 0, y1: 0, x2: 0, y2: figHeight, //$NON-NLS-1$
			colors: [
				{ offset: 0, color: "#FFFFFF" }, { offset: 1, color: "#D9D9D9" } //$NON-NLS-1$ //$NON-NLS-2$
			]
		}).setStroke({color: [205,183,158, 1], width: 1}).moveToBack();
	},

	/**
	 * Gets the absolute position of a diagram shape. This is relative to the entire
	 * page is a root shapeLayer is given. Otherwise, relative to the its root layer.
	 * @param  {???} shape      the shape to get the position of.
	 * @param  {Widget} shapeLayer the root layer the same is part of.
	 * @return {object}            the x, y, w, and h dimensions of the shape.
	 */
	shapePosition: function(shape, shapeLayer) {
		var corners = shape.getTransformedBoundingBox();
		var topLeft = corners[0];
		var bottomRight = corners[2];
		// Corners are relative to the layer, but the menu should be absolute
		// on the page, so adjust based on layer pos. I'm pretty sure this can't be //$NON-NLS-1$
		// null, but I'll check just incase.
		var layerPos = shapeLayer ?
			dojo.position(shapeLayer.domNode) :
			{x: 0, y: 0};
			
		return {
			x: topLeft.x + layerPos.x,
			y: topLeft.y + layerPos.y,
			w: bottomRight.x - topLeft.x,
			h: bottomRight.y - topLeft.y
		};
	},

	/**
	 * Checks if a mouse event looks like it's a right-click. Right-click will
	 * send a contextmenu event, but can also send a mousedown event that we
	 * may want to ignore when there is a dedicated contextmenu event handler.
	 * 
	 * @param  {mouse event}  event
	 * @return {Boolean}      true if it's a right-click event.
	 */
	isRightClick: function(event) {
		if (event.which) {
			return event.which === 3;
		}
		else if (event.button) {
			return event.button === 2;
		}

		return false;
	},

	/**
	 * Creates and shows a new menu widgets for the given
	 * menu info actions.
	 * @param  {object} nodeWidget the node widget that the menu acts on. Must
	 *     be a node (e.g., ResourceNode) since this is passed to action that
	 *     expected.
	 * @param  {array} menuInfos  array of objects to create menus items for.
	 * @param  {int} x          
	 * @param  {int} y          
	 * @return {jazz.ui.Menu} menu that will self-destroy on blur.
	 */
	createAndPopupMenu: function(nodeWidget, menuInfos, x, y) {
		if (!menuInfos || menuInfos.length == 0) return null;
		
		var menu = this._createMenu(nodeWidget, menuInfos);
		
		menu.startup();

		this.popupMenu(nodeWidget, menu, x, y);
		return menu;
	},

	_createMenu: function(nodeWidget, menuInfos) {
		var selectable = dojo.some(menuInfos, function(info) {return info["selected"] != undefined;}); //$NON-NLS-1$
		var menu = new jazz.ui.Menu({selectable: selectable});

		// Must be higher than RichHovers
		menu.domNode.style.zIndex = 10001;

		var self = this;
		// create menu items
		dojo.forEach(menuInfos, function(info){
			var menuItem;
			if (info == 'separator') { //$NON-NLS-1$
				menuItem = new dijit.MenuSeparator();
			} else if (info.isGroup) {
				var submenu = self._createMenu(nodeWidget, info.menuInfos);
				menuItem = new dijit.PopupMenuItem({
					iconClass: info.iconClass || null,
					label: info.label, 
					popup: submenu 
				});
				// workaround for align folder menu item to others
				if (menuItem.domNode.firstElementChild)
					menuItem.domNode.firstElementChild.style.width = "10px"; //$NON-NLS-1$
			} else {
				menuItem = new jazz.ui.menu.MenuItem({
					iconClass: info.iconClass || null,
					label: info.label, 
					onClick: function(evt){
						info.onClick(nodeWidget, evt);
					},
					selected: info.selected,
					disabled: info.disabled
				});
			}

			menu.addChild(menuItem);
		});
		
		return menu;
	},
	
	/**
	 * Display an existing menu widget on screen. Adds events listeners that
	 * will destroy the menu onblur after an items is chosen or the menu is
	 * canceled.
	 * @param  {object} parentWidget parent widget for this menu. 
	 * @param  {jazz.ui.Menu} menu         
	 * @param  {int} x            
	 * @param  {int} y            
	 */
	popupMenu: function(parentWidget, menu, x, y) {
		var popupArgs = {
			parent: parentWidget,
			popup: menu,
			x: x,
			y: y,

			orient: {BL:'TL', BR:'TR', TL:'BL', TR:'BR'}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$

			onClose: dojo.hitch(this, function() {
				menu.destroyRecursive();
				if(parentWidget && parentWidget._viewer){
					parentWidget._viewer.setFocus(parentWidget);
				}
			}),

			onCancel: function() {
				dijit.popup.close(menu);
			},

			onExecute:  function(e) {
				dijit.popup.close(menu);
			}
		};

		menu.connect(menu, 'onBlur', function() { //$NON-NLS-1$
			// Occassionally, the context menus are missing their icons, but
			// it's very hard to reproduce. If this happens, you can call run
			// this in the Firebug console to keeps menus open onblur to
			// inspect them in Firebug.
			// 	 		dojo.setObject('com.ibm.relm.debug.menus.noCloseOnBlur', true); //$NON-NLS-1$
			if (dojo.getObject('com.ibm.relm.debug.menus.noCloseOnBlur')) return; //$NON-NLS-1$

			dijit.popup.close(menu);
		});

		dijit.popup.open(popupArgs);
		menu.focus();
	},

	getLinkQuery: function(linkDef, config, dynamicPrams){
		var sparql = null;
		var parameters = null;
		if(linkDef.baseQueryId){
			// query is specified
			var queryTemplate = config.getQueryTemplate(linkDef.baseQueryId);
			sparql = queryTemplate && queryTemplate.sparql;
			if(sparql){
				// replace by params defined in 1.<connection><links> 2. <view> 3. <queryTemplate>
				var connParams = nodeUtils.getParamValue(linkDef.params);
				var configParams = nodeUtils.getParamValue(config.params);
				var queryParams = nodeUtils.getParamValue(queryTemplate.params);
				var paramArray = [dynamicPrams, connParams, configParams, queryParams];
				sparql = configUtils.evalParamsArray(sparql, paramArray, null, true);
				parameters = configUtils.getParameterValuesFromParamArray(paramArray);
			}
		}else if(linkDef.params.length > 0){
			// <param> nodes are specified
			sparql = nodeUtils._buildSparql(null, nodeUtils.getParamValue(linkDef.params), LINK_QUERY_SPARQL);
		}else if(linkDef.type){
			// type attribute is specified
			sparql = nodeUtils._buildSparql(null, [linkDef], LINK_QUERY_SPARQL);
		}else{
			// error
		}
		return {sparql: sparql, parameterValues: parameters};
	},
	
	createConnections: function(linkDefs, viewer, params){
		var queryServiceUrl = com.ibm.relm.explorer.web.ui.queryServiceUri;
		var config = viewer.config;
		var deferredArray = dojo.map(linkDefs, function(connectionLinkDef){
			if(connectionLinkDef.treeOnly && connectionLinkDef.treeOnly !== "false")//$NON-NLS-1$
				return;
			var query = nodeUtils.getLinkQuery(connectionLinkDef, config, params);
			var sparql = query.sparql;
			if(sparql){
				// if not custom query, we use VALUES to reduce the number of result resources to resources displayed in the current view
				if(!connectionLinkDef.baseQueryId || connectionLinkDef.useBindings){
					sparql += " VALUES ?source {"; //$NON-NLS-1$
					for(var resourceUri in viewer.getAllResources()){
						sparql += "<" + resourceUri + "> "; //$NON-NLS-1$ //$NON-NLS-2$
					}
					sparql += "}"; //$NON-NLS-1$
				}
				
				var componentType = (connectionLinkDef.component && connectionLinkDef.component.type) || DEFAULT_CONNECTION_COMPONENT;
				var direction = nodeUtils._getConnectionDirection(viewer, componentType);
				
				var cachedResult = viewer._getCachedResult && viewer._getCachedResult(sparql, query.parameterValues);
				var xhr;
				if(cachedResult){
					xhr = new dojo.Deferred();
					setTimeout(function(){xhr.callback(cachedResult); }, 10);
				}else{
					var content ={ 
						category: "connections", //$NON-NLS-1$
						sparql: sparql,
						format: false
					};
					if(query.parameterValues){
						content.parameterValues = dojo.toJson(query.parameterValues);
					}
					xhr = jazz.client.xhrPost({
						url: queryServiceUrl,
						headers: {"Accept":"text/json"}, //$NON-NLS-1$ //$NON-NLS-2$
						content: content, 
						handleAs: "json", //$NON-NLS-1$
						error: function(response, ioargs){
							console.error(decodeURIComponent(ioargs.query) + "\n" + ioargs.xhr.responseText); //$NON-NLS-1$
						}
					});
				}
				xhr.addCallback(function(response){
					if(viewer._addCachedResult){
						viewer._addCachedResult(sparql, query.parameterValue, response);
					}  
					var links = response.results.bindings;
					dojo.forEach(links, function(link){
						nodeUtils._createConnection(viewer, link, connectionLinkDef, componentType, direction);
					});
				});
				return xhr;
			}
		});
		return dojo.filter(deferredArray, function(deferred){
			return deferred; // exist or not
		});
	},
	
	/*
	 * link: {source: {value: sourceUri}, target: {value: targetUri}}
	 */
	_createConnection: function(viewer, link, linkDef, componentType, direction){
		if(!link["source"] || !link["target"]) //$NON-NLS-1$ //$NON-NLS-2$
			return;
		var source = link["source"].value; //$NON-NLS-1$
		var target = link["target"].value; //$NON-NLS-1$
		var sourceids = viewer.uriToIds(source);
		var targetids = viewer.uriToIds(target);
		dojo.forEach(sourceids, function(sourceId){
			var sourceWidget = dijit.byId(sourceId);
			if(sourceWidget){
				dojo.forEach(targetids, function(targetId){
					var targetWidget = dijit.byId(targetId);
					if(targetWidget) {
						if(linkDef.targetProps && linkDef.targetProps.length > 0){
							var mismatch = dojo.every(linkDef.targetProps, function(target){
								return dojo.some(target, function(targetProp){
									var targetPropName = link[targetProp.name];
									if(!targetPropName || targetPropName.value != targetProp.value){
										return true;
									}
								});
							});
							if(mismatch){
								return;
							}
						}
						var componentParams = linkDef.component && linkDef.component.params;
						var lineWidget = nodeUtils.createConnectionWidget(sourceWidget, targetWidget, componentType, componentParams, direction, link);
						if(!lineWidget) {
							return;
						}
						if(linkDef.id) {
							lineWidget.linkId = linkDef.id;
						}
						
						viewer.addChild(lineWidget);
						
						// rich hoer
						nodeUtils._createRichHoverForConnection(lineWidget, linkDef);
						
						// start
						lineWidget.startup();
						viewer._links.push(lineWidget);
					}
				});
			}
		});
	},
	
	createConnectionWidget: function(sourceWidget, targetWidget, componentType, componentParams, direction, queryResult){
		var viewer = sourceWidget._viewer;
		if(!componentType) componentType = DEFAULT_CONNECTION_COMPONENT;
		if(!direction) direction = nodeUtils._getConnectionDirection(viewer, componentType);
		var params = {
			sourceAnchor: sourceWidget.id+":base", //$NON-NLS-1$
			targetAnchor: targetWidget.id+":base", //$NON-NLS-1$
			startDir: sourceWidget.startDir || direction.startDir,
			endDir: sourceWidget.endDir || direction.endDir
		};
		if(componentParams) {
			var connParams = nodeUtils.getParamValue(componentParams);
			if(queryResult){
				connParams = nodeUtils.evalParameters(connParams, queryResult);
			}
			dojo.safeMixin(params, connParams);								
		}
		var lineWidget = viewer.createComponent(componentType, params);
		if(! (lineWidget instanceof com.ibm.relm.explorer.web.base.internal.gdc.AbstractLine)) {
			lineWidget.destroy();
			console.error(componentType + " is not a component for connections. Please check the component definition in configuration file."); //$NON-NLS-1$
			return null;
		}
		// properties from query result
		if(queryResult){
			dojo.safeMixin(lineWidget, nodeUtils._loadPropsFromQueryResult(viewer.getAttributes(lineWidget), queryResult));
		}
		return lineWidget;
	},
	
	_createRichHoverForConnection: function(widget, definition){
		var props = [];
		if(definition.title){
			props.push({
				label: _messages.title,
				query: function(callback, errorBack){
					callback([{targetTitle: {value: definition.title}}]);
				}
			});
		}
		if(definition.path){
			props.push({
				label: _messages.linkPath,
				query: function(callback, errorBack){
					callback([{targetTitle: {value: definition.path}}]);
				}
			});
		}
		if(definition.type){
			props.push({
				label: _messages.linkType,
				query: function(callback, errorBack){
					var shortName = definition.type;
					var last = shortName.lastIndexOf("."); //$NON-NLS-1$
					if(last > 0 && last < shortName.length-1){
						shortName = shortName.substring(last + 1);
					}
					callback([{targetTitle: {value: shortName, tooltip: definition.type}}]);
				}
			});
		}
		
		return this._createRichHover(widget, function(){
			this._contentWidget = new com.ibm.relm.explorer.web.ui.internal.hover.PropHoverContent({
				contentInfo: { props: props }
			});
			return this._contentWidget.domNode;
		});
	},
	
	/*
	 * arguments:
	 * 	statausRequests: array of {resourceUri: resourceUri, linkTypes: []}
	 * 	callbacks: array of function
	 */
	queryLinkedStatus: function(statusRequests, callbacks){
		var deferred = jazz.client.xhrPost({
			url: com.ibm.relm.explorer.web.ui.queryServiceUri,
			headers: {"Accept":"application/json"}, //$NON-NLS-1$ //$NON-NLS-2$
			content: {
				category: "status", //$NON-NLS-1$
				sparql: nodeUtils._buildSparqlForStatus(statusRequests)
			},
			handleAs: "json", //$NON-NLS-1$
			load: function(response, ioargs){
				dojo.forEach(callbacks, function(callback){
					callback(response, ioargs);
				});
			},
			error: function(response, ioargs){
				response.ioargs = ioargs;
				console.error(decodeURIComponent(ioargs.query) + "\n" + ioargs.xhr.responseText); //$NON-NLS-1$
			}
		});
		
		return deferred;
	},

	getStatus: function(resource){
		var status = resource.status && resource.status.value;
		if(resource.status_inprogress){
			if(resource.status_inprogress.value === "true"){ //$NON-NLS-1$
				status = "InProgress"; //$NON-NLS-1$
			}else if(resource.status_inprogress.value === "false"){ //$NON-NLS-1$
				status = "New"; //$NON-NLS-1$
			}
		}
		if(resource.status_fixed && resource.status_fixed.value === "true"){ //$NON-NLS-1$
			status = "Resolved"; //$NON-NLS-1$
		}
		if(resource.status_closed && resource.status_closed.value === "true"){ //$NON-NLS-1$
			status = "Closed"; //$NON-NLS-1$
		}
		return status || null;
	},
	
	/*
	 * get status from well known status word
	 */
	getStatusIconUrl: function(status){
		var baseUrl = net.jazz.ajax._contextRoot + "/web/com.ibm.relm.explorer.web/ui/internal/view/images/"; //$NON-NLS-1$
		if(status == "New" || status == "Not Done"){ //$NON-NLS-1$ //$NON-NLS-2$
			iconUrl = baseUrl + "state_open.gif"; //$NON-NLS-1$
		}
		else if(status == "Reopened"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_reopened.gif"; //$NON-NLS-1$
		}
		else if(status == "InProgress" || status == "In Progress"){ //$NON-NLS-1$ //$NON-NLS-2$
			iconUrl = baseUrl + "state_inprogress.gif"; //$NON-NLS-1$
		}
		else if(status == "Resolved"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_resolved.gif"; //$NON-NLS-1$
		}
		else if(status == "Closed" || status == "Done"){ //$NON-NLS-1$ //$NON-NLS-2$
			iconUrl = baseUrl + "state_closed.gif"; //$NON-NLS-1$
		}
		// status for Test Result
		else if(status == "com.ibm.rqm.execution.common.state.failed"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_fail.gif"; //$NON-NLS-1$
		}
		else if(status == "com.ibm.rqm.execution.common.state.incomplete"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_incomplete.gif"; //$NON-NLS-1$
		}
		else if(status == "com.ibm.rqm.execution.common.state.passed"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_pass.gif"; //$NON-NLS-1$
		}
		else if(status == "com.ibm.rqm.execution.common.state.inconclusive"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_inconclusive.gif"; //$NON-NLS-1$
		}
		else if(status == "com.ibm.rqm.execution.common.state.blocked"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_blocked.gif"; //$NON-NLS-1$
		}
		else if(status == "com.ibm.rqm.execution.common.state.error"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_error.gif"; //$NON-NLS-1$
		}
		else if(status == "com.ibm.rqm.execution.common.state.deferred"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_deferred.gif"; //$NON-NLS-1$
		}
		else if(status == "com.ibm.rqm.execution.common.state.part_blocked"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_partblocked.gif"; //$NON-NLS-1$
		}
		else if(status == "com.ibm.rqm.execution.common.state.perm_failed"){ //$NON-NLS-1$
			iconUrl = baseUrl + "state_permfailed.gif"; //$NON-NLS-1$
		}
		
		else {
			if(status !== undefined){
				console.debug("Unknown status: " + status); //$NON-NLS-1$
			}
			iconUrl = ""; // null will cause error //$NON-NLS-1$
		}
		return iconUrl;
	},
	
	_buildSparqlForStatus: function(arr){
		var partialTemplate = "  { ${source} ${linkType} ?target; a ?type; dcterms:identifier ?sourceId. ?resourceUri a ?type; dcterms:identifier ?sourceId. }\n"; //$NON-NLS-1$
		var partialSparql = this._buildPartialSparql(arr[0].resourceUri, arr[0].statusLinkTypes, partialTemplate);
		for(var i=0; i<arr.length; i++){
			partialSparql += " UNION " + this._buildPartialSparql(arr[i].resourceUri, arr[i].statusLinkTypes, partialTemplate); //$NON-NLS-1$
		}
		return CALC_STATUS_QUERY_SPARQL.replace("${linksPart}", partialSparql); //$NON-NLS-1$
	},
	
	_buildPartialSparql: function(resourceUri, predicates, partialTemplate){
		if(!predicates || predicates.length == 0) {
			return null;
		}
		var sourceRef = resourceUri ? "<" + resourceUri + ">" : "?source"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		// first predicate
		var partialSparql = partialTemplate.replace("${source}", sourceRef).replace("${linkType}", predicates[0].type || predicates[0].value); //$NON-NLS-1$ //$NON-NLS-2$
		// make uniot with other predicates
		for(var idx = 1; idx < predicates.length; idx++){
			var type = predicates[idx].type || predicates[idx].value;
			if(type){
				if (type.indexOf("http://") === 0 || type.indexOf("https://") === 0){ //$NON-NLS-1$ //$NON-NLS-2$
					// special care if raw URI is specified for predicate
					type = "<" + type + ">";//$NON-NLS-1$ //$NON-NLS-2$
				}
				partialSparql = partialSparql + "UNION" + partialTemplate.replace("${source}", sourceRef).replace("${linkType}", type); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			}
		}
		return partialSparql;
	},
	
	_buildSparql: function(resourceUri, predicates, template){
		var partialSparql = this._buildPartialSparql(resourceUri, predicates, "  { ${source} ${linkType} ?target }\n"); //$NON-NLS-1$
		if(!partialSparql) {
			return null;
		}
		return template.replace("${linksPart}", partialSparql); //$NON-NLS-1$
	},
	
	// obsoleted: will be removed
	_getPropertyValueFromQueryResult: function(property, resource){
		return this._getPropertyValueFromParams(property, resource); 
	},
	
	_loadPropsRegexpMap: {},
	
	_getPropertyValueFromParams: function(property, paramsArray){
		var value = null;
		if(dojo.isString(property)){
			// first try $var$ case
			var start = property.indexOf("$"); //$NON-NLS-1$
			if(start == 0){
				var end = property.lastIndexOf("$"); //$NON-NLS-1$
				if(end == property.length-1){
					var name = property.substring(start+1, end);
					value = nodeUtils._getPropertyValueFromParamsCore(name, paramsArray);
					if(!value)
						value = ""; //$NON-NLS-1$
				}				
			}
			if(value === null){
				// if not $var$, try ${var} for backward compatibility
				var start = property.indexOf("${"); //$NON-NLS-1$
				if(start == 0){
					var end = property.lastIndexOf("}"); //$NON-NLS-1$
					if(end == property.length-1){
						var name = property.substring(start+2, end);
						value = nodeUtils._getPropertyValueFromParamsCore(name, paramsArray);
						if(!value)
							value = ""; //$NON-NLS-1$
					}
				}
			}
		}
		return value;
	},
	
	_getHtmlValue: function(value){
		// IE8 removes "\n" in jazz.util.html.removeScript, so keep it and replace to "\n" later
		value = nodeUtils.replaceAll(value, "<br/>", BR_PLACEHOLDER);//$NON-NLS-1$
		value = nodeUtils.replaceAll(value, "<br></br>", BR_PLACEHOLDER);//$NON-NLS-1$
		value = jazz.util.html.unescape(jazz.util.html.removeScript(value));
		value = nodeUtils.replaceAll(value, BR_PLACEHOLDER, "\n");//$NON-NLS-1$
		return value;
	},
	
	_getPropertyValueFromParamsCore: function(propSpec, paramsArray){
		if(!dojo.isArray(paramsArray)) paramsArray = [paramsArray];
		var value = null;
		for(var i=0; i<paramsArray.length; i++){
			var params = paramsArray[i];
			var r = params[propSpec];
			if(r && r.value){
				value = r.value; 
				if(r.datatype === "http://www.w3.org/1999/02/22-rdf-syntax-ns#XMLLiteral"){ //$NON-NLS-1$
					value = nodeUtils._getHtmlValue(value);
				}
			} else if (propSpec.indexOf(":") != -1) { //$NON-NLS-1$
				// check if RegExp replacement is enabled
				if (propSpec.match(/^(.*):\/(.*)\/(.*)\//)) {
					var pname = RegExp.$1;
					var pattern = RegExp.$2;
					var replacement = RegExp.$3;
					
					var re = nodeUtils._loadPropsRegexpMap[pattern];
					if (!re) {
						re = new RegExp(pattern);
						nodeUtils._loadPropsRegexpMap[pattern] = re;
					}
					
					var r = params[pname];
					if (r && r.value) {
						var v = r.value;
						if(r.datatype === "http://www.w3.org/1999/02/22-rdf-syntax-ns#XMLLiteral"){ //$NON-NLS-1$
							v = nodeUtils._getHtmlValue(v);
						}
						v = v.replace(re, replacement);
						value = v;
					}
				} 
			}
			if(value)
				break;
		};
		return value;
	},
	
	evalVariables: function(str, resource){
		return configUtils.evalVariables(str, resource, nodeUtils._getPropertyValueFromParamsCore);
	},
	
	evalSimpleNodeVariables: function(src, nodeWidget) {
		if (!nodeWidget._viewer)
			return src;
		var config = nodeWidget._viewer.config;
		if (!config)
			return src;
		
		var params = utils.getParamValue(config.params);
		return configUtils.evalVariables(src, params);
	},
	
	/*
	 * Evaluate parametes with properties in the specified resource
	 * For example:
	 * 		params = {name1: "val1", name2: "${val2}" }
	 * 		resource.val2 = "foo"
	 * then the output params becomes
	 * 		{name1: "val1", name2: "foo"}
	 */
	evalParameters: function(params, resource){
		var evaluatedParams = {};
		for(var p in params){
			var val = params[p];
			var evaluatedVal = nodeUtils._getPropertyValueFromParams(val, resource);
			evaluatedParams[p] = evaluatedVal || val;
		};
		return evaluatedParams;
	},
	
	/*
	 * Open a view with parameters 
	 */
	openView: function(viewId, params, resource, target, webBaseUri){
		if(viewId){
			var evaluatedParams = nodeUtils.evalParameters(params, resource);
			var args = ""; //$NON-NLS-1$
			for(var p in evaluatedParams){
				var val = evaluatedParams[p];
				args = args + "&" + encodeURIComponent(p) + "=" + encodeURIComponent(val); //$NON-NLS-1$ //$NON-NLS-2$
			}
			this._showView(viewId, args, target, webBaseUri);
		}
	},
	
	_showView: function(viewId, args, target, webBaseUri) {
		var url = (webBaseUri || "") + "#action=com.ibm.relm.explorer.web.showDiagram&id=" + encodeURIComponent(viewId) + args; //$NON-NLS-1$//$NON-NLS-2$
		window.open(url, webBaseUri ? "_blank" : target || "_self"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	/*
	 * Open a view with artifact uri parameter value
	 * view : view  {viewid: (view id), uri: (view uri), ...}
	 * params : view parameters in array  [{name: (parameter name), type: ("product" or "artifact"), value: ....}, {}...]
	 * resource: target resource info {uri: uri, type: ( resource type such as "product" or "artifact" or "http://jazz.net/ns/pd#ItemVersion", etc. ) }
	 * base uri: base uri
	 */
	openViewWithTargetArtifact: function(view, resource, target, webBaseUri){
		
		var self = this;
		jazz.client.xhrGet({
			url: view.uri + "?parameterOnly=", //$NON-NLS-1$ 
			headers: { "Accept" : "text/json"},  //$NON-NLS-1$ //$NON-NLS-2$
			handleAs: "json", //$NON-NLS-1$
			load: function(response, ioArgs){
				self._evalParameterWithUri(view, response.params, resource, target, webBaseUri);
			},
			error: function(response) {
				console.error(response.message);
			}
		});

	},
	
	_evalParameterWithUri: function(view, params, resource, target, webBaseUri){
		var paramUriIdx = [];
		var openViewInfo = {view: view, target: target, webBaseUri: webBaseUri};
		for(var i = 0; i< params.length; i++) {
			if(params[i].type &&
					((params[i].type == "product" && this._isProductType(resource.type)) || params[i].type == "artifact"))  //$NON-NLS-1$ //$NON-NLS-2$
			{
				paramUriIdx.push(i); //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
		if(paramUriIdx.length == 1 ) {
			params[paramUriIdx[0]].value = resource.uri;
			this._callback({params: params, openViewInfo:openViewInfo});
		}else if(paramUriIdx.length > 1 ){
			// open dialog to choose parameter to be set
			SelectionDialog.openParameterSelectionDialog(
					_messages.selectParameterTitle, 
					{
						mainMessage:_messages.selectParameterTitle,
						mainHtmlMessage: _messages.selectParameterDialogText
					},
					openViewInfo, 
					params, 
					paramUriIdx, 
					resource, 
					this._callback);
		}
	},
	
	_callback: function(value) {

		var evaluatedParams = value.params;
		var viewInfo = value.openViewInfo;

		var args = ""; //$NON-NLS-1$
		for(var i = 0; i < evaluatedParams.length; i++){
			var val = evaluatedParams[i];
			args = args + "&" + encodeURIComponent(val.name) + "=" + encodeURIComponent(val.value); //$NON-NLS-1$ //$NON-NLS-2$
		}
		nodeUtils._showView(viewInfo.view.viewid, args, viewInfo.target, viewInfo.webBaseUri);
	},

	
	_isProductType: function(type) {
		return (type=="http://jazz.net/ns/pd#ItemVersion" || type=="http://jazz.net/ns/pd#ConfigurationVersion" || type=="product" || type=="configVersion"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
	},
	
	/*
	 * Evaluate attribute values with query result.
	 * e.g. [{name: "name1", value: "value1"}, {name: "name2", value: "${val}"}] to {name2: "val in query result"} 
	 */
	_loadPropsFromQueryResult: function(attributes, resource){
		var props = {};
		dojo.forEach(attributes, function(attr){
			var val = nodeUtils._getPropertyValueFromParams(attr.value, resource);
			if(val !== null){
				props[attr.name] = val;
			}
		});
		return props;
	},
	
	_getConnectionDirection: function(viewer, componentType){
		var direction = connectionDirCache[componentType];
		if(!direction){
			var info = viewer.hlp_getComponentInfo(componentType);
			var attrs = (info && info.attributes) || [];
	
			// set default attribute values if any
			var startDir = null, endDir = null;
			for(var j = 0, len = attrs.length; j < len; j++){	
				var attr = attrs[j];
				if(attr.name == "startDir"){ //$NON-NLS-1$
					startDir = attr.value;
				}else if(attr.name == "endDir"){ //$NON-NLS-1$
					endDir = attr.value;
				}
				if(startDir && endDir)
					break;
			}
			direction = {"startDir": startDir, "endDir": endDir}; //$NON-NLS-1$ //$NON-NLS-2$
			connectionDirCache[componentType] = direction;
		}
	
		if(!direction.startDir || !direction.endDir){
	//		var calcedDirection = nodeUtils._calcConnectionDirection(sourceWidget, targetWidget);
			var calcedDirection = {"startDir": "right", "endDir": "left"}; // fixed default value //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
				
			if(!direction.startDir){
				direction.startDir = calcedDirection.startDir;
			}
			if(!direction.endDir){
				direction.endDir = calcedDirection.endDir;
			}
		}
		return direction;
	},


	_calcConnectionDirection: function(source, target){
		var sRect = source.domNode.getBoundingClientRect();
		var sPoint = [
				{"side": "left", "x": sRect.left, "y": (sRect.top + source.height/2), "c": 1}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{"side": "right", "x":  (sRect.left + source.width), "y": (sRect.top + source.height/2), "c": 1}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{"side": "top", "x":  (sRect.left + source.width/2), "y": sRect.top, "c": 1}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{"side": "bottom", "x":  (sRect.left + source.width/2), "y": (sRect.top + source.height), "c": 1} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
		];
		var tRect = target.domNode.getBoundingClientRect();
		var tPoint = [
				{"side": "left", "x": tRect.left, "y": (tRect.top + target.height/2), "c": -1}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{"side": "right", "x": tRect.left + target.width, "y": (tRect.top + target.height/2), "c": -1}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{"side": "top", "x": (tRect.left + target.width/2), "y": tRect.top, "c": -1}, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
				{"side": "bottom", "x": (tRect.left + target.width/2), "y": (tRect.top + target.height), "c": -1} //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
		];
		var slopes = new Array();
		var slopeMap = {};
		for(var i=0;i<sPoint.length;i++){
			for(var j=0;j<tPoint.length;j++){
				var sides = {"s": sPoint[i].side, "t": tPoint[j].side}; //$NON-NLS-1$ //$NON-NLS-2$
				if((sides.s == "left" && sides.t == "right") //$NON-NLS-1$ //$NON-NLS-2$
				|| (sides.s == "right" && sides.t == "left") //$NON-NLS-1$ //$NON-NLS-2$
				|| (sides.s == "top" && sides.t == "bottom") //$NON-NLS-1$ //$NON-NLS-2$
				|| (sides.s == "bottom" && sides.t == "top")){ //$NON-NLS-1$ //$NON-NLS-2$
//				if(sides.s != sides.t){
					var xDir = tPoint[j].x - sPoint[i].x;
					var yDir = tPoint[j].y - sPoint[i].y;
					var flag = false;
					dojo.forEach([sPoint[i], tPoint[j]], function(point){
						switch(point.side){
						case "left" : //$NON-NLS-1$
							if(xDir*point.c > 0){
								flag = true;
							}
							break;
						case "right" : //$NON-NLS-1$
							if(xDir*point.c < 0){
								flag = true;
							}
							break;
						case "top" : //$NON-NLS-1$
							if(yDir*point.c > 0){
								flag = true;
							}
							break;
						case "bottom" : //$NON-NLS-1$
							if(yDir*point.c < 0){
								flag = true;
							}
							break;
						default:
							break;
						}
					});
					if(flag){
						continue;
					}
					var slope = nodeUtils._getSlope([sPoint[i].x, sPoint[i].y], [tPoint[j].x, tPoint[j].y]);
					var absSlope = Math.abs(Math.abs(slope) - 1);
					slopes.push(absSlope);
					slopeMap[absSlope] = {startDir: sPoint[i].side, endDir: tPoint[j].side};
				}
			}
		}

		var dir = slopeMap[Math.min.apply(null, slopes)];
		return dir ? dir : {"startDir": "right", "endDir": "left"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
	},
	
	_getSlope : function(source, target){
		if(target[0] == source[0]){
			if(target[1] > source[1]){
				return Number.POSITIVE_INFINITY;
			}else{
				return Number.NEGATIVE_INFINITY;
			}
		}else{
			return (target[1] - source[1])/(target[0] - source[0]);
		}
	},
	
	/*
	 * complext data set to simple name:value set
	 * e.g. { aaa: { value: "bbb", description: "ccc" }, ...} to {aaa: "bbb"}
	 */
	getParamValue: function(params){
		var retParams = {};
		for(var name in params) {
			var value = params[name].value;
			if (params[name].type == "date" && value) { //$NON-NLS-1$
				if (!dojo.isString(value)) value = dojo.date.stamp.toISOString(value); 
				retParams[name] = {type: params[name].type, value: value};
			} else {
				retParams[name] = value;
						}
		}
		return retParams;
	}
});

nodeUtils.reset();
com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils = nodeUtils;

})();