/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.policies.OutlineRenderer"); //$NON-NLS-1$

dojo.require("rmpw.common.policy.Policy"); //$NON-NLS-1$

dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.policies.OutlineRenderer", rmpw.common.policy.Policy, { //$NON-NLS-1$
	singleton: ["outlineRenderer"], //$NON-NLS-1$

	constructor: function() {
	},
		
	destroy: function() {
		this.refresh();
		this.inherited(arguments);
	},
	
	refresh: function() {
		if (this.outlineShape) {
			this.outlineShape.removeShape().destroy();
			this.outlineShape = null;
		}
	},
	
	/*
	 * Update the outline shape with the polyline points
	 */
	updateOutlineShape: function(parentShape, matrix) {
		if (!this.outlineShape) {
			this.outlineShape = parentShape.createRect();
			this.outlineShape.setStroke("blue").setFill("#BDD7EF"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		var widget = this.host;
		var bb = widget.shape.getTransformedBoundingBox();
		var dim = {x: bb[0].x, y: bb[0].y, width: bb[2].x - bb[0].x, height: bb[2].y - bb[0].y};
		if (matrix) {
			dim = dojox.gfx.matrix.multiplyRectangle(matrix, dim);
		}
		this.outlineShape.setShape(dim);
	}
});