/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.tools.DragPan"); //$NON-NLS-1$

dojo.require("rmpw.diagrams.edit.tools.DragPan"); //$NON-NLS-1$
dojo.require('com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils'); //$NON-NLS-1$

/**
 * Pans the diagram when a mouse drag event isn't caught by anything else first.
 * 
 */
dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.tools.DragPan", rmpw.diagrams.edit.tools.DragPan, { //$NON-NLS-1$

	_onMouseDown: function(e) {
		if (com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils.isRightClick(e)) return;

		// cancel any previous move that we apparently lost track of (didn't get mouseup)
		// for example, can happen if a breakpoint is hit or exception occurs between mousedown and mouseup
		if(this.viewport.isPanning()) {
			this._onMouseUp();
			return;
		}
		
		if(this.host.root.editor.movingWidget) {
			return;
		}
		// initialize mouse tracking
		this._lastX = e.clientX;
		this._lastY = e.clientY;
		
		// wait for drag events
		this.dragEvents = [
			dojo.connect(document, "onmousemove", this, "_onMouseMove"), //$NON-NLS-1$ //$NON-NLS-2$
			dojo.connect(document, "onmouseup",   this, "_onMouseUp"), //$NON-NLS-1$ //$NON-NLS-2$
			// cancel text selection and text dragging
			dojo.connect(document, "ondragstart",   dojo, "stopEvent"), //$NON-NLS-1$ //$NON-NLS-2$
			dojo.connect(document, "onselectstart", dojo, "stopEvent") //$NON-NLS-1$ //$NON-NLS-2$
		];
	}
	
});