
/*******************************************************************************
* Licensed Materials - Property of IBM
* Copyright IBM Corp. 2010. All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.tools.WheelMove"); //$NON-NLS-1$
dojo.require("rmpw.common.policy.Policy"); //$NON-NLS-1$
dojo.require("dojox.gfx.matrix"); //$NON-NLS-1$
dojo.require("dojox.gfx.fx"); //$NON-NLS-1$
dojo.require("dojo.fx.easing"); //$NON-NLS-1$
/**
* Zooms the diagram with the mouse wheel scroll wheel.
*
* @author Marc Gobeil
*/
dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.tools.WheelMove", rmpw.common.policy.Policy, { //$NON-NLS-1$
	singleton: "wheelMove", //$NON-NLS-1$
	_animDuration: 0,
	_wheelMoveSpeed: 3,
	constructor: function() {
		this.viewport = this.host.root.viewport;
		this.container = this.viewport.container;
		this._connectListeners();
	},

	/**
	 * bug #3763: Dojo should fix mouse wheel events - http://bugs.dojotoolkit.org/ticket/3763
	 */
	_connectListeners: function() {
		var eventType = (dojo.isMozilla ? "DOMMouseScroll" : "onmousewheel"); //$NON-NLS-1$ //$NON-NLS-2$
		this.wheelMoveListener = dojo.connect(this.container, eventType, this, "_onMouseWheel"); //$NON-NLS-1$
	},

	destroy: function() {
		dojo.disconnect(this.wheelMoveListener);
	},

	_onMouseWheel: function (e) {
//		Smooth out IE/FF differences and normalize data
//		- bug: http://bugs.dojotoolkit.org/ticket/3763
//		- ref: http://www.switchonthecode.com/tutorials/javascript-tutorial-the-scroll-wheel
		e = e ? e : window.event;
//		data: ff:detail, ie:wheelData, up positive, down negative, ff scrolls in increments of 3 units with my mouse (MG)
		var dx = dy = 0;
		var wheelData = e.detail ? e.detail * -1 : e.wheelDelta / 40;
		var moveChange = (wheelData * this._wheelMoveSpeed);
		if(e.ctrlKey) {
			dx = moveChange;
		} else {
			if(!e.axis) {
				// IE
				dy = moveChange;
			} else if(e.axis == e.HORIZONTAL_AXIS) {
				dx = moveChange;
			} else if(e.axis == e.VERTICAL_AXIS){
				dy = moveChange;
			}
		}
		this.viewport.pan(dx, dy);
//		prevent window from scrolling/zooming
		if(e.stopPropagation) {
			e.stopPropagation();
		}
		if(e.preventDefault) {
			e.preventDefault();
		}
		e.cancel = true;
		e.cancelBubble = true;
		e.returnValue = false;
		return false;
	}
});
