/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.tools.WheelZoom"); //$NON-NLS-1$

dojo.require("rmpw.diagrams.edit.tools.WheelZoom"); //$NON-NLS-1$


dojo.declare("com.ibm.relm.explorer.web.ui.internal.view.tools.WheelZoom", rmpw.diagrams.edit.tools.WheelZoom, { //$NON-NLS-1$


	_onMouseWheel: function (e) {

		e = e ? e : window.event;
		var wheelData = e.detail ? e.detail * -1 : e.wheelDelta / 40;
		// normalize to +/-1 unit per wheel click
		wheelData /= 3;

		var zoomChange = 1 + (wheelData * this._wheelZoomSpeed);
		var oldZoom = this.viewport.getZoom();
		var scale = oldZoom * zoomChange;
		if(	(scale <= this._maxZoom || (oldZoom > this._maxZoom && zoomChange < 1)) &&
			(scale >= this._minZoom || (oldZoom < this._minZoom && zoomChange > 1)) ) {
			
			dojo.publish("relmZoomChanged", [{scale: scale, editor: this.editor}]); //$NON-NLS-1$

		}

		var editor = this.editor;
		var allResourceNodes = editor.getAllResourceNodes();
		var foundResourceNode = dojo.filter(allResourceNodes, function(node){
			return (node.reduceRatio != undefined);
		});
		if(scale < 1) {

			dojo.forEach(foundResourceNode, function(node){
				var zoom = 1 / scale * ( 1 - (1 - scale) * node.reduceRatio / 100);
				node.setScale(zoom);
			});
		}
		
		this.inherited(arguments);

	},
	
	destroy: function() {
		dojo.disconnect(this.wheelZoomListener);
	}


});