/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.relm.ple.web.ui.internal.views.ArtifactView"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.ple.web.ui.internal.views", "PropertiesViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require("jazz.ui.Button"); //$NON-NLS-1$
dojo.require("dijit.InlineEditBox"); //$NON-NLS-1$
dojo.require("dijit.form.TextBox"); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.util'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.AutoHeightBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.EasyMessageBox'); //$NON-NLS-1$
dojo.require('jazz.ui.internal.ResourceLinkAggregator'); //$NON-NLS-1$
dojo.require('jazz.util.internal.login'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.LoadingMessage'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.doors.DoorsUtils'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.RtcSettings'); //$NON-NLS-1$

// jazz.core.loader.load_async('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil', function() {
// 	// no op callback
// });

var gator_ = jazz.ui.internal.resourceLinkAggreagtor();
var DoorsUtils = com.ibm.relm.ple.web.doors.DoorsUtils;

dojo.declare("com.ibm.relm.ple.web.ui.internal.views.ArtifactView", //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ], {
		
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.ple.web","ui/internal/views/templates/ArtifactView.html"), //$NON-NLS-1$ //$NON-NLS-2$
	messages: dojo.i18n.getLocalization("com.ibm.relm.ple.web.ui.internal.views", "PropertiesViewMessages"), //$NON-NLS-1$ //$NON-NLS-2$

	// Use blank icon initially since CSS is used to draw generic artifacts
	label: '', //$NON-NLS-1$

	artifactUri: '', //$NON-NLS-1$
	artifactOslcUri: '', //$NON-NLS-1$

	constructor: function(args, node) {
		if (args.liveIcon) {
			this.iconSrc = args.liveIcon;
		}
		else {
			this.iconSrc = this._blankGif;
		}

		if (args.liveTitle) this.liveTitle = args.liveTitle;
	},
	
	postCreate: function() {
		// IE workaround
		this.subscribe('ple.product_tree.drag_did_end', this.hideDragWrapper); //$NON-NLS-1$

		if (relm.app.Permissions.canProductsAddProperty()) {
			dojo.addClass(this.domNode, 'relm-products-addProperty'); //$NON-NLS-1$
		}

		if (this.liveIcon) {
			// Remove the artifact generic artifact CSS since we have a real (better) icon now.
			dojo.removeClass(this._iconNode, 'ple-icon-artifactLink'); //$NON-NLS-1$
		}

		if (!this.artifactOslcUri) {
			// Shouldn't happen
			this.artifactOslcUri = this.artifactUri;
		}
		if (com.ibm.relm.ple.web.rtc.RtcSettings.prototype50) {
			if (this.artifact["http://jazz.net/ns/vvc#configuration_fake_inherited"] !== undefined) //$NON-NLS-1$
			{
				var uri = this.artifact.oslcConceptUri;
				var configurationUri = encodeURIComponent(this.artifact["http://jazz.net/ns/vvc#configuration_fake_inherited"]); //$NON-NLS-1$
				if (uri.indexOf("?") > 0) //$NON-NLS-1$
					uri = uri + "&vvc.configuration="+configurationUri; //$NON-NLS-1$
				else
					uri = uri + "?vvc.configuration="+configurationUri; //$NON-NLS-1$
				this.artifactOslcUri = uri;
			}
		}
		if (this.liveTitle) {
			this._titleNode.innerHTML = this.liveTitle;
		}

		var dummyNode = dojo.create('span', { //$NON-NLS-1$
			innerHTML: this.label
		});
		net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(dummyNode.textContent);

		if (this.isDoorsBaseline && this.privateBaseline) {
			var deferred = DoorsUtils.fetchBaseline(this.privateBaseline);
			deferred.then(dojo.hitch(this, this._showDoorsPreview), dojo.hitch(this, this._noPreview));
		}
		gator_.register(this.artifactOslcUri, dojo.hitch(this, this._updatePreview), dojo.hitch(this, this._noPreview));
	},

	hideDragWrapper: function() {
		dojo.removeClass(this._dragWrapper, 'ple-ProductView-dragWrapperVisible'); //$NON-NLS-1$
	},

	showDragWrapper: function() {
		dojo.addClass(this._dragWrapper, 'ple-ProductView-dragWrapperVisible'); //$NON-NLS-1$
	},

	_onDragStart: function(e) {
		if (!relm.app.Permissions.canProductsAddProperty()) {
			dojo.stopEvent(e);
			return;
		}

		var productTree = com.ibm.relm.ple.web.ui.tree.TreeRefresh.getTree();
		if (!productTree) return;

		var draggedSite = com.ibm.relm.ple.web.ui.TreeSelection.getSelectedSite();
		if (!draggedSite) return;

		var self = this;
		function avatarFactory() {
			var avatarPos = dojo.position(self._iconNode);

			// Fudge the position a bit to accommodate padding. Not really needed.
			avatarPos.x -= 4;
			avatarPos.y -= 4;

			var avatar = new com.ibm.relm.ple.web.dnd.Avatar({
				startX: avatarPos.x,
				startY: avatarPos.y
			});

			var iconNode = self._iconNode.cloneNode(true);
			dojo.removeAttr(iconNode, 'title'); //$NON-NLS-1$
			var labelNode = self._titleNode.cloneNode(true);

			dojo.place(iconNode, avatar.contentNode);
			dojo.place(labelNode, avatar.contentNode);

			return avatar;
		}

		productTree.startDrag(e, draggedSite, avatarFactory);
	},
	
	_noPreview: function(error) {
		// check that we weren't unloaded
		if (!this._loadingMessage) return;

		var explanation;
		if (error && error.explanation) explanation = error.explanation;

		this._loadingMessage.hide();
		this._urlNode.style.display = ''; //$NON-NLS-1$
		this._messageBox.showErrorObject({
			type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
			summary: this.messages.noPreview,
			explanation: explanation,
			userAction: this.messages.noPreview$useraction
		});
	},

	_doLogin: function(e) {
		dojo.stopEvent(e);

		// jazz.client is smart enough to inercept this request and do the login for us.
		// Just need to refresh previews once we're done.
		jazz.client.xhrGet({
				url: this.artifactOslcUri,
				headers: {
					accept: "application/x-oslc-compact+xml" //$NON-NLS-1$
				},
			
				load: dojo.hitch(this, function (result) {
					gator_.resendOauth(this._oauthToken);
				}),
			
				error: dojo.hitch(this, function(error, ioArgs) {
					this._messageBox.showErrorObject({
						type: jazz.ui.MessageBox.STATUS_TYPES.WARNING,
						summary: this.messages.artifactLoginFailed,
						explanation: this.messages.artifactLoginFailed$explanation,
						userAction: dojo.replace(this.messages.artifactLoginFailed$useraction, [this.artifactUri])
					});
				})
			});
	},

	_updatePreview: function(result) {
		// check that we weren't unloaded
		if (!this._loadingMessage) return;

		this._loadingMessage.hide();

		if (result.oauthRequired) {
			var loginLink = jazz.util.internal.login.insertLoginLink(this._loginNode, result.token);
			this._oauthToken = result.token;
			this.connect(loginLink, 'onclick', this._doLogin); //$NON-NLS-1$
			this._loginNode.style.display = ''; //$NON-NLS-1$
			return;
		}

		this._messageBox.hideMessage();
		this._loginNode.style.display = 'none'; //$NON-NLS-1$

		var title;
		var icon;
		var preview;

		if (result.oslcCompact) {
			title = result.oslcCompact.title;
			icon = result.oslcCompact.icon;
			var previewData = result.oslcCompact.largePreview || result.oslcCompact.smallPreview;
			preview = previewData.document;
		}
		else if (result.compactRendering) {
			title = result.compactRendering.title;
			icon = result.compactRendering.icon;
			preview = result.compactRendering.largePreview || result.compactRendering.smallPreview;
		}
		else {
			console.debug('Do not know how to render this preview style:', result); //$NON-NLS-1$
			return;
		}

		if (icon && !this.isDoorsBaseline) {
			dojo.removeClass(this._iconNode, 'ple-icon-artifactLink'); //$NON-NLS-1$
			this._iconNode.src = icon;
		}

		if (title && !this.isDoorsBaseline) {
			this._titleNode.innerHTML = title;
		}

		if (preview) {
			var iframe = dojo.create('iframe', { //$NON-NLS-1$
				src: preview,
				'title': this.messages.ArtifactPreview, //$NON-NLS-1$
				frameBorder: 0,
				className: 'ple-ResourceView-richPreview' //$NON-NLS-1$
			}, this._previewNode, "last"); //$NON-NLS-1$
			this._autoHeight = new com.ibm.relm.common.web.ui.AutoHeightBox(iframe);
		}	
	},
	
	_showDoorsPreview: function(baseline) {
		this._loadingMessage.hide();
		var preview = DoorsUtils.createBaselinePreview(baseline, true, this.conceptUri);
		dojo.place(preview, this._previewNode, "first"); //$NON-NLS-1$
	},

	uninitialize: function(){
		net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(''); //$NON-NLS-1$
		this._autoHeight && this._autoHeight.destroy();
		this.inherited(arguments);
	}
	
});

})();