/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.ui.internal.views.EmptyPartView'); //$NON-NLS-1$

dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.ple.web.ui.internal.views', 'EmptyPartViewMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require('jazz.util.html'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.internal.views.ContextConfigVersionHeader'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeSelection'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Goto'); //$NON-NLS-1$

(function(){
	var html = jazz.util.html;
	
	dojo.declare(
		'com.ibm.relm.ple.web.ui.internal.views.EmptyPartView', //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','ui/internal/views/templates/EmptyPartView.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,
			messages: dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui.internal.views', 'EmptyPartViewMessages'), //$NON-NLS-1$ //$NON-NLS-2$

			item: null,
			site: null,

			postCreate: function() {
				this.site = com.ibm.relm.ple.web.ui.TreeSelection.getSelectedSite();

				// Add the context config version header
				if (this.site) {
					var contextConfigVersionHeader = com.ibm.relm.ple.web.ui.internal.views.ContextConfigVersionHeader({
						site: this.site
					});
					this.own(contextConfigVersionHeader);
					contextConfigVersionHeader.placeAt(this.domNode, 'first'); //$NON-NLS-1$
				}
				this.inherited(arguments);

				// Add Title
				this._titleNode.innerHTML = html.escape(this.item.name);	

				// Add help text with links.
				
				if (this.site.emptyPart.isPartForConfigVersion) {
					this._helpTextNode.innerHTML = this.messages.emptyConfigurationPartHelpTextHtml;

					var removeConfigVersionLink = dojo.query('.ple-EmptyPartView-remove', this._helpTextNode)[0]; //$NON-NLS-1$
					this.connect(removeConfigVersionLink, 'onclick', this._remove); //$NON-NLS-1$
				}
				else {
					this._helpTextNode.innerHTML = this.messages.emptyProductPartHelpTextHtml;

					var removeLink = dojo.query('.ple-EmptyPartView-remove', this._helpTextNode)[0]; //$NON-NLS-1$
					var replaceVersionLink = dojo.query('.ple-EmptyPartView-replaceVersion', this._helpTextNode)[0]; //$NON-NLS-1$
					var auditHistoryLink = dojo.query('.ple-EmptyPartView-auditHistory', this._helpTextNode)[0]; //$NON-NLS-1$
					this.connect(removeLink, 'onclick', this._remove); //$NON-NLS-1$
					this.connect(replaceVersionLink, 'onclick', this._replaceVersion); //$NON-NLS-1$
					this.connect(auditHistoryLink, 'onclick', this._showAuditHistory); //$NON-NLS-1$
				}
			},

			_showAuditHistory: function(e) {
				dojo.stopEvent(e);

				com.ibm.relm.ple.web.ui.Goto.gotoShowHistory(null, this.site.contextPartUri);
			},

			_remove: function(e) {
				dojo.stopEvent(e);
				var selectedSites = [this.site];
				dojo.publish('ple.remove_anything', [selectedSites]); //$NON-NLS-1$
			},

			_replaceVersion: function(e) {
				dojo.stopEvent(e);
				var d = new com.ibm.relm.ple.web.ui.pages.ReplaceVersionDialog({
					site: this.site
					});
				d.startup();
			}
		}
	);
})();