/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.ui.internal.views.ProductView'); //$NON-NLS-1$

dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require('dijit._Widget'); //$NON-NLS-1$
dojo.require('dojo.date.locale'); //$NON-NLS-1$
dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.ple.web.ui.internal.views', 'ProductViewMessages'); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require('net.jazz.ajax.ui.PlatformUI'); //$NON-NLS-1$

dojo.require('jazz.ui.StyledTable'); //$NON-NLS-1$
dojo.require('jazz.ui.PageTemplate'); //$NON-NLS-1$
dojo.require('jazz.ui.Dialog'); //$NON-NLS-1$
dojo.require('jazz.util.html'); //$NON-NLS-1$

dojo.require('com.ibm.relm.common.web.ui.AutoHeightBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.EasyMessageBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.FloatingMessageBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.LoadingMessage'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.Section'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.util'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.audit.ProductAudit'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.EditBranchDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.prop.UserPropertyTable'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.productedit.EditPropertiesDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.prop.PropertyName'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.productedit.RenameResourceDialog'); //$NON-NLS-1$
dojo.require('jazz.ui.Toolbar'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.Button'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.Separator'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Goto'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.tree.TreeRefresh'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeSelection'); //$NON-NLS-1$
dojo.require('relm.app.Permissions'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ResourceLinkBatchLoader'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.variability.EditConditionsDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.StatusMessage'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.variability.EditConfigurationDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.RtcSettings'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.advanced.AdvancedSettings'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.StreamManagement'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.RtcSettings'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.internal.views.ContextConfigVersionHeader'); //$NON-NLS-1$

(function() {

var formatting = com.ibm.relm.ple.web.ui.formatting;
var html = jazz.util.html;
var TreeSelection = com.ibm.relm.ple.web.ui.TreeSelection;
var StreamManagement = com.ibm.relm.ple.web.rtc.StreamManagement;

var MILLISECONDS_PER_DAY = 1000 * 60 * 60 * 24 ;
var MILLISECONDS_PER_HALF_DAY = MILLISECONDS_PER_DAY / 2;

var SYSTEM_PROPERTIES = com.ibm.relm.ple.web.ui.prop.UserPropertyTable.SYSTEM_PROPERTIES;

var _advancedSettings = com.ibm.relm.ple.web.advanced.AdvancedSettings;

var Permissions = relm.app.Permissions;

function text(str)
{
	return document.createTextNode(str);
}

function _nameValid(propertyName) {
	if (SYSTEM_PROPERTIES[propertyName]) {
		return false;
	}
	return true;
}

var AnalysisUtil = false;

jazz.core.loader.load_async('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil', function() { //$NON-NLS-1$
	// Replace the flag with the actual object once loaded.
	AnalysisUtil = dojo.getObject('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil'); //$NON-NLS-1$
});

var dateTimeFormatMedium = {
	formatLength: 'medium' //$NON-NLS-1$
};

var dateFormatMedium = {
	selector: 'date', //$NON-NLS-1$
	formatLength: 'medium' //$NON-NLS-1$
};

var timeFormatMedium = {
	selector: 'time', //$NON-NLS-1$
	formatLength: 'medium' //$NON-NLS-1$
};

/**
 * Formats a time in millis into a human readable time. If the time is during
 * today (last 12 hours) then only the time is shown. If it's older, then the
 * date is shown. (This isn't quite right--we should really calculate if it's actually
 * today's current date or not).
 * 
 * @param  {integer} timeMillis a date time in milliseconds.
 * @return {string}            formatted date or time.
 */
function formatSmartDateTime(timeMillis) {
	var diffMillis = Date.now() - timeMillis;

	var format = diffMillis > MILLISECONDS_PER_HALF_DAY
		? dateFormatMedium
		: timeFormatMedium;

	return dojo.date.locale.format(
		new Date(timeMillis),
		format);
}

function formatMediumDateTime(timeMillis) {
	return dojo.date.locale.format(
		new Date(timeMillis),
		dateTimeFormatMedium);
}

dojo.declare("com.ibm.relm.ple.web.ui.internal.views.ProductView", //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ], {

	templatePath: dojo.moduleUrl("com.ibm.relm.ple.web","ui/internal/views/templates/ProductView.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,

	// The item version of config version for this view.
	// It can be either since 5.0
	resourceVersion: null,

	// If this view was created from the product tree, this is the 
	// selected site for the resource version. If we are showing
	// this from an external link without a path, the site could be null,
	// which forces us into a read-only mode.
	optionalSite: null,


	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.ple.web.ui.internal.views", "ProductViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.parentId = args.parentId;

		this.resourceVersion = args.product;

		this._isAuditLoaded = false;
		this._resourceLinks = [];

		this.advancedImport_enabled = !!_advancedSettings.advanced_import;
		this.variableInclusion_enabled = !!_advancedSettings.variable_include;
	},

	postMixInProperties: function() {
		this.inherited(arguments);

		// Just a convenience
		var type = this.resourceVersion.type;
		this.isItemVersion = type === 'product'; //$NON-NLS-1$
		this.isConfigVersion = type === 'configVersion'; //$NON-NLS-1$

		// If we know we're in a baseline. If we have no site, we don't know, which is
		// OK, since we'll likely be outside the product tree too, which is more restrictive.
		this.isInBaseline = this.optionalSite && this.optionalSite.isInBaseline;
		this.isBaseline = this.optionalSite && this.optionalSite.configVersion && this.optionalSite.configVersion.isImmutable;
 
		// If this view is being shown outside the product tree. This happens
		// when clicking a link from inside a product rich hover or a link from another
		// product that doesn't know the path to the product. No edits are allowed in this case.
		this.isOutsideProductTree = !this.optionalSite;

		this._noPropertiesMessage = this.isOutsideProductTree || (this.isBaseline || this.isInBaseline) ? this.messages.noPropertiesReadOnly : this.messages.noProperties;
	},

	hideDragWrapper: function() {
		dojo.removeClass(this._dragWrapper, 'ple-ProductView-dragWrapperVisible'); //$NON-NLS-1$
	},

	showDragWrapper: function() {
		dojo.addClass(this._dragWrapper, 'ple-ProductView-dragWrapperVisible'); //$NON-NLS-1$
	},

	_onDragStart: function(e) {
		if (!Permissions.canProductsModify()) {
			return;
		}

		if (this.isOutsideProductTree) return;

		var productTree = com.ibm.relm.ple.web.ui.tree.TreeRefresh.getTree();
		if (!productTree) return;

		var draggedSite = TreeSelection.getSelectedSite();
		if (!draggedSite) return;

		var self = this;
		function avatarFactory() {
			var avatarPos = dojo.position(self._iconNode);

			// Fudge the position a bit to accommodate padding. Not really needed.
			avatarPos.x -= 4;
			avatarPos.y -= 4;

			var avatar = new com.ibm.relm.ple.web.dnd.Avatar({
				startX: avatarPos.x,
				startY: avatarPos.y
			});

			var iconNode = self._iconNode.cloneNode(true);
			dojo.removeAttr(iconNode, 'title'); //$NON-NLS-1$
			var labelNode = self._titleNode.cloneNode(true);

			dojo.place(iconNode, avatar.contentNode);
			dojo.place(labelNode, avatar.contentNode);

			return avatar;
		}

		productTree.startDrag(e, draggedSite, avatarFactory);
	},

	_initOutsideProductTreeToolbar: function() {
		this._toolbar = new jazz.ui.Toolbar();
		dojo.addClass(this._toolbar.domNode, 'r-right r-clear r-small-margin-b'); //$NON-NLS-1$

		this._toolbar.placeAt(this._systemPropertiesNode, 'first'); //$NON-NLS-1$

		var showProductButton = new jazz.ui.toolbar.Button({
			imgClass: 'ple-icon-showInTree', //$NON-NLS-1$
			title: this.messages.showInProductTree,
			label: this.messages.showInProductTree,
			onClick: dojo.hitch(this, this.findPaths)
		});
		this._toolbar.addChild(showProductButton);

		this._toolbar.addChild(new jazz.ui.toolbar.Separator());

		var findUseButton = new jazz.ui.toolbar.Button({
			imgClass: 'ple-icon-findUse', //$NON-NLS-1$
			title: this.messages.findUse,
			onClick: dojo.hitch(com.ibm.relm.ple.web.ui.Goto, com.ibm.relm.ple.web.ui.Goto.gotoFindUse, this.resourceVersion.uri)
		});
		this._toolbar.addChild(findUseButton);

		if (AnalysisUtil) {
			var analysisButton = new jazz.ui.toolbar.Button({
				imgClass: 'ple-icon-impactAnalysis', //$NON-NLS-1$
				title: this.messages.startAnalysis,
				onClick: dojo.hitch(this, this._startAnalysis)
			});
			this._toolbar.addChild(analysisButton);
		}

		this._toolbar.addChild(new jazz.ui.toolbar.Separator());

		var self = this;
		var historyButton = new jazz.ui.toolbar.Button({
			imgClass: 'ple-icon-history', //$NON-NLS-1$
			title: this.messages.showHistory,
			onClick: function(e) {
				com.ibm.relm.ple.web.ui.Goto.gotoShowHistory(self.resourceVersion.uri);
			}
		});
		this._toolbar.addChild(historyButton);
	},

	_startAnalysis: function(args) {
		AnalysisUtil.createAnalysisForResource(this.resourceVersion.uri);
	},

	/**
	 * Adds additional details to the product header section if the product
	 * was imported.
	 */
	_initImportDetails: function(){
		if (this._importInfoNode) {
			dojo.destroy(this._importInfoNode);
			delete this._importInfoNode;
		}

		this._importInfoNode = dojo.create('div', { //$NON-NLS-1$
			className: 'ple-ProductView-importInfo' //$NON-NLS-1$
		});

		// XXX: As far as I can tell, this could all be replaced with a div. There is never more than one cell.
		dojo.create('hr', null, this._importInfoNode); //$NON-NLS-1$
		var table = dojo.place('<table class=""><col width="0"><col width="999"></table>', this._importInfoNode); //$NON-NLS-1$

		var row = dojo.create('tr', null, table); //$NON-NLS-1$
		var td = dojo.create('td', { //$NON-NLS-1$
			className: 'j-label', //$NON-NLS-1$
			style: 'white-space: nowrap' //$NON-NLS-1$
		}, row);

		td.appendChild(document.createTextNode(this.messages.imported));

		dojo.place(this._importInfoNode, this._headerNode);
	},

	/**
	 * Adds additional details to the product header section if the product
	 * is connected to an RTC stream or component. 
	 */
	_initRtcDetails: function() {

		if (this._rtcInfoNode) {
			dojo.destroy(this._rtcInfoNode);
			delete this._rtcInfoNode;
		}

		this._rtcInfoNode = dojo.create('div', { //$NON-NLS-1$
			className: 'ple-ProductView-rtcInfo' //$NON-NLS-1$
		});

		dojo.create('hr', null, this._rtcInfoNode); //$NON-NLS-1$
		var table = dojo.place('<table class=""><col width="0"><col width="999"></table>', this._rtcInfoNode); //$NON-NLS-1$

		/**
		 * Helper function to create a table row with two cells: a TH with the given
		 * label, and an empty TD that is returned to fill later.
		 * @param  {string} label string for the label
		 * @return {TD}       the data cell to fill.
		 */
		function createRowGetTd(label) {
			var row = dojo.create('tr', null, table); //$NON-NLS-1$
			
			var th = dojo.create('th', { //$NON-NLS-1$
				scope: 'row', //$NON-NLS-1$
				innerHTML: html.escape(label),
				className: 'j-label' //$NON-NLS-1$
			}, row);

			return dojo.create('td', { //$NON-NLS-1$
			}, row);
		}

		if (this.resourceVersion.rtcComponent) {
			 var componentTd = createRowGetTd(this.messages.rtcConnectedToComponent);
			 dojo.create('img', { //$NON-NLS-1$
				src: this._blankGif,
				alt: '', //$NON-NLS-1$
				className: 'ple-icon ple-icon-rtcComponent' //$NON-NLS-1$
			 }, componentTd);
			 componentTd.appendChild(document.createTextNode(this.resourceVersion.rtcTitle));

			var baselineTd = createRowGetTd(this.messages.rtcBaseline);
			dojo.create('img', { //$NON-NLS-1$
				src: this._blankGif,
				alt: '', //$NON-NLS-1$
				className: 'ple-icon ple-icon-rtcBaseline' //$NON-NLS-1$
			}, baselineTd);
			baselineTd.appendChild(document.createTextNode(this.resourceVersion.rtcBaselineName));
		}
		else if (this.resourceVersion.rtcStream) {
			var streamTd = createRowGetTd(this.messages.rtcConnectedToStream);
			dojo.create('img', { //$NON-NLS-1$
				src: this._blankGif,
				alt: '', //$NON-NLS-1$
				className: 'ple-icon ple-icon-rtcStream' //$NON-NLS-1$
			}, streamTd);
			streamTd.appendChild(document.createTextNode(this.resourceVersion.rtcTitle));
		}

		var rtcServer = this.resourceVersion.rtcServer;
		var rtcServerName = this.resourceVersion.rtcServerName;
		if (!rtcServer) {
			rtcServer = com.ibm.relm.ple.web.rtc.RtcSettings.rtcUrls[0];
		}

		var serverTd = createRowGetTd(this.messages.rtcConnectedToServer);
		if (serverTd) {
			dojo.create('a', { //$NON-NLS-1$
				target: '_blank', //$NON-NLS-1$
				href: rtcServer,
				innerHTML: html.escape(rtcServerName) || html.escape(rtcServer)
			}, serverTd);
		}

		if (this.resourceVersion.originalRtcStream){
			var originalRtcStreamTd = createRowGetTd(this.messages.rtcOriginalStreamId);
			if (originalRtcStreamTd) {
				dojo.create('span', { //$NON-NLS-1$
					innerHTML: html.escape(this.resourceVersion.originalRtcStream)
				}, originalRtcStreamTd);
			}
		}
		if (this.resourceVersion.originalRtcStreamName){
			var originalRtcStreamNameTd = createRowGetTd(this.messages.rtcOriginalStreamName);
			if (originalRtcStreamNameTd) {
				dojo.create('span', { //$NON-NLS-1$
					innerHTML: html.escape(this.resourceVersion.originalRtcStreamName)
				}, originalRtcStreamNameTd);
			}
		}
	
		dojo.place(this._rtcInfoNode, this._headerNode);
	},

	_initConditionSection: function() {
		try {
			if (this._conditionsSection) {
					this._conditionsSection.destroyRecursive();
					delete this._conditionsSection;
				}
		
				this._conditionsSection = new com.ibm.relm.common.web.ui.Section({
					label: this.messages.conditionsHeader,
					showHelp: false,
					canCollapse: true
				});
		
				this._conditionsSection.placeAt(this._branchSection, 'after'); //$NON-NLS-1$
		
				if (!this.isOutsideProductTree && !this.isBaseline && !this.isInBaseline) {
					var editConditionsLink = dojo.create('a', { //$NON-NLS-1$
						href: '#', //$NON-NLS-1$
						title: this.messages.editConditionsTooltip,
						innerHTML: html.escape(this.messages.editBranchDimensionsLink),
						className: 'relm-Section-link'}); //$NON-NLS-1$
					this.connect(editConditionsLink, 'onclick', this._onEditConditions); //$NON-NLS-1$
					this._conditionsSection.setControls(editConditionsLink);
				}
		}
		catch (e) {
			// FIXME: this seems to fail sometimes, but I don't know why. This is just here to debug if I see again.
			console.debug(e);
		}
	},

	_initConfigurationVariablesSection: function() {
		if (this._configSection) {
			this._configSection.destroyRecursive();
			delete this._configSection;
			delete this._configurationNode;
		}

		this._configSection = new com.ibm.relm.common.web.ui.Section({
			label: this.messages.configurationSection,
			canCollapse: true,
			showHelp: false
		});
		
		this._configurationNode = dojo.create('div', null, this._configSection.containerNode); //$NON-NLS-1$

		if (!this.isOutsideProductTree && !this.isBaseline && !this.isInBaseline) {
			var editConfigurationLink = dojo.create('a', { //$NON-NLS-1$
				href: '#', //$NON-NLS-1$
				title: this.messages.editConfigurationsTooltip,
				innerHTML: html.escape(this.messages.editBranchDimensionsLink),
				className: 'relm-Section-link' //$NON-NLS-1$
			});

			this.connect(editConfigurationLink, 'onclick', dojo.hitch(this, this._onEditConfiguration)); //$NON-NLS-1$
			this._configSection.setControls(editConfigurationLink);
		}

		this._configSection.placeAt(this._contentNode, 'first'); //$NON-NLS-1$
	},

	_onEditConfiguration: function(e) {
		dojo.stopEvent(e);
		var dialog = new com.ibm.relm.ple.web.variability.EditConfigurationDialog({
			site: this.optionalSite
		});
		dialog.startup();
	},


	_initPropertiesSection: function() {
		this._propertiesSection = new com.ibm.relm.common.web.ui.Section({
			label: this.messages.propertiesSection,
			canCollapse: true,
			uaKey: 'com.ibm.relm.common.web.page_Properties001' //$NON-NLS-1$
		});

		this._propertiesSection.placeAt(this._contentNode, 'first'); //$NON-NLS-1$

		this._propertiesTable = new jazz.ui.StyledTable({
			trim: jazz.ui.StyledTable.TrimStyles.SECONDARY_HEADLESS,
			showHover: false,
			columns: [
				{
					label: this.messages.propertyName,
					width: '50px' //$NON-NLS-1$
				},
				{
					label: this.messages.propertyValue,
					width: '9999px' //$NON-NLS-1$
				},
				{
					label: '', //$NON-NLS-1$
					width: '20px' //$NON-NLS-1$
				}

			]
		});

		this._propertiesTable.placeAt(this._propertiesSection.containerNode);

		this._noProperties = dojo.create('div', { //$NON-NLS-1$
			className: 'r-small-no-results', //$NON-NLS-1$
			style: 'display: none', //$NON-NLS-1$
			innerHTML: html.escape(this._noPropertiesMessage)
		}, this._propertiesSection.containerNode);

		if (!this.isOutsideProductTree && !this.isBaseline && !this.isInBaseline) {
			var editPropertiesLink = dojo.create('a', { //$NON-NLS-1$
				href: '#', //$NON-NLS-1$
				title: this.messages.editPropertiesTooltip,
				innerHTML: html.escape(this.messages.editPropertiesLink),
				className: 'relm-Section-link' //$NON-NLS-1$
			});
			this.connect(editPropertiesLink, 'onclick', dojo.hitch(this, function(e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				dojo.publish('ple.edit_properties'); //$NON-NLS-1$
			}));
			this._propertiesSection.setControls(editPropertiesLink);
		}

	},

	postCreate: function() {
		this.inherited(arguments);

		if (com.ibm.relm.ple.web.rtc.RtcSettings.prototype50) {
			this._extraInfoDiv.style.display = ''; //$NON-NLS-1$
		}

		this.subscribe('ple.detail_view.save', this.save); //$NON-NLS-1$
		// IE workaround
		this.subscribe('ple.product_tree.drag_did_end', this.hideDragWrapper); //$NON-NLS-1$

		var product = this.resourceVersion;

		if (product.conditionVariables !== undefined) {
			this._initConfigurationVariablesSection();			
		}
		else {
			this._initPropertiesSection();
		}

		if (this.isOutsideProductTree) {
			dojo.addClass(this.domNode, 'ple-ProductView-readonly'); //$NON-NLS-1$
			dojo.addClass(this._titleNode, 'j-h1'); //$NON-NLS-1$

			this._initOutsideProductTreeToolbar();
			this._linksSection = new com.ibm.relm.common.web.ui.Section({
				label: this.messages.linksSection,
				canCollapse: true,
				showHelp: false
			});

			this._linksSection.placeAt(this._propertiesSection.domNode, 'after'); //$NON-NLS-1$
		}

		if (!this.isOutsideProductTree && !this.isBaseline && !this.isInBaseline) {
			if (Permissions.canProductsAddProperty()) {
				dojo.addClass(this.domNode, 'relm-products-addProperty'); //$NON-NLS-1$
			}

			if (Permissions.canProductsModify()) {
				dojo.addClass(this.domNode, 'relm-products-modify'); //$NON-NLS-1$
			}
		}

		this._initFromResourceVersion();

		if (!this.isOutsideProductTree) {
			this._autoHeight = new com.ibm.relm.common.web.ui.AutoHeightBox(this._contentNode, {
				listenOnPage: 'com.ibm.relm.ple.web.ui.pages.ProductsPage', //$NON-NLS-1$
				fillPageWidth: false
			});

			if (Permissions.canProductsBranch()  && this.isConfigVersion && !this.isBaseline) { //$NON-NLS-1$
				var editBranches = dojo.create('a', { //$NON-NLS-1$
					href: '#', //$NON-NLS-1$
					title: this._getEditDimensionsTooltip(),
					innerHTML: html.escape(this.messages.editBranchDimensionsLink),
					className: 'relm-Section-link'}); //$NON-NLS-1$
				this.connect(editBranches, 'onclick', this._onEditDimensions); //$NON-NLS-1$
				this._branchSection.setControls(editBranches);
			}
		}

		if (this.isConfigVersion) {
			this._branchSection.setLabel(this.messages.dimensionSection);
		}

		if (this.isItemVersion) {
			this.connect(this._auditSection, 'onCollapse', this._loadAudit); //$NON-NLS-1$
		}
		else {
			if (this._auditSection) {
				this._auditSection.destroyRecursive();
				delete this._auditSection;
			}
		}
	},

	_getEditDimensionsTooltip: function()
	{
		if (this.isConfigVersion) {
			return this.messages.editBranchDimensionsForConfigurationsTooltip;
		}
		else {
			return this.messages.editBranchDimensionsTooltip;
		}
	},
	
	_onEditConditions: function(e) {
		dojo.stopEvent(e);

		if (!this.optionalSite) {
			console.error('Can only edit from within the product tree.'); //$NON-NLS-1$
			return;
		}

		var dialog = new com.ibm.relm.ple.web.variability.EditConditionsDialog({
			site: this.optionalSite
		});
		dialog.startup();
		return;
	},

	updateConfiguration: function() {
		if (!this._configurationNode) return;

		var configHtml = this.resourceVersion.conditionVariablesHtml;

		dojo.empty(this._configurationNode);

		if (configHtml) {
			this._configurationNode.innerHTML = this.resourceVersion.conditionVariablesHtml;
		}
		else {
			dojo.create('div', { //$NON-NLS-1$
				innerHTML: html.escape(this.messages.noConfigurationVariables),
				className: 'r-small-no-results' //$NON-NLS-1$
			}, this._configurationNode);
		}
	},

	updateConditions: function() {
		if (!this._conditionsSection) return;

		var box = this._conditionsSection.containerNode;
		dojo.empty(box);

		if (this.resourceVersion.condition) {
			box.innerHTML = html.escape(this.resourceVersion.condition);
		}
		else {
			dojo.create('div', { //$NON-NLS-1$
				innerHTML: html.escape(this.messages.noConditions),
				className: 'r-small-no-results' //$NON-NLS-1$
			}, box);
		}
	},

	findPaths: function() {
		com.ibm.relm.ple.web.ui.productapi.findPathsToProductAndShow(this.resourceVersion.uri, true);
	},

	rename: function() {
		if (this.isOutsideProductTree || !Permissions.canProductsAddProperty() || this.isBaseline || this.isInBaseline) return;

		var site = TreeSelection.getSelectedSite();
		var dialog;
		
		dialog = com.ibm.relm.ple.web.productedit.RenameResourceDialog({
			site: TreeSelection.getSelectedSite()
		});
		dialog.startup();
	},
	
	_loadAudit: function(nowOpen) {
		this._auditMessageBox.hideMessage();

		var self = this;

		function cleanUp() {
			self._auditLoadingMessage.hide();
		}

		if (!this._isAuditLoaded) {
			var get = jazz.client.xhrGet({
				url: net.jazz.ajax._contextRoot + '/ple/audit_log', //$NON-NLS-1$
				handleAs: 'json', //$NON-NLS-1$
				content: {
					itemVersionUri: this.resourceVersion.uri
				},

				error: function(_, args) {
					cleanUp();
					self._auditMessageBox.showXhrError(args.xhr);
				}
			});

			get.then(function(jsonAuditData) {
				cleanUp();
				self._productAudit && self._productAudit.destroyRecursive();

				self._productAudit = new com.ibm.relm.ple.web.ui.audit.ProductAudit({
					auditData: jsonAuditData,
					batchLoader: new com.ibm.relm.common.web.ResourceLinkBatchLoader()
				});
				self._productAudit.placeAt(self._auditLogContainer);

				self._isAuditLoaded = true;
			});

		}
	},

	_drawBranchTable: function(branchDimensions) {
		dojo.empty(this._branchDimTable);

		if (branchDimensions.length === 0) {
			dojo.create('div', { //$NON-NLS-1$
				innerHTML: this._getInnerHTMLForNoDimensions(),
				className: 'r-small-no-results' //$NON-NLS-1$
			}, this._branchDimTable);
			
			return;
		}

		var columns = [
			{label: this.messages.dimensionScopeColumnLabel, width: '1px', style: {textWrap: 'suppress'}}, //$NON-NLS-1$ //$NON-NLS-2$
			{label: this.messages.dimensionNameColumnLabel, width: '1px', style: {textWrap: 'suppress'}}, //$NON-NLS-1$ //$NON-NLS-2$
			{label: this.messages.dimensionValueColumnLabel, width: '9999px'} //$NON-NLS-1$
		];

		this._branchTable = new jazz.ui.StyledTable({columns: columns});

		for (var i = 0; i < branchDimensions.length; i++) {
			
			var dimension = branchDimensions[i];

			var row = dojo.create('tr', null, this._branchTable.tbody); //$NON-NLS-1$

			dojo.create('td', { //$NON-NLS-1$
				innerHTML: formatting.formatDimensionScope(dimension, this.isConfigVersion),
				style: {whiteSpace: 'nowrap'} //$NON-NLS-1$
			}, row);

			dojo.create('td', { //$NON-NLS-1$
				innerHTML: html.escape(dimension.name),
				style: {whiteSpace: 'nowrap'} //$NON-NLS-1$
			}, row);

			dojo.create('td', {innerHTML: html.escape(dimension.value)}, row); //$NON-NLS-1$
		}

		this._branchTable.placeAt(this._branchDimTable);
	},
	
	_getInnerHTMLForNoDimensions: function() {
		if (this.isOutsideProductTree || this.isBaseline || this.isInBaseline)
		{
			return this.messages.noDimensionsReadOnly;
		}
		else
		{
			if (!this.isItemVersion) {
				return this.messages.noDimensionsInfoForConfigurationsMessage;
			}
			else {
				return this.messages.noDimensionsReadOnly;
			}
		}
	},

	_destroyResourceLinks: function() {
		dojo.forEach(this._resourceLinks, function(resourceLink) {
			resourceLink.destroyRecursive();
		});

		this._resourceLinks = [];
	},

	/**
	 * Only for read-only view (when not shown in the tree).
	 * Draws all the resource links the product is related to.
	 * @return {[type]} [description]
	 */
	_drawLinks: function() {
		this._destroyResourceLinks();

		dojo.forEach(this._resourceLinks, function(resourceLink) {
			resourceLink.destroyRecursive();
		});

		dojo.empty(this._linksSection.containerNode);

		var links = this.resourceVersion.children;
		if (!links || !links.length) {
			var noLinksDiv = dojo.create('div', { //$NON-NLS-1$
				className: 'r-small-no-results', //$NON-NLS-1$
				innerHTML: html.escape(this.messages.noLinks)
			});
			this._linksSection.containerNode.appendChild(noLinksDiv);
		}
		else {
			var list = dojo.create('ul', { //$NON-NLS-1$
				className: 'ple-linkList' //$NON-NLS-1$
			});

			for (var i = 0; i < links.length; i++) {
				var link = links[i];
				var listItem = dojo.create('li', null, list); //$NON-NLS-1$

				var icon = dojo.create('img', { //$NON-NLS-1$
					alt: '', //$NON-NLS-1$
					height: '16', //$NON-NLS-1$
					width: '16', //$NON-NLS-1$
					className: 'ple-icon', //$NON-NLS-1$
					src: dojo.moduleUrl('com.ibm.relm.ple.web','ui/images/hyperlink_co.gif') //$NON-NLS-1$ //$NON-NLS-2$
				}, listItem);

				var a = dojo.create('a', { //$NON-NLS-1$
					href: link.oslcUri,
					innerHTML: html.escape(link.name)
				}, listItem);

				var resourceLink = new jazz.ui.ResourceLink({
					iconNode: icon
				}, a);

				this._resourceLinks.push(resourceLink);
			}

			this._linksSection.containerNode.appendChild(list);
		}
	},

	isProduct: function(productVersionUri) {
		return this.resourceVersion && productVersionUri == this.resourceVersion.uri;
	},

	_onEditDimensions: function(e) {
		dojo.stopEvent(e);

		if (!this.optionalSite) {
			console.error('Can only edit dimensions from within the product tree'); //$NON-NLS-1$
			return;
		}

		var args = {
			site: this.optionalSite,
			servicePath: '/ple/edit_dimensions' //$NON-NLS-1$
		};

		var d = new com.ibm.relm.ple.web.ui.branch.EditBranchDialog(args);
		d.startup();
	},

	_drawPropertiesTable: function() {
		// RTC Configuration objects have no properties table.
		if (!this._propertiesSection) return;

		var userProperties = {};

		for (var anyName in this.resourceVersion) {
			if (SYSTEM_PROPERTIES[anyName]) continue;

			userProperties[anyName] = this.resourceVersion[anyName];
		}

		var sortedNames = [];

		for (var n in userProperties) {
			sortedNames.push(n);
		}

		// TODO: better sorting. Maybe creation order is better
		sortedNames.sort(function(left, right) {
			left = left.toLowerCase();
			right = right.toLowerCase();
			if (left < right) return -1;
			if (left > right) return 1;
			return 0;
		});

		dojo.empty(this._propertiesTable.tbody);

		var frag = document.createDocumentFragment();

		for (var i = 0; i < sortedNames.length; i++) {
			var name = sortedNames[i];
			var value = userProperties[name];

			var row = dojo.create('tr', null, frag); //$NON-NLS-1$
			var nameCell = dojo.create('td', { //$NON-NLS-1$
				className: 'j-label ple-ProductView-propertyName', //$NON-NLS-1$
				nowrap: true
			}, row);
			nameCell.appendChild(document.createTextNode(com.ibm.relm.ple.web.ui.prop.PropertyName.getReadOnlyDisplayName(name)));
			var valueCell = dojo.create('td', null, row); //$NON-NLS-1$
			valueCell.appendChild(document.createTextNode(value));
		}

		this._propertiesTable.tbody.appendChild(frag);

		this._showNoPropertiesMessage();
	},

	_showNoPropertiesMessage: function() {
		if (this._propertiesTable.tbody.rows.length === 0) {
			this._noProperties.style.display = ''; //$NON-NLS-1$
			this._propertiesTable.domNode.style.display = 'none'; //$NON-NLS-1$
		}
		else {
			this._noProperties.style.display = 'none'; //$NON-NLS-1$
			this._propertiesTable.domNode.style.display = ''; //$NON-NLS-1$
		}
	},
	
_showConfigurationDetails: function(product) {
		
		this._configurationLabel.innerHTML = this.messages.globalConfiguration;
			
		var icon = dojo.create('img', { //$NON-NLS-1$
			height: '16', //$NON-NLS-1$
			width: '16', //$NON-NLS-1$
			className: 'ple-icon', //$NON-NLS-1$
			src: dojo.moduleUrl('com.ibm.relm.ple.web','ui/images/configuration2.gif') //$NON-NLS-1$ //$NON-NLS-2$
		}, this._configNode);

		var a = dojo.create('a', { //$NON-NLS-1$
			href: product["http://jazz.net/ns/vvc#configuration_fake_global"], //$NON-NLS-1$
			innerHTML: product.name
		}, this._configNode);

		new jazz.ui.ResourceLink({
			iconNode: icon
		}, a);
	},
	
	_showProductWithAssociatedConfigurationDetails: function(product) {
		this._configurationLabel.innerHTML = this.messages.externalConfiguration;
		
		var icon = dojo.create('img', { //$NON-NLS-1$
			height: '16', //$NON-NLS-1$
			width: '16', //$NON-NLS-1$
			className: 'ple-icon', //$NON-NLS-1$
			src: dojo.moduleUrl('com.ibm.relm.ple.web','ui/images/configuration2.gif') //$NON-NLS-1$ //$NON-NLS-2$
		}, this._configNode);

		var a = dojo.create('a', { //$NON-NLS-1$
			href: product["http://jazz.net/ns/vvc#configuration_fake"], //$NON-NLS-1$
			innerHTML: product.name
		}, this._configNode);

		new jazz.ui.ResourceLink({
			iconNode: icon
		}, a);
	},
	
	_initFromResourceVersion: function() {

		this._contextConfigVersionHeader && this._contextConfigVersionHeader.destroyRecursive();
		delete this._contextConfigVersionHeader;

		if (this.optionalSite && this.optionalSite.contextConfigVersionUri) {
			this._contextConfigVersionHeader = new com.ibm.relm.ple.web.ui.internal.views.ContextConfigVersionHeader({
				site: this.optionalSite
			});

			this._contextConfigVersionHeader.placeAt(this._headerNode, 'first'); //$NON-NLS-1$
		}

		var resourceVersion = this.resourceVersion;

		if (resourceVersion.createdMillis) {
			var createdSmart = dojo.replace(this.messages.createdOnDateX, [formatSmartDateTime(resourceVersion.createdMillis)]);
			var createdMedium = dojo.replace(this.messages.createdOnDateX, [formatMediumDateTime(resourceVersion.createdMillis)]);
			this._createdNode.innerHTML = html.escape(createdSmart);
			this._createdNode.title = createdMedium;
		}

		if (resourceVersion.modifiedMillis && resourceVersion.modifiedMillis !== resourceVersion.createdMillis) {
			var modifiedSmart = dojo.replace(this.messages.modifiedOnDateX, [formatSmartDateTime(resourceVersion.modifiedMillis)]);
			var modifiedMedium = dojo.replace(this.messages.modifiedOnDateX, [formatMediumDateTime(resourceVersion.modifiedMillis)]);
			this._modifiedNode.innerHTML = html.escape(modifiedSmart);
			this._modifiedNode.title = modifiedMedium;
		}

		if (this.isConfigVersion && resourceVersion.version) { //$NON-NLS-1$
			this._versionNode.innerHTML = html.escape(dojo.replace(this.messages.versionX, [resourceVersion.version]));
		}

		if (resourceVersion.creatorName) {
			this._creatorNode.innerHTML = html.escape(resourceVersion.creatorName);
		}

		if (resourceVersion.isImported){
			this._initImportDetails();
		}

		var forRtc = resourceVersion.rtcStream || resourceVersion.rtcComponent;

		if (forRtc) {
			this._initRtcDetails();
		}
		else {
			if (this._rtcInfoNode) {
				dojo.destroy(this._rtcInfoNode);
				delete this._rtcInfoNode;
			}
		}

		// Show Variability Expressions for all nodes unders a stream (components and grouping products).
		var showConditions = false;

		if (this.variableInclusion_enabled) {
			if (resourceVersion.rtcComponent) {
				showConditions = true;
			}
			// hide for Streams and Variability Parameters. Otherwise, show under streams.
			else if (!resourceVersion.rtcStream && resourceVersion.conditionVariables === undefined) {
				var site = TreeSelection.getSelectedSite();
				var parentStream = site && StreamManagement.getParentStreamProduct(site);
				if (parentStream) showConditions = true;
			}

			if (showConditions) {
				this._initConditionSection();
			}
			else {
				this._conditionsSection && this._conditionsSection.destroyRecursive();
				delete this._conditionsSection;
			}
		}			

		net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(resourceVersion.name);
		
		this._titleNode.innerHTML = com.ibm.relm.ple.web.ui.formatting.formatProductTitleForItem(resourceVersion);

		var classAndAltText = com.ibm.relm.ple.web.ui.formatting.getIconClassAndAltTextForItem(resourceVersion);

		// We override the classes here instead of .addClass since this view
		// used to be reused and needed to "reset" the icon to the default
		// classes first. I, Jay, don't think that's the case anymore, but
		// haven't had time to verify for 5.0, so I'm not changing this yet.
		dojo.attr(this._iconNode, {
			className: 'ple-icon r-left ' + classAndAltText[0], //$NON-NLS-1$
			alt: classAndAltText[1]
		});

		this._drawBranchTable(resourceVersion.branchDimensions || []);
		this._drawPropertiesTable();

		if (this.isOutsideProductTree) {
			this._drawLinks();
		}


		this.updateConditions();
		this.updateConfiguration();
	},

	uninitialize: function(){
		net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(''); //$NON-NLS-1$
		this._autoHeight && this._autoHeight.destroy();
		this._branchTable && this._branchTable.destroyRecursive();
		this.resourceVersionAudit && this.resourceVersionAudit.destroyRecursive();
		this._toolbar && this._toolbar.destroyRecursive();
		this._destroyResourceLinks();
		this._linksSection && this._linksSection.destroyRecursive();
		this._configSection && this._configSection.destroyRecursive();
		this._conditionsSection && this._conditionsSection.destroyRecursive();
		this._contextConfigVersionHeader && this._contextConfigVersionHeader.destroyRecursive();
		this.inherited(arguments);
	}
});

})();
