/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	// Understanding the word "slot":
	// Each node of the tree tree is logically a "slot" that different versions
	// of product can be put in to. Normally you don't think about the slot,
	// just the product in it. But in some cases there are no selected product
	// version for the slot. In this case it's still visible (as a little
	// dotted outline in the tree), but nothing is in that slot.
	//
	// Note that we are trying to use a very general term when describing this,
	// instead of trying to invent a new word. In that sense, whichever word
	// means "a place to hold stuff" in the translated language could be used.
	// This term is not currently used in any UI menus/actions so the exact
	// translation can be pretty loose I think.
	emptyProductPartHelpTextHtml: '<p>This slot is empty. The {product} for this slot does not have dimensions and values that match the parent {product} configuration. If this is incorrect, you can:<\/p>' //$NON-NLS-1$
	+ '<ul>' //$NON-NLS-1$
	+ '<li><a href="#" class="ple-EmptyPartView-replaceVersion">Replace Version...<\/a> to pin a particular {product} version.<\/li>' //$NON-NLS-1$
	+ '<li><a href="#" class="ple-EmptyPartView-remove">Remove<\/a> this part if it is no longer needed.<\/li>' //$NON-NLS-1$
	+ '<li>Edit the dimensions and values for the parent {product} configuration so that they match a {product} version for this slot.<\/li>' //$NON-NLS-1$
	+ '<li>Check out a branch of the missing {product} configuration from <a href="#" class="ple-EmptyPartView-auditHistory">Audit History<\/a> and change the dimensions and values to match the parent {product} configuration.<\/li>' //$NON-NLS-1$
	+ '<\/ul>', //$NON-NLS-1$

	emptyConfigurationPartHelpTextHtml: '<p>This slot is empty. The {product} configuration for this slot is not compatible with its parent configuration. If this is incorrect, you can:<\/p>' //$NON-NLS-1$
	+ '<ul>' //$NON-NLS-1$
	+ '<li><a href="#" class="ple-EmptyPartView-remove">Remove<\/a> this part if it is no longer needed.<\/li>' //$NON-NLS-1$
	+ '<\/ul>' //$NON-NLS-1$

});