/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/


(function()  {
dojo.provide("com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("jazz.ui.Wizard"); //$NON-NLS-1$
dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.wizard.SpecifyNameWizardStep"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.wizard.SpecifyParameterWizardStep"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.wizard.GuideStep"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "CreateNewDiagramWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "utilMessages"); //$NON-NLS-1$ //$NON-NLS-2$


//var wizardStepHeader = jazz.ui.wizard.WizardStepHeader;
//var wizardStep = jazz.ui.wizard.WizardStep;

dojo.declare("com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard",  //$NON-NLS-1$
		[jazz.ui.Wizard, dijit._Widget, dijit._Templated] ,{
	
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web",  "ui/internal/wizard/templates/CreateNewDiagramWizard.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,
		
	step1: null,
	step2: null,
	permissions: {},

	postMixInProperties: function() {
		this.inherited(arguments);

		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "CreateNewDiagramWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function() {
		this.inherited(arguments);
		
		// Step 1
		this.step1 = new com.ibm.relm.explorer.web.ui.internal.wizard.SpecifyNameWizardStep({
			wizard: this,
			stepTitle: this.messages.nameWizardStep,
			permissions: this.permissions
		});
		this.addStep(this.step1);
		
		// Step 2
		this.step2 = new com.ibm.relm.explorer.web.ui.internal.wizard.SpecifyParameterWizardStep({
			wizard: this,
			stepTitle: this.messages.parameterWizardStep
		});
		this.addStep(this.step2);
		
		// Step 3
//		this.step3 = new com.ibm.relm.explorer.web.ui.internal.wizard.GuideStep({
//			wizard: this,
//			stepTitle: this.messages.guideStep
//		});
//		this.addStep(this.step3);

		this.selectStep(1);

	}	
	
});

var BLANK_TEMPLATE = "__blank__"; //$NON-NLS-1$

com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard.openWizard = function(shared){
	// invoke New Diagram Wizard
	var _messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "utilMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	// check permission if shared view
	jazz.client.xhrGet({
		url: com.ibm.relm.explorer.web.ui.configServiceUri + "?id=-1&permission=", //$NON-NLS-1$ 
		preventCache: true,
		handleAs: "json", //$NON-NLS-1$
		load: function(response, ioArgs){
			
			var permissions = null; 
			permissions = com.ibm.relm.explorer.web.ui.internal.util.parsePermission(response);
			
			if((permissions && permissions.createPermission) || !shared) {
				// has create permission or creating personal view
				var wizard = new com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard({
					openFromSharedFolder: shared,
					permissions: permissions,
					primaryTitle: _messages.wizardTitle,
					customProcessFinish: function(resource) {
						
						var name = wizard.step1.getViewName();;
						var templateId = wizard.step1.getViewUri();
						var shared = wizard.step1.selectedFolder.shared;
						var parentUUID = wizard.step1.selectedFolder.folderUUID;
						var params = wizard.step2.parameters;
						var paramString = dojo.toJson(params);
						
						var type = (templateId == BLANK_TEMPLATE)? type = "blank" : type = "template"; //$NON-NLS-2$ //$NON-NLS-1$

						// TODO:
						var url = com.ibm.relm.explorer.web.ui.configServiceUri;

						jazz.client.xhrPost({
							handleAs: 'json',  //$NON-NLS-1$

							url: url,
							content: {
								createType: type,
								diagramName: name,
								shared: shared,
								templateId: templateId,
								parentUUID: parentUUID,
								parameters: paramString
							},
							load: function(response, xhrArgs) {
								var location = xhrArgs.xhr.getResponseHeader("Location");//$NON-NLS-1$
								dojo.publish("com.ibm.relm.explorer.web.VIEW_CREATED", [{shared:shared, viewUri: location}]); //$NON-NLS-1$
							},
							error: function(error) {
								alert(error.message);
							}
						});
						
					}
				});
				wizard.connect(wizard, "close", function(){ //$NON-NLS-1$
					wizard.destroy();
				});
				
				wizard.startup();				
			} else {
				alert(_messages.noPermissionToCreateView);
			}
		},
		error: function(error) {
			alert(error.message);
		}
	});	
};


}) ();