/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

(function()  {
dojo.provide("com.ibm.relm.explorer.web.ui.internal.wizard.SpecifyParameterWizardStep");  //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dijit.InlineEditBox"); //$NON-NLS-1$

dojo.require("jazz.ui.wizard.WizardStepHeader"); //$NON-NLS-1$
dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$
dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.SetParametersTable"); //$NON-NLS-1$


dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "CreateNewDiagramWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var WizardStepHeader = jazz.ui.wizard.WizardStepHeader;
var WizardStep = jazz.ui.wizard.WizardStep;

dojo.declare("com.ibm.relm.explorer.web.ui.internal.wizard.SpecifyParameterWizardStep",  //$NON-NLS-1$
		[WizardStep, dijit._Widget, dijit._Templated] ,{
	
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web",  "ui/internal/wizard/templates/SpecifyParameterWizardStep.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,
	
	parameters:[],
	
	postMixInProperties: function() {
		this.inherited(arguments);
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "CreateNewDiagramWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function() {
		this.inherited(arguments);
		this.connect(this._paramTable, "onUpdateParamValue", function(){//$NON-NLS-1$
			this.triggerButtonStateUpdate();			
		});
		this.header = new WizardStepHeader ({stepTitle: ""}); //$NON-NLS-1$
		this.stepHeaderArea.appendChild(this.header.domNode);
		this.startup();
	},
	
	destroy: function(){
		this.inherited(arguments);		
	},
	
//	_skippedToNext: false,
	focusStep: function() {
		this.parameters = this.wizard.templateParams;
		this._paramTable.setParameters(this.parameters);
		// hack to skip this page if the target template doesn't have parameter 
//		if(!this.parameters || this.parameters.length == 0){
//			if(this._skippedToNext){
//				this.onPrevious();
//				this._skippedToNext = false;
//			}else{
//				this.onNext();
//				this._skippedToNext = true;
//			}
//		}
	},
	
	////////////////////////////////////////

	canFinish: function() {
		// check all parameters have been set
		var hasEmptyParams = dojo.some(this.parameters, function(param){ 
			return !param.value || dojo.string.trim(param.value).length == 0; 
		}); 
		if (hasEmptyParams) {
			this.header.showMessage({
				summary: this.messages.noValueSpecified, 
				type: jazz.ui.MessageBox.STATUS_TYPES.WARNING});
		} else {
			this.header.hideMessage();
		}
		// even if some parameters are empty, allow to finish
		return true;
	},
	
	canCancel: function() {
		return true;
	}
	
	
	
});

}) ();