/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.xmlutils"); //$NON-NLS-1$

(function(){

com.ibm.relm.explorer.web.ui.internal.xmlutils = {
		
	getChildNodes: function(node){
		return (node && (node.children || node.childNodes)) || [];
	},
	
	getChildNodesByName: function(nodeName, node){
		var children = com.ibm.relm.explorer.web.ui.internal.xmlutils.getChildNodes(node);
		var nodes = [];
		dojo.forEach(children, function(child){
			if(child.nodeName == nodeName){
				nodes.push(child);
			}
		});
		return nodes;
	},
		
	getSubNodes: function(xpath, node){
		return dojo.query(xpath, node);
	},
		
	findNode: function(xpath, node){
		var nodes = this.getSubNodes(xpath, node);
		return nodes.length > 0 ? nodes[0] : null;		
	},
		
	getContent: function(xpath, node){
		var node = this.findNode(xpath, node);
		return node ? (node.textContent || node.text) : null;
	},
	
	getBooleanValue: function(propValue) {
		return (propValue == "true") ? true : ((propValue == "false") ? false : propValue); //$NON-NLS-1$ //$NON-NLS-2$
	}
};

})();