dojo.provide('com.ibm.relm.common.web.ui.lqeclient'); //$NON-NLS-1$

dojo.require('com.ibm.relm.common.web.ui.LqeAuthInterceptor'); //$NON-NLS-1$

/**
 * DEPRECATED: Just require com.ibm.relm.common.web.ui.LqeAuthInterceptor instead.
 * 
 * XHR decorators that will automatically open the LQE user authorization page
 * in response to an error header from LQE. These can be used as direct replacements
 * for jazz.client.xhr methods when a call is known to deal with LQE.
 * 
 * Methods will automatically be retried after the auth window is closed by the user
 * or they have waited too long to log in, normally making the authorization
 * transparent to the called.
 */
(function() {

/**
 * XHR method that overrides the xhrArgs.error handle
 * to open the LQE auth dialog if necessary. The original request
 * will be retried once the auth window closes. The original error handler
 * will be deferred to once this code has had its chance.
 * @param  {string}  method  HTTP verb to use.
 * @param  {object}  xhrArgs dojo XHR args.
 * @param  {boolean} hasBody pass true for POST and PUT. That's what dojo wants.
 * @return {dojo.Deferred}          result from true XHR call.
 */
function xhr(/*String*/ method, /*dojo.__XhrArgs*/ xhrArgs, /*Boolean?*/ hasBody) {
	console.warn('lqeclient is deprecated, though still functional for now. Instead, simply dojo.require com.ibm.relm.common.web.ui.LqeAuthInterceptor and use standard jazz.client.xhr* methods.'); //$NON-NLS-1$
	return jazz.client.xhr(method, xhrArgs, hasBody);	// start with original request args.
}

dojo.mixin(com.ibm.relm.common.web.ui.lqeclient, {
	xhr: xhr,

	xhrGet: function(args) {
		return this.xhr('GET', args); //$NON-NLS-1$
	},

	xhrPut: function(args) {
		return this.xhr('PUT', args, true); //$NON-NLS-1$
	},

	xhrPost: function(args) {
		return this.xhr('POST', args, true); //$NON-NLS-1$
	},

	xhrDelete: function(args) {
		return this.xhr('DELETE', args); //$NON-NLS-1$
	},

	xhrHead: function(args) {
		return this.xhr('HEAD', args); //$NON-NLS-1$
	}
});

})();