/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.page.DiagramsWelcomePage");  //$NON-NLS-1$

dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("dojox.xml.parser");  //$NON-NLS-1$
dojo.require("jazz.ui.SearchBox"); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.HelpTwistie'); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard"); //$NON-NLS-1$
dojo.require("com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "DiagramsWelcomeMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var parser= dojox.xml.parser;
var SearchBox= jazz.ui.SearchBox;
var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var leServiceUtils = com.ibm.relm.le.ui.internal.LifecycleElementServiceUtils;

dojo.declare(
	"com.ibm.relm.explorer.web.ui.page.DiagramsWelcomePage", //$NON-NLS-1$
	[ dijit._Widget, dijit._Templated ], {
		
		templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/page/templates/DiagramsWelcomePage.html"), //$NON-NLS-1$ //$NON-NLS-2$
		widgetsInTemplate: true,
		
		_messageForTextTrackResources: null,
		
		_searchBoxDiv: null,
		
		_allDiagramsAnchor1: null,
		
		_allDiagramsAnchor2: null,
		
		_createDiagramAnchor1: null,
		
		_createDiagramAnchor2: null,
						
		constructor: function() {
			this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "DiagramsWelcomeMessages"); //$NON-NLS-1$ //$NON-NLS-2$
			var _miniAnchor= "<a target='_blank' href='/clmhelp/topic/com.ibm.jazz.dashboard.doc/topics/c_about_dash_mini.html' class='img-mini-db'>${0}</a>"; //$NON-NLS-1$
			_miniAnchor= dojo.string.substitute(_miniAnchor, [this._messages.textMiniDashboard]);
			this._messageForTextTrackResources= dojo.string.substitute(this._messages.textTrackResources, [_miniAnchor]);
		},
		
	    postCreate: function() {
	    	var self=this;
			this.permissions = {};		
			leServiceUtils.getPermissions().then(function(results){
				dojo.forEach(results, function(p){
					if(p == "modify") self.permissions.modifyPermission = true; //$NON-NLS-1$
				});
				if(!self.permissions.modifyPermission) {
					dojo.addClass( self.browseLEList, "hideSection"); //$NON-NLS-1$
					dojo.addClass( self.createLE, "hideSection"); //$NON-NLS-1$
				}
			});
            this.connect(this._createDiagramAnchor1, 'onclick', dojo.hitch(this, "_handleCreateDiagramClicked")); //$NON-NLS-1$ //$NON-NLS-2$
    		this.connect(this._createDiagramAnchor2, 'onclick', dojo.hitch(this, "_handleCreateDiagramClicked")); //$NON-NLS-1$ //$NON-NLS-2$
//          this.connect(this._allDiagramsAnchor1, 'onclick', dojo.hitch(this, "_handleAllDiagramsClicked"));
//          this.connect(this._allDiagramsAnchor2, 'onclick', dojo.hitch(this, "_handleAllDiagramsClicked"));
//          var parms= {};
//    		var searchBox= new SearchBox(parms);
//    		parser.replaceChildren(this._searchBoxDiv, searchBox.domNode);
            this.inherited(arguments);
	    },
	    
	    destroy: function() {
			for (var i=0; i < this._contentWidgets.length; i++) {
				var widget = this._contentWidgets[i];
				widget.destroy();
			}
			this.inherited(arguments);
		},
	    		
		constructPage: function() {
			if (!this._contentWidgets) {
				this._contentWidgets = [];
			}
		},
		
		_loadPage: function() {
			
		},
		
		_handleAllDiagramsClicked: function() {
			// compute URL instead of having it in the HTML file
		},
		
		_handleCreateDiagramClicked: function(e) {
			dojo.stopEvent(e);
			window.location.href = "#action=com.ibm.relm.explorer.web.showViewList&scope=personal"; //$NON-NLS-1$
			com.ibm.relm.explorer.web.ui.internal.wizard.CreateNewDiagramWizard.openWizard();
		},

		_tbd: function(e) {
			dojo.stopEvent(e);
			alert("tbd"); //$NON-NLS-1$
		}
	});
})();