/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.page.QueriesWelcomePage");  //$NON-NLS-1$

dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("dojox.xml.parser");  //$NON-NLS-1$
dojo.require("jazz.ui.SearchBox"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "QueriesWelcomeMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var parser= dojox.xml.parser;
var SearchBox= jazz.ui.SearchBox;
var PlatformUI = net.jazz.ajax.ui.PlatformUI;

dojo.declare(
	"com.ibm.relm.explorer.web.ui.page.QueriesWelcomePage", //$NON-NLS-1$
	[ dijit._Widget, dijit._Templated ], {
		
		templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/page/templates/QueriesWelcomePage.html"), //$NON-NLS-1$ //$NON-NLS-2$
		
		_messages: dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "QueriesWelcomeMessages"), //$NON-NLS-1$ //$NON-NLS-2$
		
		_messageForTextTrackResources: null,
		
		constructor: function() {
			var _miniAnchor= "<a target='_blank' href='/clmhelp/topic/com.ibm.jazz.dashboard.doc/topics/c_about_dash_mini.html' class='img-mini-db'>${0}</a>"; //$NON-NLS-1$
			_miniAnchor= dojo.string.substitute(_miniAnchor, [this._messages.textMiniDashboard]);
			this._messageForTextTrackResources= dojo.string.substitute(this._messages.textTrackResources, [_miniAnchor]);
		},
		
	    postCreate: function() {
            this.inherited(arguments);
	    },
	    
	    destroy: function() {
			for (var i=0; i < this._contentWidgets.length; i++) {
				var widget = this._contentWidgets[i];
				widget.destroy();
			}
			this.inherited(arguments);
		},
	    		
		constructPage: function() {
			if (!this._contentWidgets) {
				this._contentWidgets = [];
			}
		},
		
		_runSearchEvent: function(e) {
			dojo.stopEvent(e);

			var searchString = this._searchBox.value;

			window.location = '#' + dojo.objectToQuery({ //$NON-NLS-1$
				action: 'relm.queries.search', //$NON-NLS-1$
				q: searchString,
				scope: 'all', //$NON-NLS-1$
				time: new Date().getTime()
			});
		},

		_loadPage: function() {
			
		},
		
		_handleAllQueriesClicked: function() {
			// compute URL instead of having it in the HTML file
		},
		
		_handleCreateQueryClicked: function() {
			// compute URL instead of having it in the HTML file
		},

		selectSearch: function() {
			this._searchBox.select();	
		}
	});
})();