/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide('com.ibm.relm.ple.web.ui.pages.MainWelcomePage'); //$NON-NLS-1$


dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require('net.jazz.ajax.ui.PlatformUI'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.picker.LqeArtifactPicker'); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.ple.web.ui.pages", "MainWelcomeMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var PlatformUI = net.jazz.ajax.ui.PlatformUI;

var searchFocusAttempts_ = 0;

dojo.declare(
	"com.ibm.relm.ple.web.ui.pages.MainWelcomePage", //$NON-NLS-1$
	[ dijit._Widget, dijit._Templated ], {

		templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','ui/templates/MainWelcomePage.html'), //$NON-NLS-1$ //$NON-NLS-2$
		widgetsInTemplate: true,
		
		_messages: dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui.pages', 'MainWelcomeMessages'), //$NON-NLS-1$ //$NON-NLS-2$
		_messageForTextTrackResources: null,

		constructor: function() {
			var _miniAnchor= '<a target="_blank" href="/clmhelp/topic/com.ibm.jazz.dashboard.doc/topics/c_about_dash_mini.html" class="img-mini-db">${0}</a>'; //$NON-NLS-1$
			_miniAnchor= dojo.string.substitute(_miniAnchor, [this._messages.textMiniDashboard]);
			this._messageForTextTrackResources = dojo.string.substitute(this._messages.textTrackResources, [_miniAnchor]);
		},

		postCreate: function() {
			this.inherited(arguments);
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction('relm.welcome', this, 'init'); //$NON-NLS-1$ //$NON-NLS-2$
		},

		_showQuickSearch: function() {
			var searchInput = dojo.query('.jazz-ui-BannerSearchBox .SearchInputText')[0]; //$NON-NLS-1$

			if (!searchInput) {
				if (searchFocusAttempts_ >= 20) return;
				searchFocusAttempts_++;

				var self = this;
				setTimeout(function() {
					self._showQuickSearch();
				}, 250);
				return;
			}

			var searchBox = dijit.getEnclosingWidget(searchInput);

			// Find the product provider and use that to ensure we have the right scope.
			dojo.forEach(searchBox.providers, function(provider) {
				if (provider.declaredClass === 'com.ibm.relm.explorer.web.ui.page.IndexSearchProvider') { //$NON-NLS-1$
					searchBox._setScope({
						provider: provider,
						scope: provider.scopes[0],
						focusText: false
					});

					// Now focus on the box.
					searchInput.focus();
				}
			});
		},

		init: function() {
			if (!this._inited) {
				this._showQuickSearch();
				this._inited = true;
			}
		}
	});
})();