/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$

(function() {
dojo.provide("com.ibm.relm.ple.web.ui.pages.ProductComponetMenu"); //$NON-NLS-1$

dojo.require("jazz.app._ComponentMenu"); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.ple.web.ui.pages", "ProductComponentMenuMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('relm.app.Permissions'); //$NON-NLS-1$
dojo.require('net.jazz.ajax.ui.PlatformUI'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.ManageDimensionsPage'); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.editor.CapabilityComponentMenu"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.editor.PageHelper"); //$NON-NLS-1$

//This contains hints for how the menu should do wrapping.
//var wrapHint = jazz.ui.internal.MegaMenu.wrapHint;
var PAGE_ID = "com.ibm.relm.ple.web.configgroupings.EditConfigGrouping"; //$NON-NLS-1$

//This code was modeled off the code I found in "ModelingComponentMenu.js" from the DM code.
dojo.declare("com.ibm.relm.ple.web.ui.pages.ProductComponetMenu", com.ibm.relm.common.web.ui.editor.CapabilityComponentMenu, { //$NON-NLS-1$

	_basicPrefix: "#action=jazz.viewPage&id=com.ibm.relm.ple.web.ui.pages.", //$NON-NLS-1$

	_messages: dojo.i18n.getLocalization("com.ibm.relm.ple.web.ui.pages", "ProductComponentMenuMessages"), //$NON-NLS-1$ //$NON-NLS-2$

	_highlightedNode: null,

	constructor: function()
	{
		this.inherited(arguments);
	},

	addCapabilityComponentMenuItems: function() {

		this.inherited(arguments);
		
		this.createMenuItems();
	},

	getPageId: function(){
		return PAGE_ID;
	},
	
	getPageHelperClass: function() {
		return com.ibm.relm.common.web.ui.editor.PageHelper;
	},

	createMenuItems: function() {
		//Take a look at MegaMenu.js to get some decent documentation for what is allowed here or at least some documentation
		//for addItemByArgs.
		var welcomePage = this.addItemByArgs({
			href: '#action=ple.welcome', //$NON-NLS-1$
			label: this._messages.welcomeToProducts,
			iconClass: 'ple-icon-product' //$NON-NLS-1$
		});
		welcomePage.onClick = dojo.hitch(this, "_highlightNode", welcomePage); //$NON-NLS-1$

		this.addTitle(this._messages.headerQueries);

		var recents = this.addItemByArgs({
			href: '#action=ple.browse_products&show=recents', //$NON-NLS-1$
			label: this._messages.recentConfigs,
			iconClass: 'ple-icon-recentProducts' //$NON-NLS-1$
		});
		recents.onClick = dojo.hitch(this, "_highlightNode", recents); //$NON-NLS-1$
		dojo.query('.MenuItemContent', recents.domNode).addClass('r-small-margin-b'); //$NON-NLS-1$ //$NON-NLS-2$

		var favorites = this.addItemByArgs({
			href: '#action=ple.browse_products&show=favorites', //$NON-NLS-1$
			label: this._messages.favoriteConfigs,
			iconClass: 'ple-icon-favorite' //$NON-NLS-1$
		});
		favorites.onClick = dojo.hitch(this, "_highlightNode", recents); //$NON-NLS-1$
		dojo.query('.MenuItemContent', favorites.domNode).addClass('r-small-margin-b'); //$NON-NLS-1$ //$NON-NLS-2$

		if (relm.app.Permissions.canProductsModify()) {

			this.addItemByArgs({
				href: '#action=ple.manage_config_groupings', //$NON-NLS-1$
				label: this._messages.configGroupings,
				iconClass: 'ple-icon-grouping' //$NON-NLS-1$
			});

			this.addTitle(this._messages.headerCreate);

			var self = this;
			
			this.addItemByArgs({
				label: this._messages.createConfiguration,
				iconClass: 'ple-icon-createConfigVersion', //$NON-NLS-1$
				onClick: function() {
					self.createTopConfigVersion();
				}
			});
		}

		if (relm.app.Permissions.canProductsBranch()) {
			this.addTitle(this._messages.manageHeading);

			this._manageDimensionsItem = this.addItemByArgs({
				href: '#action=ple.manage_dimensions', //$NON-NLS-1$
				label: this._messages.dimensions,
				iconClass: 'ple-icon-dimension' //$NON-NLS-1$
			});
		}
	},

	createTopConfigVersion: function() {
		net.jazz.ajax.ui.PlatformUI.getWorkbench().viewPage('com.ibm.relm.ple.web.ui.pages.ProductsPage', function() { //$NON-NLS-1$
			com.ibm.relm.ple.web.ui.productapi.createConfigVersion();
		});
	},

	//The following two functions were taken from rmps.app.ui.internal.pages.SideNavigation.
	_clearHighlight: function() {
		if (this._highlightedNode) {
			dojo.removeClass(this._highlightedNode, "selected"); //$NON-NLS-1$
		}
	},

	_highlightNode: function(item, event){
		var node = item.domNode;
		if (this._highlightedNode != node) {
			this._clearHighlight();
			dojo.addClass(node, "selected"); //$NON-NLS-1$
			this._highlightedNode = node;
		}
	},

	onOpen: function() {
		this.inherited(arguments);

		if (this._manageDimensionsItem) {
			dojo.toggleClass(this._manageDimensionsItem.containerNode, 'j-dirty', !!com.ibm.relm.ple.web.ui.branch.ManageDimensionsPage.dirty); //$NON-NLS-1$
		}
	}
});

})();
