	/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.ple.web.ui.pages.ProductsPage"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.ple.web.ui.pages", "ProductsPageMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.ple.web.ui", "TreeMenuFactoryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dijit.form.Button"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.ActionRegistry"); //$NON-NLS-1$
dojo.require("com.ibm.relm.ple.web.ui.picker.LqeArtifactPicker"); //$NON-NLS-1$
dojo.require("com.ibm.relm.ple.web.ui.picker.ConfigurationPicker"); //$NON-NLS-1$
dojo.require("com.ibm.relm.ple.web.ui.internal.views.ProductView"); //$NON-NLS-1$
dojo.require("com.ibm.relm.ple.web.ui.internal.views.ArtifactView"); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.CreateBaselineDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.CreateBranchDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.UseBranchDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.ReplaceVersionDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.RemoveDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.ProductSidebar'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.picker.AddUrlDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.picker.ProductPicker'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.EasyMessageBox'); //$NON-NLS-1$
dojo.require('jazz.ui.MessageBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.ProductBreadcrumbs'); //$NON-NLS-1$
dojo.require('jazz.ui.Toolbar'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.Button'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.MenuButton'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.Separator'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeSelection'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeMenuFactory'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Drawer'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.AutoHeightBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.MoveReusePlaceState'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Goto'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.internal.views.MultiSelectView'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.StatusMessage'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.tree.TreeRefresh'); //$NON-NLS-1$
dojo.require('relm.app.Permissions'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.StreamManagement'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.ProductSearchProvider'); //$NON-NLS-1$
dojo.require('jazz.util.html'); //$NON-NLS-1$
dojo.require("com.ibm.relm.ple.web.productedit.EditPropertiesDialog"); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.advanced.AdvancedSettings'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.ReplaceBaselineDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.internal.views.EmptyPartView'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.ExportProductDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.VvcRefresh'); //$NON-NLS-1$

(function(){

var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var productapi = com.ibm.relm.ple.web.ui.productapi;
var TreeSelection = com.ibm.relm.ple.web.ui.TreeSelection;
var MoveReusePlaceState = com.ibm.relm.ple.web.ui.MoveReusePlaceState;
var Goto = com.ibm.relm.ple.web.ui.Goto;
var Permissions = relm.app.Permissions;
var StreamManagement = com.ibm.relm.ple.web.rtc.StreamManagement;
var AdvancedSettings = com.ibm.relm.ple.web.advanced.AdvancedSettings;

// Start out as a flag saying this hasn't bee loaded yet.
var AnalysisUtil = false;

jazz.core.loader.load_async('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil', function() { //$NON-NLS-1$
	// Replace the flag with the actual object once loaded.
	AnalysisUtil = dojo.getObject('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil'); //$NON-NLS-1$
});

var messages = dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui.pages', 'ProductsPageMessages'); //$NON-NLS-1$ //$NON-NLS-2$

// All the toolbar button tooltips are the same as on the context menu, so just mixin those messages
dojo.mixin(messages, dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui', 'TreeMenuFactoryMessages')); //$NON-NLS-1$ //$NON-NLS-2$

function buildNoSelectionNode(showLoadingMessage) {
	var node = dojo.create('div', { //$NON-NLS-1$
		className: 'ple-ProductsPage-noSelection' //$NON-NLS-1$
	});


	node.innerHTML = showLoadingMessage ?
		messages.loading: messages.emptySidePane;
	return node;
}

dojo.declare(
	'com.ibm.relm.ple.web.ui.pages.ProductsPage', //$NON-NLS-1$
	[ dijit._Widget, dijit._Templated ],
	{
		messages: messages,
		templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','ui/pages/templates/ProductsPage.html'), //$NON-NLS-1$ //$NON-NLS-2$
		widgetsInTemplate: true,

		constructor: function()
		{	
			this._rootUri = null;
			this._filterSelectId = dijit.getUniqueId('ple-ProductsPage-filter'); //$NON-NLS-1$

			// This is a String from localStorage, but we want a boolean
			this._drawerInitiallyCollapsed = window.localStorage['com.ibm.relm.ple.detailsView.collapsed']; //$NON-NLS-1$
			this._drawerInitiallyCollapsed = this._drawerInitiallyCollapsed === 'true'; //$NON-NLS-1$
		},

		_onTreeFilterChange: function(e) {
			var filterOption = this._filterSelect.options[this._filterSelect.selectedIndex];
			var newTreeFilter = filterOption.value;

			window.location.href = '#' + dojo.objectToQuery({ //$NON-NLS-1$
				action: 'ple.browse_products', //$NON-NLS-1$
				show: newTreeFilter
			});
		},

		/**
		 * Adds a button to log the selected tree item in debug=true mode.
		 */
		_addDumpButton: function() {
			if (window.djConfig.isDebug) {
				this._toolbar.addChild(new jazz.ui.toolbar.Separator());

				this._toolbar.addChild(
					new jazz.ui.toolbar.Button({
						title: 'Dump selected item to console.debug', //$NON-NLS-1$
						label: 'Dump', //$NON-NLS-1$
						imgSrc: 'com.ibm.relm.ple.web/ui/images/log-selected-item.gif', //$NON-NLS-1$
						onClick: dojo.hitch(this, this.logSelectedItem)
				}));

			}
		},

		_hideExportButton: function() {
			var exportEnabled = !!AdvancedSettings.product_export;

			if (!exportEnabled){
				dojo.style(this._exportButton.domNode, { display: 'none' } ); //$NON-NLS-1$
			}
		},

		/**
		 * Shows an "empty" details pane. Possiblly with help text for when no product
		 * is selected.
		 *
		 * @param  {object} args args.showLoadingMessage will replace the normal help text with a loading message
		 *                       for slow to load products. args.clearTreeSelection will deselect the item in the tree visually, which may
		 *                       be needed after loading a bookmark to a dead product.
		 */
		clearDetailsPane: function(args) {
			args = args || {};
			this._detailsView && this._detailsView.destroyRecursive();
			this._detailsView = null;
			this._drawer.setDrawerContent(buildNoSelectionNode(args.showLoadingMessage));
			if (args.clearTreeSelection) {
				this._sidebar.deselectTrees();
			}
		},

		postCreate: function() {
			this._autoScrollHeight = new com.ibm.relm.common.web.ui.AutoHeightBox(this._drawer.domNode, {
				listenOnPage: 'com.ibm.relm.ple.web.ui.pages.ProductsPage' //$NON-NLS-1$
			});

			this._drawer.watch('collapsed', function(property, oldValue, newValue) { //$NON-NLS-1$
				window.localStorage['com.ibm.relm.ple.detailsView.collapsed'] = String(newValue); //$NON-NLS-1$
			});

			this._addDumpButton();
			this._hideExportButton();

			this.clearDetailsPane();

			dojo.addClass(this.domNode, 'ple-sidebar-page'); //$NON-NLS-1$

			this.subscribe('ple.pick_contribution', this.showContributionPicker); //$NON-NLS-1$
			this.subscribe('ple.pick_configuration', this.showConfigurationPicker); //$NON-NLS-1$
			this.subscribe('ple.compare', this.compare); //$NON-NLS-1$
			this.subscribe('ple.remove_anything', this._removeAnything); //$NON-NLS-1$
			this.subscribe('ple.remove_child_config', this._removeChildConfig); //$NON-NLS-1$
			this.subscribe('ple.find_artifact_use', this.gotoFindArtifactUse); //$NON-NLS-1$
			this.subscribe('ple.create_branch', this.showCreateBranchDialog); //$NON-NLS-1$
			this.subscribe('ple.check_out', this.checkOut); //$NON-NLS-1$
			this.subscribe('ple.edit_properties', this.showSelectedEditProperties); //$NON-NLS-1$
			this.subscribe('ple.redact', this.redactProducts); //$NON-NLS-1$
			this.subscribe('ple.create_snapshot', this.createSelectedSnapshot); //$NON-NLS-1$

			this.subscribe('ple.refresh', this.refreshTree); //$NON-NLS-1$
			this.subscribe('ple.branch_was_updated', this.refreshTree); //$NON-NLS-1$
			this.subscribe('ple.refresh_selected_path', this.refreshSelectedPath); //$NON-NLS-1$

			this.subscribe('ple.use_branch', this.showUseBranchDialog); //$NON-NLS-1$
			this.subscribe('ple.replace_version', this.showReplaceVersionDialog); //$NON-NLS-1$
			this.subscribe('ple.select_nothing', this.selectNothing); //$NON-NLS-1$
			this.subscribe('ple.debug_selected_item', this.logSelectedItem); //$NON-NLS-1$

			this.subscribe('ple.load_any_single_item_details', this.loadAnySingleItemDetails); //$NON-NLS-1$
			this.subscribe('ple.load_item_version_or_config_version_details', this.loadItemVersionOrConfigVersionDetails); //$NON-NLS-1$
			this.subscribe('ple.load_empty_part', this.loadEmptyPartDetails); //$NON-NLS-1$
			this.subscribe('ple.load_link_details', this.loadLinkDetails); //$NON-NLS-1$
			this.subscribe('ple.multi_select_details', this.loadMultiSelectDetails); //$NON-NLS-1$
			this.subscribe('ple.clear_details', this.clearDetailsPane); //$NON-NLS-1$

			this.subscribe('ple.show_drag_message', this.showDragMessage); //$NON-NLS-1$
			this.subscribe('ple.hide_drag_message', this.hideDragMessage); //$NON-NLS-1$

			this.connect(TreeSelection, 'onSelectionChange', this._enableToolbarButtons); //$NON-NLS-1$
			this.connect(MoveReusePlaceState, 'onChosenChange', this._enableToolbarButtons); //$NON-NLS-1$

			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("ple.browse_products", this, 'browseProductsAction'); //$NON-NLS-1$ //$NON-NLS-2$

			ActionRegistry.registerAction('ple.view_path', this, 'selectProductTreePathAction'); //$NON-NLS-1$ //$NON-NLS-2$

			delete this._filterSelectId;

			var self = this;
			StreamManagement.awaitSettings().then(function(settings) {
				if (settings.enabled) {
					self._addRtcStreamManagementMenu();
				}
			});

			// Load the product grouping list now or whenever notified.
			this.loadConfigGroupings();
			this.subscribe('ple.config_groupings_did_change', this.loadConfigGroupings); //$NON-NLS-1$

			//Load recently imported groupings
			this.loadRecentImports();
			this.subscribe('ple.recent_imports_did_change', this.loadRecentImports); //$NON-NLS-1$

			this.enableRedaction();
		},

		onShow: function() {
			PlatformUI.getWorkbench().setTitle(this.messages.browseProducts);
		},
		
		/**
		 * Hide redaction toolbar item if not jazz admin
		 */
		enableRedaction: function() {
			if (!Permissions.canProductsRedact()) {
				dojo.addClass(this._redactButton.domNode, 'j-hide'); //$NON-NLS-1$
			}			
		},

		_redactSelected: function() {
			var allSelectedSites = TreeSelection.getAllSelectedSites();
			this.redactProducts(allSelectedSites);
		},

		importProducts: function(args) {
			var site = TreeSelection.getSelectedSite();
			productapi.importProducts(site);
		},

		_exportSelected: function() {
			var d = new com.ibm.relm.ple.web.ui.ExportProductDialog({site: TreeSelection.getSelectedSite()});
			d.startup();
		},

		redactProducts: function(products) {
			productapi.redactProducts(products, function(path) {
				com.ibm.relm.ple.web.ui.tree.TreeRefresh.refresh({
					selectPath: path
				});
			});
		},

		refresh: function(){
			com.ibm.relm.ple.web.ui.tree.TreeRefresh.refresh().then(function() {
			 	dojo.publish('ple.detail_view.refresh'); //$NON-NLS-1$
			});
		},

		/**
		 * This is intended to be called if a product/config was updated when the products page was not showing (ex history page)
		 */
		refreshSelectedPath: function() {
			var selectedSite = TreeSelection.getSelectedSite();

			com.ibm.relm.ple.web.ui.tree.TreeRefresh.refresh({
				selectPath: selectedSite && selectedSite.path,
				noGoto: true
			});
		},

		showSelectedEditProperties: function() {
			var selectedSite = TreeSelection.getSelectedSite();

			TreeSelection.loadSelectedSiteWithUserProperties()
			.then(function(site) {
				var dialog = new com.ibm.relm.ple.web.productedit.EditPropertiesDialog({
					site: site
				});

				dialog.startup();
			})
			.otherwise(function(errorObject) {
				dojo.publish('ple.product_tree_error', [errorObject]); //$NON-NLS-1$
			});
		},

		loadRecentImports: function(gotoImportedBaselinePathSegment) {

			var self = this;
			jazz.client.xhrGet({
				url: net.jazz.ajax._contextRoot + "/ple/recent_imports", //$NON-NLS-1$
				handleAs: "json", //$NON-NLS-1$

				load: function(info) {
					if (info.hasRecentlyImportedBaselines) {
						self.recentlyImportBaselinesOption.style.display = ''; //$NON-NLS-1$

						if (gotoImportedBaselinePathSegment) {
							Goto.gotoRecentlyImportedBaselines(gotoImportedBaselinePathSegment);
						}
					}
					else {
						self.recentlyImportBaselinesOption.style.display = 'none'; //$NON-NLS-1$
					}
				}
			});
		},

		loadConfigGroupings: function() {
			var self = this;
			this.loadingConfigGrouping = jazz.client.xhrGet({
					url: net.jazz.ajax._contextRoot + "/ple/config_grouping", //$NON-NLS-1$
					handleAs: "json", //$NON-NLS-1$
					content: {
						method: "loadGroupings" //$NON-NLS-1$
					},
					load: function(groupings) {
						//Delete old product groupings on this list
						dojo.empty(self.treeGroupings);

						//Add new product groupings
						if (groupings && groupings.length > 0) {
							self.treeGroupings.style.display = ''; //$NON-NLS-1$
							dojo.forEach(groupings, function(grouping){
								dojo.create("option", { //$NON-NLS-1$
									innerHTML: jazz.util.html.escape(grouping.name),
									value: grouping.uri
								}, self.treeGroupings, "last"); //$NON-NLS-1$
							}, self);
						}
						else {
							self.treeGroupings.style.display = 'none'; //$NON-NLS-1$
						}

						// If loading a project grouping for the URI, we might
						// have loaded that grouping before we even know it's
						// name. Now that we know all the names, check the
						// current ?show value and set it again so that the
						// dropdown scope menu will reflect the current
						// project grouping. This feels a little brittle.
						var hash = dojo.doc.location.hash;
						var hashObject = dojo.queryToObject(hash.substring(1));
						self._selectFilterValue(hashObject.show);
					},
					error: function(error, args) {
						dojo.publish("ple.product_tree_xhrError", [args.xhr, true]); //$NON-NLS-1$
					},
					handle: function() {
						delete self.loadingConfigGrouping;
					}
			});
		},

		_addRtcStreamManagementMenu: function() {
			// Expect that this is before Delete, but after everything else.
			var atIndex = 2;

			this._rtcButton = jazz.ui.toolbar.MenuButton({
				group: 'ple.products_page.toolbar', //$NON-NLS-1$
				destroyOnClose: true,
				imgClass: 'ple-icon-rtc', //$NON-NLS-1$
				title: this.messages.streamManagement,
				enabled: false
			});

			this._rtcButton.set('menuProvider', function() { //$NON-NLS-1$
				return StreamManagement.createMenuForSelectedSites();
			});

			this._toolbar.addChild(new jazz.ui.toolbar.Separator(), atIndex++);
			this._toolbar.addChild(this._rtcButton, atIndex++);
		},

		showDragMessage: function(htmlMessage) {
			if (!this._dragMessageBox) {
				this._dragMessageBox = new jazz.ui.MessageBox();
				this._dragMessageBox.placeAt(this._drawer.domNode);
			}

			this._dragMessageBox.showMessage({
				type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
				summary: htmlMessage,
				closable: false
			});

			dojo.style(this._dragMessageBox.domNode, {
				position: 'absolute', //$NON-NLS-1$
				bottom: '10px', //$NON-NLS-1$
				width: '500px', //$NON-NLS-1$
				left: '50%', //$NON-NLS-1$
				marginLeft: '-250px', //$NON-NLS-1$
				zIndex: '100' //$NON-NLS-1$
			});
		},

		hideDragMessage: function() {
			if (!this._dragMessageBox) return;
			this._dragMessageBox.destroyRecursive();
			delete this._dragMessageBox;
		},

		/**
		 * Enables toolbar buttons when multiple tree items are selected.
		 * Assumes that all buttons start as disabled.
		 * @param  {array} sites selected sites.
		 */
		_enableToolbarButtonsForMultiSelect: function(sites) {
			var canModify = Permissions.canProductsModify();
			var canRedact = Permissions.canProductsRedact();

			var anyImmutable = false;
			var allAreItemVersions = true;
			var allAreConfigVersions = true;
			var anyTopLevelItems = false;
			var anyEmptyParts = false;
			var allHaveSameParent = true;

			var firstParent = sites[0].parentResourceVersion;

			for (var i = 0; i < sites.length; i++) {
				var site = sites[i];

				if (site.parentResourceVersion !== firstParent) {
					allHaveSameParent = false;
				}

				if (site.isInBaseline) {
					anyImmutable = true;
				}
				else if ((site.configVersion || site.itemVersionName || {}).isImmutable) {
					anyImmutable = true;	
				}

				if (!site.itemVersion) {
					allAreItemVersions = false;
				}

				if (!site.configVersion) {
					allAreConfigVersions = false;
				}

				if (!site.contextConfigVersionUri && !site.link) {
					anyTopLevelItems = true;
				}

				if (site.emptyPart) {
					anyEmptyParts = true;
				}
			}

			// Compare Selected (2 versions)
			if (allAreConfigVersions && sites.length === 2) {
				this._compareButton.set('enabled', true); //$NON-NLS-1$
				this._compareButton.set('title', messages.compareSelected); //$NON-NLS-1$
			}

			// Move
			if (!anyTopLevelItems && canModify) this._moveButton.set('enabled', true); //$NON-NLS-1$

			// Reuse
			if (!anyEmptyParts && canModify) this._reuseButton.set('enabled', true); //$NON-NLS-1$

			// Remove
			var anyTopLevelBaselinesSelected = anyTopLevelItems && anyImmutable;
			if (allHaveSameParent && canModify && !anyTopLevelBaselinesSelected) this._removeButton.set('enabled', true); //$NON-NLS-1$

			this._redactButton.set('enabled', canRedact && allAreItemVersions); //$NON-NLS-1$
		},

		replaceSelectedWithNewConfigVersion: function() {
			productapi.replaceWithNewConfigVersion(TreeSelection.getSelectedSite());
		},

		replaceSelectedWithChildren: function() {
			productapi.replaceWithChildren(TreeSelection.getSelectedSite());
		},

		createCopyOfConfigurationSelected: function() {
			productapi.createCopyOfConfiguration(TreeSelection.getSelectedSite());
		},

		patchBaselineOfConfigurationSelected: function() {
			productapi.patchBaselineOfConfiguration(TreeSelection.getSelectedSite());
		},

		useVersionOfConfigurationSelected: function() {
			productapi.useVersionOfConfiguration(TreeSelection.getSelectedSite());
		},

		_enableToolbarButtonsForConfigVersion: function(site) {
			var canModify = Permissions.canProductsModify();
			var canAddProperty = Permissions.canProductsAddProperty();

			var isInBaseline = site.isInBaseline;
			var isTopLevel = !site.contextConfigVersionUri;
			var isImmutable = site.configVersion.isImmutable;
			var isPlaceReady = MoveReusePlaceState.isPlaceReady();
			var isChild =  !!site.parentResourceVersion;
			var hasChildren = site.configVersion.children;

			// Create Configuration... - Can't create product or config under a baseline or under anything that is part of a baseline
			this._createConfigVersionButton.set('enabled', canModify && !isInBaseline && !isImmutable); //$NON-NLS-1$
			this._createProductButton.set('enabled', canModify && !isInBaseline && !isImmutable); //$NON-NLS-1$

			// hide this for config versions always
			dojo.addClass(this._checkInOutButton.domNode, 'j-hide'); //$NON-NLS-1$

			// Create Baseline...
			if (!isImmutable) {
				this._createBaselineButton.set('enabled', canModify); //$NON-NLS-1$
				dojo.removeClass(this._createBaselineButton.domNode, 'j-hide'); //$NON-NLS-1$
			}

			// Create Copy...
			dojo.removeClass(this._createCopyButton.domNode, 'j-hide'); //$NON-NLS-1$
			dojo.addClass(this._createBranchButton.domNode, 'j-hide'); //$NON-NLS-1$
			this._createCopyButton.set('enabled', canModify); //$NON-NLS-1$
			if (isImmutable) {
				this._createCopyButton.set('title', this.messages.createModifiableCopyOfConfiguration); //$NON-NLS-1$
			}

			// Patch baseline...
			if (isImmutable) {
				this._patchBaselineButton.set('enabled', canModify); //$NON-NLS-1$
				dojo.removeClass(this._patchBaselineButton.domNode, 'j-hide'); //$NON-NLS-1$
			}

			// Add Product or Configuration... - Can't add product or config to a baseline or anything under that is part of a baseline
			this._addProductOrConfigVersionButton.set('enabled', canModify && !isInBaseline && !isImmutable); //$NON-NLS-1$

			// Add Link to Artifact... - Can't add link to a baseline or anything under that is part of a baseline
			this._addArtifactButton.set('enabled', canAddProperty && !isInBaseline && !isImmutable); //$NON-NLS-1$

			// Add URL... - Can't add link to a baseline or anything under that is part of a baseline
			this._addLinkButton.set('enabled', canAddProperty && !isInBaseline && !isImmutable); //$NON-NLS-1$

			// Replace Version - Can replace version of a config that is immutable, but not one that is part of a baseline
			this._replaceVersionButton.set('enabled', canModify && isChild && !isInBaseline); //$NON-NLS-1$
			this._replaceVersionButton.set('imgClass', 'ple-icon-replaceConfigVersion'); //$NON-NLS-1$ //$NON-NLS-2$

			// Replace with Child Products - Can replace baseline with children, but not a config in a baseline
			dojo.removeClass(this._replaceWithChildrenButton.domNode, 'j-hide'); //$NON-NLS-1$
			dojo.addClass(this._replaceWithNewConfigVersionButton.domNode, 'j-hide'); //$NON-NLS-1$
			this._replaceWithChildrenButton.set('enabled', canModify && !isInBaseline && isChild && hasChildren); //$NON-NLS-1$
			
			//analysis
			this._startAnalysisButton.set('enabled', true); //$NON-NLS-1$
			
			// Find Use
			this._findUseButton.set('enabled', true); //$NON-NLS-1$

			// Compare
			this._compareButton.set('enabled', true); //$NON-NLS-1$

			// Move - can't move top level config or config within a baseline
			this._moveButton.set('enabled', canModify && !isInBaseline && !isTopLevel); //$NON-NLS-1$

			// Reuse
			this._reuseButton.set('enabled',  canModify); //$NON-NLS-1$

			// Place - Can't place within a child of a baseline (isInBaseline) or the baseline itself (isImmutable)
			this._placeButton.set('enabled', canModify && !isInBaseline && !isImmutable && isPlaceReady); //$NON-NLS-1$

			// Remove & Delete
			this._removeButton.set('enabled', canModify && !(isTopLevel && isImmutable) && !isInBaseline && !isTopLevel); //$NON-NLS-1$
			this._deleteButton.set('enabled', canModify && !(isTopLevel && isImmutable) && !isInBaseline); //$NON-NLS-1$

			// Import
			this._importButton.set('enabled', canModify && !isInBaseline && !isImmutable); //$NON-NLS-1$

			// Export
			this._exportButton.set('enabled', canModify); //$NON-NLS-1$
		},


		_enableToolbarButtonsForEmptyPart: function(site) {
			var canModify = Permissions.canProductsModify();

			var isInBaseline = site.isInBaseline;
			var isPartForConfigVersion = site.emptyPart.isPartForConfigVersion;

			// Replace Version...
			this._replaceVersionButton.set('enabled', canModify && !isInBaseline); //$NON-NLS-1$
			
			// Audit History
			// Show Audit History
			this._showAuditHistoryButton.set('enabled', !isPartForConfigVersion); //$NON-NLS-1$

			// Move
			this._moveButton.set('enabled', canModify && !isInBaseline); //$NON-NLS-1$

			// Remove & Delete
			this._removeButton.set('enabled', canModify && !isInBaseline); //$NON-NLS-1$
			this._deleteButton.set('enabled', false); //$NON-NLS-1$
		},

		_enableToolbarButtonsForLink: function(site) {
			var canModify = Permissions.canProductsModify();
			var canDeleteProperty = Permissions.canProductsDeleteProperty();
			var isInBaseline = site.isInBaseline;

			// Replace Version... special for DOORS baseline links only (the only versioned artifact we know of)
			if (site.link.isDoorsBaseline) {
				this._replaceVersionButton.set('enabled', true); //$NON-NLS-1$
				this._replaceVersionButton.set('title', this.messages.replaceBaseline); //$NON-NLS-1$
				this._replaceVersionButton.set('imgClass', 'ple-icon-replaceBaseline'); //$NON-NLS-1$ //$NON-NLS-2$
			}

			// Find Use...
			this._findUseButton.set('enabled', true); //$NON-NLS-1$
			this._findUseButton.set('title', this.messages.findUseInProducts); //$NON-NLS-1$

			// Start Analysis
			this._startAnalysisButton.set('enabled', true); //$NON-NLS-1$

			// Move
			this._moveButton.set('enabled', canModify && !isInBaseline); //$NON-NLS-1$

			// Remove & Delete
			this._removeButton.set('enabled', canDeleteProperty && !isInBaseline); //$NON-NLS-1$
			this._deleteButton.set('enabled', false); //$NON-NLS-1$
		},

		_enableToolbarButtonsForItemVersion: function(site) {
			var canModify = Permissions.canProductsModify();
			var canBranch = Permissions.canProductsBranch();
			var canRedact = Permissions.canProductsRedact();
			var canSnapshot = Permissions.canProductsCreateSnapshot();
			var canAddProperty = Permissions.canProductsAddProperty();

			var itemVersion = site.itemVersion;
			var isImmutable = itemVersion.isImmutable;
			var isVariabilityParameters = itemVersion.conditionVariables !== undefined;
			var isInBaseline = site.isInBaseline;
			var isPlaceReady = MoveReusePlaceState.isPlaceReady();
			var isChild =  !!site.parentResourceVersion;
			var hasChildren = !!site.itemVersion.children;

			// Create Configuration...
			this._createConfigVersionButton.set('enabled', canModify && !isVariabilityParameters && !isInBaseline); //$NON-NLS-1$

			// Create Product...
			this._createProductButton.set('enabled', canModify && !isVariabilityParameters && !isInBaseline); //$NON-NLS-1$

			if (isImmutable) {
				// Check Out...
				this._checkInOutButton.set('enabled', canModify && !isInBaseline); //$NON-NLS-1$
				this._checkInOutButton.set('title', messages.checkOut); //$NON-NLS-1$
				this._checkInOutButton.set('imgClass', 'ple-icon-checkOut'); //$NON-NLS-1$ //$NON-NLS-2$
				this._checkInOutButton.set('onClick', dojo.hitch(this, this.checkOutSelected)); //$NON-NLS-1$
			}
			else {
				// Check In...
				this._checkInOutButton.set('enabled', canSnapshot && !isInBaseline); //$NON-NLS-1$
				this._checkInOutButton.set('title', messages.checkIn); //$NON-NLS-1$
				this._checkInOutButton.set('imgClass', 'ple-icon-checkIn'); //$NON-NLS-1$ //$NON-NLS-2$
				this._checkInOutButton.set('onClick', dojo.hitch(this, this.createSelectedSnapshot)); //$NON-NLS-1$
			}

			// Manage Stream
			this._rtcButton && this._rtcButton.set('enabled', !isVariabilityParameters); //$NON-NLS-1$

			// Check Out New Branch...
			this._createBranchButton.set('enabled', canBranch && !isInBaseline); //$NON-NLS-1$

			// Add Product or Configuration...
			this._addProductOrConfigVersionButton.set('enabled', canModify && !isVariabilityParameters && !isInBaseline); //$NON-NLS-1$

			// Add Link to Artifact...
			this._addArtifactButton.set('enabled', canAddProperty && !isVariabilityParameters && !isInBaseline); //$NON-NLS-1$

			// Add URL...
			this._addLinkButton.set('enabled', canAddProperty && !isVariabilityParameters && !isInBaseline); //$NON-NLS-1$

			this._replaceVersionButton.set('enabled', canModify && !isInBaseline); //$NON-NLS-1$

			// Swap with New Configuration
			dojo.addClass(this._replaceWithChildrenButton.domNode, 'j-hide'); //$NON-NLS-1$
			dojo.removeClass(this._replaceWithNewConfigVersionButton.domNode, 'j-hide'); //$NON-NLS-1$
			this._replaceWithNewConfigVersionButton.set('enabled', canModify && !isInBaseline && isChild); //$NON-NLS-1$

			this._replaceBranchButton.set('enabled', canModify && !isInBaseline); //$NON-NLS-1$
			this._findUseButton.set('enabled', true); //$NON-NLS-1$
			this._startAnalysisButton.set('enabled', true); //$NON-NLS-1$
			
			// Show Audit History
			this._showAuditHistoryButton.set('enabled', true); //$NON-NLS-1$

			// Move
			this._moveButton.set('enabled', canModify && !isInBaseline); //$NON-NLS-1$

			// Reuse
			this._reuseButton.set('enabled',  canModify); //$NON-NLS-1$

			// Place
			this._placeButton.set('enabled', canModify && !isInBaseline && isPlaceReady); //$NON-NLS-1$

			// Remove & Delete
			this._removeButton.set('enabled', canModify && !isInBaseline && isImmutable); //$NON-NLS-1$
			this._deleteButton.set('enabled', canModify && !isInBaseline && !isImmutable); //$NON-NLS-1$

			// Import
			this._importButton.set('enabled', canModify && !isInBaseline); //$NON-NLS-1$

			// Export
			this._exportButton.set('enabled', canModify); //$NON-NLS-1$

			// Redact
			this._redactButton.set('enabled', canRedact); //$NON-NLS-1$
		},

		/**
		 * Enables and disables toolbar buttons based on the currently selected item.
		 */
		_enableToolbarButtons: function() {
			var allButtons = [
				this._createConfigVersionButton, 
				this._createProductButton, 
				this._checkInOutButton, 
				this._createBranchButton, 
				this._rtcButton, 
				this._addProductOrConfigVersionButton, 
				this._addArtifactButton, 
				this._addLinkButton, 
				this._findUseButton, 
				this._startAnalysisButton, 
				this._replaceBranchButton, 
				this._replaceVersionButton, 
				this._showAuditHistoryButton, 
				this._compareButton, 
				this._moveButton, 
				this._reuseButton, 
				this._placeButton, 
				this._removeButton,
				this._deleteButton,
				this._redactButton, 
				this._importButton, 
				this._exportButton, 
				this._createBaselineButton,
				this._replaceWithChildrenButton,
				this._createCopyButton,
				this._patchBaselineButton];

			// Start by disabling all buttons and resetting to their default titles.
			// This gives a clear slate each time so we just set enable what relevant
			// and ignroe the rest.
			for (var i = 0; i < allButtons.length; i++) {
				var button = allButtons[i];
				if (button) button.set('enabled', false); //$NON-NLS-1$
			}

			this._createCopyButton.set('title', this.messages.createCopyOfConfiguration); //$NON-NLS-1$

			// Show Check In/Out button by default. Will swap with Create
			// Baseline if a mutable config is selected.
			dojo.addClass(this._createBaselineButton.domNode, 'j-hide'); //$NON-NLS-1$
			dojo.removeClass(this._checkInOutButton.domNode, 'j-hide'); //$NON-NLS-1$

			// Show Create Branch button by default. Will swap with Create
			// Copy if a configuration is selected.
			dojo.addClass(this._createCopyButton.domNode, 'j-hide'); //$NON-NLS-1$
			dojo.removeClass(this._createBranchButton.domNode, 'j-hide'); //$NON-NLS-1$

			// Hide create patch button by default. Will show and enable if a baseline is selected
			dojo.addClass(this._patchBaselineButton.domNode, 'j-hide'); //$NON-NLS-1$

			// Will change to "Compare Seleceted" if there was a multi-selection
			this._compareButton.set('title', messages.compareWithLastSnapshot); //$NON-NLS-1$

			// Replace Version button is default, but turns into Replace Baseline is DOORS baseline is selected
			// or replace config version if a configuration is selected.
			this._replaceVersionButton.set('title', this.messages.replaceVersion); //$NON-NLS-1$
			this._replaceVersionButton.set('imgClass', 'ple-icon-replaceItemVersion'); //$NON-NLS-1$ //$NON-NLS-2$

			// Hide unless on a child config version
			dojo.removeClass(this._replaceWithChildrenButton.domNode, 'j-hide'); //$NON-NLS-1$
			dojo.addClass(this._replaceWithNewConfigVersionButton.domNode, 'j-hide'); //$NON-NLS-1$

			var selectedSites = TreeSelection.getAllSelectedSites();

			if (selectedSites.length === 0) {
				// If no selection, you can still create floating config versions and perform an import
				var canModify = Permissions.canProductsModify();
				this._createConfigVersionButton.set('enabled', canModify); //$NON-NLS-1$
				this._importButton.set('enabled', canModify); //$NON-NLS-1$
				return;
			}

			if (selectedSites.length > 1) {
				this._enableToolbarButtonsForMultiSelect(selectedSites);
				return;
			}

			// We know there is only one selected now.
			var site = selectedSites[0];
			var type = site.type;

			switch (type) {
			case 'configVersion': //$NON-NLS-1$
				this._enableToolbarButtonsForConfigVersion(site);
				return;

			case 'emptyPart': //$NON-NLS-1$
				this._enableToolbarButtonsForEmptyPart(site);
				return;

			case 'product': //$NON-NLS-1$
				this._enableToolbarButtonsForItemVersion(site);
				return;

			case 'link': //$NON-NLS-1$
				this._enableToolbarButtonsForLink(site);
				return;

			default:
				console.warn('Unknown type selected: ' + type); //$NON-NLS-1$
				return;
			}
		},

		logSelectedItem: function() {
			var selected = TreeSelection.getSelectedSite();
			if (!selected) return;

			var type = selected.type;

			console.warn('Remember, what\'s cached in the tree may be older than ProductStore'); //$NON-NLS-1$
			switch(type) {
				case "link": //$NON-NLS-1$
				console.debug('Link ' + selected.link.name," - ", selected.link); //$NON-NLS-1$ //$NON-NLS-2$
				break;
				case "product": //$NON-NLS-1$
				console.debug(selected.product.name," - ", selected.product); //$NON-NLS-1$
				break;
				case "configVersion": //$NON-NLS-1$
				console.debug(selected.configVersion.name," - ", selected.configVersion); //$NON-NLS-1$
				break;
				default:
				console.debug("Selected site:", selected); //$NON-NLS-1$
				break;
			}
		},

		gotoSelectedFindUse: function(e) {
			var sel = TreeSelection.getSelectedSite();
			if (sel.link) {
				var artifactUri = sel.link.uri;
				var privateBaseline = sel.link.privateBaseline;
				Goto.gotoFindArtifactUse(artifactUri, privateBaseline);
				return;
			}
			else {
				Goto.gotoFindUse(sel.configVersionUri || sel.itemVersionUri);
				return;
			}
		},

		gotoFindArtifactUse: function(artifactUri, privateBaseline) {
			Goto.gotoFindArtifactUse(artifactUri, privateBaseline);
		},

		gotoFindUse: function(itemVersionUri) {
			if (!itemVersionUri) return;
			Goto.gotoFindUse(itemVersionUri);
		},

		launchAnalysis: function(args) {
			var selected = TreeSelection.getSelectedSite();
			if (selected.link) {
				AnalysisUtil.createAnalysisForResource(selected.link.oslcConceptUri	);
			}
			else if (selected.type == "configVersion") { //$NON-NLS-1$
				AnalysisUtil.createAnalysisForResource(selected.configVersionUri);
			}
			else {
				AnalysisUtil.createAnalysisForResource(selected.product.uri, selected.contextConfigVersionUri);
			}
		},

		_createProduct: function() {
			productapi.createProduct(TreeSelection.getSelectedSite());
		},

		_createConfigVersion: function() {
			productapi.createConfigVersion(TreeSelection.getSelectedSite());
		},

		showSelectedCreateBranchDialog: function() {
			this.showCreateBranchDialog(TreeSelection.getSelectedSite());
		},

		showCreateBranchDialog: function(selected) {
			if (!selected) return;

			var d = new com.ibm.relm.ple.web.ui.branch.CreateBranchDialog(selected);
			d.startup();
		},

		showSelectedUseBranchDialog: function(e) {
			var selected = TreeSelection.getSelectedSite();
			this.showUseBranchDialog(selected);
		},

		showUseBranchDialog: function(selected) {
			if (!selected || !selected.parentProduct) return;

			var d = new com.ibm.relm.ple.web.ui.branch.UseBranchDialog({site: selected});
			d.startup();
		},

		moveSelected: function() {
			MoveReusePlaceState.saveSelectionForMove();
		},

		reuseSelected: function() {
			MoveReusePlaceState.saveSelectionForReuse();
		},

		placeSelected: function() {
			MoveReusePlaceState.placeSavedSelection();
		},

		showSelectedReplaceVersionDialog: function(e) {
			var selectedSite = TreeSelection.getSelectedSite();
			if (selectedSite.type == "configVersion") { //$NON-NLS-1$
				this.useVersionOfConfigurationSelected();
			} else if (selectedSite.link && selectedSite.link.isDoorsBaseline) {
				this.showReplaceBaselineDialog(selectedSite);
			} else {
				this.showReplaceVersionDialog(selectedSite);
			}
		},

		showReplaceBaselineDialog: function(site) {
			var d = new com.ibm.relm.ple.web.ui.pages.ReplaceBaselineDialog({
				site: site
			});
			d.startup();
		},

		showReplaceVersionDialog: function(site) {
			var d = new com.ibm.relm.ple.web.ui.pages.ReplaceVersionDialog({
				site: site
				});
			d.startup();
		},

		createSelectedBaseline: function() {
			var site = TreeSelection.getSelectedSite();	
			productapi.createBaseline(site);
		},

		createSelectedSnapshot: function() {
			var site = TreeSelection.getSelectedSite();

			if (site.contextConfigVersionUri) {
				productapi.checkInProduct(site);
				return;
			}

			var itemVersion = site.product;
			var itemVersionUri = TreeSelection.store.getValue(itemVersion, 'uri'); //$NON-NLS-1$
			var itemVersionName = TreeSelection.store.getValue(itemVersion, 'name'); //$NON-NLS-1$
			var branchName = TreeSelection.store.getValue(itemVersion, 'branchName'); //$NON-NLS-1$
			var branchUri = TreeSelection.store.getValue(itemVersion, 'branchUri'); //$NON-NLS-1$
			this.createSnapshot(itemVersionUri, itemVersionName, branchName, branchUri);
		},

		createSnapshot: function(productId, productName, branchName, branchUri) {
			// TODO: Legacy path, remove
			var d = new com.ibm.relm.ple.web.ui.pages.CreateBaselineDialog({
				productName: productName,
				productId: productId,
				branchName: branchName,
				branchUri: branchUri
			});
			d.startup();
		},

		checkOutSelected: function(args) {
			var selectedSite = TreeSelection.getSelectedSite();
			productapi.checkOutProduct(selectedSite);
		},

		compareSelected: function() {
			var allSelected = TreeSelection.getAllSelectedSites();

			if (allSelected.length === 1) {
				var selected = allSelected[0];
				this.compare(selected);
			}
			else {
				var left = allSelected[0];
				var right = allSelected[1];
				this.compare(left, right);
			}
		},

		// XXX: These are revered order since RIGHT is always required. Maybe this should change.
		/**
		 * Run product comparison
		 * @param  {[string]} rightItemVersionUri require right side of compare.
		 * @param  {[type]} leftItemVersionUri  optional left side of compare. If null, the last snapshot of the right is
		 * compared against.
		 */
		compare: function(leftSite, rightSite) {
			Goto.gotoCompare(leftSite, rightSite);
		},

		showSelectedHistory: function() {
			var site = TreeSelection.getSelectedSite();

			if (site.emptyPart) {
				Goto.gotoShowHistory(null, site.contextPartUri);
			}
			else {
				Goto.gotoShowHistory(site.itemVersion.uri);
			}
		},

		showSelectedArtifactPicker: function(e) {
			var selectedSite = TreeSelection.getSelectedSite();
			
			var picker = new com.ibm.relm.ple.web.ui.picker.LqeArtifactPicker({
				selectedSite: selectedSite,
				filterProducts: true,
				showAddAndClose: true
			});

			picker.startup();
		},

		/**
		 * Opens the LQE artifact picker dialog to add a contribution to the selected product.
		 *
		 * @param  {object} selected the selected product to add the contribution to as returned by TreeSelection.
		 */
		showConfigurationPicker: function(selected) {
			if (!selected.product) return;
			var product = selected.product;

			var parentVersion = this._sidebar.store.getValue(product, 'uri'); //$NON-NLS-1$
			var parentPart = this._sidebar.store.getValue(product, 'pd:part'); //$NON-NLS-1$
			var parentView = this._sidebar.store.getValue(product, 'pd:view'); //$NON-NLS-1$
			
			var picker = new com.ibm.relm.ple.web.ui.picker.ConfigurationPicker({
				product: product,
				site: selected,
				parentVersionUri: parentVersion,
				parentPartUri: parentPart,
				parentPath: selected.path,
				parentViewUri: parentView
			});

			picker.startup();
		},

		/**
		 * Shows the Add Product picker for the currently selected product, if
		 * any.
		 */
		showSelectedProductPicker: function() {
			var selected = TreeSelection.getSelectedSite();
			if (!selected) return;

			var picker = new com.ibm.relm.ple.web.ui.picker.ProductPicker({
				selected: selected
			});

			picker.startup();
		},

		showSelectedAddUrlDialog: function(e) {
			var picker = new com.ibm.relm.ple.web.ui.picker.AddUrlDialog({
				site: TreeSelection.getSelectedSite()
			});

			picker.startup();
		},

		/**
		 * Gets the currently selected item in the tree, if any,
		 * and does the appropriate remove style action for the selected
		 * type, either a product or artifact link.
		 */
		_removeSelected: function() {
			var allSelected = TreeSelection.getAllSelectedSites();
			if (dojo.some(allSelected, function(selected){
					return selected.type == 'configVersion' && selected.parentProduct != undefined;})) { //$NON-NLS-1$
				this._removeChildConfig(allSelected);
			} else {
				this._removeAnything(allSelected);
			}
		},

		/**
		 * Gets the currently selected item in the tree, if any,
		 * and does the appropriate delete style action for the selected
		 * type, either a product or artifact link.
		 */
		_deleteSelected: function() {
			var allSelected = TreeSelection.getAllSelectedSites();
			this._removeAnything(allSelected);
		},
		
		/**
		 * Shows dialog to remove any number of links and child products.
		 * All must have the same parent product.
		 * @param  {array} allSelected selected objects from TreeSelection.
		 */
		_removeAnything: function(selectedSites) {
			if (selectedSites.length === 0) return;

			var canDelete = true;
			var removeSites = [];

			// If these are not top-level products, they must all have the same parent product.
			var contextConfigVersionUri = selectedSites[0].contextConfigVersionUri;

			for (var i = 0; i < selectedSites.length; i++) {
				var site = selectedSites[i];

				// We can remove products, configurations, empty parts... and links under them
				var resourceVersion = site.itemVersion || site.configVersion || site.emptyPart;

				if (site.contextConfigVersionUri !== contextConfigVersionUri) {
					throw new Error('All selected items to be removed must have same parent.'); //$NON-NLS-1$
				}

				if (resourceVersion.isImmutable || site.emptyPart || site.link || site.isInBaseline) {
					canDelete = false;
				}

				removeSites.push(site);
			}

			var args = {
				contextConfigVersionUri: contextConfigVersionUri,
				removeSites: removeSites,
				canDelete: canDelete
			};

			if (removeSites.length == 1) {
				var selectedSite = removeSites[0];
				args.name = (selectedSite.link) ? selectedSite.link.name : (selectedSite.product || selectedSite.configVersion || selectedSite.emptyPart).name;
			}

			var removeDialog = new com.ibm.relm.ple.web.ui.pages.RemoveDialog(args);
			removeDialog.startup();
		},
		
		/**
		 * Shows dialog to remove any number product configurations that are children of other items.
		 * All must have the same parent product.
		 * @param  {array} allSelected selected objects from TreeSelection.
		 */
		_removeChildConfig: function(selectedSites) {
			if (selectedSites.length === 0) return;

			// If these are not top-level configurations, they must all have the same parent product.
			var contextConfigVersionUri = selectedSites[0].contextConfigVersionUri;

			for (var i = 0; i < selectedSites.length; i++) {
				var site = selectedSites[i];
				if (!site.configVersion) {
					// make sure only configuration were selected
					throw new Error('All selected items to be removed must be Configurations.'); //$NON-NLS-1$
				}
				if (site.contextConfigVersionUri !== contextConfigVersionUri) {
					throw new Error('All selected items to be removed must have same parent.'); //$NON-NLS-1$
				}
			}

			var args = {
				contextConfigVersionUri: contextConfigVersionUri,
				removeSites: selectedSites,
				canDelete: false
			};

			if (selectedSites.length == 1) {
				var selectedSite = selectedSites[0];
				args.name = selectedSite.configVersion.name;
			}

			var removeDialog = new com.ibm.relm.ple.web.ui.pages.RemoveDialog(args);
			removeDialog.startup();
		},

		_selectFilterValue: function(newOptionValue) {
			for (var i = 0; i < this._filterSelect.options.length; i++) {
				var option = this._filterSelect.options[i];
				if (option.value == newOptionValue) {
					this._filterSelect.selectedIndex = i;
					break;
				}
			}
		},
		
		/**
		 * Jazz action to view a product tree path.
		 * @param  {object} jazzEvent event with .path property to view. Slash separated tree IDs.
		 */
		selectProductTreePathAction: function(jazzEvent) {
			var path = jazzEvent.path;
			if (!path) return;

			var treeFilter = jazzEvent.show;
			if (treeFilter) {
				this._setTreeFilter(treeFilter);
			}

			path = path.split('/'); //$NON-NLS-1$
			this._sidebar.selectProductTreePath(path);
		},

		_setTreeFilter: function(filter) {
			// Try to set this now. Will work for recents and favorites. If
			// this is a product grouping, then they might not have loaded
			// yet. This will get set again after they load so we know which
			// name in the menu to select (we might only know the URI right
			// now).
			this._selectFilterValue(filter);

			this._sidebar.set('treeFilter', filter); //$NON-NLS-1$
		},

		/**
		 * Updates the tree filter and tells the sidebar to update in response.
		 * @param  {[type]} actionEvent [description]
		 * @return {[type]}             [description]
		 */
		browseProductsAction: function(actionEvent){
			var treeFilter = actionEvent.show;
			if (!treeFilter) treeFilter = 'recents'; //$NON-NLS-1$

			this._setTreeFilter(treeFilter);
		},

		/**
		 * Refreshes the tree with the latest data from the sever. Causes icons
		 * to redraw if needed. Also enables and disabled toolbar buttons to match
		 * the current selected item, if any.
		 *
		 * Code that may want to change the selected tree node first may need
		 * to call tree.refreshStore and _enableToolbarButtons itself--this is a convenience.
		 */
		refreshTree: function() {
			dojo.publish('ple.product_tree_hide_message'); //$NON-NLS-1$
			return this._sidebar.refresh();
		},

		isDetailsViewDirty: function() {
			return this._detailsView && this._detailsView.isDirty && this._detailsView.isDirty();
		},

		/**
		 * Completely rebuilds the store, models, and visual tree. The tree widget is destroyed and rebuilt.
		 * Used for a last resort refresh that will always pull the latest information. Should not be needed often.
		 */
		_fullRefresh: function(force) {
			var site = TreeSelection.getSelectedSite();
			if (site) {
				var focusConfigVersion = site.closestConfigVersion();
				if (focusConfigVersion && !focusConfigVersion.isImmutable) {
					com.ibm.relm.ple.web.ui.VvcRefresh.refreshConfigVersion(focusConfigVersion);	
				} 
			}

			if (force || !this.isDetailsViewDirty()) {
				return this._sidebar._fullRefresh(true);
			}
			else {
				// FIXME: This doesn't return a Deferred? Is anything using this result anymore?
				var d = new com.ibm.relm.ple.web.ui.tree.DiscardChangesDialog({
					onDiscard: dojo.hitch(this, this._fullRefresh, true)
				});
				d. startup();
				return undefined;
			}
		},

		_onFullRefresh: function(e) {
			this._fullRefresh(false);
		},

		/**
		 * Clears the details pane and shows a loading indicator
		 * after a short timeout. This  is to avoid flashing if the details
		 * view can be loaded very quickly (Loading never needs to show at all),
		 * but will still show Loading if the load takes too long.
		 * Note that this must be canceled with cancelShowLoading once the
		 * real details are loaded.
		 */
		showLoadingSoon: function() {
			// Don't clear the detail pane right away to avoid flashing. Only after a delay of loading.
			this.cancelShowLoading();
			this._clearViewTimeout = setTimeout(dojo.hitch(this, function() {
				this.clearDetailsPane({
					showLoadingMessage: true
				});
			}), 400);
		},

		/**
		 * Cancels the pending clear of the details pane.
		 * @return {[type]} [description]
		 */
		cancelShowLoading: function() {
			clearTimeout(this._clearViewTimeout);
		},

		/**
		 * Loads the appropriate details view for any known tree node type.
		 * 
		 * @param  {object} item a JSON item as associated with tree nodes for
		 *     an item version, config version, link, or empty part.
		 */
		loadAnySingleItemDetails: function(item) {
			var type = item.type;

			if (type === 'product' || type === 'configVersion') { //$NON-NLS-1$ //$NON-NLS-2$
				this.loadItemVersionOrConfigVersionDetails(item);
			}
			else if (type === 'link') { //$NON-NLS-1$
				this.loadLinkDetails(item);
			}
			else if (type === 'emptyPart') { //$NON-NLS-1$
				this.loadEmptyPartDetails(item);
			}
			else {
				throw new Error('loadAnySingleItemDetails - Unknown type: ' + type); //$NON-NLS-1$
			}
		},

		loadItemVersionOrConfigVersionDetails: function(itemVersionOrConfigVersion) {
			this.showLoadingSoon();

			if (itemVersionOrConfigVersion.type === 'configVersion') { //$NON-NLS-1$
				var contextConfigVersionUri = itemVersionOrConfigVersion.uri;
				var contextPartUri = null;
			}
			else {
				contextConfigVersionUri = itemVersionOrConfigVersion.contextConfigVersionUri;
				contextPartUri = itemVersionOrConfigVersion.contextPartUri;	
			}

			jazz.client.xhrGet({
				handleAs: 'json', //$NON-NLS-1$
				url: net.jazz.ajax._contextRoot + '/ple/get_resource_version', //$NON-NLS-1$
				content: {
					contextConfigVersionUri: contextConfigVersionUri,
					contextPartUri: contextPartUri,
					includeUserProperties: true
				},

				handle: dojo.hitch(this, function() {
					this.cancelShowLoading();
				}),

				load: dojo.hitch(this, function (resourceVersion) {
					this._detailsView && this._detailsView.destroyRecursive();
					if (!resourceVersion) return;

					this._detailsView = new com.ibm.relm.ple.web.ui.internal.views.ProductView({
						optionalSite: TreeSelection.getSelectedSite(),
						resourceVersion: resourceVersion
					});

					this._drawer.setDrawerContent(this._detailsView.domNode);

					if (itemVersionOrConfigVersion.etag != resourceVersion.etag) {
						com.ibm.relm.ple.web.ui.tree.TreeRefresh.refresh();
					}
				}),

				error: dojo.hitch(this, function(error) {
					this._detailsView && this._detailsView.destroyRecursive();
					console.log(error);

					this.refreshTree();
					this.clearDetailsPane();
				})
			});
		},

		loadMultiSelectDetails: function() {
			if (this._detailsView) {
				if (this._detailsView.isMultiselect) {
					return;
				}
			}

			this._setDetailsView(new com.ibm.relm.ple.web.ui.internal.views.MultiSelectView({}));
		},

		_setDetailsView: function(detailsViewWidget) {
			this._detailsView && this._detailsView.destroyRecursive();
			this._detailsView = detailsViewWidget;
			this._drawer.setDrawerContent(detailsViewWidget.domNode);
		},

		loadEmptyPartDetails: function(emptyPartItem) {
			var emptyPartView = new com.ibm.relm.ple.web.ui.internal.views.EmptyPartView({
				item: emptyPartItem
			});
			this._setDetailsView(emptyPartView);
		},

		/**
		 * @param  {object} itemVersion item version linked from.
		 * @param  {object} link        item for the link.
		 */
		loadLinkDetails: function(link) {

			if (link.isDoorsBaseline) {
				var artifactUri = link.privateBaseline;
				var artifactOslcUri = null;
			}
			else {
				artifactUri = link.uri;
				artifactOslcUri = link.oslcUri;
			}

			var artifactView = new com.ibm.relm.ple.web.ui.internal.views.ArtifactView({
				isDoorsBaseline: link.isDoorsBaseline,
				artifactUri: artifactUri,
				artifactOslcUri: artifactOslcUri,
				privateBaseline: link.privateBaseline,
				label: link.name,
				liveTitle: link.liveTitle,
				liveIcon: link.liveIcon,
				conceptUri: link.conceptUri,
				artifact: link  //TODO: Remove if prototype no longer needed, check in ArtifactView.js
			});

			this._setDetailsView(artifactView);
		},

		selectNothing: function()
		{
			window.location.href = '#' + dojo.objectToQuery({ action: 'ple.view_path' }); //$NON-NLS-1$ //$NON-NLS-2$
			this.clearDetailsPane();
			this._sidebar.deselectTrees();
			dojo.publish(jazz.ui.PageTemplate.StatusMessage.HIDE);
		},

		uninitialize: function()
		{
			this._detailsView.destroyRecursive();
			this._autoScrollHeight.destroy();
			this.inherited(arguments);
		}

	});
})();
