/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.ple.web.ui.pages.ProductsWelcomePage"); //$NON-NLS-1$

dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("jazz.ui.SearchBox"); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.searching'); //$NON-NLS-1$
dojo.require('relm.app.Permissions'); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.ple.web.ui.pages", "ProductsWelcomeMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization('com.ibm.relm.ple.web.internal', 'ProductSearchProviderMessages'); //$NON-NLS-1$ //$NON-NLS-2$


(function() {
var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var searching = com.ibm.relm.ple.web.ui.searching;

dojo.declare(
	"com.ibm.relm.ple.web.ui.pages.ProductsWelcomePage", //$NON-NLS-1$
	[ dijit._Widget, dijit._Templated ], {

		templatePath: dojo.moduleUrl("com.ibm.relm.ple.web","ui/templates/ProductsWelcomePage.html"), //$NON-NLS-1$ //$NON-NLS-2$

		_messages: dojo.i18n.getLocalization("com.ibm.relm.ple.web.ui.pages", "ProductsWelcomeMessages"), //$NON-NLS-1$ //$NON-NLS-2$

		_searchMessages: dojo.i18n.getLocalization('com.ibm.relm.ple.web.internal', 'ProductSearchProviderMessages'), //$NON-NLS-1$ //$NON-NLS-2$

		_messageForTextTrackResources: null,

		_myProductsAnchor1: null,

		_myProductsAnchor2: null,

		_createProductAnchor1: null,

		_createProductAnchor2: null,

		constructor: function() {
			var _miniAnchor= "<a target='_blank' href='/clmhelp/topic/com.ibm.jazz.dashboard.doc/topics/c_about_dash_mini.html' class='img-mini-db'>${0}</a>"; //$NON-NLS-1$
			_miniAnchor= dojo.string.substitute(_miniAnchor, [this._messages.textMiniDashboard]);
			this._messageForTextTrackResources= dojo.string.substitute(this._messages.textTrackResources, [_miniAnchor]);
		},

		postCreate: function() {
			this.inherited(arguments);
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("ple.welcome", this, "constructPage"); //$NON-NLS-1$ //$NON-NLS-2$

			this._searchBox = new jazz.ui.SearchBox({
				scopes: searching.getWelcomeProductScopes(),
				onUpdate: dojo.hitch(searching, searching.searchOnUpdateForSearchBox)
			}, this._searchBoxDiv);

			if (!relm.app.Permissions.canProductsModify()) {
				this._createProduct.style.display = "none"; //$NON-NLS-1$
			} else {
				this.connect(this._createConfigAnchor1, 'click', dojo.hitch(this, "_handleCreateConfigClicked")); //$NON-NLS-1$ //$NON-NLS-2$
				this.connect(this._createConfigAnchor2, 'click', dojo.hitch(this, "_handleCreateConfigClicked")); //$NON-NLS-1$ //$NON-NLS-2$
			}

			if (!relm.app.Permissions.canViewsCreate()) {
				this._manageGroupings.style.display = "none"; //$NON-NLS-1$
			}
		},

		onShow: function() {
			PlatformUI.getWorkbench().setTitle(this._messages.welcomeToProducts);
		},

		constructPage: function() {
		},

		uninitialize: function() {
			this._searchBox.destroyRecursive();
		},

		_handleMyProductsClicked: function() {
			// compute URL instead of having it in the HTML file
		},

		_handleCreateConfigClicked: function(e) {
			dojo.stopEvent(e);
			window.location.href = '#action=ple.browse_products'; //$NON-NLS-1$
			com.ibm.relm.ple.web.ui.productapi.createConfigVersion();
		}
	});
})();