/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.ui.picker.HeaderList'); //$NON-NLS-1$

// dojo.require('dojo.i18n');
// dojo.requireLocalization('com.ibm.relm.ple.web.ui.picker', 'HeaderListMessages');
dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.picker.StyledList'); //$NON-NLS-1$

(function(){
	
	/**
	 * Combines a StyledList with a header. This is really just to insulate the sizing
	 * of the StyledList, letting outer widges just set the size of the HeaderList
	 * and not having to worry about the size of the nested StyledList (it will fill up)
	 * the rest of the space.
	 *
	 * The size of the header is currently fixed and geared toward using with a ColumnBrowser
	 * when picking module baselines with a single "back" link in the header.
	 */
	dojo.declare(
		'com.ibm.relm.ple.web.ui.picker.HeaderList', //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','ui/picker/templates/HeaderList.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: true,

			/**
			 * The text to use for the Back link.
			 * This should likely be the name of the resource that we will go
			 * back to. (Note that this widget on call onBack and doesn't handle
			 * the back action itself). Must always override.
			 * 
			 * @type {String}
			 */
			backLabel: 'Back', //$NON-NLS-1$

			postCreate: function() {
				this.inherited(arguments);
				dojo.addClass(this.list.domNode, 'ple-HeaderList-listPosition'); //$NON-NLS-1$
			},

			/**
			 * Callback when the "Back" link is clicked. Up to the parent widget to
			 * decide what to do then.
			 */
			onBack: function() {
			},

			_onBack: function(e) {
				dojo.stopEvent(e);
				this.onBack();
			},

			/**
			 * Just delegates to the underlying list for conveniece.
			 */
			selectPrevious: function() {
				this.list.selectPrevious();
			},

			/**
			 * Just delegates to the underlying list for conveniece.
			 */
			selectNext: function() {
				this.list.selectNext();
			},
		}
	);

})();