/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.ui.picker.StreamComponentRadios'); //$NON-NLS-1$

// dojo.require('dojo.i18n');
// dojo.requireLocalization('com.ibm.relm.ple.web.ui.picker', 'StreamComponentRadiosMessages');
dojo.require('dijit._Templated'); //$NON-NLS-1$

(function(){
	dojo.declare(
		'com.ibm.relm.ple.web.ui.picker.StreamComponentRadios', //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.ple.web','ui/picker/templates/StreamComponentRadios.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,
			// messages: dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui.picker', 'StreamComponentRadiosMessages'),

			constructor: function() {
				this._streamUuid = dijit.getUniqueId('StreamComponentRadios'); //$NON-NLS-1$
				this._componentId = dijit.getUniqueId('StreamComponentRadios'); //$NON-NLS-1$
			},

			_onClick: function(e) {
				this.onChange(e.target.value);
			},

			onChange: function(newValue) {
				// callback
			},

			getValue: function() {
				var radios = ['_streamRadio', '_componentRadio']; //$NON-NLS-1$ //$NON-NLS-2$

				for (var i = 0; i < radios.length; i++) {
					var radio = radios[i];
					if (radio.checked) {
						return radio.value;
					}
				}

				// Default to 'component' if there is nothing else
				return 'baseline'; //$NON-NLS-1$
			}
		}
	);

})();