/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.common.web.ui.table.HoverRow"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require('jazz.ui.Toolbar'); //$NON-NLS-1$

(function(){
	function log(s) {
		dojo.byId('content-cell').appendChild(dojo.create('div', { //$NON-NLS-1$ //$NON-NLS-2$
			innerHTML: s
		}));
	}
	/**
	 * A table row that always has a toolbar in the last cell. By Jazz UI standards, 
	 * the row highlights when mouseovered and shows the toolbar. Additionaly, the toolbar
	 * can be tabbed to, even when hidden.
	 */
	dojo.declare(
		"com.ibm.relm.common.web.ui.table.HoverRow", //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ], 
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.common.web','ui/table/templates/HoverRow.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: true,

			/**
			 * The toolbar in the last column of this root. Can be publicly accessed.
			 */
			toolbar: null,

			/**
			 * Adds a new cell to this row. Cells are added from left to right, and always before
			 * the final toolbar cell.
			 * @param td the optional cell to add. If null, a new empty cell will
			 * be created and returned.
			 * @return the cell added, either the one given, or if that was null, one
			 * created by this method.
			 */
			addCell: function(td) {
				if (!td) td = document.createElement('TD'); //$NON-NLS-1$

				if (this._lastCell) {
					dojo.place(td, this._lastCell, 'after'); //$NON-NLS-1$
				}
				else {
					dojo.place(td, this.domNode, 'first'); //$NON-NLS-1$
				}
				this._lastCell = td;
				return td;
			},

			_onRowFocus: function() {
				dojo.addClass(this.domNode, 'ple-HoverRow-focused'); //$NON-NLS-1$
			},

			_onRowBlur: function() {
				dojo.removeClass(this.domNode, 'ple-HoverRow-focused'); //$NON-NLS-1$
			},

			uninitialize: function() {
				delete this._lastCell;
			}
		}	
	);
})();