/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.ple.web.ui.tree.ProductTreeModel"); //$NON-NLS-1$
dojo.require('dijit.tree.ForestStoreModel'); //$NON-NLS-1$
dojo.require('dijit.tree.TreeStoreModel'); //$NON-NLS-1$

(function(){

var contextRoot = net.jazz.ajax._contextRoot;
if (contextRoot.indexOf('jazz') != -1) contextRoot += '/jfs'; //$NON-NLS-1$ //$NON-NLS-2$

//function XsortFunction(a, b) {
//
//}

dojo.declare(
	"com.ibm.relm.ple.web.ui.tree.ProductTreeModel", //$NON-NLS-1$
	[ dijit.tree.ForestStoreModel ],
	{

		constructor: function(args, node) {
			this._sortChildren = args.sort === undefined || args.sort === true;
		},

		onSetItem: function(/* item */ item,
					/* attribute-name-string */ attribute,
					/* object | array */ oldValue,
					/* object | array */ newValue){

			// XXX: Hack: This just avoids calling the ForestStoreModel version, which constantly
			// calls _requeryTop. That's just too slow and painful, but it's not clear
			// if that's important or not.
			dijit.tree.TreeStoreModel.prototype.onSetItem.apply(this, arguments);
		},

		onNewItem: function(/* dojo.data.Item */ item, /* Object */ parentInfo){
			// XXX: Hack: This just avoids calling the ForestStoreModel version, which constantly
			// calls _requeryTop. That's just too slow and painful, but it's not clear
			// if that's important or not.
			dijit.tree.TreeStoreModel.prototype.onNewItem.apply(this, arguments);
		},
		/**
		 * This is a COPY of ForestStoreModel's _requeryTop, except that it returns
		 * a Deferred that is called once the query finishes, even if there is no children
		 * change. Needed to dismiss Loading messages.
		 */
		requeryTop: function() {
			var deferred = new dojo.Deferred();

			// reruns the query for the children of the root node,
			// sending out an onSet notification if those children have changed
			var oldChildren = this.root.children || [];
			this.store.fetch({
				query: this.query,
				onComplete: dojo.hitch(this, function(newChildren){
					this.root.children = newChildren;

					// If the list of children or the order of children has changed...
					if(oldChildren.length != newChildren.length ||
						dojo.some(oldChildren, function(item, idx){ return newChildren[idx] != item;})){
						this.onChildrenChange(this.root, newChildren);
					}

					deferred.callback();
				})
			});

			return deferred;
		},

		getIdentity: function(/* item */ item){
			// When setting the path attr in a tree that has no visible root (forest)
			// the first, root item has a null ID. This causes a problem when the item for that ID is looked up.
			if (!item) return null;
			return this.inherited(arguments);
		},

		onChildrenChange: function(parent, newChildrenList){
			//console.log("Items that will be sorted:", newChildrenList);
			if (this.sortFunction) newChildrenList.sort(dojo.hitch(this, this.sortFunction));
			dijit.tree.ForestStoreModel.prototype.onChildrenChange.apply(this, [parent, newChildrenList]);
		},

		getChildren: function(/*dojo.data.Item*/ parentItem,
				/*function(items)*/ callback,
				/*function*/ onError){
			var newCallback = dojo.hitch(this, function(items){
				//console.log("Items that will be sorted:", items);
				if (this.sortFunction) items.sort(dojo.hitch(this, this.sortFunction));
				callback(items);
			});
			dijit.tree.ForestStoreModel.prototype.getChildren.apply(this, [parentItem, newCallback, onError]);
		},

		//This should be passed in since it is difference some times
		sortFunction: null


	}
);

})();