/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2014.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.view.util.ViewUtils"); //$NON-NLS-1$

dojo.require("jazz.app.context"); //$NON-NLS-1$
dojo.require("dijit.MenuItem"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.SelectionDialog"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewUtilsMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var _messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewUtilsMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var SelectionDialog = com.ibm.relm.explorer.web.ui.internal.view.common.SelectionDialog;
var nodeUtils = com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils;
var ICONCLASS_VIEW = "view-icon"; //$NON-NLS-1$

com.ibm.relm.explorer.web.ui.view.util.ViewUtils = {

		/*
		 * Create a menu item to open view selection dialog and open the selected view with the target resource as a parameter
		 * 
		 * targetResource: resource as a parameter  {uri: resource uri , type: resource type}
		 * target: target window to open the view (_self, _blank, etc.)
		 */
	createMenuItemToOpenViewForSelectedArtifact: function (targetResource, target) {

		var projectAreaUUID = jazz.app.context.get().itemId || ""; //$NON-NLS-1$
		
		var menuItem = new dijit.MenuItem({
			label: _messages.openViewMenuLabel, 
			iconClass: ICONCLASS_VIEW,
			onClick: function(event){
				if(!target) {
					target = (event.ctrlKey) ? "_blank" : "_self" ; //$NON-NLS-1$ //$NON-NLS-2$
				}
				SelectionDialog.openViewSelectionDialog(_messages.selectViewDialogTitle, projectAreaUUID, targetResource, function(value) {
					nodeUtils.openViewWithTargetArtifact(value.view, targetResource, target);
				});
			}
		});
		return menuItem;

	}
};
})();