/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.dashboard.ui.internal.RELMViewViewlet");//$NON-NLS-1$

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");//$NON-NLS-1$
dojo.require("com.ibm.team.dashboard.web.ui.CustomPreferenceProvider");//$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog");//$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ViewSelect"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.dashboard.ui.internal.RELMViewViewletPreferenceProvider"); //$NON-NLS-1$

(function() {

var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;

var PREFERENCE_VIEWURI = "com.ibm.relm.explorer.web.dashboard.preference.viewuri";//$NON-NLS-1$
var PREFERENCE_HEIGHT = "com.ibm.relm.explorer.web.dashboard.preference.height";//$NON-NLS-1$
var PREFERENCE_ZOOMLEVEL = "com.ibm.relm.explorer.web.dashboard.preference.zoomlevel";//$NON-NLS-1$
var PREFERENCE_TOOLBAR = "com.ibm.relm.explorer.web.dashboard.preference.toolbar";//$NON-NLS-1$
var PREFERENCE_OUTLINE = "com.ibm.relm.explorer.web.dashboard.preference.outline";//$NON-NLS-1$
/*
 * The viewlet class.
 */
dojo.declare("com.ibm.relm.explorer.web.dashboard.ui.internal.RELMViewViewlet",//$NON-NLS-1$
	Viewlet, {
	
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web.dashboard", "ui/internal/templates/RELMViewViewlet.html"),//$NON-NLS-1$ //$NON-NLS-2$
	
	// communication between viewlets
	useGadgetPubSub: false, 
	windowMessageListener: null,

	postCreate: function(){
		this.inherited(arguments);
		
		// inter-widgets communication
		var g = dojo.getObject("gadgets");//$NON-NLS-1$
		if(g){
			// open-social gadget
			if(g.pubsub){
				g.pubsub.subscribe("com.ibm.relm.explorer.web.dashboard", dojo.hitch(this, this.onMessage));//$NON-NLS-1$
				this.useGadgetPubSub = true;
			}
		}else{
			// Jazz viewlet
			this.windowMessageListener = dojo.hitch(this, this.onMessage);
			parent.addEventListener("message", this.windowMessageListener);//$NON-NLS-1$
		}
		
		this.refresh();
	},
	
	uninitialize: function(){
		this.inherited(arguments);
		if(this.useGadgetPubSub){
			var g = dojo.getObject("gadgets");//$NON-NLS-1$
			g.pubsub.unsubscribe("com.ibm.relm.explorer.web.dashboard");	//$NON-NLS-1$		
		}
		if(this.windowMessageListener){
			parent.removeEventListener("message", this.windowMessageListener);//$NON-NLS-1$
		}
	},
	
	getPreferenceProvider: function(prefId){
		var ret = null;
		if(prefId == PREFERENCE_VIEWURI){
			return new com.ibm.relm.explorer.web.dashboard.ui.internal.RELMViewViewletPreferenceProvider();
		}
		return ret; 
	},
	
	refresh: function() {
		var height = this.getPreference(PREFERENCE_HEIGHT);
		this.relmframe.style.height = height + "px";//$NON-NLS-1$

		var view = this.getPreference(PREFERENCE_VIEWURI);
		if (view){
			try {
				view = dojo.fromJson(view);

				this._showFrame(true);
				var zoomLevel = this.getPreference(PREFERENCE_ZOOMLEVEL);
				var toolbar = this.getPreference(PREFERENCE_TOOLBAR);
				var outline = this.getPreference(PREFERENCE_OUTLINE);
				var frameUrl = view.uri + "?relm.ajaxmodule=true" + //$NON-NLS-1$
									"&relm.zoomLevel=" + zoomLevel +//$NON-NLS-1$
									"&relm.hideToolbar=" + !toolbar +//$NON-NLS-1$
									"&relm.showOutline=" + outline;//$NON-NLS-1$
				if(djConfig.isDebug){
					frameUrl += "&debug=true";//$NON-NLS-1$
				}
				var viewUrl = view.uri;
				var paramString = "";//$NON-NLS-1$
				if(view.params && view.params.length > 0){
					dojo.forEach(view.params, function(p, index){
						if(p.name && p.value){
							var str = encodeURIComponent(p.name) + "=" + encodeURIComponent(p.value);//$NON-NLS-1$
							if(index === 0){
								paramString = str;
							}else{
								paramString = paramString + "&" + str;//$NON-NLS-1$ 								
							}
						}
					});
				}
				this.relmframe.src = frameUrl + "&" + paramString;//$NON-NLS-1$
				this.getSite().setTitleHyperlinkURL(viewUrl + "?" + paramString);//$NON-NLS-1$
			}catch(e){
				this._showFrame(false);
			}
		} else {
			this._showFrame(false);
		}
	},
	
	_showFrame: function(show){
		if(show){
			dojo.style(this.messageArea, "display", "none");//$NON-NLS-1$ //$NON-NLS-2$
			dojo.style(this.relmframe, "display", "");//$NON-NLS-1$ //$NON-NLS-2$
		}else{
			dojo.style(this.relmframe, "display", "none");//$NON-NLS-1$ //$NON-NLS-2$
			dojo.style(this.messageArea, "display", "");//$NON-NLS-1$ //$NON-NLS-2$			
		}
	},
	
	onMessage: function(event){
//		var type = event.data[0];
//		var value = event.data.substring(1);
	}	
});

})();
